/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/network","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","os","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ie=function(q){for(var e=[],E=0,t=q.length;E<t;E++)e[E]=ee[q[E]];return e};define(ee[119],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function E(M){return M?M.replace(/\$\((.*?)\)/g,(A,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=E;class t{constructor(A,P,m){this.id=A,this.definition=P,this.description=m,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var C;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function P(S){if(S instanceof t)return["codicon","codicon-"+S.id];const k=A.exec(S.id);if(!k)return P(t.error);const[,I,f]=k,p=["codicon","codicon-"+I];return f&&p.push("codicon-modifier-"+f.substring(1)),p}M.asClassNameArray=P;function m(S){return P(S).join(" ")}M.asClassName=m;function w(S){return"."+P(S).join(".")}M.asCSSSelector=w})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ee[120],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(P,m){const w=Math.pow(10,m);return Math.round(P*w)/w}class t{constructor(m,w,S,k=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,S))|0,this.a=E(Math.max(Math.min(1,k),0),3)}static equals(m,w){return m.r===w.r&&m.g===w.g&&m.b===w.b&&m.a===w.a}}e.RGBA=t;class C{constructor(m,w,S,k){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=E(Math.max(Math.min(1,w),0),3),this.l=E(Math.max(Math.min(1,S),0),3),this.a=E(Math.max(Math.min(1,k),0),3)}static equals(m,w){return m.h===w.h&&m.s===w.s&&m.l===w.l&&m.a===w.a}static fromRGBA(m){const w=m.r/255,S=m.g/255,k=m.b/255,I=m.a,f=Math.max(w,S,k),p=Math.min(w,S,k);let g=0,b=0;const h=(p+f)/2,v=f-p;if(v>0){switch(b=Math.min(h<=.5?v/(2*h):v/(2-2*h),1),f){case w:g=(S-k)/v+(S<k?6:0);break;case S:g=(k-w)/v+2;break;case k:g=(w-S)/v+4;break}g*=60,g=Math.round(g)}return new C(g,b,h,I)}static i(m,w,S){return S<0&&(S+=1),S>1&&(S-=1),S<1/6?m+(w-m)*6*S:S<1/2?w:S<2/3?m+(w-m)*(2/3-S)*6:m}static toRGBA(m){const w=m.h/360,{s:S,l:k,a:I}=m;let f,p,g;if(S===0)f=p=g=k;else{const b=k<.5?k*(1+S):k+S-k*S,h=2*k-b;f=C.i(h,b,w+1/3),p=C.i(h,b,w),g=C.i(h,b,w-1/3)}return new t(Math.round(f*255),Math.round(p*255),Math.round(g*255),I)}}e.HSLA=C;class M{constructor(m,w,S,k){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=E(Math.max(Math.min(1,w),0),3),this.v=E(Math.max(Math.min(1,S),0),3),this.a=E(Math.max(Math.min(1,k),0),3)}static equals(m,w){return m.h===w.h&&m.s===w.s&&m.v===w.v&&m.a===w.a}static fromRGBA(m){const w=m.r/255,S=m.g/255,k=m.b/255,I=Math.max(w,S,k),f=Math.min(w,S,k),p=I-f,g=I===0?0:p/I;let b;return p===0?b=0:I===w?b=((S-k)/p%6+6)%6:I===S?b=(k-w)/p+2:b=(w-S)/p+4,new M(Math.round(b*60),g,I,m.a)}static toRGBA(m){const{h:w,s:S,v:k,a:I}=m,f=k*S,p=f*(1-Math.abs(w/60%2-1)),g=k-f;let[b,h,v]=[0,0,0];return w<60?(b=f,h=p):w<120?(b=p,h=f):w<180?(h=f,v=p):w<240?(h=p,v=f):w<300?(b=p,v=f):w<=360&&(b=f,v=p),b=Math.round((b+g)*255),h=Math.round((h+g)*255),v=Math.round((v+g)*255),new t(b,h,v,I)}}e.HSVA=M;class A{static fromHex(m){return A.Format.CSS.parseHex(m)||A.red}static equals(m,w){return!m&&!w?!0:!m||!w?!1:m.equals(w)}get hsla(){return this.i?this.i:C.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof t)this.rgba=m;else if(m instanceof C)this.i=m,this.rgba=C.toRGBA(m);else if(m instanceof M)this.j=m,this.rgba=M.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&t.equals(this.rgba,m.rgba)&&C.equals(this.hsla,m.hsla)&&M.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=A.k(this.rgba.r),w=A.k(this.rgba.g),S=A.k(this.rgba.b),k=.2126*m+.7152*w+.0722*S;return E(k,4)}static k(m){const w=m/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(m){const w=this.getRelativeLuminance(),S=m.getRelativeLuminance();return w>S?(w+.05)/(S+.05):(S+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const w=this.getRelativeLuminance(),S=m.getRelativeLuminance();return w>S}isDarkerThan(m){const w=this.getRelativeLuminance(),S=m.getRelativeLuminance();return w<S}lighten(m){return new A(new C(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new A(new C(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:w,g:S,b:k,a:I}=this.rgba;return new A(new t(w,S,k,I*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const w=m.rgba,S=this.rgba.a,k=w.a,I=S+k*(1-S);if(I<1e-6)return A.transparent;const f=this.rgba.r*S/I+w.r*k*(1-S)/I,p=this.rgba.g*S/I+w.g*k*(1-S)/I,g=this.rgba.b*S/I+w.b*k*(1-S)/I;return new A(new t(f,p,g,I))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:w,g:S,b:k,a:I}=this.rgba;return new A(new t(m.rgba.r-I*(m.rgba.r-w),m.rgba.g-I*(m.rgba.g-S),m.rgba.b-I*(m.rgba.b-k),1))}flatten(...m){const w=m.reduceRight((S,k)=>A.o(k,S));return A.o(this,w)}static o(m,w){const S=1-m.rgba.a;return new A(new t(S*w.rgba.r+m.rgba.a*m.rgba.r,S*w.rgba.g+m.rgba.a*m.rgba.g,S*w.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(m,w,S){if(m.isLighterThan(w))return m;S=S||.5;const k=m.getRelativeLuminance(),I=w.getRelativeLuminance();return S=S*(I-k)/I,m.lighten(S)}static getDarkerColor(m,w,S){if(m.isDarkerThan(w))return m;S=S||.5;const k=m.getRelativeLuminance(),I=w.getRelativeLuminance();return S=S*(k-I)/k,m.darken(S)}}e.Color=A,A.white=new A(new t(255,255,255,1)),A.black=new A(new t(0,0,0,1)),A.red=new A(new t(255,0,0,1)),A.blue=new A(new t(0,0,255,1)),A.green=new A(new t(0,255,0,1)),A.cyan=new A(new t(0,255,255,1)),A.lightgrey=new A(new t(211,211,211,1)),A.transparent=new A(new t(0,0,0,0)),function(P){let m;(function(w){let S;(function(k){function I(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:P.Format.CSS.formatRGBA(n)}k.formatRGB=I;function f(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}k.formatRGBA=f;function p(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(n)}k.formatHSL=p;function g(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}k.formatHSLA=g;function b(n){const r=n.toString(16);return r.length!==2?"0"+r:r}function h(n){return`#${b(n.rgba.r)}${b(n.rgba.g)}${b(n.rgba.b)}`}k.formatHex=h;function v(n,r=!1){return r&&n.rgba.a===1?P.Format.CSS.formatHex(n):`#${b(n.rgba.r)}${b(n.rgba.g)}${b(n.rgba.b)}${b(Math.round(n.rgba.a*255))}`}k.formatHexA=v;function d(n){return n.isOpaque()?P.Format.CSS.formatHex(n):P.Format.CSS.formatRGBA(n)}k.format=d;function u(n){const r=n.length;if(r===0||n.charCodeAt(0)!==35)return null;if(r===7){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),a=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),s=16*c(n.charCodeAt(5))+c(n.charCodeAt(6));return new P(new t(i,a,s,1))}if(r===9){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),a=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),s=16*c(n.charCodeAt(5))+c(n.charCodeAt(6)),l=16*c(n.charCodeAt(7))+c(n.charCodeAt(8));return new P(new t(i,a,s,l/255))}if(r===4){const i=c(n.charCodeAt(1)),a=c(n.charCodeAt(2)),s=c(n.charCodeAt(3));return new P(new t(16*i+i,16*a+a,16*s+s))}if(r===5){const i=c(n.charCodeAt(1)),a=c(n.charCodeAt(2)),s=c(n.charCodeAt(3)),l=c(n.charCodeAt(4));return new P(new t(16*i+i,16*a+a,16*s+s,(16*l+l)/255))}return null}k.parseHex=u;function c(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(S=w.CSS||(w.CSS={}))})(m=P.Format||(P.Format={}))}(A=e.Color||(e.Color={}))}),define(ee[53],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(A){return(P,m,w)=>{let S=null,k=null;if(typeof w.value=="function"?(S="value",k=w.value):typeof w.get=="function"&&(S="get",k=w.get),!k)throw new Error("not supported");w[S]=A(k,m)}}function t(A,P,m){let w=null,S=null;if(typeof m.value=="function"?(w="value",S=m.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(w="get",S=m.get),!S)throw new Error("not supported");const k=`$memoize$${P}`;m[w]=function(...I){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,I)}),this[k]}}e.memoize=t;function C(A,P,m){return E((w,S)=>{const k=`$debounce$${S}`,I=`$debounce$result$${S}`;return function(...f){this[I]||(this[I]=m?m():void 0),clearTimeout(this[k]),P&&(this[I]=P(this[I],...f),f=[this[I]]),this[k]=setTimeout(()=>{w.apply(this,f),this[I]=m?m():void 0},A)}})}e.debounce=C;function M(A,P,m){return E((w,S)=>{const k=`$throttle$timer$${S}`,I=`$throttle$result$${S}`,f=`$throttle$lastRun$${S}`,p=`$throttle$pending$${S}`;return function(...g){if(this[I]||(this[I]=m?m():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),P&&(this[I]=P(this[I],...g)),this[p])return;const b=this[f]+A;b<=Date.now()?(this[f]=Date.now(),w.apply(this,[this[I]]),this[I]=m?m():void 0):(this[p]=!0,this[k]=setTimeout(()=>{this[p]=!1,this[f]=Date.now(),w.apply(this,[this[I]]),this[I]=m?m():void 0},b-Date.now()))}})}e.throttle=M}),define(ee[15],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?d.isErrorNoTelemetry(n)?new d(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(r=>{r(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=E,e.errorHandler=new E;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function C(c){m(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=C;function M(c){m(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=M;function A(c){if(c instanceof Error){const{name:n,message:r}=c,i=c.stacktrace||c.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:d.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=A;const P="Canceled";function m(c){return c instanceof w?!0:c instanceof Error&&c.name===P&&c.message===P}e.isCancellationError=m;class w extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=w;function S(){const c=new Error(P);return c.name=c.message,c}e.canceled=S;function k(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=k;function I(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=I;function f(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function p(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=p;function g(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=g;class b extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=b;class h extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=h;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class d extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof d)return n;const r=new d;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=d;class u extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype);debugger}}e.BugIndicatingError=u}),define(ee[24],ie([0,1,15]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,x=0){return j[j.length-(1+x)]}e.tail=t;function C(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=C;function M(j,x,_=(ae,ge)=>ae===ge){if(j===x)return!0;if(!j||!x||j.length!==x.length)return!1;for(let ae=0,ge=j.length;ae<ge;ae++)if(!_(j[ae],x[ae]))return!1;return!0}e.equals=M;function A(j,x){const _=j.length-1;x<_&&(j[x]=j[_]),j.pop()}e.removeFastWithoutKeepingOrder=A;function P(j,x,_){return m(j.length,ae=>_(j[ae],x))}e.binarySearch=P;function m(j,x){let _=0,ae=j-1;for(;_<=ae;){const ge=(_+ae)/2|0,Me=x(ge);if(Me<0)_=ge+1;else if(Me>0)ae=ge-1;else return ge}return-(_+1)}e.binarySearch2=m;function w(j,x){let _=0,ae=j.length;if(ae===0)return 0;for(;_<ae;){const ge=Math.floor((_+ae)/2);x(j[ge])?ae=ge:_=ge+1}return _}e.findFirstInSorted=w;function S(j,x,_){if(j=j|0,j>=x.length)throw new TypeError("invalid index");const ae=x[Math.floor(x.length*Math.random())],ge=[],Me=[],Oe=[];for(const De of x){const Re=_(De,ae);Re<0?ge.push(De):Re>0?Me.push(De):Oe.push(De)}return j<ge.length?S(j,ge,_):j<ge.length+Oe.length?Oe[0]:S(j-(ge.length+Oe.length),Me,_)}e.quickSelect=S;function k(j,x){const _=[];let ae;for(const ge of j.slice(0).sort(x))!ae||x(ae[0],ge)!==0?(ae=[ge],_.push(ae)):ae.push(ge);return _}e.groupBy=k;function I(j,x,_){const ae=[];function ge(De,Re,ve){if(Re===0&&ve.length===0)return;const we=ae[ae.length-1];we&&we.start+we.deleteCount===De?(we.deleteCount+=Re,we.toInsert.push(...ve)):ae.push({start:De,deleteCount:Re,toInsert:ve})}let Me=0,Oe=0;for(;;){if(Me===j.length){ge(Me,0,x.slice(Oe));break}if(Oe===x.length){ge(Me,j.length-Me,[]);break}const De=j[Me],Re=x[Oe],ve=_(De,Re);ve===0?(Me+=1,Oe+=1):ve<0?(ge(Me,1,[]),Me+=1):ve>0&&(ge(Me,0,[Re]),Oe+=1)}return ae}e.sortedDiff=I;function f(j,x,_){const ae=I(j,x,_),ge=[],Me=[];for(const Oe of ae)ge.push(...j.slice(Oe.start,Oe.start+Oe.deleteCount)),Me.push(...Oe.toInsert);return{removed:ge,added:Me}}e.delta=f;function p(j,x,_){if(_===0)return[];const ae=j.slice(0,_).sort(x);return b(j,x,ae,_,j.length),ae}e.top=p;function g(j,x,_,ae,ge){return _===0?Promise.resolve([]):new Promise((Me,Oe)=>{(async()=>{const De=j.length,Re=j.slice(0,_).sort(x);for(let ve=_,we=Math.min(_+ae,De);ve<De;ve=we,we=Math.min(we+ae,De)){if(ve>_&&await new Promise(be=>setTimeout(be)),ge&&ge.isCancellationRequested)throw new E.CancellationError;b(j,x,Re,ve,we)}return Re})().then(Me,Oe)})}e.topAsync=g;function b(j,x,_,ae,ge){for(const Me=_.length;ae<ge;ae++){const Oe=j[ae];if(x(Oe,_[Me-1])<0){_.pop();const De=w(_,Re=>x(Oe,Re)<0);_.splice(De,0,Oe)}}}function h(j){return j.filter(x=>!!x)}e.coalesce=h;function v(j){let x=0;for(let _=0;_<j.length;_++)j[_]&&(j[x]=j[_],x+=1);j.length=x}e.coalesceInPlace=v;function d(j,x,_){j.splice(_,0,j.splice(x,1)[0])}e.move=d;function u(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=u;function c(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=c;function n(j,x=_=>_){const _=new Set;return j.filter(ae=>{const ge=x(ae);return _.has(ge)?!1:(_.add(ge),!0)})}e.distinct=n;function r(j){const x=new Set;return _=>{const ae=j(_);return x.has(ae)?!1:(x.add(ae),!0)}}e.uniqueFilter=r;function i(j,x){const _=a(j,x);if(_!==-1)return j[_]}e.findLast=i;function a(j,x){for(let _=j.length-1;_>=0;_--){const ae=j[_];if(x(ae))return _}return-1}e.lastIndex=a;function s(j,x){return j.length>0?j[0]:x}e.firstOrDefault=s;function l(j,x){return j.length>0?j[j.length-1]:x}e.lastOrDefault=l;function o(j,x,_=(ae,ge)=>ae===ge){let ae=0;for(let ge=0,Me=Math.min(j.length,x.length);ge<Me&&_(j[ge],x[ge]);ge++)ae++;return ae}e.commonPrefixLength=o;function y(j){return[].concat(...j)}e.flatten=y;function D(j,x){let _=typeof x=="number"?j:0;typeof x=="number"?_=j:(_=0,x=j);const ae=[];if(_<=x)for(let ge=_;ge<x;ge++)ae.push(ge);else for(let ge=_;ge>x;ge--)ae.push(ge);return ae}e.range=D;function O(j,x,_){return j.reduce((ae,ge)=>(ae[x(ge)]=_?_(ge):ge,ae),Object.create(null))}e.index=O;function N(j,x){return j.push(x),()=>Y(j,x)}e.insert=N;function Y(j,x){const _=j.indexOf(x);if(_>-1)return j.splice(_,1),x}e.remove=Y;function G(j,x,_){const ae=j.slice(0,x),ge=j.slice(x);return ae.concat(_,ge)}e.arrayInsert=G;function V(j,x){let _;if(typeof x=="number"){let ae=x;_=()=>{const ge=Math.sin(ae++)*179426549;return ge-Math.floor(ge)}}else _=Math.random;for(let ae=j.length-1;ae>0;ae-=1){const ge=Math.floor(_()*(ae+1)),Me=j[ae];j[ae]=j[ge],j[ge]=Me}}e.shuffle=V;function se(j,x){const _=j.indexOf(x);_>-1&&(j.splice(_,1),j.unshift(x))}e.pushToStart=se;function oe(j,x){const _=j.indexOf(x);_>-1&&(j.splice(_,1),j.push(x))}e.pushToEnd=oe;function re(j,x){for(const _ of x)j.push(_)}e.pushMany=re;function de(j,x){return Array.isArray(j)?j.map(x):x(j)}e.mapArrayOrNot=de;function X(j){return Array.isArray(j)?j:[j]}e.asArray=X;function le(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=le;function F(j,x){for(const _ of j){const ae=x(_);if(ae!==void 0)return ae}}e.mapFind=F;function L(j,x,_){const ae=U(j,x),ge=j.length,Me=_.length;j.length=ge+Me;for(let Oe=ge-1;Oe>=ae;Oe--)j[Oe+Me]=j[Oe];for(let Oe=0;Oe<Me;Oe++)j[Oe+ae]=_[Oe]}e.insertInto=L;function T(j,x,_,ae){const ge=U(j,x),Me=j.splice(ge,_);return L(j,ge,ae),Me}e.splice=T;function U(j,x){return x<0?Math.max(x+j.length,0):Math.min(x,j.length)}var Q;(function(j){function x(ge){return ge<0}j.isLessThan=x;function _(ge){return ge>0}j.isGreaterThan=_;function ae(ge){return ge===0}j.isNeitherLessOrGreaterThan=ae,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function B(j,x){return(_,ae)=>x(j(_),j(ae))}e.compareBy=B;function H(...j){return(x,_)=>{for(const ae of j){const ge=ae(x,_);if(!Q.isNeitherLessOrGreaterThan(ge))return ge}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=H;const R=(j,x)=>j-x;e.numberComparator=R;function W(j,x){if(j.length===0)return;let _=j[0];for(let ae=1;ae<j.length;ae++){const ge=j[ae];x(ge,_)>0&&(_=ge)}return _}e.findMaxBy=W;function $(j,x){if(j.length===0)return;let _=j[0];for(let ae=1;ae<j.length;ae++){const ge=j[ae];x(ge,_)>=0&&(_=ge)}return _}e.findLastMaxBy=$;function z(j,x){return W(j,(_,ae)=>-x(_,ae))}e.findMinBy=z;class J{constructor(x){this.f=x,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(x){let _=this.c;for(;_<this.f.length&&x(this.f[_]);)_++;const ae=_===this.c?null:this.f.slice(this.c,_);return this.c=_,ae}takeFromEndWhile(x){let _=this.d;for(;_>=0&&x(this.f[_]);)_--;const ae=_===this.d?null:this.f.slice(_+1,this.d+1);return this.d=_,ae}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const x=this.f[this.c];return this.c++,x}removeLast(){const x=this.f[this.d];return this.d--,x}takeCount(x){const _=this.f.slice(this.c,this.c+x);return this.c+=x,_}}e.ArrayQueue=J;class ne{constructor(x){this.iterate=x}forEach(x){this.iterate(_=>(x(_),!0))}toArray(){const x=[];return this.iterate(_=>(x.push(_),!0)),x}filter(x){return new ne(_=>this.iterate(ae=>x(ae)?_(ae):!0))}map(x){return new ne(_=>this.iterate(ae=>_(x(ae))))}some(x){let _=!1;return this.iterate(ae=>(_=x(ae),!_)),_}findFirst(x){let _;return this.iterate(ae=>x(ae)?(_=ae,!1):!0),_}findLast(x){let _;return this.iterate(ae=>(x(ae)&&(_=ae),!0)),_}findLastMaxBy(x){let _,ae=!0;return this.iterate(ge=>((ae||Q.isGreaterThan(x(ge,_)))&&(ae=!1,_=ge),!0)),_}}e.CallbackIterable=ne,ne.empty=new ne(j=>{})}),define(ee[121],ie([0,1,15]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(m,w){if(!m)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=t;function C(m,w="Unreachable"){throw new Error(w)}e.assertNever=C;function M(m){if(!m)throw new E.BugIndicatingError("Assertion Failed")}e.assert=M;function A(m){if(!m()){debugger;m(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function P(m,w){let S=0;for(;S<m.length-1;){const k=m[S],I=m[S+1];if(!w(k,I))return!1;S++}return!0}e.checkAdjacentItems=P}),define(ee[49],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(t){const C=this;let M=!1,A;return function(){return M||(M=!0,A=t.apply(C,arguments)),A}}e.once=E}),define(ee[66],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(t){function C(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=C;const M=Object.freeze([]);function A(){return M}t.empty=A;function*P(u){yield u}t.single=P;function m(u){return C(u)?u:P(u)}t.wrap=m;function w(u){return u||M}t.from=w;function S(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=S;function k(u){return u[Symbol.iterator]().next().value}t.first=k;function I(u,c){for(const n of u)if(c(n))return!0;return!1}t.some=I;function f(u,c){for(const n of u)if(c(n))return n}t.find=f;function*p(u,c){for(const n of u)c(n)&&(yield n)}t.filter=p;function*g(u,c){let n=0;for(const r of u)yield c(r,n++)}t.map=g;function*b(...u){for(const c of u)for(const n of c)yield n}t.concat=b;function h(u,c,n){let r=n;for(const i of u)r=c(r,i);return r}t.reduce=h;function*v(u,c,n=u.length){for(c<0&&(c+=u.length),n<0?n+=u.length:n>u.length&&(n=u.length);c<n;c++)yield u[c]}t.slice=v;function d(u,c=Number.POSITIVE_INFINITY){const n=[];if(c===0)return[n,u];const r=u[Symbol.iterator]();for(let i=0;i<c;i++){const a=r.next();if(a.done)return[n,t.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return r}}]}t.consume=d})(E=e.Iterable||(e.Iterable={}))}),define(ee[43],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function A(n,r=!1){let i=0;const a=n.length;let s="",l=0,o=16,y=0;function D(oe){let re=0,de=0;for(;re<oe;){const X=n.charCodeAt(i);if(X>=48&&X<=57)de=de*16+X-48;else if(X>=65&&X<=70)de=de*16+X-65+10;else if(X>=97&&X<=102)de=de*16+X-97+10;else break;i++,re++}return re<oe&&(de=-1),de}function O(oe){i=oe,s="",l=0,o=16,y=0}function N(){const oe=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&w(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&w(n.charCodeAt(i)))for(i++;i<n.length&&w(n.charCodeAt(i));)i++;else return y=3,n.substring(oe,i);let re=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&w(n.charCodeAt(i))){for(i++;i<n.length&&w(n.charCodeAt(i));)i++;re=i}else y=3;return n.substring(oe,re)}function Y(){let oe="",re=i;for(;;){if(i>=a){oe+=n.substring(re,i),y=2;break}const de=n.charCodeAt(i);if(de===34){oe+=n.substring(re,i),i++;break}if(de===92){if(oe+=n.substring(re,i),i++,i>=a){y=2;break}switch(n.charCodeAt(i++)){case 34:oe+='"';break;case 92:oe+="\\";break;case 47:oe+="/";break;case 98:oe+="\b";break;case 102:oe+="\f";break;case 110:oe+=`
`;break;case 114:oe+="\r";break;case 116:oe+="	";break;case 117:{const le=D(4);le>=0?oe+=String.fromCharCode(le):y=4;break}default:y=5}re=i;continue}if(de>=0&&de<=31)if(m(de)){oe+=n.substring(re,i),y=2;break}else y=6;i++}return oe}function G(){if(s="",y=0,l=i,i>=a)return l=a,o=17;let oe=n.charCodeAt(i);if(P(oe)){do i++,s+=String.fromCharCode(oe),oe=n.charCodeAt(i);while(P(oe));return o=15}if(m(oe))return i++,s+=String.fromCharCode(oe),oe===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),o=14;switch(oe){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,s=Y(),o=10;case 47:{const re=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<a&&!m(n.charCodeAt(i));)i++;return s=n.substring(re,i),o=12}if(n.charCodeAt(i+1)===42){i+=2;const de=a-1;let X=!1;for(;i<de;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,X=!0;break}i++}return X||(i++,y=1),s=n.substring(re,i),o=13}return s+=String.fromCharCode(oe),i++,o=16}case 45:if(s+=String.fromCharCode(oe),i++,i===a||!w(n.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),o=11;default:for(;i<a&&V(oe);)i++,oe=n.charCodeAt(i);if(l!==i){switch(s=n.substring(l,i),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(oe),i++,o=16}}function V(oe){if(P(oe)||m(oe))return!1;switch(oe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let oe;do oe=G();while(oe>=12&&oe<=15);return oe}return{setPosition:O,getPosition:()=>i,scan:r?se:G,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>y}}e.createScanner=A;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function m(n){return n===10||n===13||n===8232||n===8233}function w(n){return n>=48&&n<=57}var S;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(S||(S={}));function k(n,r){const i=[],a=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function y(D,O,N,Y){l.value=D,l.offset=O,l.length=N,l.type=Y,l.colonOffset=void 0,s=l}try{d(n,{onObjectBegin:(D,O)=>{if(r<=D)throw a;s=void 0,o=r>D,i.push("")},onObjectProperty:(D,O,N)=>{if(r<O||(y(D,O,N,"property"),i[i.length-1]=D,r<=O+N))throw a},onObjectEnd:(D,O)=>{if(r<=D)throw a;s=void 0,i.pop()},onArrayBegin:(D,O)=>{if(r<=D)throw a;s=void 0,i.push(0)},onArrayEnd:(D,O)=>{if(r<=D)throw a;s=void 0,i.pop()},onLiteralValue:(D,O,N)=>{if(r<O||(y(D,O,N,c(D)),r<=O+N))throw a},onSeparator:(D,O,N)=>{if(r<=O)throw a;if(D===":"&&s&&s.type==="property")s.colonOffset=O,o=!1,s=void 0;else if(D===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(o=!0,i[i.length-1]=""),s=void 0}}})}catch(D){if(D!==a)throw D}return{path:i,previousNode:s,isAtPropertyKey:o,matches:D=>{let O=0;for(let N=0;O<D.length&&N<i.length;N++)if(D[O]===i[N]||D[O]==="*")O++;else if(D[O]!=="**")return!1;return O===D.length}}}e.getLocation=k;function I(n,r=[],i=M.DEFAULT){let a=null,s=[];const l=[];function o(D){Array.isArray(s)?s.push(D):a!==null&&(s[a]=D)}return d(n,{onObjectBegin:()=>{const D={};o(D),l.push(s),s=D,a=null},onObjectProperty:D=>{a=D},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const D=[];o(D),l.push(s),s=D,a=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:o,onError:(D,O,N)=>{r.push({error:D,offset:O,length:N})}},i),s[0]}e.parse=I;function f(n,r=[],i=M.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(D){a.type==="property"&&(a.length=D-a.offset,a=a.parent)}function l(D){return a.children.push(D),D}d(n,{onObjectBegin:D=>{a=l({type:"object",offset:D,length:-1,parent:a,children:[]})},onObjectProperty:(D,O,N)=>{a=l({type:"property",offset:O,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:D,offset:O,length:N,parent:a})},onObjectEnd:(D,O)=>{a.length=D+O-a.offset,a=a.parent,s(D+O)},onArrayBegin:(D,O)=>{a=l({type:"array",offset:D,length:-1,parent:a,children:[]})},onArrayEnd:(D,O)=>{a.length=D+O-a.offset,a=a.parent,s(D+O)},onLiteralValue:(D,O,N)=>{l({type:c(D),offset:O,length:N,parent:a,value:D}),s(O+N)},onSeparator:(D,O,N)=>{a.type==="property"&&(D===":"?a.colonOffset=O:D===","&&s(O))},onError:(D,O,N)=>{r.push({error:D,offset:O,length:N})}},i);const y=a.children[0];return y&&delete y.parent,y}e.parseTree=f;function p(n,r){if(!n)return;let i=n;for(const a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===a){i=l.children[1],s=!0;break}if(!s)return}else{const s=a;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=p;function g(n){if(!n.parent||!n.parent.children)return[];const r=g(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.getNodePath=g;function b(n){switch(n.type){case"array":return n.children.map(b);case"object":{const r=Object.create(null);for(const i of n.children){const a=i.children[1];a&&(r[i.children[0].value]=b(a))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=b;function h(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.contains=h;function v(n,r,i=!1){if(h(n,r,i)){const a=n.children;if(Array.isArray(a))for(let s=0;s<a.length&&a[s].offset<=r;s++){const l=v(a[s],r,i);if(l)return l}return n}}e.findNodeAtOffset=v;function d(n,r,i=M.DEFAULT){const a=A(n,!1);function s(B){return B?()=>B(a.getTokenOffset(),a.getTokenLength()):()=>!0}function l(B){return B?H=>B(H,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=s(r.onObjectBegin),y=l(r.onObjectProperty),D=s(r.onObjectEnd),O=s(r.onArrayBegin),N=s(r.onArrayEnd),Y=l(r.onLiteralValue),G=l(r.onSeparator),V=s(r.onComment),se=l(r.onError),oe=i&&i.disallowComments,re=i&&i.allowTrailingComma;function de(){for(;;){const B=a.scan();switch(a.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:oe||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(B){case 12:case 13:oe?X(10):V();break;case 16:X(1);break;case 15:case 14:break;default:return B}}}function X(B,H=[],R=[]){if(se(B),H.length+R.length>0){let W=a.getToken();for(;W!==17;){if(H.indexOf(W)!==-1){de();break}else if(R.indexOf(W)!==-1)break;W=de()}}}function le(B){const H=a.getTokenValue();return B?Y(H):y(H),de(),!0}function F(){switch(a.getToken()){case 11:{let B=0;try{B=JSON.parse(a.getTokenValue()),typeof B!="number"&&(X(2),B=0)}catch{X(2)}Y(B);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return de(),!0}function L(){return a.getToken()!==10?(X(3,[],[2,5]),!1):(le(!1),a.getToken()===6?(G(":"),de(),Q()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function T(){o(),de();let B=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(B||X(4,[],[]),G(","),de(),a.getToken()===2&&re)break}else B&&X(6,[],[]);L()||X(4,[],[2,5]),B=!0}return D(),a.getToken()!==2?X(7,[2],[]):de(),!0}function U(){O(),de();let B=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(B||X(4,[],[]),G(","),de(),a.getToken()===4&&re)break}else B&&X(6,[],[]);Q()||X(4,[],[4,5]),B=!0}return N(),a.getToken()!==4?X(8,[4],[]):de(),!0}function Q(){switch(a.getToken()){case 3:return U();case 1:return T();case 10:return le(!0);default:return F()}}return de(),a.getToken()===17?i.allowEmptyContent?!0:(X(4,[],[]),!1):Q()?(a.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=d;function u(n,r){const i=A(n),a=[];let s,l=0,o;do switch(o=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:l!==o&&a.push(n.substring(l,o)),r!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,r)),l=i.getPosition();break}while(s!==17);return a.join("")}e.stripComments=u;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ee[122],ie([0,1,43]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(w,S,k){let I,f,p,g,b;if(S){for(g=S.offset,b=g+S.length,p=g;p>0&&!m(w,p-1);)p--;let o=b;for(;o<w.length&&!m(w,o);)o++;f=w.substring(p,o),I=A(f,k)}else f=w,I=0,p=0,g=0,b=w.length;const h=P(k,w);let v=!1,d=0,u;k.insertSpaces?u=M(" ",k.tabSize||4):u="	";const c=(0,E.createScanner)(f,!1);let n=!1;function r(){return h+M(u,I+d)}function i(){let o=c.scan();for(v=!1;o===15||o===14;)v=v||o===14,o=c.scan();return n=o===16||c.getTokenError()!==0,o}const a=[];function s(o,y,D){!n&&y<b&&D>g&&w.substring(y,D)!==o&&a.push({offset:y,length:D-y,content:o})}let l=i();if(l!==17){const o=c.getTokenOffset()+p,y=M(u,I);s(y,p,o)}for(;l!==17;){let o=c.getTokenOffset()+c.getTokenLength()+p,y=i(),D="";for(;!v&&(y===12||y===13);){const N=c.getTokenOffset()+p;s(" ",o,N),o=c.getTokenOffset()+c.getTokenLength()+p,D=y===12?r():"",y=i()}if(y===2)l!==1&&(d--,D=r());else if(y===4)l!==3&&(d--,D=r());else{switch(l){case 3:case 1:d++,D=r();break;case 5:case 12:D=r();break;case 13:v?D=r():D=" ";break;case 6:D=" ";break;case 10:if(y===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?D=" ":y!==5&&y!==17&&(n=!0);break;case 16:n=!0;break}v&&(y===12||y===13)&&(D=r())}const O=c.getTokenOffset()+p;s(D,o,O),l=y}return a}e.format=t;function C(w,S){const k=JSON.stringify(w,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?k.replace(/\r\n|\r|\n/g,S.eol):k}e.toFormattedString=C;function M(w,S){let k="";for(let I=0;I<S;I++)k+=w;return k}function A(w,S){let k=0,I=0;const f=S.tabSize||4;for(;k<w.length;){const p=w.charAt(k);if(p===" ")I++;else if(p==="	")I+=f;else break;k++}return Math.floor(I/f)}function P(w,S){for(let k=0;k<S.length;k++){const I=S.charAt(k);if(I==="\r")return k+1<S.length&&S.charAt(k+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=P;function m(w,S){return`\r
`.indexOf(w.charAt(S))!==-1}e.isEOL=m}),define(ee[123],ie([0,1,43,122]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(w,S,k){return M(w,S,void 0,k)}e.removeProperty=C;function M(w,S,k,I,f){const p=S.slice(),g=[],b=(0,E.parseTree)(w,g);let h,v;for(;p.length>0&&(v=p.pop(),h=(0,E.findNodeAtLocation)(b,p),h===void 0&&k!==void 0);)typeof v=="string"?k={[v]:k}:k=[k];if(h)if(h.type==="object"&&typeof v=="string"&&Array.isArray(h.children)){const d=(0,E.findNodeAtLocation)(h,[v]);if(d!==void 0)if(k===void 0){if(!d.parent)throw new Error("Malformed AST");const u=h.children.indexOf(d.parent);let c,n=d.parent.offset+d.parent.length;if(u>0){const r=h.children[u-1];c=r.offset+r.length}else c=h.offset+1,h.children.length>1&&(n=h.children[1].offset);return A(w,{offset:c,length:n-c,content:""},I)}else return A(w,{offset:d.offset,length:d.length,content:JSON.stringify(k)},I);else{if(k===void 0)return[];const u=`${JSON.stringify(v)}: ${JSON.stringify(k)}`,c=f?f(h.children.map(r=>r.children[0].value)):h.children.length;let n;if(c>0){const r=h.children[c-1];n={offset:r.offset+r.length,length:0,content:","+u}}else h.children.length===0?n={offset:h.offset+1,length:0,content:u}:n={offset:h.offset+1,length:0,content:u+","};return A(w,n,I)}}else if(h.type==="array"&&typeof v=="number"&&Array.isArray(h.children))if(k!==void 0){const d=`${JSON.stringify(k)}`;let u;if(h.children.length===0||v===0)u={offset:h.offset+1,length:0,content:h.children.length===0?d:d+","};else{const c=v===-1||v>h.children.length?h.children.length:v,n=h.children[c-1];u={offset:n.offset+n.length,length:0,content:","+d}}return A(w,u,I)}else{const d=v,u=h.children[d];let c;if(h.children.length===1)c={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===d){const n=h.children[d-1],r=n.offset+n.length,i=h.offset+h.length;c={offset:r,length:i-2-r,content:""}}else c={offset:u.offset,length:h.children[d+1].offset-u.offset,content:""};return A(w,c,I)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${h.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return A(w,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(k)},I)}}e.setProperty=M;function A(w,S,k){let I=P(w,S),f=S.offset,p=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;f>0&&!(0,t.isEOL)(I,f-1);)f--;for(;p<I.length&&!(0,t.isEOL)(I,p);)p++}const g=(0,t.format)(I,{offset:f,length:p-f},k);for(let h=g.length-1;h>=0;h--){const v=g[h];I=P(I,v),f=Math.min(f,v.offset),p=Math.max(p,v.offset+v.length),p+=v.content.length-v.length}const b=w.length-(I.length-p)-f;return[{offset:f,length:b,content:I.substring(f,p)}]}e.withFormatting=A;function P(w,S){return w.substring(0,S.offset)+S.content+w.substring(S.offset+S.length)}e.applyEdit=P;function m(w,S){const k=S.slice(0).sort((f,p)=>{const g=f.offset-p.offset;return g===0?f.length-p.length:g});let I=w.length;for(let f=k.length-1;f>=0;f--){const p=k[f];if(p.offset+p.length<=I)w=P(w,p);else throw new Error("Overlapping edit");I=p.offset}return w}e.applyEdits=m}),define(ee[124],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(C){this.d=C,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(C){return new E(()=>C(this.getValue()))}}e.Lazy=E}),define(ee[2],ie([0,1,49,66]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let M=null;function A(l){M=l}if(e.setDisposableTracker=A,C){const l="__is_disposable_tracked__";A(new class{trackDisposable(o){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[l]||console.log(y)},3e3)}setParent(o,y){if(o&&o!==v.None)try{o[l]=!0}catch{}}markAsDisposed(o){if(o&&o!==v.None)try{o[l]=!0}catch{}}markAsSingleton(o){}})}function P(l){return M?.trackDisposable(l),l}function m(l){M?.markAsDisposed(l)}function w(l,o){M?.setParent(l,o)}function S(l,o){if(!!M)for(const y of l)M.setParent(y,o)}function k(l){return M?.markAsSingleton(l),l}e.markAsSingleton=k;function I(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=I;function f(l){if(t.Iterable.is(l)){const o=[];for(const y of l)if(y)try{y.dispose()}catch(D){o.push(D)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=f;function p(l){for(const o of l)I(o)&&o.dispose();return[]}e.disposeIfDisposable=p;function g(...l){const o=b(()=>f(l));return S(l,o),o}e.combinedDisposable=g;function b(l){const o=P({dispose:(0,E.once)(()=>{m(o),l()})});return o}e.toDisposable=b;class h{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(m(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{f(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return w(o,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this.q=new h,P(this),w(this.q,this)}dispose(){m(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class d{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&w(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&w(o,null),o}}e.MutableDisposable=d;class u{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(o){let y=o;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,m(this))},this}}e.SafeDisposable=c;class n{constructor(){this.a=new Map}acquire(o,...y){let D=this.a.get(o);D||(D={counter:0,object:this.b(o,...y)},this.a.set(o,D));const{object:O}=D,N=(0,E.once)(()=>{--D.counter===0&&(this.c(o,D.object),this.a.delete(o))});return D.counter++,{object:O,dispose:N}}}e.ReferenceCollection=n;class r{constructor(o){this.a=o}async acquire(o,...y){const D=this.a.acquire(o,...y);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(O){throw D.dispose(),O}}}e.AsyncReferenceCollection=r;class i{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=i;function a(l){const o=new h;try{l(o)}finally{o.dispose()}}e.disposeOnReturn=a;class s{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,y,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(o)?.dispose(),this.a.set(o,y)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(ee[95],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(M){this.element=M,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let M=this.a;for(;M!==E.Undefined;){const A=M.next;M.prev=E.Undefined,M.next=E.Undefined,M=A}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,A){const P=new E(M);if(this.a===E.Undefined)this.a=P,this.b=P;else if(A){const w=this.b;this.b=P,P.prev=w,w.next=P}else{const w=this.a;this.a=P,P.next=w,w.prev=P}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==E.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==E.Undefined&&M.next!==E.Undefined){const A=M.prev;A.next=M.next,M.next.prev=A}else M.prev===E.Undefined&&M.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):M.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):M.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==E.Undefined;)yield M.element,M=M.next}}e.LinkedList=t}),define(ee[39],ie([0,1]),function(q,e){"use strict";var E,t,C;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(p,g,b){let h=p.get(g);return h===void 0&&(h=b,p.set(g,h)),h}e.getOrSet=M;function A(p){const g=[];return p.forEach((b,h)=>{g.push(`${h} => ${b}`)}),`Map(${p.size}) {${g.join(", ")}}`}e.mapToString=A;function P(p){const g=[];return p.forEach(b=>{g.push(b)}),`Set(${p.size}) {${g.join(", ")}}`}e.setToString=P;class m{constructor(g,b){this.uri=g,this.value=b}}class w{constructor(g,b){this[E]="ResourceMap",g instanceof w?(this.b=new Map(g.b),this.c=b??w.a):(this.b=new Map,this.c=g??w.a)}set(g,b){return this.b.set(this.c(g),new m(g,b)),this}get(g){return this.b.get(this.c(g))?.value}has(g){return this.b.has(this.c(g))}get size(){return this.b.size}clear(){this.b.clear()}delete(g){return this.b.delete(this.c(g))}forEach(g,b){typeof b<"u"&&(g=g.bind(b));for(const[h,v]of this.b)g(v.value,v.uri,this)}*values(){for(const g of this.b.values())yield g.value}*keys(){for(const g of this.b.values())yield g.uri}*entries(){for(const g of this.b.values())yield[g.uri,g.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.b)yield[g.uri,g.value]}}e.ResourceMap=w,w.a=p=>p.toString();class S{constructor(g,b){this[t]="ResourceSet",!g||typeof g=="function"?this.a=new w(g):(this.a=new w(b),g.forEach(this.add,this))}get size(){return this.a.size}add(g){return this.a.set(g,g),this}clear(){this.a.clear()}delete(g){return this.a.delete(g)}forEach(g,b){this.a.forEach((h,v)=>g.call(b,v,v,this))}has(g){return this.a.has(g)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=S;var k;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(k=e.Touch||(e.Touch={}));class I{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(g){return this.a.has(g)}get(g,b=0){const h=this.a.get(g);if(!!h)return b!==0&&this.j(h,b),h.value}set(g,b,h=0){let v=this.a.get(g);if(v)v.value=b,h!==0&&this.j(v,h);else{switch(v={key:g,value:b,next:void 0,previous:void 0},h){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(g,v),this.d++}return this}delete(g){return!!this.remove(g)}remove(g){const b=this.a.get(g);if(!!b)return this.a.delete(g),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const g=this.b;return this.a.delete(g.key),this.i(g),this.d--,g.value}forEach(g,b){const h=this.e;let v=this.b;for(;v;){if(b?g.bind(b)(v.value,v.key,this):g(v.value,v.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const g=this,b=this.e;let h=this.b;const v={[Symbol.iterator](){return v},next(){if(g.e!==b)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.key,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return v}values(){const g=this,b=this.e;let h=this.b;const v={[Symbol.iterator](){return v},next(){if(g.e!==b)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.value,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return v}entries(){const g=this,b=this.e;let h=this.b;const v={[Symbol.iterator](){return v},next(){if(g.e!==b)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:[h.key,h.value],done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return v}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(g){if(g>=this.size)return;if(g===0){this.clear();return}let b=this.b,h=this.size;for(;b&&h>g;)this.a.delete(b.key),b=b.next,h--;this.b=b,this.d=h,b&&(b.previous=void 0),this.e++}g(g){if(!this.b&&!this.c)this.c=g;else if(this.b)g.next=this.b,this.b.previous=g;else throw new Error("Invalid list");this.b=g,this.e++}h(g){if(!this.b&&!this.c)this.b=g;else if(this.c)g.previous=this.c,this.c.next=g;else throw new Error("Invalid list");this.c=g,this.e++}i(g){if(g===this.b&&g===this.c)this.b=void 0,this.c=void 0;else if(g===this.b){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this.b=g.next}else if(g===this.c){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this.c=g.previous}else{const b=g.next,h=g.previous;if(!b||!h)throw new Error("Invalid list");b.previous=h,h.next=b}g.next=void 0,g.previous=void 0,this.e++}j(g,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(g===this.b)return;const h=g.next,v=g.previous;g===this.c?(v.next=void 0,this.c=v):(h.previous=v,v.next=h),g.previous=void 0,g.next=this.b,this.b.previous=g,this.b=g,this.e++}else if(b===2){if(g===this.c)return;const h=g.next,v=g.previous;g===this.b?(h.previous=void 0,this.b=h):(h.previous=v,v.next=h),g.next=void 0,g.previous=this.c,this.c.next=g,this.c=g,this.e++}}}toJSON(){const g=[];return this.forEach((b,h)=>{g.push([h,b])}),g}fromJSON(g){this.clear();for(const[b,h]of g)this.set(b,h)}}e.LinkedMap=I;class f extends I{constructor(g,b=1){super(),this.k=g,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(g){this.k=g,this.m()}get ratio(){return this.l}set ratio(g){this.l=Math.min(Math.max(0,g),1),this.m()}get(g,b=2){return super.get(g,b)}peek(g){return super.get(g,0)}set(g,b){return super.set(g,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=f}),define(ee[76],ie([0,1,39]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new E.LRUCache(1e4);function C(w){return m(w,"NFC",t)}e.normalizeNFC=C;const M=new E.LRUCache(1e4);function A(w){return m(w,"NFD",M)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function m(w,S,k){if(!w)return w;const I=k.get(w);if(I)return I;let f;return P.test(w)?f=w.normalize(S):f=w,k.set(w,f),f}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(S){return A(S).replace(w,"")}}()}),function(){function q(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function A(m){M.push(m,Date.now())}function P(){const m=[];for(let w=0;w<M.length;w+=2)m.push({name:M[w],startTime:M[w+1]});return m}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(C+A.startTime)});return M}};if(typeof process=="object"){const C=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function E(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=E(t))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var t in E)(typeof exports=="object"?exports:q)[t]=E[t]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function E(t){if(e[t])return e[t].exports;var C=e[t]={i:t,l:!1,exports:{}};return q[t].call(C.exports,C,C.exports,E),C.l=!0,C.exports}return E.m=q,E.c=e,E.d=function(t,C,M){E.o(t,C)||Object.defineProperty(t,C,{enumerable:!0,get:M})},E.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},E.t=function(t,C){if(1&C&&(t=E(t)),8&C||4&C&&typeof t=="object"&&t&&t.__esModule)return t;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:t}),2&C&&typeof t!="string")for(var A in t)E.d(M,A,function(P){return t[P]}.bind(null,A));return M},E.n=function(t){var C=t&&t.__esModule?function(){return t.default}:function(){return t};return E.d(C,"a",C),C},E.o=function(t,C){return Object.prototype.hasOwnProperty.call(t,C)},E.p="",E(E.s=0)}([function(q,e,E){(function(t){var C;e=q.exports=R,C=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],m=e.src=[],w=0,S=w++;m[S]="0|[1-9]\\d*";var k=w++;m[k]="[0-9]+";var I=w++;m[I]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=w++;m[f]="("+m[S]+")\\.("+m[S]+")\\.("+m[S]+")";var p=w++;m[p]="("+m[k]+")\\.("+m[k]+")\\.("+m[k]+")";var g=w++;m[g]="(?:"+m[S]+"|"+m[I]+")";var b=w++;m[b]="(?:"+m[k]+"|"+m[I]+")";var h=w++;m[h]="(?:-("+m[g]+"(?:\\."+m[g]+")*))";var v=w++;m[v]="(?:-?("+m[b]+"(?:\\."+m[b]+")*))";var d=w++;m[d]="[0-9A-Za-z-]+";var u=w++;m[u]="(?:\\+("+m[d]+"(?:\\."+m[d]+")*))";var c=w++,n="v?"+m[f]+m[h]+"?"+m[u]+"?";m[c]="^"+n+"$";var r="[v=\\s]*"+m[p]+m[v]+"?"+m[u]+"?",i=w++;m[i]="^"+r+"$";var a=w++;m[a]="((?:<|>)?=?)";var s=w++;m[s]=m[k]+"|x|X|\\*";var l=w++;m[l]=m[S]+"|x|X|\\*";var o=w++;m[o]="[v=\\s]*("+m[l]+")(?:\\.("+m[l]+")(?:\\.("+m[l]+")(?:"+m[h]+")?"+m[u]+"?)?)?";var y=w++;m[y]="[v=\\s]*("+m[s]+")(?:\\.("+m[s]+")(?:\\.("+m[s]+")(?:"+m[v]+")?"+m[u]+"?)?)?";var D=w++;m[D]="^"+m[a]+"\\s*"+m[o]+"$";var O=w++;m[O]="^"+m[a]+"\\s*"+m[y]+"$";var N=w++;m[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=w++;m[Y]="(?:~>?)";var G=w++;m[G]="(\\s*)"+m[Y]+"\\s+",P[G]=new RegExp(m[G],"g");var V=w++;m[V]="^"+m[Y]+m[o]+"$";var se=w++;m[se]="^"+m[Y]+m[y]+"$";var oe=w++;m[oe]="(?:\\^)";var re=w++;m[re]="(\\s*)"+m[oe]+"\\s+",P[re]=new RegExp(m[re],"g");var de=w++;m[de]="^"+m[oe]+m[o]+"$";var X=w++;m[X]="^"+m[oe]+m[y]+"$";var le=w++;m[le]="^"+m[a]+"\\s*("+r+")$|^$";var F=w++;m[F]="^"+m[a]+"\\s*("+n+")$|^$";var L=w++;m[L]="(\\s*)"+m[a]+"\\s*("+r+"|"+m[o]+")",P[L]=new RegExp(m[L],"g");var T=w++;m[T]="^\\s*("+m[o]+")\\s+-\\s+("+m[o]+")\\s*$";var U=w++;m[U]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var Q=w++;m[Q]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)C(B,m[B]),P[B]||(P[B]=new RegExp(m[B]));function H(Z,ue){if(Z instanceof R)return Z;if(typeof Z!="string"||Z.length>M||!(ue?P[i]:P[c]).test(Z))return null;try{return new R(Z,ue)}catch{return null}}function R(Z,ue){if(Z instanceof R){if(Z.loose===ue)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof R))return new R(Z,ue);C("SemVer",Z,ue),this.loose=ue;var he=Z.trim().match(ue?P[i]:P[c]);if(!he)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ie=+ye;if(Ie>=0&&Ie<A)return Ie}return ye}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=H,e.valid=function(Z,ue){var he=H(Z,ue);return he?he.version:null},e.clean=function(Z,ue){var he=H(Z.trim().replace(/^[=v]+/,""),ue);return he?he.version:null},e.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(Z){return C("SemVer.compare",this.version,this.loose,Z),Z instanceof R||(Z=new R(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},R.prototype.compareMain=function(Z){return Z instanceof R||(Z=new R(Z,this.loose)),$(this.major,Z.major)||$(this.minor,Z.minor)||$(this.patch,Z.patch)},R.prototype.comparePre=function(Z){if(Z instanceof R||(Z=new R(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ue=0;do{var he=this.prerelease[ue],ye=Z.prerelease[ue];if(C("prerelease compare",ue,he,ye),he===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(he===void 0)return-1;if(he!==ye)return $(he,ye)}while(++ue)},R.prototype.inc=function(Z,ue){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ue,he,ye){typeof he=="string"&&(ye=he,he=void 0);try{return new R(Z,he).inc(ue,ye).version}catch{return null}},e.diff=function(Z,ue){if(j(Z,ue))return null;var he=H(Z),ye=H(ue);if(he.prerelease.length||ye.prerelease.length){for(var Ie in he)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&he[Ie]!==ye[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in he)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&he[Ie]!==ye[Ie])return Ie},e.compareIdentifiers=$;var W=/^[0-9]+$/;function $(Z,ue){var he=W.test(Z),ye=W.test(ue);return he&&ye&&(Z=+Z,ue=+ue),he&&!ye?-1:ye&&!he?1:Z<ue?-1:Z>ue?1:0}function z(Z,ue,he){return new R(Z,he).compare(new R(ue,he))}function J(Z,ue,he){return z(Z,ue,he)>0}function ne(Z,ue,he){return z(Z,ue,he)<0}function j(Z,ue,he){return z(Z,ue,he)===0}function x(Z,ue,he){return z(Z,ue,he)!==0}function _(Z,ue,he){return z(Z,ue,he)>=0}function ae(Z,ue,he){return z(Z,ue,he)<=0}function ge(Z,ue,he,ye){var Ie;switch(ue){case"===":typeof Z=="object"&&(Z=Z.version),typeof he=="object"&&(he=he.version),Ie=Z===he;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof he=="object"&&(he=he.version),Ie=Z!==he;break;case"":case"=":case"==":Ie=j(Z,he,ye);break;case"!=":Ie=x(Z,he,ye);break;case">":Ie=J(Z,he,ye);break;case">=":Ie=_(Z,he,ye);break;case"<":Ie=ne(Z,he,ye);break;case"<=":Ie=ae(Z,he,ye);break;default:throw new TypeError("Invalid operator: "+ue)}return Ie}function Me(Z,ue){if(Z instanceof Me){if(Z.loose===ue)return Z;Z=Z.value}if(!(this instanceof Me))return new Me(Z,ue);C("comparator",Z,ue),this.loose=ue,this.parse(Z),this.semver===Oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(Z,ue){return $(ue,Z)},e.major=function(Z,ue){return new R(Z,ue).major},e.minor=function(Z,ue){return new R(Z,ue).minor},e.patch=function(Z,ue){return new R(Z,ue).patch},e.compare=z,e.compareLoose=function(Z,ue){return z(Z,ue,!0)},e.rcompare=function(Z,ue,he){return z(ue,Z,he)},e.sort=function(Z,ue){return Z.sort(function(he,ye){return e.compare(he,ye,ue)})},e.rsort=function(Z,ue){return Z.sort(function(he,ye){return e.rcompare(he,ye,ue)})},e.gt=J,e.lt=ne,e.eq=j,e.neq=x,e.gte=_,e.lte=ae,e.cmp=ge,e.Comparator=Me;var Oe={};function De(Z,ue){if(Z instanceof De)return Z.loose===ue?Z:new De(Z.raw,ue);if(Z instanceof Me)return new De(Z.value,ue);if(!(this instanceof De))return new De(Z,ue);if(this.loose=ue,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Re(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function ve(Z,ue,he,ye,Ie,We,Te,ze,Be,qe,Ye,je,Xe){return((ue=Re(he)?"":Re(ye)?">="+he+".0.0":Re(Ie)?">="+he+"."+ye+".0":">="+ue)+" "+(ze=Re(Be)?"":Re(qe)?"<"+(+Be+1)+".0.0":Re(Ye)?"<"+Be+"."+(+qe+1)+".0":je?"<="+Be+"."+qe+"."+Ye+"-"+je:"<="+ze)).trim()}function we(Z,ue){for(var he=0;he<Z.length;he++)if(!Z[he].test(ue))return!1;if(ue.prerelease.length){for(he=0;he<Z.length;he++)if(C(Z[he].semver),Z[he].semver!==Oe&&Z[he].semver.prerelease.length>0){var ye=Z[he].semver;if(ye.major===ue.major&&ye.minor===ue.minor&&ye.patch===ue.patch)return!0}return!1}return!0}function be(Z,ue,he){try{ue=new De(ue,he)}catch{return!1}return ue.test(Z)}function Ce(Z,ue,he,ye){var Ie,We,Te,ze,Be;switch(Z=new R(Z,ye),ue=new De(ue,ye),he){case">":Ie=J,We=ae,Te=ne,ze=">",Be=">=";break;case"<":Ie=ne,We=_,Te=J,ze="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(Z,ue,ye))return!1;for(var qe=0;qe<ue.set.length;++qe){var Ye=ue.set[qe],je=null,Xe=null;if(Ye.forEach(function(K){K.semver===Oe&&(K=new Me(">=0.0.0")),je=je||K,Xe=Xe||K,Ie(K.semver,je.semver,ye)?je=K:Te(K.semver,Xe.semver,ye)&&(Xe=K)}),je.operator===ze||je.operator===Be||(!Xe.operator||Xe.operator===ze)&&We(Z,Xe.semver)||Xe.operator===Be&&Te(Z,Xe.semver))return!1}return!0}Me.prototype.parse=function(Z){var ue=this.loose?P[le]:P[F],he=Z.match(ue);if(!he)throw new TypeError("Invalid comparator: "+Z);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new R(he[2],this.loose):this.semver=Oe},Me.prototype.toString=function(){return this.value},Me.prototype.test=function(Z){return C("Comparator.test",Z,this.loose),this.semver===Oe||(typeof Z=="string"&&(Z=new R(Z,this.loose)),ge(Z,this.operator,this.semver,this.loose))},Me.prototype.intersects=function(Z,ue){if(!(Z instanceof Me))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new De(Z.value,ue),be(this.value,he,ue);if(Z.operator==="")return he=new De(this.value,ue),be(Z.semver,he,ue);var ye=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),We=this.semver.version===Z.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),ze=ge(this.semver,"<",Z.semver,ue)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Be=ge(this.semver,">",Z.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return ye||Ie||We&&Te||ze||Be},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(Z){var ue=this.loose;Z=Z.trim(),C("range",Z,ue);var he=ue?P[U]:P[T];Z=Z.replace(he,ve),C("hyphen replace",Z),Z=Z.replace(P[L],"$1$2$3"),C("comparator trim",Z,P[L]),Z=(Z=(Z=Z.replace(P[G],"$1~")).replace(P[re],"$1^")).split(/\s+/).join(" ");var ye=ue?P[le]:P[F],Ie=Z.split(" ").map(function(We){return function(Te,ze){return C("comp",Te),Te=function(Be,qe){return Be.trim().split(/\s+/).map(function(Ye){return function(je,Xe){C("caret",je,Xe);var K=Xe?P[X]:P[de];return je.replace(K,function(ce,fe,me,Se,Le){var Ne;return C("caret",je,ce,fe,me,Se,Le),Re(fe)?Ne="":Re(me)?Ne=">="+fe+".0.0 <"+(+fe+1)+".0.0":Re(Se)?Ne=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Le?(C("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ne=fe==="0"?me==="0"?">="+fe+"."+me+"."+Se+Le+" <"+fe+"."+me+"."+(+Se+1):">="+fe+"."+me+"."+Se+Le+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Se+Le+" <"+(+fe+1)+".0.0"):(C("no pr"),Ne=fe==="0"?me==="0"?">="+fe+"."+me+"."+Se+" <"+fe+"."+me+"."+(+Se+1):">="+fe+"."+me+"."+Se+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Se+" <"+(+fe+1)+".0.0"),C("caret return",Ne),Ne})}(Ye,qe)}).join(" ")}(Te,ze),C("caret",Te),Te=function(Be,qe){return Be.trim().split(/\s+/).map(function(Ye){return function(je,Xe){var K=Xe?P[se]:P[V];return je.replace(K,function(ce,fe,me,Se,Le){var Ne;return C("tilde",je,ce,fe,me,Se,Le),Re(fe)?Ne="":Re(me)?Ne=">="+fe+".0.0 <"+(+fe+1)+".0.0":Re(Se)?Ne=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Le?(C("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ne=">="+fe+"."+me+"."+Se+Le+" <"+fe+"."+(+me+1)+".0"):Ne=">="+fe+"."+me+"."+Se+" <"+fe+"."+(+me+1)+".0",C("tilde return",Ne),Ne})}(Ye,qe)}).join(" ")}(Te,ze),C("tildes",Te),Te=function(Be,qe){return C("replaceXRanges",Be,qe),Be.split(/\s+/).map(function(Ye){return function(je,Xe){je=je.trim();var K=Xe?P[O]:P[D];return je.replace(K,function(ce,fe,me,Se,Le,Ne){C("xRange",je,ce,fe,me,Se,Le,Ne);var it=Re(me),Ze=it||Re(Se),Ve=Ze||Re(Le);return fe==="="&&Ve&&(fe=""),it?ce=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Ve?(Ze&&(Se=0),Ve&&(Le=0),fe===">"?(fe=">=",Ze?(me=+me+1,Se=0,Le=0):Ve&&(Se=+Se+1,Le=0)):fe==="<="&&(fe="<",Ze?me=+me+1:Se=+Se+1),ce=fe+me+"."+Se+"."+Le):Ze?ce=">="+me+".0.0 <"+(+me+1)+".0.0":Ve&&(ce=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),C("xRange return",ce),ce})}(Ye,qe)}).join(" ")}(Te,ze),C("xrange",Te),Te=function(Be,qe){return C("replaceStars",Be,qe),Be.trim().replace(P[Q],"")}(Te,ze),C("stars",Te),Te}(We,ue)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(We){return!!We.match(ye)})),Ie=Ie.map(function(We){return new Me(We,ue)})},De.prototype.intersects=function(Z,ue){if(!(Z instanceof De))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(ye){return Z.set.some(function(Ie){return Ie.every(function(We){return ye.intersects(We,ue)})})})})},e.toComparators=function(Z,ue){return new De(Z,ue).set.map(function(he){return he.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},De.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new R(Z,this.loose));for(var ue=0;ue<this.set.length;ue++)if(we(this.set[ue],Z))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(Z,ue,he){var ye=null,Ie=null;try{var We=new De(ue,he)}catch{return null}return Z.forEach(function(Te){We.test(Te)&&(ye&&Ie.compare(Te)!==-1||(Ie=new R(ye=Te,he)))}),ye},e.minSatisfying=function(Z,ue,he){var ye=null,Ie=null;try{var We=new De(ue,he)}catch{return null}return Z.forEach(function(Te){We.test(Te)&&(ye&&Ie.compare(Te)!==1||(Ie=new R(ye=Te,he)))}),ye},e.validRange=function(Z,ue){try{return new De(Z,ue).range||"*"}catch{return null}},e.ltr=function(Z,ue,he){return Ce(Z,ue,"<",he)},e.gtr=function(Z,ue,he){return Ce(Z,ue,">",he)},e.outside=Ce,e.prerelease=function(Z,ue){var he=H(Z,ue);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(Z,ue,he){return Z=new De(Z,he),ue=new De(ue,he),Z.intersects(ue)},e.coerce=function(Z){if(Z instanceof R)return Z;if(typeof Z!="string")return null;var ue=Z.match(P[N]);return ue==null?null:H((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,E(1))},function(q,e){var E,t,C=q.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(b){if(E===setTimeout)return setTimeout(b,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(b,0);try{return E(b,0)}catch{try{return E.call(null,b,0)}catch{return E.call(this,b,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var m,w=[],S=!1,k=-1;function I(){S&&m&&(S=!1,m.length?w=m.concat(w):k=-1,w.length&&f())}function f(){if(!S){var b=P(I);S=!0;for(var h=w.length;h;){for(m=w,w=[];++k<h;)m&&m[k].run();k=-1,h=w.length}m=null,S=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(b)}}function p(b,h){this.fun=b,this.array=h}function g(){}C.nextTick=function(b){var h=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)h[v-1]=arguments[v];w.push(new p(b,h)),w.length!==1||S||P(f)},p.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=g,C.addListener=g,C.once=g,C.off=g,C.removeListener=g,C.removeAllListeners=g,C.emit=g,C.prependListener=g,C.prependOnceListener=g,C.listeners=function(b){return[]},C.binding=function(b){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(b){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ee[125],ie([0,1]),function(q,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(P,m,w){this.level=P,this.key=m,this.value=w,this.forward=[]}}const C=void 0;class M{constructor(P,m=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(m)|0),this.e=new t(this.c,C,C)}get size(){return this.f}clear(){this.e=new t(this.c,C,C)}has(P){return Boolean(M.g(this,P,this.comparator))}get(P){return M.g(this,P,this.comparator)?.value}set(P,m){return M.h(this,P,m,this.comparator)&&(this.f+=1),this}delete(P){const m=M.k(this,P,this.comparator);return m&&(this.f-=1),m}forEach(P,m){let w=this.e.forward[0];for(;w;)P.call(m,w.value,w.key,this),w=w.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",m=this.e.forward[0];for(;m;)P+=`node(${m.key}, ${m.value}, lvl:${m.level})`,m=m.forward[0];return P}static g(P,m,w){let S=P.e;for(let k=P.d-1;k>=0;k--)for(;S.forward[k]&&w(S.forward[k].key,m)<0;)S=S.forward[k];if(S=S.forward[0],S&&w(S.key,m)===0)return S}static h(P,m,w,S){const k=[];let I=P.e;for(let f=P.d-1;f>=0;f--){for(;I.forward[f]&&S(I.forward[f].key,m)<0;)I=I.forward[f];k[f]=I}if(I=I.forward[0],I&&S(I.key,m)===0)return I.value=w,!1;{const f=M.j(P);if(f>P.d){for(let p=P.d;p<f;p++)k[p]=P.e;P.d=f}I=new t(f,m,w);for(let p=0;p<f;p++)I.forward[p]=k[p].forward[p],k[p].forward[p]=I;return!0}}static j(P,m=.5){let w=1;for(;Math.random()<m&&w<P.c;)w+=1;return w}static k(P,m,w){const S=[];let k=P.e;for(let I=P.d-1;I>=0;I--){for(;k.forward[I]&&w(k.forward[I].key,m)<0;)k=k.forward[I];S[I]=k}if(k=k.forward[0],!k||w(k.key,m)!==0)return!1;for(let I=0;I<P.d&&S[I].forward[I]===k;I++)S[I].forward[I]=k.forward[I];for(;P.d>0&&P.e.forward[P.d-1]===C;)P.d-=1;return!0}}e.SkipList=M}),define(ee[57],ie([0,1,15,2]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(u){const c=u;return c?typeof c.read=="function":!1}e.isReadable=C;function M(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=M;function A(u){const c=u;return c?M(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(u,c){return new m(u,c)}e.newWriteableStream=P;class m{constructor(c,n){this.e=c,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(n=>n(c))}h(c){this.c.error.length===0?(0,E.onUnexpectedError)(c):this.c.error.slice(0).forEach(n=>n(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,n){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(c,n){if(this.a.destroyed)return;let r;switch(c){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(u,c){const n=[];let r;for(;(r=u.read())!==null;)n.push(r);return c(n)}e.consumeReadable=w;function S(u,c,n){const r=[];let i;for(;(i=u.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const a=i;return i=void 0,a}return u.read()}}}e.peekReadable=S;function k(u,c){return new Promise((n,r)=>{const i=[];I(u,{onData:a=>{c&&i.push(a)},onError:a=>{c?r(a):n(void 0)},onEnd:()=>{n(c?c(i):void 0)}})})}e.consumeStream=k;function I(u,c){let n=!1;return u.on("error",r=>{n||c.onError(r)}),u.on("end",()=>{n||c.onEnd()}),u.on("data",r=>{n||c.onData(r)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=I;function f(u,c){return new Promise((n,r)=>{const i=new t.DisposableStore,a=[],s=y=>{if(a.push(y),a.length>c)return i.dispose(),u.pause(),n({stream:u,buffer:a,ended:!1})},l=y=>r(y),o=()=>n({stream:u,buffer:a,ended:!0});i.add((0,t.toDisposable)(()=>u.removeListener("error",l))),u.on("error",l),i.add((0,t.toDisposable)(()=>u.removeListener("end",o))),u.on("end",o),i.add((0,t.toDisposable)(()=>u.removeListener("data",s))),u.on("data",s)})}e.peekStream=f;function p(u,c){const n=P(c);return n.end(u),n}e.toStream=p;function g(){const u=P(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=g;function b(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=b;function h(u,c,n){const r=P(n);return I(u,{onData:i=>r.write(c.data(i)),onError:i=>r.error(c.error?c.error(i):i),onEnd:()=>r.end()}),r}e.transform=h;function v(u,c,n){let r=!1;return{read:()=>{const i=c.read();return r?i:(r=!0,i!==null?n([u,i]):u)}}}e.prefixedReadable=v;function d(u,c,n){let r=!1;const i=P(n);return I(c,{onData:a=>r?i.write(a):(r=!0,i.write(n([u,a]))),onError:a=>i.error(a),onEnd:()=>{r||(r=!0,i.write(u)),i.end()}}),i}e.prefixedStream=d}),define(ee[17],ie([0,1,57]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let C,M;class A{static alloc(y){return t?new A(Buffer.allocUnsafe(y)):new A(new Uint8Array(y))}static wrap(y){return t&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new A(y)}static fromString(y,D){return!(D?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(y)):(C||(C=new TextEncoder),new A(C.encode(y)))}static fromByteArray(y){const D=A.alloc(y.length);for(let O=0,N=y.length;O<N;O++)D.buffer[O]=y[O];return D}static concat(y,D){if(typeof D>"u"){D=0;for(let Y=0,G=y.length;Y<G;Y++)D+=y[Y].byteLength}const O=A.alloc(D);let N=0;for(let Y=0,G=y.length;Y<G;Y++){const V=y[Y];O.set(V,N),N+=V.byteLength}return O}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=A.alloc(this.byteLength);return y.set(this),y}toString(){return t?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(y,D){return new A(this.buffer.subarray(y,D))}set(y,D){if(y instanceof A)this.buffer.set(y.buffer,D);else if(y instanceof Uint8Array)this.buffer.set(y,D);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),D);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return w(this.buffer,y)}writeUInt32BE(y,D){S(this.buffer,y,D)}readUInt32LE(y){return k(this.buffer,y)}writeUInt32LE(y,D){I(this.buffer,y,D)}readUInt8(y){return f(this.buffer,y)}writeUInt8(y,D){p(this.buffer,y,D)}}e.VSBuffer=A;function P(o,y){return o[y+0]<<0>>>0|o[y+1]<<8>>>0}e.readUInt16LE=P;function m(o,y,D){o[D+0]=y&255,y=y>>>8,o[D+1]=y&255}e.writeUInt16LE=m;function w(o,y){return o[y]*2**24+o[y+1]*2**16+o[y+2]*2**8+o[y+3]}e.readUInt32BE=w;function S(o,y,D){o[D+3]=y,y=y>>>8,o[D+2]=y,y=y>>>8,o[D+1]=y,y=y>>>8,o[D]=y}e.writeUInt32BE=S;function k(o,y){return o[y+0]<<0>>>0|o[y+1]<<8>>>0|o[y+2]<<16>>>0|o[y+3]<<24>>>0}e.readUInt32LE=k;function I(o,y,D){o[D+0]=y&255,y=y>>>8,o[D+1]=y&255,y=y>>>8,o[D+2]=y&255,y=y>>>8,o[D+3]=y&255}e.writeUInt32LE=I;function f(o,y){return o[y]}e.readUInt8=f;function p(o,y,D){o[D]=y}e.writeUInt8=p;function g(o){return E.consumeReadable(o,y=>A.concat(y))}e.readableToBuffer=g;function b(o){return E.toReadable(o)}e.bufferToReadable=b;function h(o){return E.consumeStream(o,y=>A.concat(y))}e.streamToBuffer=h;async function v(o){return o.ended?A.concat(o.buffer):A.concat([...o.buffer,await h(o.stream)])}e.bufferedStreamToBuffer=v;function d(o){return E.toStream(o,y=>A.concat(y))}e.bufferToStream=d;function u(o){return E.transform(o,{data:y=>typeof y=="string"?A.fromString(y):A.wrap(y)},y=>A.concat(y))}e.streamToBufferReadableStream=u;function c(o){return E.newWriteableStream(y=>A.concat(y),o)}e.newWriteableBufferStream=c;function n(o,y){return E.prefixedReadable(o,y,D=>A.concat(D))}e.prefixedBufferReadable=n;function r(o,y){return E.prefixedStream(o,y,D=>A.concat(D))}e.prefixedBufferStream=r;function i(o){let y=0,D=0,O=0;const N=new Uint8Array(Math.floor(o.length/4*3)),Y=V=>{switch(D){case 3:N[O++]=y|V,D=0;break;case 2:N[O++]=y|V>>>2,y=V<<6,D=3;break;case 1:N[O++]=y|V>>>4,y=V<<4,D=2;break;default:y=V<<2,D=1}};for(let V=0;V<o.length;V++){const se=o.charCodeAt(V);if(se>=65&&se<=90)Y(se-65);else if(se>=97&&se<=122)Y(se-97+26);else if(se>=48&&se<=57)Y(se-48+52);else if(se===43||se===45)Y(62);else if(se===47||se===95)Y(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${o[V]}`)}}const G=O;for(;D>0;)Y(0);return A.wrap(N).slice(0,G)}e.decodeBase64=i;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:o},y=!0,D=!1){const O=D?s:a;let N="";const Y=o.byteLength%3;let G=0;for(;G<o.byteLength-Y;G+=3){const V=o[G+0],se=o[G+1],oe=o[G+2];N+=O[V>>>2],N+=O[(V<<4|se>>>4)&63],N+=O[(se<<2|oe>>>6)&63],N+=O[oe&63]}if(Y===1){const V=o[G+0];N+=O[V>>>2],N+=O[V<<4&63],y&&(N+="==")}else if(Y===2){const V=o[G+0],se=o[G+1];N+=O[V>>>2],N+=O[(V<<4|se>>>4)&63],N+=O[se<<2&63],y&&(N+="=")}return N}e.encodeBase64=l}),define(ee[12],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(r){return typeof r=="string"}e.isString=E;function t(r){return Array.isArray(r)&&r.every(i=>E(i))}e.isStringArray=t;function C(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=C;function M(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.isTypedArray=M;function A(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=A;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function m(r){return r===!0||r===!1}e.isBoolean=m;function w(r){return typeof r>"u"}e.isUndefined=w;function S(r){return!k(r)}e.isDefined=S;function k(r){return w(r)||r===null}e.isUndefinedOrNull=k;function I(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=I;function f(r){if(k(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=f;function p(...r){const i=[];for(let a=0;a<r.length;a++){const s=r[a];if(k(s))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(s)}return i}e.assertAllDefined=p;const g=Object.prototype.hasOwnProperty;function b(r){if(!C(r))return!1;for(const i in r)if(g.call(r,i))return!1;return!0}e.isEmptyObject=b;function h(r){return typeof r=="function"}e.isFunction=h;function v(...r){return r.length>0&&r.every(h)}e.areFunctions=v;function d(r,i){const a=Math.min(r.length,i.length);for(let s=0;s<a;s++)u(r[s],i[s])}e.validateConstraints=d;function u(r,i){if(E(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if(r instanceof i)return}catch{}if(!k(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function c(r){return r===null?void 0:r}e.withNullAsUndefined=c;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(ee[50],ie([0,1,12]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([d,u])=>{v[d]=u&&typeof u=="object"?t(u):u}),v}e.deepClone=t;function C(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const d=v.shift();Object.freeze(d);for(const u in d)if(M.call(d,u)){const c=d[u];typeof c=="object"&&!Object.isFrozen(c)&&!(0,E.isTypedArray)(c)&&v.push(c)}}return h}e.deepFreeze=C;const M=Object.prototype.hasOwnProperty;function A(h,v){return P(h,v,new Set)}e.cloneAndChange=A;function P(h,v,d){if((0,E.isUndefinedOrNull)(h))return h;const u=v(h);if(typeof u<"u")return u;if(Array.isArray(h)){const c=[];for(const n of h)c.push(P(n,v,d));return c}if((0,E.isObject)(h)){if(d.has(h))throw new Error("Cannot clone recursive data-structure");d.add(h);const c={};for(const n in h)M.call(h,n)&&(c[n]=P(h[n],v,d));return d.delete(h),c}return h}function m(h,v,d=!0){return(0,E.isObject)(h)?((0,E.isObject)(v)&&Object.keys(v).forEach(u=>{u in h?d&&((0,E.isObject)(h[u])&&(0,E.isObject)(v[u])?m(h[u],v[u],d):h[u]=v[u]):h[u]=v[u]}),h):v}e.mixin=m;function w(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let d,u;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(d=0;d<h.length;d++)if(!w(h[d],v[d]))return!1}else{const c=[];for(u in h)c.push(u);c.sort();const n=[];for(u in v)n.push(u);if(n.sort(),!w(c,n))return!1;for(d=0;d<c.length;d++)if(!w(h[c[d]],v[c[d]]))return!1}return!0}e.equals=w;function S(h){const v=new Set;return JSON.stringify(h,(d,u)=>{if((0,E.isObject)(u)||Array.isArray(u)){if(v.has(u))return"[Circular]";v.add(u)}return u})}e.safeStringify=S;function k(h,v){const d=Object.create(null);return!h||!v||Object.keys(v).forEach(c=>{const n=h[c],r=v[c];w(n,r)||(d[c]=r)}),d}e.distinct=k;function I(h,v){const d=v.toLowerCase(),u=Object.keys(h).find(c=>c.toLowerCase()===d);return u?h[u]:h[v]}e.getCaseInsensitive=I;function f(h,v){const d=Object.create(null);for(const[u,c]of Object.entries(h))v(u,c)&&(d[u]=c);return d}e.filter=f;function p(h){let v=[],d=Object.getPrototypeOf(h);for(;Object.prototype!==d;)v=v.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return v}e.getAllPropertyNames=p;function g(h){const v=[];for(const d of p(h))typeof h[d]=="function"&&v.push(d);return v}e.getAllMethodNames=g;function b(h,v){const d=c=>function(){const n=Array.prototype.slice.call(arguments,0);return v(c,n)},u={};for(const c of h)u[c]=d(c);return u}e.createProxyObject=b}),define(ee[29],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return E.test(C)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(P){for(let m=0;m<P.length;m++)P[m]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let m=0,w="";return w+=A[M[m++]],w+=A[M[m++]],w+=A[M[m++]],w+=A[M[m++]],w+="-",w+=A[M[m++]],w+=A[M[m++]],w+="-",w+=A[M[m++]],w+=A[M[m++]],w+="-",w+=A[M[m++]],w+=A[M[m++]],w+="-",w+=A[M[m++]],w+=A[M[m++]],w+=A[M[m++]],w+=A[M[m++]],w+=A[M[m++]],w+=A[M[m++]],w}}()}),define(ee[126],ie([0,1,77,40,49]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(A,P){if(await new Promise((S,k)=>{const I=t.createReadStream(A),f=E.createHash("sha1");I.pipe(f);const p=(0,C.once)((g,b)=>{I.removeAllListeners(),f.removeAllListeners(),g?k(g):S(b)});I.once("error",p),I.once("end",p),f.once("error",p),f.once("data",g=>p(void 0,g.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=M}),define(ee[127],ie([0,1,27]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(A){const P=A.replace(/\-/g,":").toLowerCase();return!t.has(P)}function M(){const A=(0,E.networkInterfaces)();for(const P in A){const m=A[P];if(m){for(const{mac:w}of m)if(C(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=M}),define(ee[96],ie([0,1,78]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(P,m,w,S=1){let k=!1;return new Promise(I=>{const f=setTimeout(()=>{if(!k)return k=!0,I(0)},w);C(P,m,S,p=>{if(!k)return k=!0,clearTimeout(f),I(p)})})}e.findFreePort=t;function C(P,m,w,S){if(m===0)return S(0);const k=new E.Socket;k.once("connect",()=>(A(k),C(P+w,m-1,w,S))),k.once("data",()=>{}),k.once("error",I=>(A(k),I.code!=="ECONNREFUSED"?C(P+w,m-1,w,S):S(P))),k.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(P,m,w,S="127.0.0.1"){let k=!1,I,f=1;const p=E.createServer({pauseOnConnect:!0});function g(b,h){k||(k=!0,p.removeAllListeners(),p.close(),I&&clearTimeout(I),h(b))}return new Promise(b=>{I=setTimeout(()=>{g(0,b)},w),p.on("listening",()=>{g(P,b)}),p.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&f<m?(P++,f++,p.listen(P,S)):g(0,b)}),p.on("close",()=>{g(0,b)}),p.listen(P,S)})}e.findFreePortFaster=M;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(m){console.error(m)}}}),define(ee[128],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[129],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(C,M){this.a=C,this.onMessage=M}send(C){try{this.a.send("vscode:message",C.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(ee[41],ie([0,1,13,15]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class C{constructor(){this.a=new WeakMap}on(A,P){const m=(w,...S)=>{this.b(A,w)&&P(w,...S)};return this.a.set(P,m),E.ipcMain.on(A,m),this}once(A,P){return E.ipcMain.once(A,(m,...w)=>{this.b(A,m)&&P(m,...w)}),this}handle(A,P){return E.ipcMain.handle(A,(m,...w)=>this.b(A,m)?P(m,...w):Promise.reject(`Invalid channel '${A}' or sender for ipcMain.handle() usage.`)),this}removeHandler(A){return E.ipcMain.removeHandler(A),this}removeListener(A,P){const m=this.a.get(P);return m&&(E.ipcMain.removeListener(A,m),this.a.delete(P)),this}b(A,P){if(!A||!A.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because the channel is unknown.`),!1;const m=P.senderFrame,w=m.url;if(!w)return!0;let S="unknown";try{S=new URL(w).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a malformed URL '${w}'.`),!1}return S!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a bad origin of '${S}'.`),!1):m.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because sender of origin '${S}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new C}),define(ee[130],ie([0,1,13,41,12,128]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function A(){t.validatedIpcMain.on(M.CONTEXT_MENU_CHANNEL,(m,w,S,k,I)=>{const f=P(m,k,S);f.popup({window:(0,C.withNullAsUndefined)(E.BrowserWindow.fromWebContents(m.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{f&&m.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=A;function P(m,w,S){const k=new E.Menu;return S.forEach(I=>{let f;I.type==="separator"?f=new E.MenuItem({type:I.type}):Array.isArray(I.submenu)?f=new E.MenuItem({submenu:P(m,w,I.submenu),label:I.label}):f=new E.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(p,g,b)=>m.sender.send(w,I.id,b)}),k.append(f)}),k}}),define(ee[131],ie([11,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(ee[132],ie([0,1,131]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,C=t*60,M=C*24,A=M*7,P=M*30,m=M*365;function w(k,I,f){typeof k!="number"&&(k=k.getTime());const p=Math.round((new Date().getTime()-k)/1e3);if(p<-30)return(0,E.localize)(0,null,w(new Date().getTime()+p*1e3,!1));if(p<30)return(0,E.localize)(1,null);let g;return p<t?(g=p,I?g===1?f?(0,E.localize)(2,null,g):(0,E.localize)(3,null,g):f?(0,E.localize)(4,null,g):(0,E.localize)(5,null,g):g===1?f?(0,E.localize)(6,null,g):(0,E.localize)(7,null,g):f?(0,E.localize)(8,null,g):(0,E.localize)(9,null,g)):p<C?(g=Math.floor(p/t),I?g===1?f?(0,E.localize)(10,null,g):(0,E.localize)(11,null,g):f?(0,E.localize)(12,null,g):(0,E.localize)(13,null,g):g===1?f?(0,E.localize)(14,null,g):(0,E.localize)(15,null,g):f?(0,E.localize)(16,null,g):(0,E.localize)(17,null,g)):p<M?(g=Math.floor(p/C),I?g===1?f?(0,E.localize)(18,null,g):(0,E.localize)(19,null,g):f?(0,E.localize)(20,null,g):(0,E.localize)(21,null,g):g===1?f?(0,E.localize)(22,null,g):(0,E.localize)(23,null,g):f?(0,E.localize)(24,null,g):(0,E.localize)(25,null,g)):p<A?(g=Math.floor(p/M),I?g===1?(0,E.localize)(26,null,g):(0,E.localize)(27,null,g):g===1?(0,E.localize)(28,null,g):(0,E.localize)(29,null,g)):p<P?(g=Math.floor(p/A),I?g===1?f?(0,E.localize)(30,null,g):(0,E.localize)(31,null,g):f?(0,E.localize)(32,null,g):(0,E.localize)(33,null,g):g===1?f?(0,E.localize)(34,null,g):(0,E.localize)(35,null,g):f?(0,E.localize)(36,null,g):(0,E.localize)(37,null,g)):p<m?(g=Math.floor(p/P),I?g===1?f?(0,E.localize)(38,null,g):(0,E.localize)(39,null,g):f?(0,E.localize)(40,null,g):(0,E.localize)(41,null,g):g===1?f?(0,E.localize)(42,null,g):(0,E.localize)(43,null,g):f?(0,E.localize)(44,null,g):(0,E.localize)(45,null,g)):(g=Math.floor(p/m),I?g===1?f?(0,E.localize)(46,null,g):(0,E.localize)(47,null,g):f?(0,E.localize)(48,null,g):(0,E.localize)(49,null,g):g===1?f?(0,E.localize)(50,null,g):(0,E.localize)(51,null,g):f?(0,E.localize)(52,null,g):(0,E.localize)(53,null,g))}e.fromNow=w;function S(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=S}),define(ee[133],ie([11,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(ee[44],ie([0,1,24,12,133]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(k,I){return I&&(k.stack||k.stacktrace)?C.localize(0,null,P(k),A(k.stack)||A(k.stacktrace)):P(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function m(k=null,I=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const f=E.coalesce(k),p=m(f[0],I);return f.length>1?C.localize(4,null,p,f.length):p}if(t.isString(k))return k;if(k.detail){const f=k.detail;if(f.error)return M(f.error,I);if(f.exception)return M(f.exception,I)}return k.stack?M(k,I):k.message?k.message:C.localize(5,null)}e.toErrorMessage=m;function w(k){const I=k;return I instanceof Error&&Array.isArray(I.actions)}e.isErrorWithActions=w;function S(k,I){let f;return typeof k=="string"?f=new Error(k):f=k,f.actions=I,f}e.createErrorWithActions=S}),define(ee[134],ie([11,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(ee[135],ie([0,1,134]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(C){switch(C){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ee[136],ie([11,10]),function(q,e){return q.create("vs/base/common/platform",e)}),define(ee[4],ie([0,1,136]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,C=!1,M=!1,A=!1,P=!1,m=!1,w=!1,S=!1,k=!1,I=!1,f,p=e.LANGUAGE_DEFAULT,g,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const v=typeof h?.versions?.electron=="string",d=v&&h?.type==="renderer";if(typeof navigator=="object"&&!d)b=navigator.userAgent,t=b.indexOf("Windows")>=0,C=b.indexOf("Macintosh")>=0,S=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=b.indexOf("Linux")>=0,I=b?.indexOf("Mobi")>=0,m=!0,f=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,p=f;else if(typeof h=="object"){t=h.platform==="win32",C=h.platform==="darwin",M=h.platform==="linux",A=M&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,w=v,k=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const o=h.env.VSCODE_NLS_CONFIG;if(o)try{const y=JSON.parse(o),D=y.availableLanguages["*"];f=y.locale,p=D||e.LANGUAGE_DEFAULT,g=y._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var u;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(u=e.Platform||(e.Platform={}));function c(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let n=0;C?n=1:t?n=3:M&&(n=2),e.isWindows=t,e.isMacintosh=C,e.isLinux=M,e.isLinuxSnap=A,e.isNative=P,e.isElectron=w,e.isWeb=m,e.isWebWorker=m&&typeof e.globals.importScripts=="function",e.isIOS=S,e.isMobile=I,e.isCI=k,e.platform=n,e.userAgent=b,e.language=p;var r;(function(o){function y(){return e.language}o.value=y;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=D;function O(){return e.language==="en"}o.isDefault=O})(r=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let O=0,N=o.length;O<N;O++){const Y=o[O];if(Y.id===D.data.vscodeScheduleAsyncWork){o.splice(O,1),Y.callback();return}}});let y=0;return D=>{const O=++y;o.push({id:O,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:O},"*")}}return o=>setTimeout(o)})();var i;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||S?2:t?1:3;let a=!0,s=!1;function l(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[32],ie([0,1,4]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const C=E.globals.vscode.process;t={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ee[9],ie([0,1,32]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,C=97,M=90,A=122,P=46,m=47,w=92,S=58,k=63;class I extends Error{constructor(u,c,n){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const i=u.indexOf(".")!==-1?"property":"argument";let a=`The "${u}" ${i} ${r} of type ${c}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(d,u){if(typeof d!="string")throw new I(u,"string",d)}function p(d){return d===m||d===w}function g(d){return d===m}function b(d){return d>=t&&d<=M||d>=C&&d<=A}function h(d,u,c,n){let r="",i=0,a=-1,s=0,l=0;for(let o=0;o<=d.length;++o){if(o<d.length)l=d.charCodeAt(o);else{if(n(l))break;l=m}if(n(l)){if(!(a===o-1||s===1))if(s===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const y=r.lastIndexOf(c);y===-1?(r="",i=0):(r=r.slice(0,y),i=r.length-1-r.lastIndexOf(c)),a=o,s=0;continue}else if(r.length!==0){r="",i=0,a=o,s=0;continue}}u&&(r+=r.length>0?`${c}..`:"..",i=2)}else r.length>0?r+=`${c}${d.slice(a+1,o)}`:r=d.slice(a+1,o),i=o-a-1;a=o,s=0}else l===P&&s!==-1?++s:s=-1}return r}function v(d,u){if(u===null||typeof u!="object")throw new I("pathObject","Object",u);const c=u.dir||u.root,n=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${n}`:`${c}${d}${n}`:n}e.win32={resolve(...d){let u="",c="",n=!1;for(let r=d.length-1;r>=-1;r--){let i;if(r>=0){if(i=d[r],f(i,"path"),i.length===0)continue}else u.length===0?i=E.cwd():(i=E.env[`=${u}`]||E.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==u.toLowerCase()&&i.charCodeAt(2)===w)&&(i=`${u}\\`));const a=i.length;let s=0,l="",o=!1;const y=i.charCodeAt(0);if(a===1)p(y)&&(s=1,o=!0);else if(p(y))if(o=!0,p(i.charCodeAt(1))){let D=2,O=D;for(;D<a&&!p(i.charCodeAt(D));)D++;if(D<a&&D!==O){const N=i.slice(O,D);for(O=D;D<a&&p(i.charCodeAt(D));)D++;if(D<a&&D!==O){for(O=D;D<a&&!p(i.charCodeAt(D));)D++;(D===a||D!==O)&&(l=`\\\\${N}\\${i.slice(O,D)}`,s=D)}}}else s=1;else b(y)&&i.charCodeAt(1)===S&&(l=i.slice(0,2),s=2,a>2&&p(i.charCodeAt(2))&&(o=!0,s=3));if(l.length>0)if(u.length>0){if(l.toLowerCase()!==u.toLowerCase())continue}else u=l;if(n){if(u.length>0)break}else if(c=`${i.slice(s)}\\${c}`,n=o,o&&u.length>0)break}return c=h(c,!n,"\\",p),n?`${u}\\${c}`:`${u}${c}`||"."},normalize(d){f(d,"path");const u=d.length;if(u===0)return".";let c=0,n,r=!1;const i=d.charCodeAt(0);if(u===1)return g(i)?"\\":d;if(p(i))if(r=!0,p(d.charCodeAt(1))){let s=2,l=s;for(;s<u&&!p(d.charCodeAt(s));)s++;if(s<u&&s!==l){const o=d.slice(l,s);for(l=s;s<u&&p(d.charCodeAt(s));)s++;if(s<u&&s!==l){for(l=s;s<u&&!p(d.charCodeAt(s));)s++;if(s===u)return`\\\\${o}\\${d.slice(l)}\\`;s!==l&&(n=`\\\\${o}\\${d.slice(l,s)}`,c=s)}}}else c=1;else b(i)&&d.charCodeAt(1)===S&&(n=d.slice(0,2),c=2,u>2&&p(d.charCodeAt(2))&&(r=!0,c=3));let a=c<u?h(d.slice(c),!r,"\\",p):"";return a.length===0&&!r&&(a="."),a.length>0&&p(d.charCodeAt(u-1))&&(a+="\\"),n===void 0?r?`\\${a}`:a:r?`${n}\\${a}`:`${n}${a}`},isAbsolute(d){f(d,"path");const u=d.length;if(u===0)return!1;const c=d.charCodeAt(0);return p(c)||u>2&&b(c)&&d.charCodeAt(1)===S&&p(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let u,c;for(let i=0;i<d.length;++i){const a=d[i];f(a,"path"),a.length>0&&(u===void 0?u=c=a:u+=`\\${a}`)}if(u===void 0)return".";let n=!0,r=0;if(typeof c=="string"&&p(c.charCodeAt(0))){++r;const i=c.length;i>1&&p(c.charCodeAt(1))&&(++r,i>2&&(p(c.charCodeAt(2))?++r:n=!1))}if(n){for(;r<u.length&&p(u.charCodeAt(r));)r++;r>=2&&(u=`\\${u.slice(r)}`)}return e.win32.normalize(u)},relative(d,u){if(f(d,"from"),f(u,"to"),d===u)return"";const c=e.win32.resolve(d),n=e.win32.resolve(u);if(c===n||(d=c.toLowerCase(),u=n.toLowerCase(),d===u))return"";let r=0;for(;r<d.length&&d.charCodeAt(r)===w;)r++;let i=d.length;for(;i-1>r&&d.charCodeAt(i-1)===w;)i--;const a=i-r;let s=0;for(;s<u.length&&u.charCodeAt(s)===w;)s++;let l=u.length;for(;l-1>s&&u.charCodeAt(l-1)===w;)l--;const o=l-s,y=a<o?a:o;let D=-1,O=0;for(;O<y;O++){const Y=d.charCodeAt(r+O);if(Y!==u.charCodeAt(s+O))break;Y===w&&(D=O)}if(O!==y){if(D===-1)return n}else{if(o>y){if(u.charCodeAt(s+O)===w)return n.slice(s+O+1);if(O===2)return n.slice(s+O)}a>y&&(d.charCodeAt(r+O)===w?D=O:O===2&&(D=3)),D===-1&&(D=0)}let N="";for(O=r+D+1;O<=i;++O)(O===i||d.charCodeAt(O)===w)&&(N+=N.length===0?"..":"\\..");return s+=D,N.length>0?`${N}${n.slice(s,l)}`:(n.charCodeAt(s)===w&&++s,n.slice(s,l))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const u=e.win32.resolve(d);if(u.length<=2)return d;if(u.charCodeAt(0)===w){if(u.charCodeAt(1)===w){const c=u.charCodeAt(2);if(c!==k&&c!==P)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(b(u.charCodeAt(0))&&u.charCodeAt(1)===S&&u.charCodeAt(2)===w)return`\\\\?\\${u}`;return d},dirname(d){f(d,"path");const u=d.length;if(u===0)return".";let c=-1,n=0;const r=d.charCodeAt(0);if(u===1)return p(r)?d:".";if(p(r)){if(c=n=1,p(d.charCodeAt(1))){let s=2,l=s;for(;s<u&&!p(d.charCodeAt(s));)s++;if(s<u&&s!==l){for(l=s;s<u&&p(d.charCodeAt(s));)s++;if(s<u&&s!==l){for(l=s;s<u&&!p(d.charCodeAt(s));)s++;if(s===u)return d;s!==l&&(c=n=s+1)}}}}else b(r)&&d.charCodeAt(1)===S&&(c=u>2&&p(d.charCodeAt(2))?3:2,n=c);let i=-1,a=!0;for(let s=u-1;s>=n;--s)if(p(d.charCodeAt(s))){if(!a){i=s;break}}else a=!1;if(i===-1){if(c===-1)return".";i=c}return d.slice(0,i)},basename(d,u){u!==void 0&&f(u,"ext"),f(d,"path");let c=0,n=-1,r=!0,i;if(d.length>=2&&b(d.charCodeAt(0))&&d.charCodeAt(1)===S&&(c=2),u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let a=u.length-1,s=-1;for(i=d.length-1;i>=c;--i){const l=d.charCodeAt(i);if(p(l)){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1),a>=0&&(l===u.charCodeAt(a)?--a===-1&&(n=i):(a=-1,n=s))}return c===n?n=s:n===-1&&(n=d.length),d.slice(c,n)}for(i=d.length-1;i>=c;--i)if(p(d.charCodeAt(i))){if(!r){c=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":d.slice(c,n)},extname(d){f(d,"path");let u=0,c=-1,n=0,r=-1,i=!0,a=0;d.length>=2&&d.charCodeAt(1)===S&&b(d.charCodeAt(0))&&(u=n=2);for(let s=d.length-1;s>=u;--s){const l=d.charCodeAt(s);if(p(l)){if(!i){n=s+1;break}continue}r===-1&&(i=!1,r=s+1),l===P?c===-1?c=s:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||r===-1||a===0||a===1&&c===r-1&&c===n+1?"":d.slice(c,r)},format:v.bind(null,"\\"),parse(d){f(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const c=d.length;let n=0,r=d.charCodeAt(0);if(c===1)return p(r)?(u.root=u.dir=d,u):(u.base=u.name=d,u);if(p(r)){if(n=1,p(d.charCodeAt(1))){let D=2,O=D;for(;D<c&&!p(d.charCodeAt(D));)D++;if(D<c&&D!==O){for(O=D;D<c&&p(d.charCodeAt(D));)D++;if(D<c&&D!==O){for(O=D;D<c&&!p(d.charCodeAt(D));)D++;D===c?n=D:D!==O&&(n=D+1)}}}}else if(b(r)&&d.charCodeAt(1)===S){if(c<=2)return u.root=u.dir=d,u;if(n=2,p(d.charCodeAt(2))){if(c===3)return u.root=u.dir=d,u;n=3}}n>0&&(u.root=d.slice(0,n));let i=-1,a=n,s=-1,l=!0,o=d.length-1,y=0;for(;o>=n;--o){if(r=d.charCodeAt(o),p(r)){if(!l){a=o+1;break}continue}s===-1&&(l=!1,s=o+1),r===P?i===-1?i=o:y!==1&&(y=1):i!==-1&&(y=-1)}return s!==-1&&(i===-1||y===0||y===1&&i===s-1&&i===a+1?u.base=u.name=d.slice(a,s):(u.name=d.slice(a,i),u.base=d.slice(a,s),u.ext=d.slice(i,s))),a>0&&a!==n?u.dir=d.slice(0,a-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let u="",c=!1;for(let n=d.length-1;n>=-1&&!c;n--){const r=n>=0?d[n]:E.cwd();f(r,"path"),r.length!==0&&(u=`${r}/${u}`,c=r.charCodeAt(0)===m)}return u=h(u,!c,"/",g),c?`/${u}`:u.length>0?u:"."},normalize(d){if(f(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===m,c=d.charCodeAt(d.length-1)===m;return d=h(d,!u,"/",g),d.length===0?u?"/":c?"./":".":(c&&(d+="/"),u?`/${d}`:d)},isAbsolute(d){return f(d,"path"),d.length>0&&d.charCodeAt(0)===m},join(...d){if(d.length===0)return".";let u;for(let c=0;c<d.length;++c){const n=d[c];f(n,"path"),n.length>0&&(u===void 0?u=n:u+=`/${n}`)}return u===void 0?".":e.posix.normalize(u)},relative(d,u){if(f(d,"from"),f(u,"to"),d===u||(d=e.posix.resolve(d),u=e.posix.resolve(u),d===u))return"";const c=1,n=d.length,r=n-c,i=1,a=u.length-i,s=r<a?r:a;let l=-1,o=0;for(;o<s;o++){const D=d.charCodeAt(c+o);if(D!==u.charCodeAt(i+o))break;D===m&&(l=o)}if(o===s)if(a>s){if(u.charCodeAt(i+o)===m)return u.slice(i+o+1);if(o===0)return u.slice(i+o)}else r>s&&(d.charCodeAt(c+o)===m?l=o:o===0&&(l=0));let y="";for(o=c+l+1;o<=n;++o)(o===n||d.charCodeAt(o)===m)&&(y+=y.length===0?"..":"/..");return`${y}${u.slice(i+l)}`},toNamespacedPath(d){return d},dirname(d){if(f(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===m;let c=-1,n=!0;for(let r=d.length-1;r>=1;--r)if(d.charCodeAt(r)===m){if(!n){c=r;break}}else n=!1;return c===-1?u?"/":".":u&&c===1?"//":d.slice(0,c)},basename(d,u){u!==void 0&&f(u,"ext"),f(d,"path");let c=0,n=-1,r=!0,i;if(u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let a=u.length-1,s=-1;for(i=d.length-1;i>=0;--i){const l=d.charCodeAt(i);if(l===m){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1),a>=0&&(l===u.charCodeAt(a)?--a===-1&&(n=i):(a=-1,n=s))}return c===n?n=s:n===-1&&(n=d.length),d.slice(c,n)}for(i=d.length-1;i>=0;--i)if(d.charCodeAt(i)===m){if(!r){c=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":d.slice(c,n)},extname(d){f(d,"path");let u=-1,c=0,n=-1,r=!0,i=0;for(let a=d.length-1;a>=0;--a){const s=d.charCodeAt(a);if(s===m){if(!r){c=a+1;break}continue}n===-1&&(r=!1,n=a+1),s===P?u===-1?u=a:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||n===-1||i===0||i===1&&u===n-1&&u===c+1?"":d.slice(u,n)},format:v.bind(null,"/"),parse(d){f(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const c=d.charCodeAt(0)===m;let n;c?(u.root="/",n=1):n=0;let r=-1,i=0,a=-1,s=!0,l=d.length-1,o=0;for(;l>=n;--l){const y=d.charCodeAt(l);if(y===m){if(!s){i=l+1;break}continue}a===-1&&(s=!1,a=l+1),y===P?r===-1?r=l:o!==1&&(o=1):r!==-1&&(o=-1)}if(a!==-1){const y=i===0&&c?1:i;r===-1||o===0||o===1&&r===a-1&&r===i+1?u.base=u.name=d.slice(y,a):(u.name=d.slice(y,r),u.base=d.slice(y,a),u.ext=d.slice(r,a))}return i>0?u.dir=d.slice(0,i-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[79],ie([0,1,4]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var C;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(C=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(P,...m){const w=m.reduce((I,f)=>(I[f]=!0,I),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(I=>!w[I]).forEach(I=>{for(let f=0;f<S.length;f++)if(I.search(S[f])!==-1){delete P[I];break}})}e.sanitizeProcessEnvironment=M;function A(P){!P||(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ee[80],ie([0,1,4]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=E.globals.performance&&typeof E.globals.performance.now=="function";class C{static create(A=!0){return new C(A)}constructor(A){this.a=t&&A,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=C}),define(ee[3],ie([0,1,15,49,2,95,80]),function(q,e,E,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,m=!1;var w;(function(l){l.None=()=>C.Disposable.None;function o(z){if(m){const{onDidAddListener:J}=z,ne=p.create();let j=0;z.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ne.print()),J?.()}}}function y(z,J){return re(z,()=>{},0,void 0,void 0,J)}l.defer=y;function D(z){return(J,ne=null,j)=>{let x=!1,_;return _=z(ae=>{if(!x)return _?_.dispose():x=!0,J.call(ne,ae)},null,j),x&&_.dispose(),_}}l.once=D;function O(z,J,ne){return oe((j,x=null,_)=>z(ae=>j.call(x,J(ae)),null,_),ne)}l.map=O;function N(z,J,ne){return oe((j,x=null,_)=>z(ae=>{J(ae),j.call(x,ae)},null,_),ne)}l.forEach=N;function Y(z,J,ne){return oe((j,x=null,_)=>z(ae=>J(ae)&&j.call(x,ae),null,_),ne)}l.filter=Y;function G(z){return z}l.signal=G;function V(...z){return(J,ne=null,j)=>(0,C.combinedDisposable)(...z.map(x=>x(_=>J.call(ne,_),null,j)))}l.any=V;function se(z,J,ne,j){let x=ne;return O(z,_=>(x=J(x,_),x),j)}l.reduce=se;function oe(z,J){let ne;const j={onWillAddFirstListener(){ne=z(x.fire,x)},onDidRemoveLastListener(){ne?.dispose()}};J||o(j);const x=new b(j);return J?.add(x),x.event}function re(z,J,ne=100,j=!1,x,_){let ae,ge,Me,Oe=0;const De={leakWarningThreshold:x,onWillAddFirstListener(){ae=z(ve=>{Oe++,ge=J(ge,ve),j&&!Me&&(Re.fire(ge),ge=void 0),clearTimeout(Me),Me=setTimeout(()=>{const we=ge;ge=void 0,Me=void 0,(!j||Oe>1)&&Re.fire(we),Oe=0},ne)})},onDidRemoveLastListener(){ae.dispose()}};_||o(De);const Re=new b(De);return _?.add(Re),Re.event}l.debounce=re;function de(z,J=0,ne){return l.debounce(z,(j,x)=>j?(j.push(x),j):[x],J,void 0,void 0,ne)}l.accumulate=de;function X(z,J=(j,x)=>j===x,ne){let j=!0,x;return Y(z,_=>{const ae=j||!J(_,x);return j=!1,x=_,ae},ne)}l.latch=X;function le(z,J,ne){return[l.filter(z,J,ne),l.filter(z,j=>!J(j),ne)]}l.split=le;function F(z,J=!1,ne=[]){let j=ne.slice(),x=z(ge=>{j?j.push(ge):ae.fire(ge)});const _=()=>{j?.forEach(ge=>ae.fire(ge)),j=null},ae=new b({onWillAddFirstListener(){x||(x=z(ge=>ae.fire(ge)))},onDidAddFirstListener(){j&&(J?setTimeout(_):_())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return ae.event}l.buffer=F;class L{constructor(J){this.event=J,this.c=new C.DisposableStore}map(J){return new L(O(this.event,J,this.c))}forEach(J){return new L(N(this.event,J,this.c))}filter(J){return new L(Y(this.event,J,this.c))}reduce(J,ne){return new L(se(this.event,J,ne,this.c))}latch(){return new L(X(this.event,void 0,this.c))}debounce(J,ne=100,j=!1,x){return new L(re(this.event,J,ne,j,x,this.c))}on(J,ne,j){return this.event(J,ne,j)}once(J,ne,j){return D(this.event)(J,ne,j)}dispose(){this.c.dispose()}}function T(z){return new L(z)}l.chain=T;function U(z,J,ne=j=>j){const j=(...ge)=>ae.fire(ne(...ge)),x=()=>z.on(J,j),_=()=>z.removeListener(J,j),ae=new b({onWillAddFirstListener:x,onDidRemoveLastListener:_});return ae.event}l.fromNodeEventEmitter=U;function Q(z,J,ne=j=>j){const j=(...ge)=>ae.fire(ne(...ge)),x=()=>z.addEventListener(J,j),_=()=>z.removeEventListener(J,j),ae=new b({onWillAddFirstListener:x,onDidRemoveLastListener:_});return ae.event}l.fromDOMEventEmitter=Q;function B(z){return new Promise(J=>D(z)(J))}l.toPromise=B;function H(z,J){return J(void 0),z(ne=>J(ne))}l.runAndSubscribe=H;function R(z,J){let ne=null;function j(_){ne?.dispose(),ne=new C.DisposableStore,J(_,ne)}j(void 0);const x=z(_=>j(_));return(0,C.toDisposable)(()=>{x.dispose(),ne?.dispose()})}l.runAndSubscribeWithStore=R;class W{constructor(J,ne){this.obs=J,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};ne||o(j),this.emitter=new b(j),ne&&ne.add(this.emitter)}beginUpdate(J){this.c++}handleChange(J,ne){this.d=!0}endUpdate(J){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function $(z,J){return new W(z,J).emitter.event}l.fromObservable=$})(w=e.Event||(e.Event={}));class S{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${S.c++}`,S.all.add(this)}start(o){this.d=new A.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=S,S.all=new Set,S.c=0;let k=-1;function I(l){const o=k;return k=l,{dispose(){k=o}}}e.setGlobalLeakWarningThreshold=I;class f{constructor(o,y=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=y,this.d=0}dispose(){this.c?.clear()}check(o,y){const D=this.threshold;if(D<=0||y<D)return;this.c||(this.c=new Map);const O=this.c.get(o.value)||0;if(this.c.set(o.value,O+1),this.d-=1,this.d<=0){this.d=D*.5;let N,Y=0;for(const[G,V]of this.c)(!N||Y<V)&&(N=G,Y=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${Y}):`),console.warn(N)}return()=>{const N=this.c.get(o.value)||0;this.c.set(o.value,N-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(o,y,D){this.callback=o,this.callbackThis=y,this.stack=D,this.subscription=new C.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class b{constructor(o){this.j=!1,this.d=o,this.f=k>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??k):void 0,this.g=this.d?._profName?new S(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const o=Array.from(this.q);queueMicrotask(()=>{for(const y of o)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,y,D)=>{if(this.q||(this.q=new M.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),C.Disposable.None;const O=this.q.isEmpty();O&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let N,Y;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(Y=p.create(),N=this.f.check(Y,this.q.size+1)),P&&(Y=Y??p.create());const G=new g(o,y,Y),V=this.q.push(G);O&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,y);const se=G.subscription.set(()=>{N?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return D instanceof C.DisposableStore?D.add(se):Array.isArray(D)&&D.push(se),se}),this.l}fire(o){if(this.q){this.m||(this.m=new v);for(const y of this.q)this.m.push(this,y,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=b;class h{constructor(){this.c=new M.LinkedList}get size(){return this.c.size}push(o,y,D){this.c.push(new d(o,y,D))}clear(o){const y=new M.LinkedList;for(const D of this.c)D.emitter!==o&&y.push(D);this.c=y}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(y){(0,E.onUnexpectedError)(y)}}}}e.EventDeliveryQueue=h;class v extends h{clear(o){this.c.clear()}}class d{constructor(o,y,D){this.emitter=o,this.listener=y,this.event=D}}class u extends b{async fireAsync(o,y,D){if(!!this.q){this.c||(this.c=new M.LinkedList);for(const O of this.q)this.c.push([O,o]);for(;this.c.size>0&&!y.isCancellationRequested;){const[O,N]=this.c.shift(),Y=[],G={...N,token:y,waitUntil:V=>{if(Object.isFrozen(Y))throw new Error("waitUntil can NOT be called asynchronous");D&&(V=D(V,O.callback)),Y.push(V)}};try{O.invoke(G)}catch(V){(0,E.onUnexpectedError)(V);continue}Object.freeze(Y),await Promise.allSettled(Y).then(V=>{for(const se of V)se.status==="rejected"&&(0,E.onUnexpectedError)(se.reason)})}}}}e.AsyncEmitter=u;class c extends b{constructor(o){super(o),this.h=0,this.s=new M.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=c;class n extends c{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=n;class r extends b{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(y=>super.fire(y)),this.c=[]}))}}e.MicrotaskEmitter=r;class i{constructor(){this.d=!1,this.f=[],this.c=new b({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const y={event:o,listener:null};this.f.push(y),this.d&&this.j(y);const D=()=>{this.d&&this.k(y);const O=this.f.indexOf(y);this.f.splice(O,1)};return(0,C.toDisposable)((0,t.once)(D))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(y=>this.c.fire(y))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class a{constructor(){this.c=[]}wrapEvent(o){return(y,D,O)=>o(N=>{const Y=this.c[this.c.length-1];Y?Y.push(()=>y.call(D,N)):y.call(D,N)},void 0,O)}bufferEvents(o){const y=[];this.c.push(y);const D=o();return this.c.pop(),y.forEach(O=>O()),D}}e.EventBufferer=a;class s{constructor(){this.c=!1,this.d=w.None,this.f=C.Disposable.None,this.g=new b({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(ee[22],ie([0,1,3]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,m){const w=setTimeout(P.bind(m),0);return{dispose(){clearTimeout(w)}}});var C;(function(P){function m(w){return w===P.None||w===P.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}P.isCancellationToken=m,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(C=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(m){this.a=void 0,this.b=void 0,this.b=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new M),this.a}cancel(){this.a?this.a instanceof M&&this.a.cancel():this.a=C.Cancelled}dispose(m=!1){m&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof M&&this.a.dispose():this.a=C.None}}e.CancellationTokenSource=A}),define(ee[137],ie([0,1,22]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.CancellationTokenSource,m=this.b(P.token);return this.a={promise:m,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=t;class C{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const m=JSON.stringify(P);return this.b!==m&&(this.b=m,this.a=this.c(P)),this.a}}e.LRUCachedFunction=C;class M{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const m=this.b(P);return this.a.set(P,m),m}}e.CachedFunction=M}),define(ee[97],ie([0,1,3,2]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const C=A=>({onDidChange:E.Event.None,value:A});e.staticObservableValue=C;class M extends t.Disposable{get value(){return this.b}set value(P){P!==this.b&&(this.b=P,this.a.fire(P))}constructor(P){super(),this.b=P,this.a=this.B(new E.Emitter),this.onDidChange=this.a.event}}e.MutableObservableValue=M}),define(ee[25],ie([0,1,137,124]),function(q,e,E,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function M(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=M;const A=/{(\d+)}/g;function P(K,...ce){return ce.length===0?K:K.replace(A,function(fe,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=ce.length?fe:ce[Se]})}e.format=P;const m=/{([^}]+)}/g;function w(K,ce){return K.replace(m,(fe,me)=>ce[me]??fe)}e.format2=w;function S(K){return K.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=S;function k(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function I(K,ce){let fe=0;const me=ce.charCodeAt(0);for(let Se=K.length-1;Se>=0;Se--)K.charCodeAt(Se)===me&&fe++;return fe}e.count=I;function f(K,ce,fe="\u2026"){return K.length<=ce?K:`${K.substr(0,ce)}${fe}`}e.truncate=f;function p(K,ce=" "){const fe=g(K,ce);return b(fe,ce)}e.trim=p;function g(K,ce){if(!K||!ce)return K;const fe=ce.length;if(fe===0||K.length===0)return K;let me=0;for(;K.indexOf(ce,me)===me;)me=me+fe;return K.substring(me)}e.ltrim=g;function b(K,ce){if(!K||!ce)return K;const fe=ce.length,me=K.length;if(fe===0||me===0)return K;let Se=me,Le=-1;for(;Le=K.lastIndexOf(ce,Se-1),!(Le===-1||Le+fe!==Se);){if(Le===0)return"";Se=Le}return K.substring(0,Se)}e.rtrim=b;function h(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function v(K){return K.replace(/\*/g,"")}e.stripWildcards=v;function d(K,ce,fe={}){if(!K)throw new Error("Cannot create regex from empty string");ce||(K=k(K)),fe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(K,me)}e.createRegExp=d;function u(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function c(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function n(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=n;function r(K){return K.split(/\r\n|\r|\n/)}e.splitLines=r;function i(K){for(let ce=0,fe=K.length;ce<fe;ce++){const me=K.charCodeAt(ce);if(me!==32&&me!==9)return ce}return-1}e.firstNonWhitespaceIndex=i;function a(K,ce=0,fe=K.length){for(let me=ce;me<fe;me++){const Se=K.charCodeAt(me);if(Se!==32&&Se!==9)return K.substring(ce,me)}return K.substring(ce,fe)}e.getLeadingWhitespace=a;function s(K,ce=K.length-1){for(let fe=ce;fe>=0;fe--){const me=K.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=s;function l(K,ce,fe){const me=[];let Se=0;for(const Le of K.matchAll(ce)){if(me.push(K.slice(Se,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Se=Le.index+Le[0].length,me.push(fe(Le[0],...Le.slice(1),Le.index,K,Le.groups))}return me.push(K.slice(Se)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=l;function o(K,ce){return K<ce?-1:K>ce?1:0}e.compare=o;function y(K,ce,fe=0,me=K.length,Se=0,Le=ce.length){for(;fe<me&&Se<Le;fe++,Se++){const Ze=K.charCodeAt(fe),Ve=ce.charCodeAt(Se);if(Ze<Ve)return-1;if(Ze>Ve)return 1}const Ne=me-fe,it=Le-Se;return Ne<it?-1:Ne>it?1:0}e.compareSubstring=y;function D(K,ce){return O(K,ce,0,K.length,0,ce.length)}e.compareIgnoreCase=D;function O(K,ce,fe=0,me=K.length,Se=0,Le=ce.length){for(;fe<me&&Se<Le;fe++,Se++){let Ze=K.charCodeAt(fe),Ve=ce.charCodeAt(Se);if(Ze===Ve)continue;if(Ze>=128||Ve>=128)return y(K.toLowerCase(),ce.toLowerCase(),fe,me,Se,Le);Y(Ze)&&(Ze-=32),Y(Ve)&&(Ve-=32);const et=Ze-Ve;if(et!==0)return et}const Ne=me-fe,it=Le-Se;return Ne<it?-1:Ne>it?1:0}e.compareSubstringIgnoreCase=O;function N(K){return K>=48&&K<=57}e.isAsciiDigit=N;function Y(K){return K>=97&&K<=122}e.isLowerAsciiLetter=Y;function G(K){return K>=65&&K<=90}e.isUpperAsciiLetter=G;function V(K,ce){return K.length===ce.length&&O(K,ce)===0}e.equalsIgnoreCase=V;function se(K,ce){const fe=ce.length;return ce.length>K.length?!1:O(K,ce,0,fe)===0}e.startsWithIgnoreCase=se;function oe(K,ce){const fe=Math.min(K.length,ce.length);let me;for(me=0;me<fe;me++)if(K.charCodeAt(me)!==ce.charCodeAt(me))return me;return fe}e.commonPrefixLength=oe;function re(K,ce){const fe=Math.min(K.length,ce.length);let me;const Se=K.length-1,Le=ce.length-1;for(me=0;me<fe;me++)if(K.charCodeAt(Se-me)!==ce.charCodeAt(Le-me))return me;return fe}e.commonSuffixLength=re;function de(K){return 55296<=K&&K<=56319}e.isHighSurrogate=de;function X(K){return 56320<=K&&K<=57343}e.isLowSurrogate=X;function le(K,ce){return(K-55296<<10)+(ce-56320)+65536}e.computeCodePoint=le;function F(K,ce,fe){const me=K.charCodeAt(fe);if(de(me)&&fe+1<ce){const Se=K.charCodeAt(fe+1);if(X(Se))return le(me,Se)}return me}e.getNextCodePoint=F;function L(K,ce){const fe=K.charCodeAt(ce-1);if(X(fe)&&ce>1){const me=K.charCodeAt(ce-2);if(de(me))return le(me,fe)}return fe}class T{get offset(){return this.e}constructor(ce,fe=0){this.c=ce,this.d=ce.length,this.e=fe}setOffset(ce){this.e=ce}prevCodePoint(){const ce=L(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=F(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=T;class U{get offset(){return this.c.offset}constructor(ce,fe=0){this.c=new T(ce,fe)}nextGraphemeLength(){const ce=We.getInstance(),fe=this.c,me=fe.offset;let Se=ce.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Le=fe.offset,Ne=ce.getGraphemeBreakType(fe.nextCodePoint());if(ye(Se,Ne)){fe.setOffset(Le);break}Se=Ne}return fe.offset-me}prevGraphemeLength(){const ce=We.getInstance(),fe=this.c,me=fe.offset;let Se=ce.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Le=fe.offset,Ne=ce.getGraphemeBreakType(fe.prevCodePoint());if(ye(Ne,Se)){fe.setOffset(Le);break}Se=Ne}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=U;function Q(K,ce){return new U(K,ce).nextGraphemeLength()}e.nextCharLength=Q;function B(K,ce){return new U(K,ce).prevGraphemeLength()}e.prevCharLength=B;function H(K,ce){ce>0&&X(K.charCodeAt(ce))&&ce--;const fe=ce+Q(K,ce);return[fe-B(K,fe),fe]}e.getCharContainingOffset=H;function R(K){const ce=new U(K);let fe=0;for(;!ce.eol();)fe++,ce.nextGraphemeLength();return fe}e.charCount=R;let W;function $(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(K){return W||(W=$()),W.test(K)}e.containsRTL=z;const J=/^[\t\n\r\x20-\x7E]*$/;function ne(K){return J.test(K)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=j;function x(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=x;function _(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=_;function ae(K,ce){if(K.length<ce)return K;const fe=/\b/g;let me=0;for(;fe.test(K)&&!(K.length-fe.lastIndex<ce);)me=fe.lastIndex,fe.lastIndex+=1;return K.substring(me).replace(/^\s/,"")}e.lcut=ae;const ge=/\x1B\x5B[12]?K/g,Me=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function De(K){return K&&(K=K.replace(ge,""),K=K.replace(Me,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=De,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function ve(K){return Re(K)?K.substr(1):K}e.stripUTF8BOM=ve;function we(K,ce){if(!K||!ce||K.length<ce.length)return!1;const fe=ce.length,me=K.toLowerCase();let Se=0,Le=-1;for(;Se<fe;){const Ne=me.indexOf(ce[Se],Le+1);if(Ne<0)return!1;Le=Ne,Se++}return!0}e.fuzzyContains=we;function be(K,ce=!1){return K?(ce&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=be;function Ce(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ce;function Z(K,ce=1){if(ce===0)return"";let fe=-1;do fe=K.indexOf(`
`,fe+1),ce--;while(ce>0&&fe>=0);return fe===-1?K:(K[fe-1]==="\r"&&fe--,K.substr(0,fe))}e.getNLines=Z;function ue(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.singleLetterHash=ue;function he(K){return We.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=he;function ye(K,ce){return K===0?ce!==5&&ce!==7:K===2&&ce===3?!1:K===4||K===2||K===3||ce===4||ce===2||ce===3?!0:!(K===8&&(ce===8||ce===9||ce===11||ce===12)||(K===11||K===9)&&(ce===9||ce===10)||(K===12||K===10)&&ce===10||ce===5||ce===13||ce===7||K===1||K===13&&ce===14||K===6&&ce===6)}var Ie;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Te()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const fe=this.d,me=fe.length/3;let Se=1;for(;Se<=me;)if(ce<fe[3*Se])Se=2*Se;else if(ce>fe[3*Se+1])Se=2*Se+1;else return fe[3*Se+2];return 0}}We.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(K,ce){if(K===0)return 0;const fe=Be(K,ce);if(fe!==void 0)return fe;const me=new T(ce,K);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=ze;function Be(K,ce){const fe=new T(ce,K);let me=fe.prevCodePoint();for(;qe(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!_(me))return;let Se=fe.offset;return Se>0&&fe.prevCodePoint()===8205&&(Se=fe.offset),Se}function qe(K){return 127995<=K&&K<=127999}var Ye;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.noBreakWhitespace="\xA0";class je{static getInstance(ce){return je.d.get(Array.from(ce))}static getLocales(){return je.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=je,C=je,je.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.d=new E.LRUCachedFunction(K=>{function ce(Ve){const et=new Map;for(let nt=0;nt<Ve.length;nt+=2)et.set(Ve[nt],Ve[nt+1]);return et}function fe(Ve,et){const nt=new Map(Ve);for(const[ct,gt]of et)nt.set(ct,gt);return nt}function me(Ve,et){if(!Ve)return et;const nt=new Map;for(const[ct,gt]of Ve)et.has(ct)&&nt.set(ct,gt);return nt}const Se=C.c.getValue();let Le=K.filter(Ve=>!Ve.startsWith("_")&&Ve in Se);Le.length===0&&(Le=["_default"]);let Ne;for(const Ve of Le){const et=ce(Se[Ve]);Ne=me(Ne,et)}const it=ce(Se._common),Ze=fe(it,Ne);return new je(Ze)}),je.e=new t.Lazy(()=>Object.keys(je.c.getValue()).filter(K=>!K.startsWith("_")));class Xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Xe.c())),this.d}static isInvisibleCharacter(ce){return Xe.e().has(ce)}static get codePoints(){return Xe.e()}}e.InvisibleCharacters=Xe,Xe.d=void 0}),define(ee[30],ie([0,1,9,4,25,12]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function P(s){return s.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function m(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=m;function w(s,l=E.posix.sep){if(!s)return"";const o=s.length,y=s.charCodeAt(0);if(A(y)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let O=3;const N=O;for(;O<o&&!A(s.charCodeAt(O));O++);if(N!==O&&!A(s.charCodeAt(O+1))){for(O+=1;O<o;O++)if(A(s.charCodeAt(O)))return s.slice(0,O+1).replace(/[\\/]/g,l)}}return l}else if(h(y)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+l:s.slice(0,2);let D=s.indexOf("://");if(D!==-1){for(D+=3;D<o;D++)if(A(s.charCodeAt(D)))return s.slice(0,D+1)}return""}e.getRoot=w;function S(s){if(!t.isWindows||!s||s.length<5)return!1;let l=s.charCodeAt(0);if(l!==92||(l=s.charCodeAt(1),l!==92))return!1;let o=2;const y=o;for(;o<s.length&&(l=s.charCodeAt(o),l!==92);o++);return!(y===o||(l=s.charCodeAt(o+1),isNaN(l)||l===92))}e.isUNC=S;const k=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(s,l=t.isWindows){const o=l?k:I;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||l&&f.test(s)||s==="."||s===".."||l&&s[s.length-1]==="."||l&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=p;function g(s,l,o){const y=s===l;return!o||y?y:!s||!l?!1:(0,C.equalsIgnoreCase)(s,l)}e.isEqual=g;function b(s,l,o,y=E.sep){if(s===l)return!0;if(!s||!l||l.length>s.length)return!1;if(o){if(!(0,C.startsWithIgnoreCase)(s,l))return!1;if(l.length===s.length)return!0;let O=l.length;return l.charAt(l.length-1)===y&&O--,s.charAt(O)===y}return l.charAt(l.length-1)!==y&&(l+=y),s.indexOf(l)===0}e.isEqualOrParent=b;function h(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=h;function v(s,l){return t.isWindows&&s.endsWith(":")&&(s+=E.sep),(0,E.isAbsolute)(s)||(s=(0,E.join)(l,s)),s=(0,E.normalize)(s),t.isWindows?(s=(0,C.rtrim)(s,E.sep),s.endsWith(":")&&(s+=E.sep)):(s=(0,C.rtrim)(s,E.sep),s||(s=E.sep)),s}e.sanitizeFilePath=v;function d(s){const l=(0,E.normalize)(s);return t.isWindows?s.length>3?!1:u(l)&&(s.length===2||l.charCodeAt(2)===92):l===E.posix.sep}e.isRootOrDriveLetter=d;function u(s,l=t.isWindows){return l?h(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(s){return u(s)?s[0]:void 0}e.getDriveLetter=c;function n(s,l,o){return l.length>s.length?-1:s===l?0:(o&&(s=s.toLowerCase(),l=l.toLowerCase()),s.indexOf(l))}e.indexOfPath=n;function r(s){const l=s.split(":");let o,y,D;for(const O of l){const N=Number(O);(0,M.isNumber)(N)?y===void 0?y=N:D===void 0&&(D=N):o=o?[o,O].join(":"):O}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:y!==void 0?y:void 0,column:D!==void 0?D:y!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(s,l,o=8){let y="";for(let O=0;O<o;O++)y+=i.charAt(Math.floor(Math.random()*i.length));let D;return l?D=`${l}-${y}`:D=y,s?(0,E.join)(s,D):D}e.randomPath=a}),define(ee[67],ie([0,1,25]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(h){return C(h,0)}e.hash=t;function C(h,v){switch(typeof h){case"object":return h===null?M(349,v):Array.isArray(h)?m(h,v):w(h,v);case"string":return P(h,v);case"boolean":return A(h,v);case"number":return M(h,v);case"undefined":return M(937,v);default:return M(617,v)}}e.doHash=C;function M(h,v){return(v<<5)-v+h|0}e.numberHash=M;function A(h,v){return M(h?433:863,v)}function P(h,v){v=M(149417,v);for(let d=0,u=h.length;d<u;d++)v=M(h.charCodeAt(d),v);return v}e.stringHash=P;function m(h,v){return v=M(104579,v),h.reduce((d,u)=>C(u,d),v)}function w(h,v){return v=M(181387,v),Object.keys(h).sort().reduce((d,u)=>(d=P(u,d),C(h[u],d)),v)}class S{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=C(v,this.g),this.g}}e.Hasher=S;var k;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function I(h,v,d=32){const u=d-v,c=~((1<<u)-1);return(h<<v|(c&h)>>>u)>>>0}function f(h,v=0,d=h.byteLength,u=0){for(let c=0;c<d;c++)h[v+c]=u}function p(h,v,d="0"){for(;h.length<v;)h=d+h;return h}function g(h,v=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(d=>d.toString(16).padStart(2,"0")).join(""):p((h>>>0).toString(16),v/4)}e.toHexString=g;class b{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const d=v.length;if(d===0)return;const u=this.p;let c=this.r,n=this.u,r,i;for(n!==0?(r=n,i=-1,n=0):(r=v.charCodeAt(0),i=0);;){let a=r;if(E.isHighSurrogate(r))if(i+1<d){const s=v.charCodeAt(i+1);E.isLowSurrogate(s)?(i++,a=E.computeCodePoint(r,s)):a=65533}else{n=r;break}else E.isLowSurrogate(r)&&(a=65533);if(c=this.w(u,c,a),i++,i<d)r=v.charCodeAt(i);else break}this.r=c,this.u=n}w(v,d,u){return u<128?v[d++]=u:u<2048?(v[d++]=192|(u&1984)>>>6,v[d++]=128|(u&63)>>>0):u<65536?(v[d++]=224|(u&61440)>>>12,v[d++]=128|(u&4032)>>>6,v[d++]=128|(u&63)>>>0):(v[d++]=240|(u&1835008)>>>18,v[d++]=128|(u&258048)>>>12,v[d++]=128|(u&4032)>>>6,v[d++]=128|(u&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=b.g,d=this.q;for(let o=0;o<64;o+=4)v.setUint32(o,d.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,I(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let u=this.h,c=this.l,n=this.m,r=this.n,i=this.o,a,s,l;for(let o=0;o<80;o++)o<20?(a=c&n|~c&r,s=1518500249):o<40?(a=c^n^r,s=1859775393):o<60?(a=c&n|c&r|n&r,s=2400959708):(a=c^n^r,s=3395469782),l=I(u,5)+a+i+s+v.getUint32(o*4,!1)&4294967295,i=r,r=n,n=I(c,30),c=u,u=l;this.h=this.h+u&4294967295,this.l=this.l+c&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=b,b.g=new DataView(new ArrayBuffer(320))}),define(ee[98],ie([0,1,25]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(t||(t={})),function(C){const M="error",A="warning",P="warn",m="info",w="ignore";function S(I){return I?E.equalsIgnoreCase(M,I)?C.Error:E.equalsIgnoreCase(A,I)||E.equalsIgnoreCase(P,I)?C.Warning:E.equalsIgnoreCase(m,I)?C.Info:C.Ignore:C.Ignore}C.fromValue=S;function k(I){switch(I){case C.Error:return M;case C.Warning:return A;case C.Info:return m;default:return w}}C.toString=k}(t||(t={})),e.default=t}),define(ee[58],ie([0,1,24,25]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const p=f.charCodeAt(0),g=this.b.charCodeAt(this.c);return p-g}value(){return this.b[this.c]}}e.StringIterator=C;class M{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,t.compareSubstring)(f,this.b,0,f.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class A{constructor(f=!0,p=!0){this.f=f,this.g=p}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let p=f.length-1;p>=0;p--,this.c--){const g=this.b.charCodeAt(p);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,t.compareSubstring)(f,this.b,0,f.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=A;var P;(function(I){I[I.Scheme=1]="Scheme",I[I.Authority=2]="Authority",I[I.Path=3]="Path",I[I.Query=4]="Query",I[I.Fragment=5]="Fragment"})(P||(P={}));class m{constructor(f,p){this.f=f,this.g=p,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(f,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,t.compare)(f,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=m;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(I){I[I.Left=-1]="Left",I[I.Mid=0]="Mid",I[I.Right=1]="Right"})(S||(S={}));class k{static forUris(f=()=>!1,p=()=>!1){return new k(new m(f,p))}static forPaths(f=!1){return new k(new A(void 0,!f))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new M)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,p){if(p){const g=p.slice(0);(0,E.shuffle)(g);for(const b of g)this.set(b,f)}else{const g=f.slice(0);(0,E.shuffle)(g);for(const b of g)this.set(b[0],b[1])}}set(f,p){const g=this.b.reset(f);let b;this.c||(this.c=new w,this.c.segment=g.value());const h=[];for(b=this.c;;){const d=g.cmp(b.segment);if(d>0)b.left||(b.left=new w,b.left.segment=g.value()),h.push([-1,b]),b=b.left;else if(d<0)b.right||(b.right=new w,b.right.segment=g.value()),h.push([1,b]),b=b.right;else if(g.hasNext())g.next(),b.mid||(b.mid=new w,b.mid.segment=g.value()),h.push([0,b]),b=b.mid;else break}const v=b.value;b.value=p,b.key=f;for(let d=h.length-1;d>=0;d--){const u=h[d][1];u.updateHeight();const c=u.balanceFactor();if(c<-1||c>1){const n=h[d][0],r=h[d+1][0];if(n===1&&r===1)h[d][1]=u.rotateLeft();else if(n===-1&&r===-1)h[d][1]=u.rotateRight();else if(n===1&&r===-1)u.right=h[d+1][1]=h[d+1][1].rotateRight(),h[d][1]=u.rotateLeft();else if(n===-1&&r===1)u.left=h[d+1][1]=h[d+1][1].rotateLeft(),h[d][1]=u.rotateRight();else throw new Error;if(d>0)switch(h[d-1][0]){case-1:h[d-1][1].left=h[d][1];break;case 1:h[d-1][1].right=h[d][1];break;case 0:h[d-1][1].mid=h[d][1];break}else this.c=h[0][1]}}return v}get(f){return this.d(f)?.value}d(f){const p=this.b.reset(f);let g=this.c;for(;g;){const b=p.cmp(g.segment);if(b>0)g=g.left;else if(b<0)g=g.right;else if(p.hasNext())p.next(),g=g.mid;else break}return g}has(f){const p=this.d(f);return!(p?.value===void 0&&p?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,p){const g=this.b.reset(f),b=[];let h=this.c;for(;h;){const v=g.cmp(h.segment);if(v>0)b.push([-1,h]),h=h.left;else if(v<0)b.push([1,h]),h=h.right;else if(g.hasNext())g.next(),b.push([0,h]),h=h.mid;else break}if(!!h){if(p?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const v=this.f(h.right);if(v.key){const{key:d,value:u,segment:c}=v;this.e(v.key,!1),h.key=d,h.value=u,h.segment=c}}else{const v=h.left??h.right;if(b.length>0){const[d,u]=b[b.length-1];switch(d){case-1:u.left=v;break;case 0:u.mid=v;break;case 1:u.right=v;break}}else this.c=v}for(let v=b.length-1;v>=0;v--){const d=b[v][1];d.updateHeight();const u=d.balanceFactor();if(u>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),b[v][1]=d.rotateLeft()):u<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),b[v][1]=d.rotateRight()),v>0)switch(b[v-1][0]){case-1:b[v-1][1].left=b[v][1];break;case 1:b[v-1][1].right=b[v][1];break;case 0:b[v-1][1].mid=b[v][1];break}else this.c=b[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const p=this.b.reset(f);let g=this.c,b;for(;g;){const h=p.cmp(g.segment);if(h>0)g=g.left;else if(h<0)g=g.right;else if(p.hasNext())p.next(),b=g.value||b,g=g.mid;else break}return g&&g.value||b}findSuperstr(f){const p=this.b.reset(f);let g=this.c;for(;g;){const b=p.cmp(g.segment);if(b>0)g=g.left;else if(b<0)g=g.right;else if(p.hasNext())p.next(),g=g.mid;else return g.mid?this.g(g.mid):void 0}}forEach(f){for(const[p,g]of this)f(g,p)}*[Symbol.iterator](){yield*this.g(this.c)}g(f){const p=[];return this.h(f,p),p[Symbol.iterator]()}h(f,p){!f||(f.left&&this.h(f.left,p),f.value&&p.push([f.key,f.value]),f.mid&&this.h(f.mid,p),f.right&&this.h(f.right,p))}_isBalanced(){const f=p=>{if(!p)return!0;const g=p.balanceFactor();return g<-1||g>1?!1:f(p.left)&&f(p.right)};return f(this.c)}}e.TernarySearchTree=k}),define(ee[7],ie([0,1,9,4]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,M=/^\//,A=/^\/\//;function P(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!C.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(i,a){return!i&&!a?"file":i}function w(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==k&&(a=k+a):a=k;break}return a}const S="",k="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(a){return a instanceof f?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,s,l,o,y,D=!1){typeof a=="object"?(this.scheme=a.scheme||S,this.authority=a.authority||S,this.path=a.path||S,this.query=a.query||S,this.fragment=a.fragment||S):(this.scheme=m(a,D),this.authority=s||S,this.path=w(this.scheme,l||S),this.query=o||S,this.fragment=y||S,P(this,D))}get fsPath(){return d(this,!1)}with(a){if(!a)return this;let{scheme:s,authority:l,path:o,query:y,fragment:D}=a;return s===void 0?s=this.scheme:s===null&&(s=S),l===void 0?l=this.authority:l===null&&(l=S),o===void 0?o=this.path:o===null&&(o=S),y===void 0?y=this.query:y===null&&(y=S),D===void 0?D=this.fragment:D===null&&(D=S),s===this.scheme&&l===this.authority&&o===this.path&&y===this.query&&D===this.fragment?this:new g(s,l,o,y,D)}static parse(a,s=!1){const l=I.exec(a);return l?new g(l[2]||S,r(l[4]||S),r(l[5]||S),r(l[7]||S),r(l[9]||S),s):new g(S,S,S,S,S)}static file(a){let s=S;if(t.isWindows&&(a=a.replace(/\\/g,k)),a[0]===k&&a[1]===k){const l=a.indexOf(k,2);l===-1?(s=a.substring(2),a=k):(s=a.substring(2,l),a=a.substring(l)||k)}return new g("file",s,a,S,S)}static from(a){const s=new g(a.scheme,a.authority,a.path,a.query,a.fragment);return P(s,!0),s}static joinPath(a,...s){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return t.isWindows&&a.scheme==="file"?l=f.file(E.win32.join(d(a,!0),...s)).path:l=E.posix.join(a.path,...s),a.with({path:l})}toString(a=!1){return u(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof f)return a;{const s=new g(a);return s._formatted=a.external,s._fsPath=a._sep===p?a.fsPath:null,s}}else return a}}e.URI=f;const p=t.isWindows?1:void 0;class g extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(a=!1){return a?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=p),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,a){let s,l=-1;for(let o=0;o<i.length;o++){const y=i.charCodeAt(o);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||a&&y===47)l!==-1&&(s+=encodeURIComponent(i.substring(l,o)),l=-1),s!==void 0&&(s+=i.charAt(o));else{s===void 0&&(s=i.substr(0,o));const D=b[y];D!==void 0?(l!==-1&&(s+=encodeURIComponent(i.substring(l,o)),l=-1),s+=D):l===-1&&(l=o)}}return l!==-1&&(s+=encodeURIComponent(i.substring(l))),s!==void 0?s:i}function v(i){let a;for(let s=0;s<i.length;s++){const l=i.charCodeAt(s);l===35||l===63?(a===void 0&&(a=i.substr(0,s)),a+=b[l]):a!==void 0&&(a+=i[s])}return a!==void 0?a:i}function d(i,a){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=d;function u(i,a){const s=a?v:h;let l="",{scheme:o,authority:y,path:D,query:O,fragment:N}=i;if(o&&(l+=o,l+=":"),(y||o==="file")&&(l+=k,l+=k),y){let Y=y.indexOf("@");if(Y!==-1){const G=y.substr(0,Y);y=y.substr(Y+1),Y=G.indexOf(":"),Y===-1?l+=s(G,!1):(l+=s(G.substr(0,Y),!1),l+=":",l+=s(G.substr(Y+1),!1)),l+="@"}y=y.toLowerCase(),Y=y.indexOf(":"),Y===-1?l+=s(y,!1):(l+=s(y.substr(0,Y),!1),l+=y.substr(Y))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const Y=D.charCodeAt(1);Y>=65&&Y<=90&&(D=`/${String.fromCharCode(Y+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const Y=D.charCodeAt(0);Y>=65&&Y<=90&&(D=`${String.fromCharCode(Y+32)}:${D.substr(2)}`)}l+=s(D,!0)}return O&&(l+="?",l+=s(O,!1)),N&&(l+="#",l+=a?N:h(N,!1)),l}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,a=>c(a)):i}}),define(ee[138],ie([0,1,7]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(w){const S=w;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.isRemoteConsoleLog=t;function C(w){const S=[];let k;try{const I=JSON.parse(w.arguments),f=I[I.length-1];f&&f.__$stack&&(I.pop(),k=f.__$stack),S.push(...I)}catch{S.push("Unable to log remote console arguments",w.arguments)}return{args:S,stack:k}}e.parse=C;function M(w){if(typeof w!="string")return M(C(w).stack);const S=w;if(S){const k=A(S),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(I&&I.length===4)return{uri:E.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=M;function A(w){if(!w)return w;const S=w.indexOf(`
`);return S===-1?w:w.substring(0,S)}function P(w,S){const{args:k,stack:I}=C(w),f=typeof k[0]=="string"&&k.length===1;let p=A(I);p&&(p=`(${p.trim()})`);let g=[];if(typeof k[0]=="string"?p&&f?g=[`%c[${S}] %c${k[0]} %c${p}`,m("blue"),m(""),m("grey")]:g=[`%c[${S}] %c${k[0]}`,m("blue"),m(""),...k.slice(1)]:g=[`%c[${S}]%`,m("blue"),...k],p&&!f&&g.push(p),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,g)}e.log=P;function m(w){return`color: ${w}`}}),define(ee[68],ie([0,1,17,25,7]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(w){return JSON.stringify(w,P)}e.stringify=M;function A(w){let S=JSON.parse(w);return S=m(S),S}e.parse=A;function P(w,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,t.regExpFlags)(S)}:S}function m(w,S=0){if(!w||S>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return C.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 16:return new Date(w.source)}if(w instanceof E.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let k=0;k<w.length;++k)w[k]=m(w[k],S+1);else for(const k in w)Object.hasOwnProperty.call(w,k)&&(w[k]=m(w[k],S+1))}return w}e.revive=m}),define(ee[14],ie([0,1,4,7]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebook="vscode-notebook",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w){this.f=`${w}/${C.vscodeRemoteResource}`}set(w,S,k){this.a[w]=S,this.b[w]=k}setConnectionToken(w,S){this.c[w]=S}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)return this.e(w);const S=w.authority;let k=this.a[S];k&&k.indexOf(":")!==-1&&k.indexOf("[")===-1&&(k=`[${k}]`);const I=this.b[S],f=this.c[S];let p=`path=${encodeURIComponent(w.path)}`;return typeof f=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),t.URI.from({scheme:E.isWeb?this.d:C.vscodeRemoteResource,authority:`${k}:${I}`,path:this.f,query:p})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(w){const S=this.b(w,q);return this.uriToBrowserUri(S)}uriToBrowserUri(w){return w.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===C.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${C.vscodeFileResource}://${A.a}`)?w.with({scheme:C.vscodeFileResource,authority:w.authority||A.a,query:null,fragment:null}):w}asFileUri(w){const S=this.b(w,q);return this.uriToFileUri(S)}uriToFileUri(w){return w.scheme===C.vscodeFileResource?w.with({scheme:C.file,authority:w.authority!==A.a?w.authority:null,query:null,fragment:null}):w}b(w,S){return t.URI.isUri(w)?w:t.URI.parse(S.toUrl(w))}}A.a="vscode-app",e.FileAccess=new A;var P;(function(m){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(w.get("3"));const S="vscode-coi";function k(f){let p;typeof f=="string"?p=new URL(f).searchParams:f instanceof URL?p=f.searchParams:t.URI.isUri(f)&&(p=new URL(f.toString(!0)).searchParams);const g=p?.get(S);if(!!g)return w.get(g)}m.getHeadersFromQuery=k;function I(f,p,g){if(!globalThis.crossOriginIsolated)return;const b=p&&g?"3":g?"2":"1";f instanceof URLSearchParams?f.set(S,b):f[S]=b}m.addSearchParam=I})(P=e.COI||(e.COI={}))}),define(ee[20],ie([0,1,30,14,9,4,25,7]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(f){return(0,P.uriToFsPath)(f,!0)}e.originalFSPath=m;class w{constructor(p){this.a=p}compare(p,g,b=!1){return p===g?0:(0,A.compare)(this.getComparisonKey(p,b),this.getComparisonKey(g,b))}isEqual(p,g,b=!1){return p===g?!0:!p||!g?!1:this.getComparisonKey(p,b)===this.getComparisonKey(g,b)}getComparisonKey(p,g=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,g,b=!1){if(p.scheme===g.scheme){if(p.scheme===t.Schemas.file)return E.isEqualOrParent(m(p),m(g),this.a(p))&&p.query===g.query&&(b||p.fragment===g.fragment);if((0,e.isEqualAuthority)(p.authority,g.authority))return E.isEqualOrParent(p.path,g.path,this.a(p),"/")&&p.query===g.query&&(b||p.fragment===g.fragment)}return!1}joinPath(p,...g){return P.URI.joinPath(p,...g)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return C.posix.basename(p.path)}extname(p){return C.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let g;return p.scheme===t.Schemas.file?g=P.URI.file(C.dirname(m(p))).path:(g=C.posix.dirname(p.path),p.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),g="/")),p.with({path:g})}normalizePath(p){if(!p.path.length)return p;let g;return p.scheme===t.Schemas.file?g=P.URI.file(C.normalize(m(p))).path:g=C.posix.normalize(p.path),p.with({path:g})}relativePath(p,g){if(p.scheme!==g.scheme||!(0,e.isEqualAuthority)(p.authority,g.authority))return;if(p.scheme===t.Schemas.file){const v=C.relative(m(p),m(g));return M.isWindows?E.toSlashes(v):v}let b=p.path||"/";const h=g.path||"/";if(this.a(p)){let v=0;for(const d=Math.min(b.length,h.length);v<d&&!(b.charCodeAt(v)!==h.charCodeAt(v)&&b.charAt(v).toLowerCase()!==h.charAt(v).toLowerCase());v++);b=h.substr(0,v)+b.substr(v)}return C.posix.relative(b,h)}resolvePath(p,g){if(p.scheme===t.Schemas.file){const b=P.URI.file(C.resolve(m(p),g));return p.with({authority:b.authority,path:b.path})}return g=E.toPosixPath(g),p.with({path:C.posix.resolve(p.path,g)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,g){return p===g||p!==void 0&&g!==void 0&&(0,A.equalsIgnoreCase)(p,g)}hasTrailingPathSeparator(p,g=C.sep){if(p.scheme===t.Schemas.file){const b=m(p);return b.length>E.getRoot(b).length&&b[b.length-1]===g}else{const b=p.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,g=C.sep){return(0,e.hasTrailingPathSeparator)(p,g)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,g=C.sep){let b=!1;if(p.scheme===t.Schemas.file){const h=m(p);b=h!==void 0&&h.length===E.getRoot(h).length&&h[h.length-1]===g}else{g="/";const h=p.path;b=h.length===1&&h.charCodeAt(h.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(p,g)?p.with({path:p.path+"/"}):p}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(f=>f.scheme===t.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new w(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function S(f,p){const g=[];for(let b=0;b<f.length;b++){const h=p(f[b]);f.some((v,d)=>d===b?!1:(0,e.isEqualOrParent)(h,p(v)))||g.push(f[b])}return g}e.distinctParents=S;var k;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function p(g){const b=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(d=>{const[u,c]=d.split(":");u&&c&&b.set(u,c)});const v=g.path.substring(0,g.path.indexOf(";"));return v&&b.set(f.META_DATA_MIME,v),b}f.parseMetaData=p})(k=e.DataUri||(e.DataUri={}));function I(f,p,g){if(p){let b=f.path;return b&&b[0]!==C.posix.sep&&(b=C.posix.sep+b),f.with({scheme:g,authority:p,path:b})}return f.with({scheme:g})}e.toLocalResource=I}),define(ee[8],ie([0,1,22,15,3,2,20,4]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(H){return!!H&&typeof H.then=="function"}e.isThenable=m;function w(H){const R=new E.CancellationTokenSource,W=H(R.token),$=new Promise((z,J)=>{const ne=R.token.onCancellationRequested(()=>{ne.dispose(),R.dispose(),J(new t.CancellationError)});Promise.resolve(W).then(j=>{ne.dispose(),R.dispose(),z(j)},j=>{ne.dispose(),R.dispose(),J(j)})});return new class{cancel(){R.cancel()}then(z,J){return $.then(z,J)}catch(z){return this.then(void 0,z)}finally(z){return $.finally(z)}}}e.createCancelablePromise=w;function S(H,R,W){return new Promise(($,z)=>{const J=R.onCancellationRequested(()=>{J.dispose(),$(W)});H.then($,z).finally(()=>J.dispose())})}e.raceCancellation=S;function k(H,R){return new Promise((W,$)=>{const z=R.onCancellationRequested(()=>{z.dispose(),$(new t.CancellationError)});H.then(W,$).finally(()=>z.dispose())})}e.raceCancellationError=k;async function I(H){let R=-1;const W=H.map((z,J)=>z.then(ne=>(R=J,ne))),$=await Promise.race(W);return H.forEach((z,J)=>{J!==R&&z.cancel()}),$}e.raceCancellablePromises=I;function f(H,R,W){let $;const z=setTimeout(()=>{$?.(void 0),W?.()},R);return Promise.race([H.finally(()=>clearTimeout(z)),new Promise(J=>$=J)])}e.raceTimeout=f;function p(H){return new Promise((R,W)=>{const $=H();m($)?$.then(R,W):R($)})}e.asPromise=p;class g{constructor(){this.a=null,this.b=null,this.d=null}queue(R){if(this.a){if(this.d=R,!this.b){const W=()=>{this.b=null;const $=this.queue(this.d);return this.d=null,$};this.b=new Promise($=>{this.a.then(W,W).then($)})}return new Promise((W,$)=>{this.b.then(W,$)})}return this.a=R(),new Promise((W,$)=>{this.a.then(z=>{this.a=null,W(z)},z=>{this.a=null,$(z)})})}}e.Throttler=g;class b{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.Sequencer=b;class h{constructor(){this.a=new Map}queue(R,W){const z=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(R)===z&&this.a.delete(R)});return this.a.set(R,z),z}}e.SequencerByKey=h;const v=(H,R)=>{let W=!0;const $=setTimeout(()=>{W=!1,R()},H);return{isTriggered:()=>W,dispose:()=>{clearTimeout($),W=!1}}},d=H=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,H())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,W=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((z,J)=>{this.d=z,this.f=J}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const $=()=>{this.a=null,this.d?.(null)};return this.a=W===e.MicrotaskDelay?d($):v(W,$),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=u;class c{constructor(R){this.a=new u(R),this.b=new g}trigger(R,W){return this.a.trigger(()=>this.b.queue(R),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=c;class n{constructor(){this.a=!1,this.b=new Promise((R,W)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class r extends n{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function i(H,R){return R?new Promise((W,$)=>{const z=setTimeout(()=>{J.dispose(),W()},H),J=R.onCancellationRequested(()=>{clearTimeout(z),J.dispose(),$(new t.CancellationError)})}):w(W=>i(H,W))}e.timeout=i;function a(H,R=0){const W=setTimeout(H,R);return(0,M.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=a;function s(H){const R=[];let W=0;const $=H.length;function z(){return W<$?H[W++]():null}function J(ne){ne!=null&&R.push(ne);const j=z();return j?j.then(J):Promise.resolve(R)}return Promise.resolve(null).then(J)}e.sequence=s;function l(H,R=$=>!!$,W=null){let $=0;const z=H.length,J=()=>{if($>=z)return Promise.resolve(W);const ne=H[$++];return Promise.resolve(ne()).then(x=>R(x)?Promise.resolve(x):J())};return J()}e.first=l;function o(H,R=$=>!!$,W=null){if(H.length===0)return Promise.resolve(W);let $=H.length;const z=()=>{$=-1;for(const J of H)J.cancel?.()};return new Promise((J,ne)=>{for(const j of H)j.then(x=>{--$>=0&&R(x)?(z(),J(x)):$===0&&J(W)}).catch(x=>{--$>=0&&(z(),ne(x))})})}e.firstParallel=o;class y{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new C.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((W,$)=>{this.f.push({factory:R,c:W,e:$}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const W=R.factory();W.then(R.c,R.e),W.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=y;class D extends y{constructor(){super(1)}}e.Queue=D;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const R=new F;return this.b.add(R),R.p}d(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,W=A.extUri){const $=W.getComparisonKey(R);let z=this.a.get($);return z||(z=new D,C.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete($),this.f()}),this.a.set($,z)),z}f(){!this.d()||this.g()}g(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class N{constructor(R,W){this.a=-1,typeof R=="function"&&typeof W=="number"&&this.setIfNotSet(R,W)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,W){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},W)}setIfNotSet(R,W){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},W))}}e.TimeoutTimer=N;class Y{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,W){this.cancel(),this.a=setInterval(()=>{R()},W)}}e.IntervalTimer=Y;class G{constructor(R,W){this.b=-1,this.a=R,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=G;class V{constructor(R,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=R,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class se extends G{constructor(R,W){super(R,W),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=se;class oe extends M.Disposable{constructor(R,W){super(),this.g=R,this.h=W,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...R),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=oe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,P.setTimeout0)(()=>{if(R)return;const W=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.runWhenIdle=(H,R)=>{const W=requestIdleCallback(H,typeof R=="number"?{timeout:R}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(W))}}}}();class re{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(W){this.g=W}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=re;async function de(H,R,W){let $;for(let z=0;z<W;z++)try{return await H()}catch(J){$=J,await i(R)}throw $}e.retry=de;class X{hasPending(R){return this.a?typeof R=="number"?this.a.taskId===R:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(R,W,$){return this.a={taskId:R,cancel:()=>$?.(),promise:W},W.then(()=>this.d(R),()=>this.d(R)),W}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this.b)this.b.run=R;else{let W,$;const z=new Promise((J,ne)=>{W=J,$=ne});this.b={run:R,promise:z,promiseResolve:W,promiseReject:$}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class le{constructor(R,W=()=>Date.now()){this.d=R,this.f=W,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.IntervalCounter=le;class F{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((R,W)=>{this.a=R,this.b=W})}complete(R){return new Promise(W=>{this.a(R),this.f=!0,W()})}error(R){return new Promise(W=>{this.b(R),this.d=!0,W()})}cancel(){new Promise(R=>{this.b(new t.CancellationError),this.d=!0,R()})}}e.DeferredPromise=F;var L;(function(H){async function R($){let z;const J=await Promise.all($.map(ne=>ne.then(j=>j,j=>{z||(z=j)})));if(typeof z<"u")throw z;return J}H.settled=R;function W($){return new Promise(async(z,J)=>{try{await $(z,J)}catch(ne){J(ne)}})}H.withAsyncBody=W})(L=e.Promises||(e.Promises={}));var T;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(T||(T={}));class U{static fromArray(R){return new U(W=>{W.emitMany(R)})}static fromPromise(R){return new U(async W=>{W.emitMany(await R)})}static fromPromises(R){return new U(async W=>{await Promise.all(R.map(async $=>W.emitOne(await $)))})}static merge(R){return new U(async W=>{await Promise.all(R.map(async $=>{for await(const z of $)W.emitOne(z)}))})}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new C.Emitter,queueMicrotask(async()=>{const W={emitOne:$=>this.g($),emitMany:$=>this.h($),reject:$=>this.k($)};try{await Promise.resolve(R(W)),this.j()}catch($){this.k($)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(R,W){return new U(async $=>{for await(const z of R)$.emitOne(W(z))})}map(R){return U.map(this,R)}static filter(R,W){return new U(async $=>{for await(const z of R)W(z)&&$.emitOne(z)})}filter(R){return U.filter(this,R)}static coalesce(R){return U.filter(R,W=>!!W)}coalesce(){return U.coalesce(this)}static async toPromise(R){const W=[];for await(const $ of R)W.push($);return W}toPromise(){return U.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.AsyncIterableObject=U,U.EMPTY=U.fromArray([]);class Q extends U{constructor(R,W){super(W),this.l=R}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Q;function B(H){const R=new E.CancellationTokenSource,W=H(R.token);return new Q(R,async $=>{const z=R.token.onCancellationRequested(()=>{z.dispose(),R.dispose(),$.reject(new t.CancellationError)});try{for await(const J of W){if(R.token.isCancellationRequested)return;$.emitOne(J)}z.dispose(),R.dispose()}catch(J){z.dispose(),R.dispose(),$.reject(J)}})}e.createCancelableAsyncIterable=B}),define(ee[99],ie([0,1,24,8,30,39,9,4,25]),function(q,e,E,t,C,M,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const S="[/\\\\]",k="[^/\\\\]",I=/\//g;function f(F,L){switch(F){case 0:return"";case 1:return`${k}*?`;default:return`(?:${S}|${k}+${S}${L?`|${S}${k}+`:""})*?`}}function p(F,L){if(!F)return[];const T=[];let U=!1,Q=!1,B="";for(const H of F){switch(H){case L:if(!U&&!Q){T.push(B),B="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}B+=H}return B&&T.push(B),T}e.splitGlobAware=p;function g(F){if(!F)return"";let L="";const T=p(F,e.GLOB_SPLIT);if(T.every(U=>U===e.GLOBSTAR))L=".*";else{let U=!1;T.forEach((Q,B)=>{if(Q===e.GLOBSTAR){if(U)return;L+=f(2,B===T.length-1)}else{let H=!1,R="",W=!1,$="";for(const z of Q){if(z!=="}"&&H){R+=z;continue}if(W&&(z!=="]"||!$)){let J;z==="-"?J=z:(z==="^"||z==="!")&&!$?J="^":z===e.GLOB_SPLIT?J="":J=(0,m.escapeRegExpCharacters)(z),$+=J;continue}switch(z){case"{":H=!0;continue;case"[":W=!0;continue;case"}":{L+=`(?:${p(R,",").map(j=>g(j)).join("|")})`,H=!1,R="";break}case"]":{L+="["+$+"]",W=!1,$="";break}case"?":L+=k;continue;case"*":L+=f(1);continue;default:L+=(0,m.escapeRegExpCharacters)(z)}}B<T.length-1&&(T[B+1]!==e.GLOBSTAR||B+2<T.length)&&(L+=S)}U=Q===e.GLOBSTAR})}return L}const b=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new M.LRUCache(1e4),r=function(){return!1},i=function(){return null};function a(F,L){if(!F)return i;let T;typeof F!="string"?T=F.pattern:T=F,T=T.trim();const U=`${T}_${!!L.trimForExclusions}`;let Q=n.get(U);if(Q)return s(Q,F);let B;return b.test(T)?Q=o(T.substr(4),T):(B=h.exec(l(T,L)))?Q=y(B[1],T):(L.trimForExclusions?d:v).test(T)?Q=D(T,L):(B=u.exec(l(T,L)))?Q=O(B[1].substr(1),T,!0):(B=c.exec(l(T,L)))?Q=O(B[1],T,!1):Q=N(T),n.set(U,Q),s(Q,F)}function s(F,L){if(typeof L=="string")return F;const T=function(U,Q){return(0,C.isEqualOrParent)(U,L.base,!P.isLinux)?F((0,m.ltrim)(U.substr(L.base.length),A.sep),Q):null};return T.allBasenames=F.allBasenames,T.allPaths=F.allPaths,T.basenames=F.basenames,T.patterns=F.patterns,T}function l(F,L){return L.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function o(F,L){return function(T,U){return typeof T=="string"&&T.endsWith(F)?L:null}}function y(F,L){const T=`/${F}`,U=`\\${F}`,Q=function(H,R){return typeof H!="string"?null:R?R===F?L:null:H===F||H.endsWith(T)||H.endsWith(U)?L:null},B=[F];return Q.basenames=B,Q.patterns=[L],Q.allBasenames=B,Q}function D(F,L){const T=X(F.slice(1,-1).split(",").map(R=>a(R,L)).filter(R=>R!==i),F),U=T.length;if(!U)return i;if(U===1)return T[0];const Q=function(R,W){for(let $=0,z=T.length;$<z;$++)if(T[$](R,W))return F;return null},B=T.find(R=>!!R.allBasenames);B&&(Q.allBasenames=B.allBasenames);const H=T.reduce((R,W)=>W.allPaths?R.concat(W.allPaths):R,[]);return H.length&&(Q.allPaths=H),Q}function O(F,L,T){const U=A.sep===A.posix.sep,Q=U?F:F.replace(I,A.sep),B=A.sep+Q,H=A.posix.sep+F;let R;return T?R=function(W,$){return typeof W=="string"&&(W===Q||W.endsWith(B)||!U&&(W===F||W.endsWith(H)))?L:null}:R=function(W,$){return typeof W=="string"&&(W===Q||!U&&W===F)?L:null},R.allPaths=[(T?"*/":"./")+F],R}function N(F){try{const L=new RegExp(`^${g(F)}$`);return function(T){return L.lastIndex=0,typeof T=="string"&&L.test(T)?F:null}}catch{return i}}function Y(F,L,T){return!F||typeof L!="string"?!1:G(F)(L,void 0,T)}e.match=Y;function G(F,L={}){if(!F)return r;if(typeof F=="string"||V(F)){const T=a(F,L);if(T===i)return r;const U=function(Q,B){return!!T(Q,B)};return T.allBasenames&&(U.allBasenames=T.allBasenames),T.allPaths&&(U.allPaths=T.allPaths),U}return re(F,L)}e.parse=G;function V(F){const L=F;return L?typeof L.base=="string"&&typeof L.pattern=="string":!1}e.isRelativePattern=V;function se(F){return F.allBasenames||[]}e.getBasenameTerms=se;function oe(F){return F.allPaths||[]}e.getPathTerms=oe;function re(F,L){const T=X(Object.getOwnPropertyNames(F).map(R=>de(R,F[R],L)).filter(R=>R!==i)),U=T.length;if(!U)return i;if(!T.some(R=>!!R.requiresSiblings)){if(U===1)return T[0];const R=function(z,J){let ne;for(let j=0,x=T.length;j<x;j++){const _=T[j](z,J);if(typeof _=="string")return _;(0,t.isThenable)(_)&&(ne||(ne=[]),ne.push(_))}return ne?(async()=>{for(const j of ne){const x=await j;if(typeof x=="string")return x}return null})():null},W=T.find(z=>!!z.allBasenames);W&&(R.allBasenames=W.allBasenames);const $=T.reduce((z,J)=>J.allPaths?z.concat(J.allPaths):z,[]);return $.length&&(R.allPaths=$),R}const Q=function(R,W,$){let z,J;for(let ne=0,j=T.length;ne<j;ne++){const x=T[ne];x.requiresSiblings&&$&&(W||(W=(0,A.basename)(R)),z||(z=W.substr(0,W.length-(0,A.extname)(R).length)));const _=x(R,W,z,$);if(typeof _=="string")return _;(0,t.isThenable)(_)&&(J||(J=[]),J.push(_))}return J?(async()=>{for(const ne of J){const j=await ne;if(typeof j=="string")return j}return null})():null},B=T.find(R=>!!R.allBasenames);B&&(Q.allBasenames=B.allBasenames);const H=T.reduce((R,W)=>W.allPaths?R.concat(W.allPaths):R,[]);return H.length&&(Q.allPaths=H),Q}function de(F,L,T){if(L===!1)return i;const U=a(F,T);if(U===i)return i;if(typeof L=="boolean")return U;if(L){const Q=L.when;if(typeof Q=="string"){const B=(H,R,W,$)=>{if(!$||!U(H,R))return null;const z=Q.replace("$(basename)",W),J=$(z);return(0,t.isThenable)(J)?J.then(ne=>ne?F:null):J?F:null};return B.requiresSiblings=!0,B}}return U}function X(F,L){const T=F.filter(R=>!!R.basenames);if(T.length<2)return F;const U=T.reduce((R,W)=>{const $=W.basenames;return $?R.concat($):R},[]);let Q;if(L){Q=[];for(let R=0,W=U.length;R<W;R++)Q.push(L)}else Q=T.reduce((R,W)=>{const $=W.patterns;return $?R.concat($):R},[]);const B=function(R,W){if(typeof R!="string")return null;if(!W){let z;for(z=R.length;z>0;z--){const J=R.charCodeAt(z-1);if(J===47||J===92)break}W=R.substr(z)}const $=U.indexOf(W);return $!==-1?Q[$]:null};B.basenames=U,B.patterns=Q,B.allBasenames=U;const H=F.filter(R=>!R.basenames);return H.push(B),H}function le(F,L){return(0,E.equals)(F,L,(T,U)=>typeof T=="string"&&typeof U=="string"?T===U:typeof T!="string"&&typeof U!="string"?T.base===U.base&&T.pattern===U.pattern:!1)}e.patternsEquals=le}),define(ee[33],ie([0,1,24,30,9,4,20,25]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function m(i,a){const{os:s,tildify:l,relative:o}=a;if(o){const O=w(i,o,s);if(typeof O=="string")return O}let y=i.fsPath;if(s===1&&!M.isWindows?y=y.replace(/\//g,"\\"):s!==1&&M.isWindows&&(y=y.replace(/\\/g,"/")),s!==1&&l?.userHome){const O=l.userHome.fsPath;let N;i.scheme!==l.userHome.scheme&&i.path.startsWith(C.posix.sep)?N=l.userHome.with({path:i.path}).fsPath:N=i.fsPath,y=I(N,O,s)}return(s===1?C.win32:C.posix).normalize(S(y,s===1))}e.getPathLabel=m;function w(i,a,s){const l=s===1?C.win32:C.posix,o=s===3?A.extUri:A.extUriIgnorePathCase,y=a.getWorkspace(),D=(0,E.firstOrDefault)(y.folders);if(!D)return;i.scheme!==D.uri.scheme&&i.path.startsWith(C.posix.sep)&&(i=D.uri.with({path:i.path}));const O=a.getWorkspaceFolder(i);if(!O)return;let N;if(o.isEqual(O.uri,i)?N="":N=o.relativePath(O.uri,i)??"",N&&(N=l.normalize(N)),y.folders.length>1&&!a.noPrefix){const Y=O.name?O.name:o.basenameOrAuthority(O.uri);N=N?`${Y} \u2022 ${N}`:Y}return N}function S(i,a=M.isWindows){return(0,t.hasDriveLetter)(i,a)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=S;let k=Object.create(null);function I(i,a,s=M.OS){if(s===1||!i||!a)return i;let l=k.original===a?k.normalized:void 0;l||(l=a,M.isWindows&&(l=(0,t.toSlashes)(l)),l=`${(0,P.rtrim)(l,C.posix.sep)}${C.posix.sep}`,k={original:a,normalized:l});let o=i;return M.isWindows&&(o=(0,t.toSlashes)(o)),(s===3?o.startsWith(l):(0,P.startsWithIgnoreCase)(o,l))?`~/${o.substr(l.length)}`:i}e.tildify=I;function f(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=f;const p="\u2026",g="\\\\",b="~";function h(i,a=C.sep){const s=new Array(i.length);let l=!1;for(let o=0;o<i.length;o++){const y=i[o];if(y===""){s[o]=`.${a}`;continue}if(!y){s[o]=y;continue}l=!0;let D="",O=y;O.indexOf(g)===0?(D=O.substr(0,O.indexOf(g)+g.length),O=O.substr(O.indexOf(g)+g.length)):O.indexOf(a)===0?(D=O.substr(0,O.indexOf(a)+a.length),O=O.substr(O.indexOf(a)+a.length)):O.indexOf(b)===0&&(D=O.substr(0,O.indexOf(b)+b.length),O=O.substr(O.indexOf(b)+b.length));const N=O.split(a);for(let Y=1;l&&Y<=N.length;Y++)for(let G=N.length-Y;l&&G>=0;G--){l=!1;let V=N.slice(G,G+Y).join(a);for(let se=0;!l&&se<i.length;se++)if(se!==o&&i[se]&&i[se].indexOf(V)>-1){const oe=G+Y===N.length,re=G>0&&i[se].indexOf(a)>-1?a+V:V,de=i[se].endsWith(re);l=!oe||de}if(!l){let se="";(N[0].endsWith(":")||D!=="")&&(G===1&&(G=0,Y++,V=N[0]+a+V),G>0&&(se=N[0]+a),se=D+se),G>0&&(se=se+p+a),se=se+V,G+Y<N.length&&(se=se+a+p),s[o]=se}}l&&(s[o]=y)}return s}e.shorten=h;var v;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function d(i,a=Object.create(null)){const s=[];let l=!1,o="";for(const y of i)if(y==="$"||l&&y==="{")o&&s.push({value:o,type:v.TEXT}),o="",l=!0;else if(y==="}"&&l){const D=a[o];if(typeof D=="string")D.length&&s.push({value:D,type:v.VARIABLE});else if(D){const O=s[s.length-1];(!O||O.type!==v.SEPARATOR)&&s.push({value:D.label,type:v.SEPARATOR})}o="",l=!1}else o+=y;return o&&!l&&s.push({value:o,type:v.TEXT}),s.filter((y,D)=>{if(y.type===v.SEPARATOR){const O=s[D-1],N=s[D+1];return[O,N].every(Y=>Y&&(Y.type===v.VARIABLE||Y.type===v.TEXT)&&Y.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=d;function u(i,a){return M.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function c(i,a){return M.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):M.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function r(i){const a=i.indexOf("/")!==-1?C.posix:C.win32,s=a.basename(i),l=a.dirname(i);return s.length?{name:s,parentPath:l}:{name:l,parentPath:""}}e.splitName=r}),define(ee[139],ie([0,1,7]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(S){return S.toJSON()}class C{constructor(k){this.a=k}transformIncoming(k){const I=this.a.transformIncoming(k);return I===k?k:t(E.URI.from(I))}transformOutgoing(k){const I=this.a.transformOutgoing(k);return I===k?k:t(E.URI.from(I))}transformOutgoingURI(k){const I=this.a.transformOutgoing(k);return I===k?k:E.URI.from(I)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function M(S,k,I){if(!S||I>200)return null;if(typeof S=="object"){if(S instanceof E.URI)return k.transformOutgoing(S);for(const f in S)if(Object.hasOwnProperty.call(S,f)){const p=M(S[f],k,I+1);p!==null&&(S[f]=p)}}return null}function A(S,k){const I=M(S,k,0);return I===null?S:I}e.transformOutgoingURIs=A;function P(S,k,I,f){if(!S||f>200)return null;if(typeof S=="object"){if(S.$mid===1)return I?E.URI.revive(k.transformIncoming(S)):k.transformIncoming(S);for(const p in S)if(Object.hasOwnProperty.call(S,p)){const g=P(S[p],k,I,f+1);g!==null&&(S[p]=g)}}return null}function m(S,k){const I=P(S,k,!1,0);return I===null?S:I}e.transformIncomingURIs=m;function w(S,k){const I=P(S,k,!0,0);return I===null?S:I}e.transformAndReviveIncomingURIs=w}),define(ee[81],ie([0,1,27,15,58,29,127]),function(q,e,E,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(S){return this.a||(this.a=C.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(S)}value(){if(this.b===void 0){let S=0,k=0;const I=(0,E.networkInterfaces)();for(const f in I){const p=I[f];if(p)for(const{mac:g,internal:b}of p)b||(k+=1,this.c(g.toUpperCase())&&(S+=1))}this.b=k>0?S/k:0}return this.b}};let P;async function m(){return P||(P=(async()=>await w()||M.generateUuid())()),P}e.getMachineId=m;async function w(){try{const S=await new Promise((I,f)=>{q(["crypto"],I,f)}),k=(0,A.getMac)();return S.createHash("sha256").update(k,"utf8").digest("hex")}catch(S){t.onUnexpectedError(S);return}}}),define(ee[23],ie([0,1,40,27,140,8,30,76,9,4,20,7]),function(q,e,E,t,C,M,A,P,m,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function f(re,de=I.UNLINK){if((0,A.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return de===I.UNLINK?g(re):p(re)}async function p(re){try{const de=(0,A.randomPath)((0,t.tmpdir)());try{await E.promises.rename(re,de)}catch(X){return X.code==="ENOENT"?void 0:g(re)}g(de).catch(X=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function g(re){return(0,C.promisify)(E.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function b(re){if((0,A.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function h(re,de){return u(await(de?v(re):(0,C.promisify)(E.readdir)(re)))}async function v(re){try{return await(0,C.promisify)(E.readdir)(re,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const de=[],X=await h(re);for(const le of X){let F=!1,L=!1,T=!1;try{const U=await e.Promises.lstat((0,m.join)(re,le));F=U.isFile(),L=U.isDirectory(),T=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}de.push({name:le,isFile:()=>F,isDirectory:()=>L,isSymbolicLink:()=>T})}return de}function d(re){return u(E.readdirSync(re))}e.readdirSync=d;function u(re){return re.map(de=>typeof de=="string"?w.isMacintosh?(0,P.normalizeNFC)(de):de:(de.name=w.isMacintosh?(0,P.normalizeNFC)(de.name):de.name,de))}async function c(re){const de=await h(re),X=[];for(const le of de)await r.existsDirectory((0,m.join)(re,le))&&X.push(le);return X}function n(re,de=1e3){return new Promise(X=>{let le=!1;const F=setInterval(()=>{le||(le=!0,E.access(re,L=>{le=!1,L&&(clearInterval(F),X(void 0))}))},de)})}e.whenDeleted=n;var r;(function(re){async function de(F){let L;try{if(L=await e.Promises.lstat(F),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(w.isWindows&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw U}throw T}}re.stat=de;async function X(F){try{const{stat:L,symbolicLink:T}=await re.stat(F);return L.isFile()&&T?.dangling!==!0}catch{}return!1}re.existsFile=X;async function le(F){try{const{stat:L,symbolicLink:T}=await re.stat(F);return L.isDirectory()&&T?.dangling!==!0}catch{}return!1}re.existsDirectory=le})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new M.ResourceQueue;function a(re,de,X){return i.queueFor(k.URI.file(re),S.extUriBiasedIgnorePathCase).queue(()=>{const le=D(X);return new Promise((F,L)=>o(re,de,le,T=>T?L(T):F()))})}let s=!0;function l(re){s=re}e.configureFlushOnWrite=l;function o(re,de,X,le){if(!s)return E.writeFile(re,de,{mode:X.mode,flag:X.flag},le);E.open(re,X.flag,X.mode,(F,L)=>{if(F)return le(F);E.writeFile(L,de,T=>{if(T)return E.close(L,()=>le(T));E.fdatasync(L,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),l(!1)),E.close(L,Q=>le(Q))))})})}function y(re,de,X){const le=D(X);if(!s)return E.writeFileSync(re,de,{mode:le.mode,flag:le.flag});const F=E.openSync(re,le.flag,le.mode);try{E.writeFileSync(F,de);try{E.fdatasyncSync(F)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),l(!1)}}finally{E.closeSync(F)}}e.writeFileSync=y;function D(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function O(re,de){if(re!==de)try{await e.Promises.rename(re,de)}catch(X){if(re.toLowerCase()!==de.toLowerCase()&&X.code==="EXDEV"||re.endsWith("."))await N(re,de,{preserveSymlinks:!1}),await f(re,I.MOVE);else throw X}}async function N(re,de,X){return G(re,de,{root:{source:re,target:de},options:X,handledSourcePaths:new Set})}const Y=511;async function G(re,de,X){if(X.handledSourcePaths.has(re))return;X.handledSourcePaths.add(re);const{stat:le,symbolicLink:F}=await r.stat(re);if(F){if(X.options.preserveSymlinks)try{return await oe(re,de,X)}catch(L){console.warn("[node.js fs] copy of symlink failed: ",L)}if(F.dangling)return}return le.isDirectory()?V(re,de,le.mode&Y,X):se(re,de,le.mode&Y)}async function V(re,de,X,le){await e.Promises.mkdir(de,{recursive:!0,mode:X});const F=await h(re);for(const L of F)await G((0,m.join)(re,L),(0,m.join)(de,L),le)}async function se(re,de,X){await e.Promises.copyFile(re,de),await e.Promises.chmod(de,X)}async function oe(re,de,X){let le=await e.Promises.readlink(re);(0,A.isEqualOrParent)(le,X.root.source,!w.isLinux)&&(le=(0,m.join)(X.root.target,le.substr(X.root.source.length+1))),await e.Promises.symlink(le,de)}e.Promises=new class{get access(){return(0,C.promisify)(E.access)}get stat(){return(0,C.promisify)(E.stat)}get lstat(){return(0,C.promisify)(E.lstat)}get utimes(){return(0,C.promisify)(E.utimes)}get read(){return(re,de,X,le,F)=>new Promise((L,T)=>{E.read(re,de,X,le,F,(U,Q,B)=>U?T(U):L({bytesRead:Q,buffer:B}))})}get readFile(){return(0,C.promisify)(E.readFile)}get write(){return(re,de,X,le,F)=>new Promise((L,T)=>{E.write(re,de,X,le,F,(U,Q,B)=>U?T(U):L({bytesWritten:Q,buffer:B}))})}get appendFile(){return(0,C.promisify)(E.appendFile)}get fdatasync(){return(0,C.promisify)(E.fdatasync)}get truncate(){return(0,C.promisify)(E.truncate)}get rename(){return(0,C.promisify)(E.rename)}get copyFile(){return(0,C.promisify)(E.copyFile)}get open(){return(0,C.promisify)(E.open)}get close(){return(0,C.promisify)(E.close)}get symlink(){return(0,C.promisify)(E.symlink)}get readlink(){return(0,C.promisify)(E.readlink)}get chmod(){return(0,C.promisify)(E.chmod)}get mkdir(){return(0,C.promisify)(E.mkdir)}get unlink(){return(0,C.promisify)(E.unlink)}get rmdir(){return(0,C.promisify)(E.rmdir)}get realpath(){return(0,C.promisify)(E.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return c}get writeFile(){return a}get rm(){return f}get move(){return O}get copy(){return N}}}),define(ee[100],ie([0,1,40,9,4,25,23]),function(q,e,E,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(I){if(C.isLinux)return I;const f=(0,t.dirname)(I);if(I===f)return I;const p=((0,t.basename)(I)||I).toLowerCase();try{const b=(0,A.readdirSync)(f).filter(h=>h.toLowerCase()===p);if(b.length===1){const h=P(f);if(h)return(0,t.join)(h,b[0])}else if(b.length>1){const h=b.indexOf(p);if(h>=0){const v=P(f);if(v)return(0,t.join)(v,b[h])}}}catch{}return null}e.realcaseSync=P;async function m(I){if(C.isLinux)return I;const f=(0,t.dirname)(I);if(I===f)return I;const p=((0,t.basename)(I)||I).toLowerCase();try{const b=(await A.Promises.readdir(f)).filter(h=>h.toLowerCase()===p);if(b.length===1){const h=await m(f);if(h)return(0,t.join)(h,b[0])}else if(b.length>1){const h=b.indexOf(p);if(h>=0){const v=await m(f);if(v)return(0,t.join)(v,b[h])}}}catch{}return null}e.realcase=m;async function w(I){try{return await A.Promises.realpath(I)}catch{const p=k(I);return await A.Promises.access(p,E.constants.R_OK),p}}e.realpath=w;function S(I){try{return E.realpathSync(I)}catch{const p=k(I);return E.accessSync(p,E.constants.R_OK),p}}e.realpathSync=S;function k(I){return(0,M.rtrim)((0,t.normalize)(I),t.sep)}}),define(ee[141],ie([0,1,27,9,23]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var m;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(m||(m={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class k{constructor(c,n,r){this.exePath=c,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await C.SymlinkSupport.existsFile(this.exePath)),this.a}}function I({useAlternateBitness:u=!1}={}){return u?w===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:u=!1,findPreview:c=!1}={}){const n=I({useAlternateBitness:u});if(!n)return null;const r=t.join(n,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(r))return null;let i=-1,a=null;for(const o of await C.Promises.readdir(r)){let y=-1;if(c){const O=o.indexOf("-");if(O<0)continue;const N=o.substring(0,O);if(!M.test(N)||o.substring(O+1)!=="preview")continue;y=parseInt(N,10)}else{if(!M.test(o))continue;y=parseInt(o,10)}if(y<=i)continue;const D=t.join(r,o,"pwsh.exe");!await C.SymlinkSupport.existsFile(D)||(a=D,i=y)}if(!a)return null;const s=n.includes("x86")?" (x86)":"",l=c?" Preview":"";return new k(a,`PowerShell${l}${s}`,!0)}async function p({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=u?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await C.Promises.readdir(c))if(n.test(i)){const a=t.join(c,i,"pwsh.exe");return new k(a,r)}return null}function g(){const u=t.join(E.homedir(),".dotnet","tools","pwsh.exe");return new k(u,".NET Core PowerShell Global Tool")}function b(){const u=t.join(process.env.windir,w===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(u,"Windows PowerShell",!0)}async function*h(){let u=await f();u&&(yield u),u=await f({useAlternateBitness:!0}),u&&(yield u),u=await p(),u&&(yield u),u=g(),u&&(yield u),u=await f({findPreview:!0}),u&&(yield u),u=await p({findPreview:!0}),u&&(yield u),u=await f({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=b(),u&&(yield u)}async function*v(){for await(const u of h())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=v;async function d(){for await(const u of v())return u;return null}e.getFirstAvailablePowerShellInstallation=d}),define(ee[82],ie([0,1,9,4,32,79,12,23]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function m(k=C.env){return k.comspec||"cmd.exe"}e.getWindowsShell=m;function w(k){let I=[],f=!1;const p=function(g){if(f){I.push(g);return}(!k.send(g,h=>{if(h&&console.error(h),f=!1,I.length>0){const v=I.slice(0);I=[],v.forEach(d=>p(d))}})||t.isWindows)&&(f=!0)};return{send:p}}e.createQueuedSender=w;var S;(function(k){async function I(f,p,g){if(E.isAbsolute(f))return f;if(p===void 0&&(p=C.cwd()),E.dirname(f)!=="."||(g===void 0&&A.isString(C.env.PATH)&&(g=C.env.PATH.split(E.delimiter)),g===void 0||g.length===0))return E.join(p,f);async function h(v){if(await P.Promises.exists(v)){let d;try{d=await P.Promises.stat(v)}catch(u){u.message.startsWith("EACCES")&&(d=await P.Promises.lstat(v))}return d?!d.isDirectory():!1}return!1}for(const v of g){let d;if(E.isAbsolute(v)?d=E.join(v,f):d=E.join(p,v,f),await h(d))return d;let u=d+".com";if(await h(u)||(u=d+".exe",await h(u)))return u}return E.join(p,f)}k.findExecutable=I})(S=e.win32||(e.win32={}))}),define(ee[101],ie([0,1,45,14]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function C(A){return new Promise((P,m)=>{let w;const S=new Map;function k(f,p,g,b,h){const v=S.get(p);if(f===A||v){const d={name:I(g),cmd:g,pid:f,ppid:p,load:b,mem:h};S.set(f,d),f===A&&(w=d),v&&(v.children||(v.children=[]),v.children.push(d),v.children.length>1&&(v.children=v.children.sort((u,c)=>u.pid-c.pid)))}}function I(f){const p=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,h=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,d=/--crashes-directory/,u=/\\pipe\\winpty-control/,c=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(d.exec(f))return"electron-crash-reporter";if(u.exec(f))return"winpty-process";if(c.exec(f))return"console-window-host (Windows internal process)";let r=n.exec(f);if(r&&r.length===2){if(r[1]==="renderer")return p.exec(f)?"shared-process":g.exec(f)?"issue-reporter":b.exec(f)?"process-explorer":"window";if(r[1]==="utility"){if(h.exec(f))return"utility-network-service";if(v.exec(f))return"extension-host"}return r[1]}const i=/[a-zA-Z-]+\.js/g;let a="";do r=i.exec(f),r&&(a+=r+" ");while(r);return a&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${a}`:f}if(process.platform==="win32"){const f=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,g)=>{q(["windows-process-tree"],p,g)}).then(p=>{p.getProcessList(A,g=>{if(!g){m(new Error(`Root process ${A} not found`));return}p.getProcessCpuUsage(g,b=>{const h=new Map;b.forEach(v=>{const d=f(v.commandLine||"");h.set(v.pid,{name:I(d),cmd:d,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),w=h.get(A),w?(h.forEach(v=>{const d=h.get(v.ppid);d&&(d.children||(d.children=[]),d.children.push(v))}),h.forEach(v=>{v.children&&(v.children=v.children.sort((d,u)=>d.pid-u.pid))}),P(w)):m(new Error(`Root process ${A} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let f=function(){let p=[w];const g=[];for(;p.length;){const h=p.shift();h&&(g.push(h.pid),h.children&&(p=p.concat(h.children)))}let b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+g.join(" "),(0,E.exec)(b,{},(h,v,d)=>{if(h||d)m(h||new Error(d.toString()));else{const u=v.toString().split(`
`);for(let c=0;c<g.length;c++){const n=S.get(g[c]);n.load=parseFloat(u[c])}if(!w){m(new Error(`Root process ${A} not found`));return}P(w)}})};(0,E.exec)("which ps",{},(p,g,b)=>{if(p||b)if(process.platform!=="linux")m(p||new Error(b.toString()));else{const h=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(h,{},(v,d,u)=>{v||u?m(v||new Error(u.toString())):(M(d,k),f())})}else{const h=g.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${h} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,u,c)=>{d||c&&!c.includes("screen size is bogus")?m(d||new Error(c.toString())):(M(u,k),process.platform==="linux"?f():w?P(w):m(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=C;function M(A,P){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=A.toString().split(`
`);for(const S of w){const k=m.exec(S.trim());k&&k.length===6&&P(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(ee[142],ie([0,1,27,4,141,82]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(f,p){return f===1?t.isWindows?k():M.getWindowsShell(p):w(f,p)}e.getSystemShell=A;function P(f,p){return f===1?t.isWindows?I(p):M.getWindowsShell(p):w(f,p)}e.getSystemShellSync=P;let m=null;function w(f,p){if(t.isLinux&&f===2||t.isMacintosh&&f===3)return"/bin/bash";if(!m){let g;if(t.isWindows)g="/bin/bash";else{if(g=p.SHELL,!g)try{g=(0,E.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}m=g}return m}let S=null;async function k(){return S||(S=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),S}function I(f){if(S)return S;const p=t.isWindows&&parseFloat((0,E.release)())>=10,g=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${f.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return p?b:M.getWindowsShell(f)}});var pe=this&&this.__decorate||function(q,e,E,t){var C=arguments.length,M=C<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,E):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(q,e,E,t);else for(var P=q.length-1;P>=0;P--)(A=q[P])&&(M=(C<3?A(M):C>3?A(e,E,M):A(e,E))||M);return C>3&&M&&Object.defineProperty(e,E,M),M};define(ee[46],ie([0,1,24,8,17,22,53,15,3,2,68,25,12]),function(q,e,E,t,C,M,A,P,m,w,S,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var f;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(f||(f={}));function p(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(g||(g={}));function b(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(h||(h={}));class v{constructor(L){this.b=L,this.a=0}read(L){const T=this.b.slice(this.a,this.a+L);return this.a+=T.byteLength,T}}class d{constructor(){this.a=[]}get buffer(){return C.VSBuffer.concat(this.a)}write(L){this.a.push(L)}}var u;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(u||(u={}));function c(F){const L=C.VSBuffer.alloc(4);return L.writeUInt32BE(F,0),L}function n(F){return F.read(4).readUInt32BE(0)}function r(F){const L=C.VSBuffer.alloc(1);return L.writeUInt8(F,0),L}const i={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object)},a=typeof Buffer<"u";function s(F,L){if(typeof L>"u")F.write(i.Undefined);else if(typeof L=="string"){const T=C.VSBuffer.fromString(L);F.write(i.String),F.write(c(T.byteLength)),F.write(T)}else if(a&&Buffer.isBuffer(L)){const T=C.VSBuffer.wrap(L);F.write(i.Buffer),F.write(c(T.byteLength)),F.write(T)}else if(L instanceof C.VSBuffer)F.write(i.VSBuffer),F.write(c(L.byteLength)),F.write(L);else if(Array.isArray(L)){F.write(i.Array),F.write(c(L.length));for(const T of L)s(F,T)}else{const T=C.VSBuffer.fromString(JSON.stringify(L));F.write(i.Object),F.write(c(T.byteLength)),F.write(T)}}function l(F){switch(F.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return F.read(n(F)).toString();case u.Buffer:return F.read(n(F)).buffer;case u.VSBuffer:return F.read(n(F));case u.Array:{const T=n(F),U=[];for(let Q=0;Q<T;Q++)U.push(l(F));return U}case u.Object:return JSON.parse(F.read(n(F)).toString())}}class o{constructor(L,T,U=null,Q=1e3){this.h=L,this.j=T,this.k=U,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(B=>this.p(B)),this.m({type:200})}registerChannel(L,T){this.b.set(L,T),setTimeout(()=>this.v(L),0)}m(L){switch(L.type){case 200:{const T=this.n([L.type]);this.k?.logOutgoing(T,0,1,b(L.type));return}case 201:case 202:case 204:case 203:{const T=this.n([L.type,L.id],L.data);this.k?.logOutgoing(T,L.id,1,b(L.type),L.data);return}}}n(L,T=void 0){const U=new d;return s(U,L),s(U,T),this.o(U.buffer)}o(L){try{return this.h.send(L),L.byteLength}catch{return 0}}p(L){const T=new v(L),U=l(T),Q=l(T),B=U[0];switch(B){case 100:return this.k?.logIncoming(L.byteLength,U[1],1,`${p(B)}: ${U[2]}.${U[3]}`,Q),this.q({type:B,id:U[1],channelName:U[2],name:U[3],arg:Q});case 102:return this.k?.logIncoming(L.byteLength,U[1],1,`${p(B)}: ${U[2]}.${U[3]}`,Q),this.s({type:B,id:U[1],channelName:U[2],name:U[3],arg:Q});case 101:return this.k?.logIncoming(L.byteLength,U[1],1,`${p(B)}`),this.t({type:B,id:U[1]});case 103:return this.k?.logIncoming(L.byteLength,U[1],1,`${p(B)}`),this.t({type:B,id:U[1]})}}q(L){const T=this.b.get(L.channelName);if(!T){this.u(L);return}const U=new M.CancellationTokenSource;let Q;try{Q=T.call(this.j,L.name,L.arg,U.token)}catch(R){Q=Promise.reject(R)}const B=L.id;Q.then(R=>{this.m({id:B,data:R,type:201}),this.d.delete(L.id)},R=>{R instanceof Error?this.m({id:B,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.m({id:B,data:R,type:203}),this.d.delete(L.id)});const H=(0,w.toDisposable)(()=>U.cancel());this.d.set(L.id,H)}s(L){const T=this.b.get(L.channelName);if(!T){this.u(L);return}const U=L.id,B=T.listen(this.j,L.name,L.arg)(H=>this.m({id:U,data:H,type:204}));this.d.set(L.id,B)}t(L){const T=this.d.get(L.id);T&&(T.dispose(),this.d.delete(L.id))}u(L){let T=this.g.get(L.channelName);T||(T=[],this.g.set(L.channelName,T));const U=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);T.push({request:L,timeoutTimer:U})}v(L){const T=this.g.get(L);if(T){for(const U of T)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.q(U.request);break;case 102:this.s(U.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=o;var y;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(L,T=null){this.l=L,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(U=>this.r(U)),this.j=T}getChannel(L){const T=this;return{call(U,Q,B){return T.a?Promise.reject(new P.CancellationError):T.m(L,U,Q,B)},listen(U,Q){return T.a?m.Event.None:T.n(L,U,Q)}}}m(L,T,U,Q=M.CancellationToken.None){const B=this.g++,R={id:B,type:100,channelName:L,name:T,arg:U};if(Q.isCancellationRequested)return Promise.reject(new P.CancellationError);let W;return new Promise((z,J)=>{if(Q.isCancellationRequested)return J(new P.CancellationError);const ne=()=>{const ae=ge=>{switch(ge.type){case 201:this.f.delete(B),z(ge.data);break;case 202:{this.f.delete(B);const Me=new Error(ge.data.message);Me.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,Me.name=ge.data.name,J(Me);break}case 203:this.f.delete(B),J(ge.data);break}};this.f.set(B,ae),this.o(R)};let j=null;this.b===h.Idle?ne():(j=(0,t.createCancelablePromise)(ae=>this.t()),j.then(()=>{j=null,ne()}));const x=()=>{j?(j.cancel(),j=null):this.o({id:B,type:101}),J(new P.CancellationError)},_=Q.onCancellationRequested(x);W=(0,w.combinedDisposable)((0,w.toDisposable)(x),_),this.d.add(W)}).finally(()=>{this.d.delete(W)})}n(L,T,U){const Q=this.g++,H={id:Q,type:102,channelName:L,name:T,arg:U};let R=null;const W=new m.Emitter({onWillAddFirstListener:()=>{R=(0,t.createCancelablePromise)(z=>this.t()),R.then(()=>{R=null,this.d.add(W),this.o(H)})},onDidRemoveLastListener:()=>{R?(R.cancel(),R=null):(this.d.delete(W),this.o({id:Q,type:103}))}}),$=z=>W.fire(z.data);return this.f.set(Q,$),W.event}o(L){switch(L.type){case 100:case 102:{const T=this.p([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(T,L.id,0,`${p(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const T=this.p([L.type,L.id]);this.j?.logOutgoing(T,L.id,0,p(L.type));return}}}p(L,T=void 0){const U=new d;return s(U,L),s(U,T),this.q(U.buffer)}q(L){try{return this.l.send(L),L.byteLength}catch{return 0}}r(L){const T=new v(L),U=l(T),Q=l(T),B=U[0];switch(B){case 200:return this.j?.logIncoming(L.byteLength,0,0,b(B)),this.s({type:U[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,U[1],0,b(B),Q),this.s({type:U[0],id:U[1],data:Q})}}s(L){if(L.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}t(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.dispose)(this.d.values()),this.d.clear()}}pe([A.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class O{get connections(){const L=[];return this.f.forEach(T=>L.push(T)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new m.Emitter,this.onDidAddConnection=this.g.event,this.h=new m.Emitter,this.onDidRemoveConnection=this.h.event,L(({protocol:T,onDidClientDisconnect:U})=>{m.Event.once(T.onMessage)(B=>{const H=new v(B),R=l(H),W=new o(T,R),$=new D(T);this.a.forEach((J,ne)=>W.registerChannel(ne,J));const z={channelServer:W,channelClient:$,ctx:R};this.f.add(z),this.g.fire(z),U(()=>{W.dispose(),$.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(L,T){const U=this;return{call(Q,B,H){let R;if((0,I.isFunction)(T)){const $=(0,E.getRandomElement)(U.connections.filter(T));R=$?Promise.resolve($):m.Event.toPromise(m.Event.filter(U.onDidAddConnection,T))}else R=T.routeCall(U,Q,B);const W=R.then($=>$.channelClient.getChannel(L));return Y(W).call(Q,B,H)},listen(Q,B){if((0,I.isFunction)(T))return U.j(L,T,Q,B);const H=T.routeEvent(U,Q,B).then(R=>R.channelClient.getChannel(L));return Y(H).listen(Q,B)}}}j(L,T,U,Q){const B=this;let H=new w.DisposableStore;const R=new m.Emitter({onWillAddFirstListener:()=>{H=new w.DisposableStore;const W=new m.EventMultiplexer,$=new Map,z=ne=>{const x=ne.channelClient.getChannel(L).listen(U,Q),_=W.add(x);$.set(ne,_)},J=ne=>{const j=$.get(ne);!j||(j.dispose(),$.delete(ne))};B.connections.filter(T).forEach(z),m.Event.filter(B.onDidAddConnection,T)(z,void 0,H),B.onDidRemoveConnection(J,void 0,H),W.event(R.fire,R,H),H.add(W)},onDidRemoveLastListener:()=>{H.dispose()}});return R.event}registerChannel(L,T){this.a.set(L,T),this.f.forEach(U=>{U.channelServer.registerChannel(L,T)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class N{constructor(L,T,U=null){const Q=new d;s(Q,T),L.send(Q.buffer),this.a=new D(L,U),this.d=new o(L,T,U)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,T){this.d.registerChannel(L,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function Y(F){return{call(L,T,U){return F.then(Q=>Q.call(L,T,U))},listen(L,T){const U=new m.Relay;return F.then(Q=>U.input=Q.listen(L,T)),U.event}}}e.getDelayedChannel=Y;function G(F){let L=!1;return{call(T,U,Q){return L?F.call(T,U,Q):(0,t.timeout)(0).then(()=>L=!0).then(()=>F.call(T,U,Q))},listen(T,U){if(L)return F.listen(T,U);const Q=new m.Relay;return(0,t.timeout)(0).then(()=>L=!0).then(()=>Q.input=F.listen(T,U)),Q.event}}}e.getNextTickChannel=G;class V{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const T of L.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await m.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.StaticRouter=V;var se;(function(F){function L(B,H){const R=B,W=H&&H.disableMarshalling,$=new Map;for(const z in R)U(z)&&$.set(z,m.Event.buffer(R[z],!0));return new class{listen(z,J,ne){const j=$.get(J);if(j)return j;if(Q(J)){const x=R[J];if(typeof x=="function")return x.call(R,ne)}throw new Error(`Event not found: ${J}`)}call(z,J,ne){const j=R[J];if(typeof j=="function"){if(!W&&Array.isArray(ne))for(let x=0;x<ne.length;x++)ne[x]=(0,S.revive)(ne[x]);return j.apply(R,ne)}throw new Error(`Method not found: ${J}`)}}}F.fromService=L;function T(B,H){const R=H&&H.disableMarshalling;return new Proxy({},{get(W,$){if(typeof $=="string")return H?.properties?.has($)?H.properties.get($):Q($)?function(z){return B.listen($,z)}:U($)?B.listen($):async function(...z){let J;H&&!(0,I.isUndefinedOrNull)(H.context)?J=[H.context,...z]:J=z;const ne=await B.call($,J);return R?ne:(0,S.revive)(ne)};throw new Error(`Property not found: ${String($)}`)}})}F.toService=T;function U(B){return B[0]==="o"&&B[1]==="n"&&k.isUpperAsciiLetter(B.charCodeAt(2))}function Q(B){return/^onDynamic/.test(B)&&k.isUpperAsciiLetter(B.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const L=F.toString();if(L!=="[object Object]")return L}return F}function de(F){return Array.isArray(F)?F.map(re):re(F)}function X(F,L,T,U,Q,B,H){H=de(H);const R=oe[Q],W=R[U%R.length];let $=[`%c[${F}]%c[${String(L).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(B)?($=$.concat(H),$.push(")")):$.push(H),console.log.apply(console,$)}class le{constructor(L,T){this.d=L,this.f=T,this.a=0,this.b=0}logOutgoing(L,T,U,Q,B){this.b+=L,X(this.d,this.b,L,T,U,Q,B)}logIncoming(L,T,U,Q,B){this.a+=L,X(this.f,this.a,L,T,U,Q,B)}}e.IPCLogger=le}),define(ee[143],ie([0,1,17,3,46]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(m){this.a=m,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",w=>E.VSBuffer.wrap(w.data)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}e.Protocol=M;class A extends C.IPCClient{constructor(m,w){const S=new M(m);super(S,w),this.b=S}dispose(){this.b.disconnect()}}e.Client=A}),define(ee[102],ie([0,1,17,3,2,46]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(a){a.enableDiagnostics=!1,a.records=[];const s=new WeakMap;let l=0;function o(D,O){if(!s.has(D)){const N=String(++l);s.set(D,N)}return s.get(D)}function y(D,O,N,Y){if(!a.enableDiagnostics)return;const G=o(D,O);if(Y instanceof E.VSBuffer||Y instanceof Uint8Array||Y instanceof ArrayBuffer||ArrayBuffer.isView(Y)){const V=E.VSBuffer.alloc(Y.byteLength);V.set(Y),a.records.push({timestamp:Date.now(),id:G,label:O,type:N,buff:V})}else a.records.push({timestamp:Date.now(),id:G,label:O,type:N,data:Y})}a.traceSocketEvent=y})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var m;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function S(){return w||(w=E.VSBuffer.alloc(0)),w}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,l){if(s===0)return S();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const O=this.a[0];return l&&(this.a.shift(),this.b-=s),O}if(this.a[0].byteLength>s){const O=this.a[0].slice(0,s);return l&&(this.a[0]=this.a[0].slice(s),this.b-=s),O}const o=E.VSBuffer.alloc(s);let y=0,D=0;for(;s>0;){const O=this.a[D];if(O.byteLength>s){const N=O.slice(0,s);o.set(N,y),y+=s,l&&(this.a[D]=O.slice(s),this.b-=s),s-=s}else o.set(O,y),y+=O.byteLength,l?(this.a.shift(),this.b-=O.byteLength):D++,s-=O.byteLength}return o}}e.ChunkStream=k;var I;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(I||(I={}));function f(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var p;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(s,l,o,y){this.type=s,this.id=l,this.ack=o,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends C.Disposable{constructor(s){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new k,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,y=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new g(o,y,D,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=E.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(l,s.data)}g(s,l){const o=this.f===0;return this.d.push(s,l),this.f+=s.byteLength+l.byteLength,o}h(){const s=E.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,l){this.g(s,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class v extends C.Disposable{constructor(s){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new h(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new g(1,0,0,s))}}e.Protocol=v;class d extends M.IPCClient{static fromSocket(s,l){return new d(new v(s),l)}get onDidDispose(){return this.b.onDidDispose}constructor(s,l,o=null){super(s,l,o),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.Client=d;class u{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.BufferedEmitter=u;class c{constructor(s){this.data=s,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let s=0,l=this.a;for(;l;)l=l.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let l=0,o=this.a;for(;o;)s[l++]=o.data,o=o.next;return s}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const l=new c(s);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const s=Date.now();for(let l=0;l<r.a;l++)this.c[l]=s-1e3*l;setInterval(()=>{for(let l=r.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),l=(1+r.a)*1e3;let o=0;for(let y=0;y<r.a;y++)s-this.c[y]<=l&&o++;return 1-o/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;class i{get unacknowledgedCount(){return this.c-this.d}constructor(s,l=null,o=r.getInstance()){this.t=new u,this.onControlMessage=this.t.event,this.u=new u,this.onMessage=this.u.event,this.v=new u,this.onDidDispose=this.v.event,this.w=new u,this.onSocketClose=this.w.event,this.x=new u,this.onSocketTimeout=this.x.event,this.s=o,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=s,this.p=new h(this.o),this.r.push(this.p),this.q=new b(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(y=>this.y(y))),this.r.push(this.o.onClose(y=>this.w.fire(y))),l&&this.q.acceptChunk(l),this.l=setInterval(()=>{this.D()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,C.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const s=new g(5,0,0,S());this.p.write(s),this.p.flush()}sendPause(){const s=new g(7,0,0,S());this.p.write(s)}sendResume(){const s=new g(8,0,0,S());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,l){this.a=!0,this.r=(0,C.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=new h(this.o),this.r.push(this.p),this.q=new b(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(o=>this.y(o))),this.r.push(this.o.onClose(o=>this.w.fire(o))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new g(3,0,this.h,S());this.p.write(s);const l=this.b.toArray();for(let o=0,y=l.length;o<y;o++)this.p.write(l[o]);this.B()}acceptDisconnect(){this.v.fire()}y(s){if(s.ack>this.d){this.d=s.ack;do{const l=this.b.peek();if(l&&l.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new g(6,0,0,S())))}else this.g=s.id,this.j=Date.now(),this.A(),this.u.fire(s.data);break}case 2:{this.t.fire(s.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const l=this.b.toArray();for(let o=0,y=l.length;o<y;o++)this.p.write(l[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const l=++this.c;this.h=this.g;const o=new g(1,l,this.h,s);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(s){const l=new g(2,0,0,s);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),l=Date.now()-s.writtenTime,o=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(l>=2e4&&o>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:o});return}const D=Math.max(2e4-l,2e4-o,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new g(3,0,this.h,S());this.p.write(s)}D(){const s=new g(9,0,0,S());this.p.write(s)}}e.PersistentProtocol=i}),define(ee[144],ie([0,1,41,17,3,2,46,129]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function m(S,k){const I=C.Event.fromNodeEventEmitter(E.validatedIpcMain,k,(p,g)=>({event:p,message:g})),f=C.Event.filter(I,({event:p})=>p.sender.id===S);return C.Event.map(f,({message:p})=>p&&t.VSBuffer.wrap(p))}class w extends A.IPCServer{static d(){const k=C.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:I})=>I);return C.Event.map(k,I=>{const f=I.id;w.b.get(f)?.dispose();const g=new C.Emitter;w.b.set(f,(0,M.toDisposable)(()=>g.fire()));const b=m(f,"vscode:message"),h=C.Event.any(C.Event.signal(m(f,"vscode:disconnect")),g.event);return{protocol:new P.Protocol(I,b),onDidClientDisconnect:h}})}constructor(){super(w.d())}}e.Server=w,w.b=new Map}),define(ee[103],ie([0,1,41,3,29,143]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class A extends M.Client{constructor(w,S){super({addEventListener:(k,I)=>w.addListener(k,I),removeEventListener:(k,I)=>w.removeListener(k,I),postMessage:k=>w.postMessage(k),start:()=>w.start(),close:()=>w.close()},S)}}e.Client=A;async function P(m){if(m.isDestroyed()||m.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,C.generateUuid)();m.webContents.send("vscode:createMessageChannel",w);const S=t.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(I,f)=>({nonce:f,port:I.ports[0]})),{port:k}=await t.Event.toPromise(t.Event.once(t.Event.filter(S,I=>I.nonce===w)));return k}e.connect=P}),define(ee[145],ie([0,1,45,8,17,22,138,15,3,2,50,82,79,46]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(h){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",v=>C.VSBuffer.wrap(Buffer.from(v,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=p;class g{constructor(h,v){this.i=h,this.j=v,this.c=new Set,this.g=new Map,this.h=new m.Emitter,this.onDidProcessExit=this.h.event;const d=v&&v.timeout?v.timeout:6e4;this.b=new t.Delayer(d),this.d=null,this.f=null}getChannel(h){const v=this;return{call(d,u,c){return v.k(h,d,u,c)},listen(d,u){return v.l(h,d,u)}}}k(h,v,d,u=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const c=this.n(h),n=(0,t.createCancelablePromise)(a=>c.call(v,d,a)),r=u.onCancellationRequested(()=>n.cancel()),i=(0,w.toDisposable)(()=>n.cancel());return this.c.add(i),n.finally(()=>{r.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(h,v,d){if(!this.b)return m.Event.None;this.b.cancel();let u;const c=new m.Emitter({onWillAddFirstListener:()=>{u=this.n(h).listen(v,d)(c.fire,c),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],v=Object.create(null);v.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(v.env={...v.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(v.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,I.removeDangerousEnvVariables)(v.env),this.d=(0,E.fork)(this.i,h,v);const d=new m.Emitter;m.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.isRemoteConsoleLog)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}d.fire(C.VSBuffer.wrap(Buffer.from(s,"base64")))});const c=this.j.useQueue?(0,k.createQueuedSender)(this.d):this.d,n=s=>this.d&&this.d.connected&&c.send(s.buffer.toString("base64")),r=d.event,i={send:n,onMessage:r};this.f=new f.ChannelClient(i);const a=()=>this.o();process.once("exit",a),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,l)=>{process.removeListener("exit",a),this.c.forEach(o=>(0,w.dispose)(o)),this.c.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:l})})}return this.f}n(h){let v=this.g.get(h);return v||(v=this.m.getChannel(h),this.g.set(h,v)),v}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=g}),define(ee[83],ie([0,1,17,15,3,2,9,4,29,46,102]),function(q,e,E,t,C,M,A,P,m,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class I{traceSocketEvent(o,y){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,y)}constructor(o,y=""){this.f=!0,this.debugLabel=y,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,t.onUnexpectedError)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const y=D=>{this.traceSocketEvent("read",D),o(E.VSBuffer.wrap(D))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(o){const y=D=>{o({type:0,hadError:D,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(o){const y=()=>{o()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,t.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,t.onUnexpectedError)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=I;var f;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var p;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(p||(p={}));class g extends M.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,y){this.socket.traceSocketEvent(o,y)}constructor(o,y,D,O){super(),this.f=this.B(new C.Emitter),this.g=this.B(new C.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:D?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new b(this,y,D,O,this.f,(N,Y)=>this.k(N,Y))),this.B(this.a.onError(N=>{console.error(N),(0,t.onUnexpectedError)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new S.ChunkStream,this.B(this.socket.onData(N=>this.l(N))),this.B(this.socket.onClose(N=>this.g.fire(N)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,y){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let D=2;o.byteLength<126?D+=0:o.byteLength<2**16?D+=2:D+=8;const O=E.VSBuffer.alloc(D);if(y?O.writeUInt8(194,0):O.writeUInt8(130,0),o.byteLength<126)O.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(o.byteLength>>>8&255,++N),O.writeUInt8(o.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(o.byteLength>>>24&255,++N),O.writeUInt8(o.byteLength>>>16&255,++N),O.writeUInt8(o.byteLength>>>8&255,++N),O.writeUInt8(o.byteLength>>>0&255,++N)}this.socket.write(E.VSBuffer.concat([O,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),D=y.readUInt8(0),O=(D&128)>>>7,N=(D&64)>>>6,Y=y.readUInt8(1),G=(Y&128)>>>7,V=Y&127;this.j.state=2,this.j.readLen=2+(G?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(N)),this.j.firstFrameOfMessage=Boolean(O),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),D=y.readUInt8(1),O=(D&128)>>>7;let N=D&127,Y=1;N===126?N=y.readUInt8(++Y)*2**8+y.readUInt8(++Y):N===127&&(N=y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*2**24+y.readUInt8(++Y)*2**16+y.readUInt8(++Y)*2**8+y.readUInt8(++Y));let G=0;O&&(G=y.readUInt8(++Y)*2**24+y.readUInt8(++Y)*2**16+y.readUInt8(++Y)*2**8+y.readUInt8(++Y)),this.j.state=3,this.j.readLen=N,this.j.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),d(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(y,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class b extends M.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(o,y,D,O,N,Y){super(),this.k=o,this.l=N,this.m=Y,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,y?(this.b=this.B(new h(this.k,O,D,{windowBits:15})),this.f=this.B(new v(this.k,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const y=await this.r(this.f,o);this.m(y,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,y){return new Promise((D,O)=>{o.write(y),o.flush(N=>D(N))})}acceptFrame(o,y,D){this.h.push({data:o,isCompressed:y,isLastFrameOfMessage:D}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const y=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(y)}else this.l.fire(o.data)}this.s=!1}}u(o,y,D){return new Promise((O,N)=>{o.write(y),D&&o.write(E.VSBuffer.fromByteArray([0,0,255,255])),o.flush(Y=>O(Y))})}}class h extends M.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(o,y,D,O){super(),this.h=o,this.j=y,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=k().zlib.createInflateRaw(O),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(E.VSBuffer.wrap(N))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=E.VSBuffer.concat(this.g);this.g.length=0,o(y)})}}class v extends M.Disposable{constructor(o,y){super(),this.g=o,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.b=k().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(E.VSBuffer.wrap(D))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=E.VSBuffer.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),o(y)})}}function d(l,o){if(o===0)return;const y=l.byteLength>>>2;for(let V=0;V<y;V++){const se=l.readUInt32BE(V*4);l.writeUInt32BE(se^o,V*4)}const D=y*4,O=l.byteLength-D,N=o>>>24&255,Y=o>>>16&255,G=o>>>8&255;O>=1&&l.writeUInt8(l.readUInt8(D)^N,D),O>=2&&l.writeUInt8(l.readUInt8(D+1)^Y,D+1),O>=3&&l.writeUInt8(l.readUInt8(D+2)^G,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const u={[2]:107,[1]:103};function c(){const l=(0,m.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):o=(0,A.join)(k().os.tmpdir(),`vscode-ipc-${l}.sock`),r(o),o}e.createRandomIPCHandle=c;function n(l,o,y){const D=k().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${y}-${o}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${y}-${o}.sock`):O=(0,A.join)(l,`${y}-${o}.sock`),r(O),O}e.createStaticIPCHandle=n;function r(l){const o=u[P.platform];typeof o=="number"&&l.length>=o&&console.warn(`WARNING: IPC handle "${l}" is longer than ${o} chars, try a shorter --user-data-dir`)}class i extends w.IPCServer{static b(o){const y=C.Event.fromNodeEventEmitter(o,"connection");return C.Event.map(y,D=>({protocol:new S.Protocol(new I(D,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(D,"close"))}))}constructor(o){super(i.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function a(l){return new Promise((o,y)=>{const D=k().net.createServer();D.on("error",y),D.listen(l,()=>{D.removeListener("error",y),o(new i(D))})})}e.serve=a;function s(l,o){return new Promise((y,D)=>{const O=k().net.createConnection(l,()=>{O.removeListener("error",D),y(S.Client.fromSocket(new I(O,`ipc-client${o}`),o))});O.once("error",D)})}e.connect=s}),define(ee[104],ie([0,1,8,3,2,12]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function P(k){const I=k;return I?.changed instanceof Map||I?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var m;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(m=e.StorageState||(e.StorageState={}));class w extends C.Disposable{constructor(I,f=Object.create(null)){super(),this.m=I,this.n=f,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=new E.ThrottledDelayer(w.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(I=>this.r(I)))}r(I){I.changed?.forEach((f,p)=>this.s(p,f)),I.deleted?.forEach(f=>this.s(f,void 0))}s(I,f){if(this.c===m.Closed)return;let p=!1;(0,M.isUndefinedOrNull)(f)?p=this.f.delete(I):this.f.get(I)!==f&&(this.f.set(I,f),p=!0),p&&this.b.fire(I)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.n.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(I,f){const p=this.f.get(I);return(0,M.isUndefinedOrNull)(p)?f:p}getBoolean(I,f){const p=this.get(I);return(0,M.isUndefinedOrNull)(p)?f:p==="true"}getNumber(I,f){const p=this.get(I);return(0,M.isUndefinedOrNull)(p)?f:parseInt(p,10)}async set(I,f){if(this.c===m.Closed)return;if((0,M.isUndefinedOrNull)(f))return this.delete(I);const p=String(f);if(this.f.get(I)!==p)return this.f.set(I,p),this.j.set(I,p),this.h.delete(I),this.b.fire(I),this.w()}async delete(I){if(!(this.c===m.Closed||!this.f.delete(I)))return this.h.has(I)||this.h.add(I),this.j.delete(I),this.b.fire(I),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=m.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const I={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(I).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(I){if(!!this.u)return this.w(I)}async w(I){return this.g.trigger(()=>this.v(),I)}async whenFlushed(){if(!!this.u)return new Promise(I=>this.l.push(I))}dispose(){this.g.dispose(),super.dispose()}}e.Storage=w,w.a=100;class S{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(I){I.insert?.forEach((f,p)=>this.a.set(p,f)),I.delete?.forEach(f=>this.a.delete(f))}async close(){}}e.InMemoryStorageDatabase=S}),define(ee[146],ie([0,1,8,3,39,9,23]),function(q,e,E,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return t.Event.None}constructor(S,k=Object.create(null)){this.g=S,this.h=k,this.c=(0,M.basename)(this.g),this.d=new m(this.h.logging),this.f=this.n(this.g)}async getItems(){const S=await this.f,k=new Map;return(await this.s(S,"SELECT * FROM ItemTable")).forEach(f=>k.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${k.size} rows`),k}async updateItems(S){const k=await this.f;return this.j(k,S)}j(S,k){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${k.insert?(0,C.mapToString)(k.insert):"0"}), delete(${k.delete?(0,C.setToString)(k.delete):"0"})`),this.t(S,()=>{const I=k.insert,f=k.delete;if(I&&I.size>0){const p=[];p.push([]);let g=0;I.forEach((b,h)=>{let v=p[g];v.length>P.b&&(g++,v=[],p.push(v)),v.push(h,b)}),p.forEach(b=>{this.u(S,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,h=>h.run(b),()=>{const h=[];let v=0;return I.forEach((d,u)=>{h.push(u),v+=d.length}),`Keys: ${h.join(", ")} Length: ${v}`})})}if(f&&f.size){const p=[];p.push([]);let g=0;f.forEach(b=>{let h=p[g];h.length>P.b&&(g++,h=[],p.push(h)),h.push(b)}),p.forEach(b=>{this.u(S,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,h=>h.run(b),()=>{const h=[];return f.forEach(v=>{h.push(v)}),`Keys: ${h.join(", ")}`})})}})}async close(S){this.d.trace(`[storage ${this.c}] close()`);const k=await this.f;return this.k(k,S)}k(S,k){return new Promise((I,f)=>{S.db.close(p=>(p&&this.o(S,`[storage ${this.c}] close(): ${p}`),this.g===P.IN_MEMORY_PATH?I():!S.isErroneous&&!S.isInMemory?this.l().then(I,g=>(this.d.error(`[storage ${this.c}] backup(): ${g}`),I())):typeof k=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(g=>{const b=()=>this.k(g,void 0);return this.j(g,{insert:k()}).then(()=>b(),h=>(b(),Promise.reject(h)))})).then(I,f):f(p||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const S=this.m(this.g);return A.Promises.copy(this.g,S,{preserveSymlinks:!1})}m(S){return`${S}.backup`}async checkIntegrity(S){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${S})`);const k=await this.f,I=await this.r(k,S?"PRAGMA integrity_check":"PRAGMA quick_check"),f=S?I.integrity_check:I.quick_check;return k.isErroneous?`${f} (last error: ${k.lastError})`:k.isInMemory?`${f} (in-memory!)`:f}async n(S,k=!0){this.d.trace(`[storage ${this.c}] open(${S}, retryOnBusy: ${k})`);try{return await this.p(S)}catch(I){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&k)return await(0,E.timeout)(P.a),this.n(S,!1);try{await A.Promises.unlink(S);try{await A.Promises.rename(this.m(S),S)}catch{}return await this.p(S)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(P.IN_MEMORY_PATH)}}}o(S,k){S.isErroneous=!0,S.lastError=k,this.d.error(k)}p(S){return new Promise((k,I)=>{new Promise((f,p)=>{q(["@vscode/sqlite3"],f,p)}).then(f=>{const p={db:new(this.d.isTracing?f.verbose().Database:f.Database)(S,g=>g?p.db&&g.code!=="SQLITE_CANTOPEN"?p.db.close(()=>I(g)):I(g):this.q(p,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(p),b=>p.db.close(()=>I(b)))),isInMemory:S===P.IN_MEMORY_PATH};p.db.on("error",g=>this.o(p,`[storage ${this.c}] Error (event): ${g}`)),this.d.isTracing&&p.db.on("trace",g=>this.d.trace(`[storage ${this.c}] Trace (event): ${g}`))},I)})}q(S,k){return new Promise((I,f)=>{S.db.exec(k,p=>p?(this.o(S,`[storage ${this.c}] exec(): ${p}`),f(p)):I())})}r(S,k){return new Promise((I,f)=>{S.db.get(k,(p,g)=>p?(this.o(S,`[storage ${this.c}] get(): ${p}`),f(p)):I(g))})}s(S,k){return new Promise((I,f)=>{S.db.all(k,(p,g)=>p?(this.o(S,`[storage ${this.c}] all(): ${p}`),f(p)):I(g))})}t(S,k){return new Promise((I,f)=>{S.db.serialize(()=>{S.db.run("BEGIN TRANSACTION"),k(),S.db.run("END TRANSACTION",p=>p?(this.o(S,`[storage ${this.c}] transaction(): ${p}`),f(p)):I())})})}u(S,k,I,f){const p=S.db.prepare(k),g=b=>{this.o(S,`[storage ${this.c}] prepare(): ${b} (${k}). Details: ${f()}`)};p.on("error",g),I(p),p.finalize(b=>{b&&g(b),p.removeListener("error",g)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.a=2e3,P.b=256;class m{constructor(S){S&&typeof S.logTrace=="function"&&process.env[m.VSCODE_TRACE_STORAGE]&&(this.a=S.logTrace),S&&typeof S.logError=="function"&&(this.b=S.logError)}get isTracing(){return!!this.a}trace(S){this.a?.(S)}error(S){this.b?.(S)}}m.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[147],ie([11,10]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(ee[148],ie([11,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[149],ie([11,10]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[150],ie([11,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(ee[151],ie([11,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(ee[152],ie([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[153],ie([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[154],ie([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[155],ie([11,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[156],ie([11,10]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[157],ie([11,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(ee[158],ie([11,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(ee[159],ie([11,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(ee[160],ie([11,10]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[161],ie([11,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[162],ie([11,10]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[163],ie([11,10]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[164],ie([11,10]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[165],ie([11,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(ee[166],ie([11,10]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(ee[167],ie([11,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[168],ie([11,10]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[169],ie([11,10]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[170],ie([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[171],ie([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[172],ie([11,10]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(ee[173],ie([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[174],ie([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[175],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(C){return C&&C.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function t(C){return C&&C.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ee[176],ie([0,1,7]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(A){return typeof A?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function C(A){let P=[];try{Array.isArray(A.workspaces)&&(P=A.workspaces.map(m=>({workspace:{id:m.id,configPath:E.URI.parse(m.configURIPath)},remoteAuthority:m.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=C;function M(A){let P=[];try{Array.isArray(A.folders)&&(P=A.folders.map(m=>({folderUri:E.URI.parse(m.folderUri),remoteAuthority:m.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=M}),define(ee[177],ie([0,1,3,2]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class C{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(P,m,w){switch(m){case"close":return Promise.resolve(this.a.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(P,m,w){switch(m){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=C,C.ChannelName="extensionhostdebugservice";class M extends t.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,m,w){this.b.call("attach",[P,m,w])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,m){this.b.call("terminate",[P,m])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,m){return this.b.call("openExtensionDevelopmentHostWindow",[P,m])}}e.ExtensionHostDebugChannelClient=M}),define(ee[178],ie([0,1,132,53,14,9,32,20,7]),function(q,e,E,t,C,M,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,M.dirname)(C.FileAccess.asFileUri("").fsPath)}get userHome(){return m.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return m.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.b.tmpDir)}get cacheHome(){return m.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return m.URI.file((0,M.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(m.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=A.env.VSCODE_PORTABLE;return g?m.URI.file((0,M.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,M.resolve)(g):(0,M.normalize)((0,M.join)(C.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?m.URI.file((0,M.resolve)(g)):m.URI.file((0,M.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,M.resolve)(g);const b=A.env.VSCODE_EXTENSIONS;if(b)return b;const h=A.env.VSCODE_PORTABLE;return h?(0,M.join)(h,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(b=>/^[^:/?#]+?:\/\//.test(b)?m.URI.parse(b):m.URI.file((0,M.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?m.URI.parse(g):m.URI.file((0,M.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const b of this.args.log||[]){const h=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(b);h&&h[1]&&h[2]&&g.push([h[1],h[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return m.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=A.env.VSCODE_PORTABLE;return g?m.URI.file((0,M.join)(g,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,b,h){this.a=g,this.b=b,this.c=h,this.editSessionId=this.args.editSessionId}}pe([t.memoize],w.prototype,"appRoot",null),pe([t.memoize],w.prototype,"userHome",null),pe([t.memoize],w.prototype,"userDataPath",null),pe([t.memoize],w.prototype,"appSettingsHome",null),pe([t.memoize],w.prototype,"tmpDir",null),pe([t.memoize],w.prototype,"cacheHome",null),pe([t.memoize],w.prototype,"stateResource",null),pe([t.memoize],w.prototype,"userRoamingDataHome",null),pe([t.memoize],w.prototype,"userDataSyncHome",null),pe([t.memoize],w.prototype,"userDataSyncLogResource",null),pe([t.memoize],w.prototype,"editSessionsLogResource",null),pe([t.memoize],w.prototype,"sync",null),pe([t.memoize],w.prototype,"machineSettingsResource",null),pe([t.memoize],w.prototype,"workspaceStorageHome",null),pe([t.memoize],w.prototype,"localHistoryHome",null),pe([t.memoize],w.prototype,"keyboardLayoutResource",null),pe([t.memoize],w.prototype,"argvResource",null),pe([t.memoize],w.prototype,"isExtensionDevelopment",null),pe([t.memoize],w.prototype,"untitledWorkspacesHome",null),pe([t.memoize],w.prototype,"installSourcePath",null),pe([t.memoize],w.prototype,"builtinExtensionsPath",null),pe([t.memoize],w.prototype,"extensionsPath",null),pe([t.memoize],w.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],w.prototype,"extensionDevelopmentKind",null),pe([t.memoize],w.prototype,"extensionTestsLocationURI",null),pe([t.memoize],w.prototype,"debugExtensionHost",null),pe([t.memoize],w.prototype,"logLevel",null),pe([t.memoize],w.prototype,"extensionLogLevel",null),pe([t.memoize],w.prototype,"serviceMachineIdResource",null),pe([t.memoize],w.prototype,"telemetryLogResource",null),pe([t.memoize],w.prototype,"disableWorkspaceTrust",null),pe([t.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function S(p,g){return f(p["inspect-extensions"],p["inspect-brk-extensions"],5870,g,p.debugId,p.extensionEnvironment)}e.parseExtensionHostPort=S;function k(p,g){return f(p["inspect-search"],p["inspect-brk-search"],5876,g,p.extensionEnvironment)}e.parseSearchPort=k;function I(p,g){return f(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,g,p.extensionEnvironment)}e.parsePtyHostPort=I;function f(p,g,b,h,v,d){const c=Number(g||p)||(h?null:b),n=c?Boolean(!!g):!1;let r;if(d)try{r=JSON.parse(d)}catch{}return{port:c,break:n,debugId:v,env:r}}}),define(ee[105],ie([0,1,276,4,150]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,C.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,C.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,C.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},category:{type:"string",cat:"e",description:(0,C.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,C.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,C.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,C.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,C.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,C.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,C.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,C.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,C.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,C.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,C.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(g,b,h=A){const v=g.find(l=>l.length>0&&l[0]!=="-"),d={},u=["_"],c=[],n={};let r;for(const l in b){const o=b[l];o.type==="subcommand"?l===v&&(r=o):(o.alias&&(d[l]=o.alias),o.type==="string"||o.type==="string[]"?(u.push(l),o.deprecates&&u.push(...o.deprecates)):o.type==="boolean"&&(c.push(l),o.deprecates&&c.push(...o.deprecates)),o.global&&(n[l]=o))}if(r&&v){const l=n;for(const O in r.options)l[O]=r.options[O];const o=g.filter(O=>O!==v),y=h.getSubcommandReporter?h.getSubcommandReporter(v):void 0,D=P(o,l,y);return{[v]:D,_:[]}}const i=E(g,{string:u,boolean:c,alias:d}),a={},s=i;a._=i._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(const l in b){const o=b[l];if(o.type==="subcommand")continue;o.alias&&delete s[o.alias];let y=s[l];if(o.deprecates)for(const D of o.deprecates)s.hasOwnProperty(D)&&(y||(y=s[D],y&&h.onDeprecatedOption(D,o.deprecationMessage||(0,C.localize)(36,null,l))),delete s[D]);if(typeof y<"u"){if(o.type==="string[]"){if(Array.isArray(y)||(y=[y]),!o.allowEmptyValue){const D=y.filter(O=>O.length>0);D.length!==y.length&&(h.onEmptyValue(l),y=D.length>0?D:void 0)}}else o.type==="string"&&(Array.isArray(y)?(y=y.pop(),h.onMultipleValues(l,y)):!y&&!o.allowEmptyValue&&(h.onEmptyValue(l),y=void 0));a[l]=y,o.deprecationMessage&&h.onDeprecatedOption(l,o.deprecationMessage)}delete s[l]}for(const l in s)h.onUnknownOption(l);return a}e.parseArgs=P;function m(g,b){let h="";return b.args&&(Array.isArray(b.args)?h=` <${b.args.join("> <")}>`:h=` <${b.args}>`),b.alias?`-${b.alias} --${g}${h}`:`--${g}${h}`}function w(g,b){const h=[];for(const v in g){const d=g[v],u=m(v,d);h.push([u,d.description])}return S(h,b)}e.formatOptions=w;function S(g,b){const v=g.reduce((c,n)=>Math.max(c,n[0].length),12)+2+1;if(b-v<25)return g.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const d=b-v-1,u=[];for(const c of g){const n=c[0],r=I(c[1],d),i=k(v-n.length-2);u.push("  "+n+i+r[0]);for(let a=1;a<r.length;a++)u.push(k(v)+r[a])}return u}function k(g){return" ".repeat(g)}function I(g,b){const h=[];for(;g.length;){const v=g.length<b?g.length:g.lastIndexOf(" ",b),d=g.slice(0,v).trim();g=g.slice(v),h.push(d)}return h}function f(g,b,h,v,d){const u=process.stdout.isTTY&&process.stdout.columns||80,c=d?.noInputFiles!==!0?`[${(0,C.localize)(37,null)}...]`:"",n=[`${g} ${h}`];n.push(""),n.push(`${(0,C.localize)(38,null)}: ${b} [${(0,C.localize)(39,null)}]${c}`),n.push(""),d?.noPipe!==!0&&(t.isWindows?n.push((0,C.localize)(40,null,b)):n.push((0,C.localize)(41,null,b)),n.push(""));const r={},i=[];for(const a in v){const s=v[a];if(s.type==="subcommand")s.description&&i.push({command:a,description:s.description});else if(s.description&&s.cat){let l=r[s.cat];l||(r[s.cat]=l={}),l[a]=s}}for(const a in r){const s=a,l=r[s];l&&(n.push(M[s]),n.push(...w(l,u)),n.push(""))}return i.length&&(n.push((0,C.localize)(42,null)),n.push(...S(i.map(a=>[a.command,a.description]),u)),n.push("")),n.join(`
`)}e.buildHelpMessage=f;function p(g,b){return`${g||(0,C.localize)(43,null)}
${b||(0,C.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=p}),define(ee[179],ie([0,1,78,177,105]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends t.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.f=P}call(P,m,w){return m==="openExtensionDevelopmentHostWindow"?this.g(w[0],w[1]):super.call(P,m,w)}async g(P,m){const w=(0,C.parseArgs)(P,C.OPTIONS);w.debugRenderer=m;const S=w.extensionDevelopmentPath;if(!S)return{success:!1};const[k]=await this.f.openExtensionDevelopmentHostWindow(S,{context:5,cli:w,forceProfile:w.profile,forceTempProfile:w["profile-temp"]});if(!m)return{success:!0};const I=k.win;if(!I)return{success:!0};const f=I.webContents.debugger;let p=f.isAttached()?1/0:0;const g=(0,E.createServer)(b=>{p++===0&&f.attach();let h=!1;const v=c=>{h||b.write(JSON.stringify(c)+"\0")},d=(c,n,r,i)=>v({method:n,params:r,sessionId:i});I.on("close",()=>{f.removeListener("message",d),b.end(),h=!0}),f.addListener("message",d);let u=Buffer.alloc(0);b.on("data",c=>{u=Buffer.concat([u,c]);for(let n=u.indexOf(0);n!==-1;n=u.indexOf(0)){let r;try{const i=u.slice(0,n).toString("utf8");u=u.slice(n+1),r=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}f.sendCommand(r.method,r.params,r.sessionId).then(i=>v({id:r.id,sessionId:r.sessionId,result:i})).catch(i=>v({id:r.id,sessionId:r.sessionId,error:{code:0,message:i.message}}))}}),b.on("error",c=>{console.error("error on cdp pipe:",c)}),b.on("close",()=>{h=!0,--p===0&&f.detach()})});return await new Promise(b=>g.listen(0,b)),I.on("close",()=>g.close()),{rendererDebugPort:g.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),define(ee[59],ie([0,1,277,151,105]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const M=2048;function A(I,f){const p=(u,c)=>{console.warn((0,t.localize)(0,null,u,c))},g=u=>{console.warn((0,t.localize)(1,null,u))},b=(u,c)=>{console.warn((0,t.localize)(2,null,u,c))},h=u=>({onUnknownOption:c=>{u!=="tunnel"&&console.warn((0,t.localize)(3,null,c,u))},onMultipleValues:p,onEmptyValue:g,onDeprecatedOption:b,getSubcommandReporter:u!=="tunnel"?h:void 0}),v={onUnknownOption:u=>{console.warn((0,t.localize)(4,null,u))},onMultipleValues:p,onEmptyValue:g,onDeprecatedOption:b,getSubcommandReporter:h},d=(0,C.parseArgs)(I,C.OPTIONS,f?v:void 0);return d.goto&&d._.forEach(u=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(u),(0,t.localize)(5,null))),d["max-memory"]&&E(parseInt(d["max-memory"])>=M,`The max-memory argument cannot be specified lower than ${M} MB.`),d}function P(I){const f=I.findIndex(p=>!/^-/.test(p));if(f>-1)return[...I.slice(0,f),...I.slice(f+1)]}function m(I){let[,...f]=I;process.env.VSCODE_DEV&&(f=P(f)||[]);const p=!k(process.env);return A(f,p)}e.parseMainProcessArgv=m;function w(I){let[,,...f]=I;return process.env.VSCODE_DEV&&(f=P(f)||[]),A(f,!0)}e.parseCLIProcessArgv=w;function S(I,...f){const p=I.indexOf("--");return p===-1?I.push(...f):I.splice(p,0,...f),I}e.addArg=S;function k(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),function(){"use strict";function q(e,E,t){function C(A,P){const m=M(A,P),w=[m];return e.isAbsolute(m)||w.unshift(t),e.resolve(...w)}function M(A,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,P);const S=A["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(k,"AppData","Roaming")}break;case"darwin":w=e.join(E.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,P)}return{getUserDataPath:C}}if(typeof define=="function")define(ee[180],ie([181,27,32]),function(e,E,t){return q(e,E,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=q(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[182],ie([0,1,27,178,180]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends t.AbstractNativeEnvironmentService{constructor(P,m){super(P,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,C.getUserDataPath)(P,m.nameShort)},m)}}e.NativeEnvironmentService=M}),define(ee[183],ie([0,1,40,27,30]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function M(A){const P=(0,C.randomPath)((0,t.tmpdir)());try{return(0,E.writeFileSync)(P,""),A&&console.log(`Marker file for --wait created: ${P}`),P}catch(m){A&&console.error(`Failed to create marker file for --wait: ${m}`);return}}e.createWaitMarkerFileSync=M}),define(ee[184],ie([0,1,12,153]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function C(A,P,m){try{M(A,P,m)}catch(w){console.error(w?.message??w)}return A}e.localizeManifest=C;function M(A,P,m){const w=(S,k,I)=>{const f=S[k];if((0,E.isString)(f)){const p=f,g=p.length;if(g>1&&p[0]==="%"&&p[g-1]==="%"){const b=p.substr(1,g-2);let h=P[b];h===void 0&&m&&(h=m[b]);const v=typeof h=="string"?h:h?.message,d=m?.[b],u=typeof d=="string"?d:d?.message;if(!v){u||console.warn(`[${A.name}]: ${(0,t.localize)(0,null,b)}`);return}if(I&&(k==="title"||k==="category")&&u&&u!==v){const c={value:v,original:u};S[k]=c}else S[k]=v}}else if((0,E.isObject)(f))for(const p in f)f.hasOwnProperty(p)&&(p==="commands"?w(f,p,!0):w(f,p,I));else if(Array.isArray(f))for(let p=0;p<f.length;p++)w(f,p,I)};for(const S in A)A.hasOwnProperty(S)&&w(A,S)}}),define(ee[185],ie([0,1,15]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(M,A){this.a.set(M,A)}updateManifest(M){if(!(!Array.isArray(M.activationEvents)||!M.contributes)&&!(typeof M.main>"u"&&typeof M.browser>"u"))for(const A in M.contributes){const P=this.a.get(A);if(!P)continue;const m=M.contributes[A],w=Array.isArray(m)?m:[m];try{P(w,M.activationEvents)}catch(S){(0,E.onUnexpectedError)(S)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ee[186],ie([0,1,20,98,155,187]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function m(h){return h=h.trim(),h==="*"||A.test(h)}e.isValidVersionStr=m;function w(h){if(!m(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=h.match(A);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=w;function S(h){if(!h)return null;const v=h.majorBase,d=h.majorMustEqual,u=h.minorBase;let c=h.minorMustEqual;const n=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(v===0||(c=!1),r=!1);let i=0;if(h.preRelease){const a=P.exec(h.preRelease);if(a){const[,s,l,o]=a;i=Date.UTC(Number(s),Number(l)-1,Number(o))}}return{majorBase:v,majorMustEqual:d,minorBase:u,minorMustEqual:c,patchBase:n,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:i}}e.normalizeVersion=S;function k(h,v,d){let u;typeof h=="string"?u=S(w(h)):u=h;let c;v instanceof Date?c=v.getTime():typeof v=="string"&&(c=new Date(v).getTime());let n;if(typeof d=="string"?n=S(w(d)):n=d,!u||!n)return!1;const r=u.majorBase,i=u.minorBase,a=u.patchBase;let s=n.majorBase,l=n.minorBase,o=n.patchBase;const y=n.notBefore;let D=n.majorMustEqual,O=n.minorMustEqual,N=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:i>l?!0:i<l||c&&c<y?!1:a>=o:(r===1&&s===0&&(!D||!O||!N)&&(s=1,l=0,o=0,D=!0,O=!1,N=!1),r<s?!1:r>s?!D:i<l?!1:i>l?!O:a<o?!1:a>o?!N:!(c&&c<y))}e.isValidVersion=k;function I(h,v,d,u,c){const n=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return n.push([t.default.Error,C.localize(0,null)]),n;if(typeof u.name!="string")return n.push([t.default.Error,C.localize(1,null,"name")]),n;if(typeof u.version!="string")return n.push([t.default.Error,C.localize(2,null,"version")]),n;if(!u.engines)return n.push([t.default.Error,C.localize(3,null,"engines")]),n;if(typeof u.engines.vscode!="string")return n.push([t.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof u.extensionDependencies<"u"&&!b(u.extensionDependencies))return n.push([t.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof u.activationEvents<"u"){if(!b(u.activationEvents))return n.push([t.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof u.main>"u"&&typeof u.browser>"u")return n.push([t.default.Error,C.localize(7,null,"activationEvents","main")]),n}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&n.push([t.default.Warning,C.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return n.push([t.default.Error,C.localize(9,null,"main")]),n;{const a=(0,E.joinPath)(d,u.main);(0,E.isEqualOrParent)(a,d)||n.push([t.default.Warning,C.localize(10,null,a.path,d.path)])}if(typeof u.activationEvents>"u")return n.push([t.default.Error,C.localize(11,null,"activationEvents","main")]),n}if(typeof u.browser<"u"){if(typeof u.browser!="string")return n.push([t.default.Error,C.localize(12,null,"browser")]),n;{const a=(0,E.joinPath)(d,u.browser);(0,E.isEqualOrParent)(a,d)||n.push([t.default.Warning,C.localize(13,null,a.path,d.path)])}if(typeof u.activationEvents>"u")return n.push([t.default.Error,C.localize(14,null,"activationEvents","browser")]),n}if(!M.valid(u.version))return n.push([t.default.Error,C.localize(15,null)]),n;const r=[];if(!f(h,v,u,c,r))for(const a of r)n.push([t.default.Error,a]);return n}e.validateExtensionManifest=I;function f(h,v,d,u,c){return u||typeof d.main>"u"&&typeof d.browser>"u"?!0:g(h,v,d.engines.vscode,c)}e.isValidExtensionVersion=f;function p(h,v,d){return h==="*"||g(v,d,h)}e.isEngineValid=p;function g(h,v,d,u=[]){const c=S(w(d));if(!c)return u.push(C.localize(16,null,d)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return u.push(C.localize(17,null,d)),!1}else if(!c.majorMustEqual)return u.push(C.localize(18,null,d)),!1;return k(h,v,c)?!0:(u.push(C.localize(19,null,h,d)),!1)}function b(h){if(!Array.isArray(h))return!1;for(let v=0,d=h.length;v<d;v++)if(typeof h[v]!="string")return!1;return!0}}),define(ee[188],ie([0,1,17,29]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function C(M,A,P){let m=P&&P.get("storage.serviceMachineId",-1)||null;if(m)return m;try{const S=(await A.readFile(M.serviceMachineIdResource)).value.toString();m=(0,t.isUUID)(S)?S:null}catch{m=null}if(!m){m=(0,t.generateUuid)();try{await A.writeFile(M.serviceMachineIdResource,E.VSBuffer.fromString(m))}catch{}}return P?.store("storage.serviceMachineId",m,-1,1),m}e.getServiceMachineId=C}),define(ee[69],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(C,M=[],A=!1){this.ctor=C,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=E}),define(ee[189],ie([0,1,69]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var C;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function M(P,m,w){m instanceof E.SyncDescriptor||(m=new E.SyncDescriptor(m,[],Boolean(w))),t.push([P,m])}e.registerSingleton=M;function A(){return t}e.getSingletonServiceDescriptors=A}),define(ee[190],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class t{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const P=this.lookupOrInsertNode(M),m=this.lookupOrInsertNode(A);P.outgoing.set(m.key,m),m.incoming.set(P.key,P)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const P of this.a.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let P=this.a.get(A);return P||(P=new E(A,M),this.a.set(A,P)),P}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,P]of this.a)M.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const P=new Set([M]),m=this.c(A,P);if(m)return m}}c(M,A){for(const[P,m]of M.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const w=this.c(m,A);if(w)return w;A.delete(P)}}}e.Graph=t}),define(ee[5],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(m){return m[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(E=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function t(A,P,m){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:A,index:m}):(P[E.DI_DEPENDENCIES]=[{id:A,index:m}],P[E.DI_TARGET]=P)}function C(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const P=function(m,w,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,m,S)};return P.toString=()=>A,E.serviceIds.set(A,P),P}e.createDecorator=C;function M(A){return A}e.refineServiceDecorator=M}),define(ee[60],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ee[18],ie([0,1,12,7,5]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function M(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationOverrides=M;function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function m(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=m;function w(h,v){const d=Object.create(null);for(const u in h)S(d,u,h[u],v);return d}e.toValuesTree=w;function S(h,v,d,u){const c=v.split("."),n=c.pop();let r=h;for(let i=0;i<c.length;i++){const a=c[i];let s=r[a];switch(typeof s){case"undefined":s=r[a]=Object.create(null);break;case"object":break;default:u(`Ignoring ${v} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=d}catch{u(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(r)}`)}else u(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=S;function k(h,v){const d=v.split(".");I(h,d)}e.removeFromValueTree=k;function I(h,v){const d=v.shift();if(v.length===0){delete h[d];return}if(Object.keys(h).indexOf(d)!==-1){const u=h[d];typeof u=="object"&&!Array.isArray(u)&&(I(u,v),Object.keys(u).length===0&&delete h[d])}}function f(h,v,d){function u(r,i){let a=r;for(const s of i){if(typeof a!="object"||a===null)return;a=a[s]}return a}const c=v.split("."),n=u(h,c);return typeof n>"u"?d:n}e.getConfigurationValue=f;function p(h,v,d){Object.keys(v).forEach(u=>{u!=="__proto__"&&(u in h?E.isObject(h[u])&&E.isObject(v[u])?p(h[u],v[u],d):d&&(h[u]=v[u]):h[u]=v[u])})}e.merge=p;function g(h,v,d){const u=h.inspect(v),c=h.inspect(d);return typeof u.userValue<"u"||typeof u.workspaceValue<"u"||typeof u.workspaceFolderValue<"u"?u.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:u.defaultValue}e.getMigratedSettingValue=g;function b(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(ee[70],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(M,A){return this.a[M]?.[A]??null}async setPassword(M,A,P){this.a[M]=this.a[M]??{},this.a[M][A]=P}async deletePassword(M,A){return this.a[M]?.[A]?(delete this.a[M][A],Object.keys(this.a[M]).length===0&&delete this.a[M],!0):!1}async findPassword(M){return JSON.stringify(this.a[M])??null}async findCredentials(M){const A=[];for(const P of Object.keys(this.a[M]||{}))A.push({account:P,password:this.a[M][P]});return A}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(ee[84],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function t(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=t;class C{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=C}),define(ee[106],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ee[34],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[26],ie([0,1,53,9,83,34,182,5]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(M.IEnvironmentService);class m extends A.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,C.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([E.memoize],m.prototype,"cachedLanguagesPath",null),pe([E.memoize],m.prototype,"backupHome",null),pe([E.memoize],m.prototype,"mainIPCHandle",null),pe([E.memoize],m.prototype,"mainLockfile",null),pe([E.memoize],m.prototype,"disableUpdates",null),pe([E.memoize],m.prototype,"disableKeytar",null),pe([E.memoize],m.prototype,"crossOriginIsolated",null),pe([E.memoize],m.prototype,"codeCachePath",null),pe([E.memoize],m.prototype,"useCodeCache",null),e.EnvironmentMainService=m}),define(ee[191],ie([0,1,152,5]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function M(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function A(h,v){switch(h){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function P(h,v){return v==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function m(h,v,d){return P(v,d)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===d?!0:w(d).includes(h)}e.isTargetPlatformCompatible=m;function w(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function S(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=S;var k;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var I;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var f;(function(h){h.Install="install",h.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var p;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var g;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(v,d){super(v),this.code=d,this.name=d}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[192],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ee[193],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[107],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ee[194],ie([0,1,45,14,9,4,79,23,82,156,107]),function(q,e,E,t,C,M,A,P,m,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=w.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends I{openTerminal(u,c){return this.spawnTerminal(E,u,m.getWindowsShell(),c)}spawnTerminal(u,c,n,r){const i=c.windowsExec||f.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const a=C.basename(i).toLowerCase();if(a==="cmder"||a==="cmder.exe")return u.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return i.indexOf(" ")>=0&&s.push('""'),s.push(i),(a==="wt"||a==="wt.exe")&&s.push("-d ."),new Promise((l,o)=>{const y=b(process),D=u.spawn(n,s,{cwd:r,env:y});D.on("error",o),D.on("exit",()=>l())})}runInTerminal(u,c,n,r,i){const a="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows();return new Promise((s,l)=>{const o=`"${c} - ${k}"`,y=`""${n.join('" "')}" & pause"`,D=["/c","start",o,"/wait",a,"/c",y],O=Object.assign({},b(process),r);Object.keys(O).filter(G=>O[G]===null).forEach(G=>delete O[G]);const N={cwd:c,env:O,windowsVerbatimArguments:!0};E.spawn(f.b,D,N).on("error",G=>{l(h(G))}),s(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.WindowsExternalTerminalService=f,f.b="cmd.exe";class p extends I{openTerminal(u,c){return this.spawnTerminal(E,u,c)}runInTerminal(u,c,n,r,i){const a=i.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((s,l)=>{if(a===S.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const o=a===S.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`).fsPath,"-t",u||k,"-w",c];for(const Y of n)D.push("-a"),D.push(Y);if(r){const Y=Object.assign({},b(process),r);for(const G in Y){const V=Y[G];V===null?(D.push("-u"),D.push(G)):(D.push("-e"),D.push(`${G}=${V}`))}}let O="";const N=E.spawn(p.b,D);N.on("error",Y=>{l(h(Y))}),N.stderr.on("data",Y=>{O+=Y.toString()}),N.on("exit",Y=>{if(Y===0)s(void 0);else if(O){const G=O.split(`
`,1);l(new Error(G[0]))}else l(new Error(w.localize(1,null,o,Y)))})}else l(new Error(w.localize(2,null,a)))})}spawnTerminal(u,c,n){const r=c.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((i,a)=>{const s=["-a",r];n&&s.push(n);const l=b(process),o=u.spawn("/usr/bin/open",s,{cwd:n,env:l});o.on("error",a),o.on("exit",()=>i())})}}e.MacExternalTerminalService=p,p.b="/usr/bin/osascript";class g extends I{openTerminal(u,c){return this.spawnTerminal(E,u,c)}runInTerminal(u,c,n,r,i){const a=i.linuxExec?Promise.resolve(i.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{const o=[];a.then(y=>{y.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const D=`${v(n)}; echo; read -p "${g.b}" -n1;`;o.push(`''${D}''`);const O=Object.assign({},b(process),r);Object.keys(O).filter(V=>O[V]===null).forEach(V=>delete O[V]);const N={cwd:c,env:O};let Y="";const G=E.spawn(y,o,N);G.on("error",V=>{l(h(V))}),G.stderr.on("data",V=>{Y+=V.toString()}),G.on("exit",V=>{if(V===0)s(void 0);else if(Y){const se=Y.split(`
`,1);l(new Error(se[0]))}else l(new Error(w.localize(4,null,y,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!M.isLinux)g.d=Promise.resolve("xterm");else{const u=await P.Promises.exists("/etc/debian_version");g.d=new Promise(c=>{u?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return g.d}spawnTerminal(u,c,n){const r=c.linuxExec?Promise.resolve(c.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((i,a)=>{r.then(s=>{const l=b(process),o=u.spawn(s,[],{cwd:n,env:l});o.on("error",a),o.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=g,g.b=w.localize(3,null);function b(d){const u={...d.env};return(0,A.sanitizeProcessEnvironment)(u),u}function h(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(w.localize(5,null,d.path)):d}function v(d){let u="";for(const c of d)c.indexOf(" ")>=0?u+='"'+c+'"':u+=c,u+=" ";return u}}),define(ee[16],ie([0,1,58,9,25,12,7,158,5]),function(q,e,E,t,C,M,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function w(X){return X.create===!0}e.isFileOpenForWriteOptions=w;var S;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var k;(function(X){X[X.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var I;(function(X){X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileClone=32768]="FileClone"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(X){return!!(X.capabilities&2)}e.hasReadWriteCapability=f;function p(X){return!!(X.capabilities&8)}e.hasFileFolderCopyCapability=p;function g(X){return!!(X.capabilities&32768)}e.hasFileCloneCapability=g;function b(X){return!!(X.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function h(X){return!!(X.capabilities&16)}e.hasFileReadStreamCapability=h;function v(X){return f(X)?!!(X.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var d;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(d=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(le,F){super(le),this.code=F}}e.FileSystemProviderError=u;function c(X,le){const F=new u(X.toString(),le);return r(F,le),F}e.createFileSystemProviderError=c;function n(X){return X||c((0,P.localize)(0,null),d.Unknown)}e.ensureFileSystemProviderError=n;function r(X,le){return X.name=le?`${le} (FileSystemError)`:"FileSystemError",X}e.markAsFileSystemProviderError=r;function i(X){if(!X)return d.Unknown;if(X instanceof u)return X.code;const le=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!le)return d.Unknown;switch(le[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileExceedsMemoryLimit:return d.FileExceedsMemoryLimit;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}e.toFileSystemProviderErrorCode=i;function a(X){if(X instanceof O)return X.fileOperationResult;switch(i(X)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 10;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileExceedsMemoryLimit:return 9;case d.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var s;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class l{constructor(le,F,L){this.resource=le,this.operation=F,this.target=L}isOperation(le){return this.operation===le}}e.FileOperationEvent=l;var o;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class y{constructor(le,F){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=le;const L=new Map;for(const T of le){const U=L.get(T.type);switch(U?U.push([T.resource,T]):L.set(T.type,[[T.resource,T]]),T.type){case 1:this.rawAdded.push(T.resource);break;case 0:this.rawUpdated.push(T.resource);break;case 2:this.rawDeleted.push(T.resource);break}}for(const[T,U]of L)switch(T){case 1:this.a=E.TernarySearchTree.forUris(()=>F),this.a.fill(U);break;case 0:this.b=E.TernarySearchTree.forUris(()=>F),this.b.fill(U);break;case 2:this.c=E.TernarySearchTree.forUris(()=>F),this.c.fill(U);break}}contains(le,...F){return this.d(le,{includeChildren:!1},...F)}affects(le,...F){return this.d(le,{includeChildren:!0},...F)}d(le,F,...L){if(!le)return!1;const T=L.length>0;return!!((!T||L.includes(1))&&(this.a?.get(le)||F.includeChildren&&this.a?.findSuperstr(le))||(!T||L.includes(0))&&(this.b?.get(le)||F.includeChildren&&this.b?.findSuperstr(le))||(!T||L.includes(2))&&(this.c?.findSubstr(le)||F.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=y;function D(X,le,F){return!X||!le||X===le||le.length>X.length?!1:(le.charAt(le.length-1)!==t.sep&&(le+=t.sep),F?(0,C.startsWithIgnoreCase)(X,le):X.indexOf(le)===0)}e.isParent=D;class O extends Error{constructor(le,F,L){super(le),this.fileOperationResult=F,this.options=L}}e.FileOperationError=O;class N extends O{constructor(le,F,L){super(le,2,L),this.stat=F}}e.NotModifiedSinceFileOperationError=N;var Y;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",X[X.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var G;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(G=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.etag=V;async function se(X,le){if(!le.hasProvider(A.URI.from({scheme:X.scheme})))return new Promise(F=>{const L=le.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===X.scheme&&T.added&&(L.dispose(),F())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class oe{static formatSize(le){return(0,M.isNumber)(le)||(le=0),le<oe.KB?(0,P.localize)(1,null,le.toFixed(0)):le<oe.MB?(0,P.localize)(2,null,(le/oe.KB).toFixed(2)):le<oe.GB?(0,P.localize)(3,null,(le/oe.MB).toFixed(2)):le<oe.TB?(0,P.localize)(4,null,(le/oe.GB).toFixed(2)):(0,P.localize)(5,null,(le/oe.TB).toFixed(2))}}e.ByteSize=oe,oe.KB=1024,oe.MB=oe.KB*oe.KB,oe.GB=oe.MB*oe.KB,oe.TB=oe.GB*oe.KB;var re;(function(X){X[X.IA32=0]="IA32",X[X.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function de(X){return{maxFileSize:X===0?300*oe.MB:16*oe.GB,maxHeapSize:X===0?700*oe.MB:2*700*oe.MB}}e.getPlatformLimits=de}),define(ee[195],ie([0,1,17,44,15,3,2,57,7,29,16]),function(q,e,E,t,C,M,A,P,m,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends A.Disposable{constructor(f,p){super(),this.a=f,this.b=p,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new M.Emitter),this.onDidWatchError=this.g.event,this.h=(0,w.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,p){const{buffer:g}=await this.a.call("readFile",[f,p]);return g}readFileStream(f,p,g){const b=(0,P.newWriteableStream)(v=>E.VSBuffer.concat(v.map(d=>E.VSBuffer.wrap(d))).buffer),h=this.a.listen("readFileStream",[f,p])(v=>{if(v instanceof E.VSBuffer)b.write(v.buffer);else{if(v==="end")b.end();else{let d=v;d instanceof Error||(d=(0,S.createFileSystemProviderError)((0,t.toErrorMessage)(d),S.FileSystemProviderErrorCode.Unknown)),b.error(d),b.end()}h.dispose()}});return g.onCancellationRequested(()=>{b.error((0,C.canceled)()),b.end(),h.dispose()}),b}writeFile(f,p,g){return this.a.call("writeFile",[f,E.VSBuffer.wrap(p),g])}open(f,p){return this.a.call("open",[f,p])}close(f){return this.a.call("close",[f])}async read(f,p,g,b,h){const[v,d]=await this.a.call("read",[f,p,h]);return g.set(v.buffer.slice(0,d),b),d}write(f,p,g,b,h){return this.a.call("write",[f,p,E.VSBuffer.wrap(g),b,h])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,p){return this.a.call("delete",[f,p])}rename(f,p,g){return this.a.call("rename",[f,p,g])}copy(f,p,g){return this.a.call("copy",[f,p,g])}cloneFile(f,p){return this.a.call("cloneFile",[f,p])}i(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const p=f;this.f.fire(p.map(g=>({resource:m.URI.revive(g.resource),type:g.type})))}else{const p=f;this.g.fire(p)}}))}watch(f,p){const g=(0,w.generateUuid)();return this.a.call("watch",[this.h,g,f,p]),(0,A.toDisposable)(()=>this.a.call("unwatch",[this.h,g]))}}e.DiskFileSystemProviderClient=k}),define(ee[108],ie([0,1,17,15,159,16]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(S,k,I,f,p,g){let b;try{await P(S,k,I,f,p,g)}catch(h){b=h}finally{b&&p.errorTransformer&&(b=p.errorTransformer(b)),typeof b<"u"&&I.error(b),I.end()}}e.readFileIntoStream=A;async function P(S,k,I,f,p,g){m(g);const b=await S.open(k,{create:!1});try{m(g);let h=0,v=0,d=p&&typeof p.length=="number"?p.length:void 0,u=E.VSBuffer.alloc(Math.min(p.bufferSize,typeof d=="number"?d:p.bufferSize)),c=p&&typeof p.position=="number"?p.position:0,n=0;do v=await S.read(b,c,u.buffer,n,u.byteLength-n),c+=v,n+=v,h+=v,typeof d=="number"&&(d-=v),n===u.byteLength&&(await I.write(f(u)),u=E.VSBuffer.alloc(Math.min(p.bufferSize,typeof d=="number"?d:p.bufferSize)),n=0);while(v>0&&(typeof d!="number"||d>0)&&m(g)&&w(h,p));if(n>0){let r=n;typeof d=="number"&&(r=Math.min(n,d)),I.write(f(u.slice(0,r)))}}catch(h){throw(0,M.ensureFileSystemProviderError)(h)}finally{await S.close(b)}}function m(S){if(S.isCancellationRequested)throw(0,t.canceled)();return!0}function w(S,k){if(k?.limits){if(typeof k.limits.memory=="number"&&S>k.limits.memory)throw(0,M.createFileSystemProviderError)((0,C.localize)(0,null),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&S>k.limits.size)throw(0,M.createFileSystemProviderError)((0,C.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[71],ie([0,1,99,2,9,4,7,16]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function m(h){return h.recursive===!0}e.isRecursiveWatchRequest=m;class w extends t.Disposable{constructor(v,d,u,c){super(),this.h=v,this.i=d,this.j=u,this.k=c,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const v=new t.DisposableStore;this.c.value=v,this.b=this.l(v),this.b.setVerboseLogging(this.j),v.add(this.b.onDidChangeFile(d=>this.h(d))),v.add(this.b.onDidLogMessage(d=>this.i(d))),v.add(this.b.onDidError(d=>this.n(d)))}n(v){this.k.restartOnError?this.g<w.a&&this.f?(this.r(`restarting watcher after error: ${v}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${v}`):this.r(v)}p(v){this.g++,this.m(),this.watch(v)}async watch(v){this.f=v,await this.b?.watch(v)}async setVerboseLogging(v){this.j=v,await this.b?.setVerboseLogging(v)}r(v){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${v}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=w,w.a=5;class S extends w{constructor(v,d,u){super(v,d,u,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=S;class k extends w{constructor(v,d,u){super(v,d,u,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function I(h){return h.map(v=>({type:v.type,resource:A.URI.file(v.path)}))}e.toFileChanges=I;function f(h){const v=new b;for(const d of h)v.processEvent(d);return v.coalesce()}e.coalesceEvents=f;function p(h,v){return typeof v=="string"&&!v.startsWith(E.GLOBSTAR)&&!(0,C.isAbsolute)(v)?{base:h,pattern:v}:v}e.normalizeWatcherPattern=p;function g(h,v){const d=[];for(const u of v)d.push((0,E.parse)(p(h,u)));return d}e.parseWatcherPatterns=g;class b{constructor(){this.a=new Set,this.b=new Map}c(v){return M.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const d=this.b.get(this.c(v));let u=!1;if(d){const c=d.type,n=v.type;d.path!==v.path&&(v.type===2||v.type===1)?u=!0:c===1&&n===2?(this.b.delete(this.c(v)),this.a.delete(d)):c===2&&n===1?d.type=0:c===1&&n===0||(d.type=n)}else u=!0;u&&(this.a.add(v),this.b.set(this.c(v),v))}coalesce(){const v=[],d=[];return Array.from(this.a).filter(u=>u.type!==2?(v.push(u),!1):!0).sort((u,c)=>u.path.length-c.path.length).filter(u=>d.some(c=>(0,P.isParent)(u.path,c,!M.isLinux))?!1:(d.push(u.path),!0)).concat(v)}}}),define(ee[196],ie([0,1,40,8,22,30,2,76,9,4,100,23,71]),function(q,e,E,t,C,M,A,P,m,w,S,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends A.Disposable{constructor(b,h,v,d){super(),this.k=b,this.l=h,this.m=v,this.n=d,this.c=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.l(u)),this.f=this.B(new t.ThrottledDelayer(f.b)),this.g=[],this.h=(0,I.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,I.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new C.CancellationTokenSource,this.ready=this.r()}async r(){try{const b=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const h=await k.Promises.stat(b);this.B(await this.t(b,h.isDirectory()))}catch(b){b.code!=="ENOENT"?this.w(b):this.C(b)}}async s(b){let h=b.path;try{h=await k.Promises.realpath(b.path),b.path===h&&(h=await(0,S.realcase)(b.path)??b.path),b.path!==h&&this.C(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${h})`)}catch{}return h}async t(b,h){if(w.isMacintosh&&(0,M.isEqualOrParent)(b,"/Volumes/",!0))return this.w(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const v=new C.CancellationTokenSource(this.j.token),d=new A.DisposableStore;try{const u=(0,m.basename)(b),c=(0,E.watch)(b);d.add((0,A.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.C(`Started watching: '${b}'`);const n=new Set;if(h)try{for(const i of await k.Promises.readdir(b))n.add(i)}catch(i){this.w(i)}const r=new Map;d.add((0,A.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),c.on("error",(i,a)=>{this.w(`Failed to watch ${b} for changes using fs.watch() (${i}, ${a})`),this.dispose()}),c.on("change",(i,a)=>{if(v.token.isCancellationRequested)return;this.C(`[raw] ["${i}"] ${a}`);let s="";if(a&&(s=a.toString(),w.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){r.get(s)?.dispose();const l=setTimeout(async()=>{if(r.delete(s),s===u&&!await k.Promises.exists(b)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,m.join)(b,s));if(v.token.isCancellationRequested)return;let y;o?n.has(s)?y=0:(y=1,n.add(s)):(n.delete(s),y=2),this.u({path:(0,m.join)(this.k.path,s),type:y})},f.a);r.set(s,(0,A.toDisposable)(()=>clearTimeout(l)))}else{let l;n.has(s)?l=0:(l=1,n.add(s)),this.u({path:(0,m.join)(this.k.path,s),type:l})}else if(i==="rename"||s!==u){const l=setTimeout(async()=>{const o=await k.Promises.exists(b);v.token.isCancellationRequested||(o?(this.u({path:this.k.path,type:0},!0),d.add(await this.t(b,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},f.a);d.clear(),d.add((0,A.toDisposable)(()=>clearTimeout(l)))}else this.u({path:this.k.path,type:0},!0)})}catch(u){await k.Promises.exists(b)&&!v.token.isCancellationRequested&&this.w(`Failed to watch ${b} for changes using fs.watch() (${u.toString()})`)}return(0,A.toDisposable)(()=>{v.dispose(!0),d.dispose()})}async u(b,h=!1){if(!this.j.token.isCancellationRequested){this.n&&this.C(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!h&&this.h.some(v=>v(b.path))?this.n&&this.C(` >> ignored (excluded) ${b.path}`):!h&&this.i&&this.i.length>0&&!this.i.some(v=>v(b.path))?this.n&&this.C(` >> ignored (not included) ${b.path}`):this.g.push(b);try{await this.f.trigger(async()=>{const v=this.g;this.g=[];const d=(0,I.coalesceEvents)(v);if(d.length>0){if(this.n)for(const c of d)this.C(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.c.work(d)?this.c.pending>0&&this.C(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(b){if(w.isLinux)return k.Promises.exists(b);try{const h=(0,m.basename)(b);return(await k.Promises.readdir((0,m.dirname)(b))).some(d=>d===h)}catch(h){return this.C(h),!1}}setVerboseLogging(b){this.n=b}w(b){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}y(b){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}C(b){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.C(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.a=100,f.b=50;async function p(g,b,h,v,d=512){const u=await k.Promises.open(g,"r"),c=Buffer.allocUnsafe(d),n=new C.CancellationTokenSource(v);let r,i=!1;const a={path:g,excludes:[],recursive:!1},s=new f(a,l=>{(async()=>{for(const{type:o}of l)if(o===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await k.Promises.read(u,c,0,d,null);if(!y||n.token.isCancellationRequested)break;b(c.slice(0,y))}}catch(y){r=new Error(y),n.dispose(!0)}finally{i=!1}}})()});return await s.ready,h(),new Promise((l,o)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await k.Promises.close(u)}catch(y){r=new Error(y)}r?o(r):l()})})}e.watchFileContents=p}),define(ee[197],ie([0,1,3,99,2,4,196]),function(q,e,E,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends C.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(w){const S=this.i(w),k=S.filter(f=>{const p=this.c.get(f.path);return p?!(0,t.patternsEquals)(p.request.excludes,f.excludes)||!(0,t.patternsEquals)(p.request.includes,f.includes):!0}),I=Array.from(this.c.values()).filter(({request:f})=>!S.find(p=>p.path===f.path&&(0,t.patternsEquals)(p.excludes,f.excludes)&&(0,t.patternsEquals)(p.includes,f.includes))).map(({request:f})=>f.path);k.length&&this.j(`Request to start watching: ${k.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),I.length&&this.j(`Request to stop watching: ${I.join(",")}`);for(const f of I)this.h(f);for(const f of k)this.g(f)}g(w){const S=new A.NodeJSFileWatcherLibrary(w,I=>this.a.fire(I),I=>this.b.fire(I),this.f),k={request:w,instance:S};this.c.set(w.path,k)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const S=this.c.get(w);S&&(this.c.delete(w),S.instance.dispose())}i(w){const S=new Map;for(const k of w){const I=M.isLinux?k.path:k.path.toLowerCase();S.set(I,k)}return Array.from(S.values())}async setVerboseLogging(w){this.f=w;for(const[,S]of this.c)S.instance.setVerboseLogging(w)}j(w){this.f&&this.b.fire({type:"trace",message:this.k(w)})}k(w,S){return S?`[File Watcher (node.js)] ${w} (path: ${S.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=P}),define(ee[198],ie([0,1,71,197]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class C extends E.AbstractNonRecursiveWatcherClient{constructor(A,P,m){super(A,P,m),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=C}),define(ee[199],ie([0,1,14,46,145,71]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends M.AbstractUniversalWatcherClient{constructor(m,w,S){super(m,w,S),this.m()}l(m){const w=m.add(new C.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(w.onDidProcessExit(({code:S,signal:k})=>this.n(`terminated by itself with code ${S}, signal: ${k}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ee[85],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...C){this.a=new Map;for(const[M,A]of C)this.set(M,A)}set(C,M){const A=this.a.get(C);return this.a.set(C,M),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.ServiceCollection=E}),define(ee[200],ie([0,1,8,15,2,69,190,5,85,95]),function(q,e,E,t,C,M,A,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class k extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class I{constructor(b=new m.ServiceCollection,h=!1,v,d=S){this.f=b,this.g=h,this.h=v,this.i=d,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=d?v?._globalGraph??new A.Graph(u=>u):void 0}createChild(b){return new I(b,this.g,this,this.i)}invokeFunction(b,...h){const v=p.traceInvocation(this.i,b);let d=!1;try{return b({get:c=>{if(d)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(c,v);if(!n)throw new Error(`[invokeFunction] unknown service '${c}'`);return n}},...h)}finally{d=!0,v.stop()}}createInstance(b,...h){let v,d;return b instanceof M.SyncDescriptor?(v=p.traceCreation(this.i,b.ctor),d=this.j(b.ctor,b.staticArguments.concat(h),v)):(v=p.traceCreation(this.i,b),d=this.j(b,h,v)),v.stop(),d}j(b,h=[],v){const d=P._util.getServiceDependencies(b).sort((n,r)=>n.index-r.index),u=[];for(const n of d){const r=this.m(n.id,v);r||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${n.id}.`,!1),u.push(r)}const c=d.length>0?d[0].index:h.length;if(h.length!==c){console.trace(`[createInstance] First service dependency of ${b.name} at position ${c+1} conflicts with ${h.length} static arguments`);const n=c-h.length;n>0?h=h.concat(new Array(n)):h=h.slice(0,c)}return Reflect.construct(b,h.concat(u))}k(b,h){if(this.f.get(b)instanceof M.SyncDescriptor)this.f.set(b,h);else if(this.h)this.h.k(b,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const h=this.f.get(b);return!h&&this.h?this.h.l(b):h}m(b,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const v=this.l(b);return v instanceof M.SyncDescriptor?this.q(b,v,h.branch(b,!0)):(h.branch(b,!1),v)}q(b,h,v){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,h,v)}finally{this.o.delete(b)}}r(b,h,v){const d=new A.Graph(n=>n.id.toString());let u=0;const c=[{id:b,desc:h,_trace:v}];for(;c.length;){const n=c.pop();if(d.lookupOrInsertNode(n),u++>1e3)throw new k(d);for(const r of P._util.getServiceDependencies(n.desc.ctor)){const i=this.l(r.id);if(i||this.u(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),i instanceof M.SyncDescriptor){const a={id:r.id,desc:i,_trace:n._trace.branch(r.id,!0)};d.insertEdge(n,a),c.push(a)}}}for(;;){const n=d.roots();if(n.length===0){if(!d.isEmpty())throw new k(d);break}for(const{data:r}of n){if(this.l(r.id)instanceof M.SyncDescriptor){const a=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,a)}d.removeNode(r)}}return this.l(b)}s(b,h,v=[],d,u){if(this.f.get(b)instanceof M.SyncDescriptor)return this.t(b,h,v,d,u);if(this.h)return this.h.s(b,h,v,d,u);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(b,h,v=[],d,u){if(d){const c=new I(void 0,this.g,this,this.i);c.c=String(b);const n=new Map,r=new E.IdleValue(()=>{const i=c.j(h,v,u);for(const[a,s]of n){const l=i[a];if(typeof l=="function")for(const o of s)l.apply(i,o)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,a){if(!r.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let o=n.get(a);return o||(o=new w.LinkedList,n.set(a,o)),(D,O,N)=>{const Y=o.push([D,O,N]);return(0,C.toDisposable)(Y)}}if(a in i)return i[a];const s=r.value;let l=s[a];return typeof l!="function"||(l=l.bind(s),i[a]=l),l},set(i,a,s){return r.value[a]=s,!0}})}else return this.j(h,v,u)}u(b,h){if(h&&console.warn(b),this.g)throw new Error(b)}}e.InstantiationService=I;var f;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(f||(f={}));class p{static traceInvocation(b,h){return b?new p(1,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(b,h){return b?new p(0,h.name):p.c}constructor(b,h){this.type=b,this.name=h,this.g=Date.now(),this.h=[]}branch(b,h){const v=new p(2,b.toString());return this.h.push([b,h,v]),v}stop(){const b=Date.now()-this.g;p.f+=b;let h=!1;function v(u,c){const n=[],r=new Array(u+1).join("	");for(const[i,a,s]of c.h)if(a&&s){h=!0,n.push(`${r}CREATES -> ${i}`);const l=v(u+1,s);l&&n.push(l)}else n.push(`${r}uses -> ${i}`);return n.join(`
`)}const d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(b>2||h)&&p.all.add(d.join(`
`))}}e.Trace=p,p.all=new Set,p.c=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p.f=0}),define(ee[6],ie([0,1,44,3,2,39,4,7,5]),function(q,e,E,t,C,M,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function w(){return new Date().toISOString()}var S;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function k(l,o,y){switch(o){case S.Trace:l.trace(y);break;case S.Debug:l.debug(y);break;case S.Info:l.info(y);break;case S.Warning:l.warn(y);break;case S.Error:l.error(y);break;default:throw new Error("Invalid log level")}}e.log=k;function I(l){let o="";for(let y=0;y<l.length;y++){let D=l[y];if(typeof D=="object")try{D=JSON.stringify(D)}catch{}o+=(y>0?" ":"")+D}return o}e.format=I;class f extends C.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}}e.AbstractLogger=f;class p extends f{constructor(o){super(),this.g=o}h(o){return this.g||this.getLevel()<=o}trace(o,...y){this.h(S.Trace)&&this.f(S.Trace,I([o,...y]))}debug(o,...y){this.h(S.Debug)&&this.f(S.Debug,I([o,...y]))}info(o,...y){this.h(S.Info)&&this.f(S.Info,I([o,...y]))}warn(o,...y){this.h(S.Warning)&&this.f(S.Warning,I([o,...y]))}error(o,...y){if(this.h(S.Error))if(o instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=o.stack,this.f(S.Error,I(D))}else this.f(S.Error,I([o,...y]))}flush(){}}e.AbstractMessageLogger=p;class g extends f{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.f=!A.isWindows}trace(o,...y){this.getLevel()<=S.Trace&&(this.f?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,o,...y):console.log(`[main ${w()}]`,o,...y))}debug(o,...y){this.getLevel()<=S.Debug&&(this.f?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,o,...y):console.log(`[main ${w()}]`,o,...y))}info(o,...y){this.getLevel()<=S.Info&&(this.f?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,o,...y):console.log(`[main ${w()}]`,o,...y))}warn(o,...y){this.getLevel()<=S.Warning&&(this.f?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,o,...y):console.warn(`[main ${w()}]`,o,...y))}error(o,...y){this.getLevel()<=S.Error&&(this.f?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,o,...y):console.error(`[main ${w()}]`,o,...y))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class b extends f{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...y){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",o,...y)}debug(o,...y){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...y)}info(o,...y){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",o,...y)}warn(o,...y){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",o,...y)}error(o,...y){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",o,...y)}dispose(){}flush(){}}e.ConsoleLogger=b;class h extends f{constructor(o,y=e.DEFAULT_LOG_LEVEL){super(),this.f=o,this.setLevel(y)}trace(o,...y){this.getLevel()<=S.Trace&&this.f.log(S.Trace,[this.g(o),...y])}debug(o,...y){this.getLevel()<=S.Debug&&this.f.log(S.Debug,[this.g(o),...y])}info(o,...y){this.getLevel()<=S.Info&&this.f.log(S.Info,[this.g(o),...y])}warn(o,...y){this.getLevel()<=S.Warning&&this.f.log(S.Warning,[this.g(o),...y])}error(o,...y){this.getLevel()<=S.Error&&this.f.log(S.Error,[this.g(o),...y])}g(o){return typeof o=="string"?o:(0,E.toErrorMessage)(o,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class v extends f{constructor(o){super(),this.f=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const y of this.f)y.setLevel(o);super.setLevel(o)}trace(o,...y){for(const D of this.f)D.trace(o,...y)}debug(o,...y){for(const D of this.f)D.debug(o,...y)}info(o,...y){for(const D of this.f)D.info(o,...y)}warn(o,...y){for(const D of this.f)D.warn(o,...y)}error(o,...y){for(const D of this.f)D.error(o,...y)}flush(){for(const o of this.f)o.flush()}dispose(){for(const o of this.f)o.dispose()}}e.MultiplexLogService=v;class d extends C.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...y){this.b.trace(o,...y)}debug(o,...y){this.b.debug(o,...y)}info(o,...y){this.b.info(o,...y)}warn(o,...y){this.b.warn(o,...y)}error(o,...y){this.b.error(o,...y)}flush(){this.b.flush()}}e.LogService=d;class u extends C.Disposable{constructor(o,y){super(),this.c=o,this.b=new M.ResourceMap,this.B(y(D=>this.setLevel(D)))}getLoggers(){return[...this.b.values()].map(({logger:o})=>o)}getLogger(o){return this.b.get(o)?.logger}createLogger(o,y,D){let O=this.b.get(o)?.logger;return O||(D=y?.always?S.Trace:D,O=this.f(o,D??this.c,y),this.b.set(o,{logger:O,logLevel:D})),O}setLevel(o,y){const D=P.URI.isUri(o)?o:void 0,O=D?y:o;if(D){const N=this.b.get(D);N&&N.logLevel!==O&&(N.logLevel=O,N.logger.setLevel(O))}else this.c=O,this.b.forEach(({logLevel:N,logger:Y})=>{N===void 0&&Y.setLevel(this.c)})}getLogLevel(o){return this.b.get(o)?.logLevel}dispose(){this.b.forEach(({logger:o})=>o.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=u;class c{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return S.Info}trace(o,...y){}debug(o,...y){}info(o,...y){}warn(o,...y){}error(o,...y){}critical(o,...y){}dispose(){}flush(){}}e.NullLogger=c;class n extends c{}e.NullLogService=n;class r extends u{constructor(){super(S.Info,t.Event.None)}f(o,y,D){return new c}}e.NullLoggerService=r;function i(l){if(l.verbose)return S.Trace;if(typeof l.logLevel=="string"){const o=s(l.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function a(l){switch(l){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Off:return"off"}}e.LogLevelToString=a;function s(l){switch(l){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Error;case"off":return S.Off}}e.parseLogLevel=s});var te=this&&this.__param||function(q,e){return function(E,t){e(E,t,q)}};define(ee[201],ie([0,1,70,3,2,6,4,8]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let m=class St extends C.Disposable{constructor(S){super(),this.g=S,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(S,k){this.g.trace("Getting password from keytar:",S,k);let I;try{I=await this.h()}catch{return null}const f=await(0,P.retry)(()=>I.getPassword(S,k),50,3);if(!f)return this.g.trace("Did not get a password from keytar for account:",k),f;let p,g;try{const b=JSON.parse(f);p=b.content,g=b.hasNextChunk}catch{}if(!p||!g)return this.g.trace("Got password from keytar for account:",k),f;try{let b=1;for(;g;){const h=await(0,P.retry)(()=>I.getPassword(S,`${k}-${b}`),50,3),v=JSON.parse(h);p+=v.content,g=v.hasNextChunk,b++}return this.g.trace(`Got ${b}-chunked password from keytar for account:`,k),p}catch(b){return this.g.error(b),f}}async setPassword(S,k,I){this.g.trace("Setting password using keytar:",S,k);let f;try{f=await this.h()}catch(p){throw this.i?.(p),p}if(A.isWindows&&I.length>St.a){let p=0,g=0,b=!0;for(;b;){const h=I.substring(p,p+St.b);p+=St.b,b=I.length-p>0;const v={content:h,hasNextChunk:b};await(0,P.retry)(()=>f.setPassword(S,g?`${k}-${g}`:k,JSON.stringify(v)),50,3),g++}this.g.trace(`Got${g?` ${g}-chunked`:""} password from keytar for account:`,k)}else await(0,P.retry)(()=>f.setPassword(S,k,I),50,3),this.g.trace("Got password from keytar for account:",k);this.c.fire({service:S,account:k})}async deletePassword(S,k){this.g.trace("Deleting password using keytar:",S,k);let I;try{I=await this.h()}catch(h){throw this.i?.(h),h}const f=await I.getPassword(S,k);if(!f)return this.g.trace("Did not get a password to delete from keytar for account:",k),!1;let p,g;try{const h=JSON.parse(f);p=h.content,g=h.hasNextChunk}catch{}let b=0;if(p&&g)try{for(b++;g;){const h=`${k}-${b}`,v=await I.getPassword(S,h);await I.deletePassword(S,h),g=JSON.parse(v).hasNextChunk,b++}}catch(h){this.g.error(h)}return await I.deletePassword(S,k)?(this.c.fire({service:S,account:k}),this.g.trace(`Deleted${b?` ${b}-chunked`:""} password from keytar for account:`,k),!0):(this.g.trace(`Keytar failed to delete${b?` ${b}-chunked`:""} password for account:`,k),!1)}async findPassword(S){let k;try{k=await this.h()}catch{return null}return await k.findPassword(S)}async findCredentials(S){let k;try{k=await this.h()}catch{return[]}return await k.findCredentials(S)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};m.a=2500,m.b=m.a-100,m=pe([te(0,M.ILogService)],m),e.BaseCredentialsMainService=m}),define(ee[202],ie([0,1,6]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(M,A){this.a=M,this.b=A}c(){return new Promise((M,A)=>q(["vscode-encrypt"],M,A))}async encrypt(M){let A;try{A=await this.c()}catch{return M}try{return A.encrypt(this.a,M)}catch(P){return this.b.error(P),M}}async decrypt(M){let A;try{A=await this.c()}catch{return M}try{return A.decrypt(this.a,M)}catch(P){return this.b.error(P),M}}};t=pe([te(1,E.ILogService)],t),e.EncryptionMainService=t}),define(ee[203],ie([0,1,24,8,15,3,2,9,71,6]),function(q,e,E,t,C,M,A,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends A.Disposable{constructor(I,f){super(),this.a=I,this.b=f,this.c=this.B(new M.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new M.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(I,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(I,f):this.u(I,f)}l(I,f){const p={path:this.D(I),excludes:f.excludes,includes:f.includes,recursive:f.recursive},g=(0,E.insert)(this.j,p);return this.m(),(0,A.toDisposable)(()=>{g(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(I=>(0,C.onUnexpectedError)(I))}n(){this.h||(this.h=this.B(this.p(f=>this.c.fire((0,m.toFileChanges)(f)),f=>this.C(f),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const I=this.b?.watcher?.recursive?.usePolling;if(I===!0)for(const f of this.j)(0,m.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(I))for(const f of this.j)(0,m.isRecursiveWatchRequest)(f)&&I.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(I,f){const p={path:this.D(I),excludes:f.excludes,includes:f.includes,recursive:!1},g=(0,E.insert)(this.s,p);return this.v(),(0,A.toDisposable)(()=>{g(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(I=>(0,C.onUnexpectedError)(I))}w(){return this.r||(this.r=this.B(this.y(I=>this.c.fire((0,m.toFileChanges)(I)),I=>this.C(I),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.r.watch(this.s)}C(I){I.type==="error"&&this.g.fire(I.message),this.a[I.type](I.message)}D(I){return(0,P.normalize)(I.fsPath)}}e.AbstractDiskFileSystemProvider=S}),define(ee[204],ie([0,1,24,8,17,22,3,67,66,2,58,14,72,20,57,157,16,108,6]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends w.Disposable{constructor(c){super(),this.b=c,this.a=256*1024,this.c=this.B(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new A.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new A.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new A.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new t.ResourceQueue)}registerProvider(c,n){if(this.h.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${c}`);const r=new w.DisposableStore;return this.h.set(c,n),this.c.fire({added:!0,scheme:c,provider:n}),r.add(n.onDidChangeFile(i=>this.R.fire(new b.FileChangesEvent(i,!this.O(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this.S.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:c}))),(0,w.toDisposable)(()=>{this.c.fire({added:!1,scheme:c,provider:n}),this.h.delete(c),(0,w.dispose)(r)})}getProvider(c){return this.h.get(c)}async activateProvider(c){const n=[];this.f.fire({scheme:c,join(r){n.push(r)}}),!this.h.has(c)&&await t.Promises.settled(n)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.h.has(c.scheme)}hasCapability(c,n){const r=this.h.get(c.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return m.Iterable.map(this.h,([c,n])=>({scheme:c,capabilities:n.capabilities}))}async j(c){if(!(0,f.isAbsolutePath)(c))throw new b.FileOperationError((0,g.localize)(0,null,this.ob(c)),8);await this.activateProvider(c.scheme);const n=this.h.get(c.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,c.toString()),r}return n}async k(c){const n=await this.j(c);if((0,b.hasOpenReadWriteCloseCapability)(n)||(0,b.hasReadWriteCapability)(n)||(0,b.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(c){const n=await this.j(c);if((0,b.hasOpenReadWriteCloseCapability)(n)||(0,b.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,n){try{return await this.n(c,n)}catch(r){throw(0,b.toFileSystemProviderErrorCode)(r)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,g.localize)(2,null,this.ob(c)),1):(0,b.ensureFileSystemProviderError)(r)}}async n(c,n){const r=await this.j(c),i=this.O(r),a=n?.resolveTo,s=n?.resolveSingleChildDescendants,l=n?.resolveMetadata,o=await r.stat(c);let y;return this.p(r,c,o,void 0,!!l,(D,O)=>(y||(y=S.TernarySearchTree.forUris(()=>!i),y.set(c,!0),a&&y.fill(!0,a)),y.get(D.resource)||y.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?O===1:!1))}async p(c,n,r,i,a,s){const{providerExtUri:l}=this.N(c),o={resource:n,name:l.basename(n),isFile:(r.type&b.FileType.File)!==0,isDirectory:(r.type&b.FileType.Directory)!==0,isSymbolicLink:(r.type&b.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&b.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,b.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(o.isDirectory&&s(o,i)){try{const y=await c.readdir(n),D=await t.Promises.settled(y.map(async([O,N])=>{try{const Y=l.joinPath(n,O),G=a?await c.stat(Y):{type:N};return await this.p(c,Y,G,y.length,a,s)}catch(Y){return this.b.trace(Y),null}}));o.children=(0,E.coalesce)(D)}catch(y){this.b.trace(y),o.children=[]}return o}return o}async resolveAll(c){return t.Promises.settled(c.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(c){const n=await this.j(c),r=await n.stat(c);return this.p(n,c,r,void 0,!0,()=>!1)}async exists(c){const n=await this.j(c);try{return!!await n.stat(c)}catch{return!1}}async canCreateFile(c,n){try{await this.r(c,n)}catch(r){return r}return!0}async r(c,n){if(!n?.overwrite&&await this.exists(c))throw new b.FileOperationError((0,g.localize)(3,null,this.ob(c)),3,n)}async createFile(c,n=C.VSBuffer.fromString(""),r){await this.r(c,r);const i=await this.writeFile(c,n);return this.m.fire(new b.FileOperationEvent(c,0,i)),i}async writeFile(c,n,r){const i=this.mb(await this.l(c),c),{providerExtUri:a}=this.N(i);try{await this.s(i,c,r)||await this.P(i,a.dirname(c));let l;if((0,b.hasReadWriteCapability)(i)&&!(n instanceof C.VSBuffer))if((0,p.isReadableStream)(n)){const o=await(0,p.peekStream)(n,3);o.ended?l=C.VSBuffer.concat(o.buffer):l=o}else l=(0,p.peekReadable)(n,o=>C.VSBuffer.concat(o),3);else l=n;!(0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)&&l instanceof C.VSBuffer?await this.db(i,c,r,l):await this.Y(i,c,r,l instanceof C.VSBuffer?(0,C.bufferToReadable)(l):l),this.m.fire(new b.FileOperationEvent(c,4))}catch(s){throw new b.FileOperationError((0,g.localize)(4,null,this.ob(c),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),r)}return this.resolve(c,{resolveMetadata:!0})}async s(c,n,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,g.localize)(5,null,this.ob(n)));let a;try{a=await c.stat(n)}catch{return}if((a.type&b.FileType.Directory)!==0)throw new b.FileOperationError((0,g.localize)(6,null,this.ob(n)),0,r);if(this.nb(n,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==b.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,b.etag)({mtime:r.mtime,size:a.size}))throw new b.FileOperationError((0,g.localize)(7,null),3,r);return a}async readFile(c,n,r){const i=await this.k(c);return n?.atomic?this.t(i,c,n,r):this.u(i,c,n,r)}async t(c,n,r,i){return new Promise((a,s)=>{this.X.queueFor(n,this.N(c).providerExtUri).queue(async()=>{try{const l=await this.u(c,n,r,i);a(l)}catch(l){s(l)}})})}async u(c,n,r,i){const a=await this.v(c,n,{...r,preferUnbuffered:!0},i);return{...a,value:await(0,C.streamToBuffer)(a.value)}}async readFileStream(c,n,r){const i=await this.k(c);return this.v(i,c,n,r)}async v(c,n,r,i){const a=new M.CancellationTokenSource(i),s=this.F(n,r).then(o=>o,o=>{throw a.cancel(),o});let l;try{return typeof r?.etag=="string"&&r.etag!==b.ETAG_DISABLED&&await s,r?.atomic&&(0,b.hasFileAtomicReadCapability)(c)||!((0,b.hasOpenReadWriteCloseCapability)(c)||(0,b.hasFileReadStreamCapability)(c))||(0,b.hasReadWriteCapability)(c)&&r?.preferUnbuffered?l=this.D(c,n,r):(0,b.hasFileReadStreamCapability)(c)?l=this.w(c,n,a.token,r):l=this.C(c,n,a.token,r),{...await s,value:l}}catch(o){l&&await(0,p.consumeStream)(l);const y=(0,g.localize)(8,null,this.ob(n),(0,b.ensureFileSystemProviderError)(o).toString());throw o instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(y,o.stat,r):new b.FileOperationError(y,(0,b.toFileOperationResult)(o),r)}}w(c,n,r,i=Object.create(null)){const a=c.readFileStream(n,i,r);return(0,p.transform)(a,{data:s=>s instanceof C.VSBuffer?s:C.VSBuffer.wrap(s),error:s=>new b.FileOperationError((0,g.localize)(9,null,this.ob(n),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),i)},s=>C.VSBuffer.concat(s))}C(c,n,r,i=Object.create(null)){const a=(0,C.newWriteableBufferStream)();return(0,h.readFileIntoStream)(c,n,a,s=>s,{...i,bufferSize:this.a,errorTransformer:s=>new b.FileOperationError((0,g.localize)(10,null,this.ob(n),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),i)},r),a}D(c,n,r){const i=(0,p.newWriteableStream)(a=>C.VSBuffer.concat(a));return(async()=>{try{let a;r?.atomic&&(0,b.hasFileAtomicReadCapability)(c)?a=await c.readFile(n,{atomic:!0}):a=await c.readFile(n),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.G(n,a.byteLength,r),i.end(C.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async F(c,n){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new b.FileOperationError((0,g.localize)(11,null,this.ob(c)),0,n);if(typeof n?.etag=="string"&&n.etag!==b.ETAG_DISABLED&&n.etag===r.etag)throw new b.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,n);return this.G(c,r.size,n),r}G(c,n,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&n>r.limits.size&&(i=7),typeof i=="number")throw new b.FileOperationError((0,g.localize)(13,null,this.ob(c)),i)}}async canMove(c,n,r){return this.H(c,n,"move",r)}async canCopy(c,n,r){return this.H(c,n,"copy",r)}async H(c,n,r,i){if(c.toString()!==n.toString())try{const a=r==="move"?this.mb(await this.l(c),c):await this.k(c),s=this.mb(await this.l(n),n);await this.M(a,c,s,n,r,i)}catch(a){return a}return!0}async move(c,n,r){const i=this.mb(await this.l(c),c),a=this.mb(await this.l(n),n),s=await this.I(i,c,a,n,"move",!!r),l=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(c,s==="move"?2:3,l)),l}async copy(c,n,r){const i=await this.k(c),a=this.mb(await this.l(n),n),s=await this.I(i,c,a,n,"copy",!!r),l=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(c,s==="copy"?3:2,l)),l}async I(c,n,r,i,a,s){if(n.toString()===i.toString())return a;const{exists:l,isSameResourceWithDifferentPathCase:o}=await this.M(c,n,r,i,a,s);if(l&&!o&&s&&await this.del(i,{recursive:!0}),await this.P(r,this.N(r).providerExtUri.dirname(i)),a==="copy"){if(c===r&&(0,b.hasFileFolderCopyCapability)(c))await c.copy(n,i,{overwrite:s});else{const y=await this.resolve(n);y.isDirectory?await this.L(c,y,r,i):await this.J(c,n,r,i)}return a}else return c===r?(await c.rename(n,i,{overwrite:s}),a):(await this.I(c,n,r,i,"copy",s),await this.del(n,{recursive:!0}),"copy")}async J(c,n,r,i){if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.fb(c,n,r,i);if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasReadWriteCapability)(r))return this.lb(c,n,r,i);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.jb(c,n,r,i);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasReadWriteCapability)(r))return this.hb(c,n,r,i)}async L(c,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async a=>{const s=this.N(r).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.L(c,await this.resolve(a.resource),r,s):this.J(c,a.resource,r,s)}))}async M(c,n,r,i,a,s){let l=!1;if(c===r){const{providerExtUri:y,isPathCaseSensitive:D}=this.N(c);if(D||(l=y.isEqual(n,i)),l&&a==="copy")throw new Error((0,g.localize)(14,null,this.ob(n),this.ob(i)));if(!l&&y.isEqualOrParent(i,n))throw new Error((0,g.localize)(15,null,this.ob(n),this.ob(i)))}const o=await this.exists(i);if(o&&!l){if(!s)throw new b.FileOperationError((0,g.localize)(16,null,this.ob(n),this.ob(i)),4);if(c===r){const{providerExtUri:y}=this.N(c);if(y.isEqualOrParent(n,i))throw new Error((0,g.localize)(17,null,this.ob(n),this.ob(i)))}}return{exists:o,isSameResourceWithDifferentPathCase:l}}N(c){const n=this.O(c);return{providerExtUri:n?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:n}}O(c){return!!(c.capabilities&1024)}async createFolder(c){const n=this.mb(await this.j(c),c);await this.P(n,c);const r=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(c,0,r)),r}async P(c,n){const r=[],{providerExtUri:i}=this.N(c);for(;!i.isEqual(n,i.dirname(n));)try{if(((await c.stat(n)).type&b.FileType.Directory)===0)throw new Error((0,g.localize)(18,null,this.ob(n)));break}catch(a){if((0,b.toFileSystemProviderErrorCode)(a)!==b.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(i.basename(n)),n=i.dirname(n)}for(let a=r.length-1;a>=0;a--){n=i.joinPath(n,r[a]);try{await c.mkdir(n)}catch(s){if((0,b.toFileSystemProviderErrorCode)(s)!==b.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,n){try{await this.Q(c,n)}catch(r){return r}return!0}async Q(c,n){const r=this.mb(await this.j(c),c);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.ob(c)));let a;try{a=await r.stat(c)}catch{}if(a)this.nb(c,a);else throw new b.FileOperationError((0,g.localize)(20,null,this.ob(c)),1);if(!!!n?.recursive){const l=await this.resolve(c);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,g.localize)(21,null,this.ob(c)))}return r}async del(c,n){const r=await this.Q(c,n),i=!!n?.useTrash,a=!!n?.recursive;await r.delete(c,{recursive:a,useTrash:i}),this.m.fire(new b.FileOperationEvent(c,1))}async cloneFile(c,n){const r=await this.j(c),i=this.mb(await this.l(n),n);if(r===i&&this.N(r).providerExtUri.isEqual(c,n))return;if(r===i&&(0,b.hasFileCloneCapability)(r))return r.cloneFile(c,n);await this.P(i,this.N(i).providerExtUri.dirname(n));const a=this.X.queueFor(c,this.N(r).providerExtUri);return r===i&&(0,b.hasFileFolderCopyCapability)(r)?a.queue(()=>r.copy(c,n,{overwrite:!0})):a.queue(()=>this.J(r,c,i,n))}watch(c,n={recursive:!1,excludes:[]}){const r=new w.DisposableStore;let i=!1,a=()=>{i=!0};return r.add((0,w.toDisposable)(()=>a())),(async()=>{try{const s=await this.W(c,n);i?(0,w.dispose)(s):a=()=>(0,w.dispose)(s)}catch(s){this.b.error(s)}})(),r}async W(c,n){const r=await this.j(c),i=(0,P.hash)([this.N(r).providerExtUri.getComparisonKey(c),n]);let a=this.U.get(i);return a||(a={count:0,disposable:r.watch(c,n)},this.U.set(i,a)),a.count+=1,(0,w.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,w.dispose)(a.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.U)(0,w.dispose)(c.disposable);this.U.clear()}async Y(c,n,r,i){return this.X.queueFor(n,this.N(c).providerExtUri).queue(async()=>{const a=await c.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(i)||(0,p.isReadableBufferedStream)(i)?await this.ab(c,a,i):await this.bb(c,a,i)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await c.close(a)}})}async ab(c,n,r){let i=0,a;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=C.VSBuffer.concat(r.buffer);await this.cb(c,n,s,s.byteLength,i,0),i+=s.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((s,l)=>{(0,p.listenStream)(a,{onData:async o=>{a.pause();try{await this.cb(c,n,o,o.byteLength,i,0)}catch(y){return l(y)}i+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>l(o),onEnd:()=>s()})})}async bb(c,n,r){let i=0,a;for(;(a=r.read())!==null;)await this.cb(c,n,a,a.byteLength,i,0),i+=a.byteLength}async cb(c,n,r,i,a,s){let l=0;for(;l<i;)l+=await c.write(n,a+l,r.buffer,s+l,i-l)}async db(c,n,r,i){return this.X.queueFor(n,this.N(c).providerExtUri).queue(()=>this.eb(c,n,r,i))}async eb(c,n,r,i){let a;i instanceof C.VSBuffer?a=i:(0,p.isReadableStream)(i)?a=await(0,C.streamToBuffer)(i):(0,p.isReadableBufferedStream)(i)?a=await(0,C.bufferedStreamToBuffer)(i):a=(0,C.readableToBuffer)(i),await c.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async fb(c,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.gb(c,n,r,i))}async gb(c,n,r,i){let a,s;try{a=await c.open(n,{create:!1}),s=await r.open(i,{create:!0,unlock:!1});const l=C.VSBuffer.alloc(this.a);let o=0,y=0,D=0;do D=await c.read(a,o,l.buffer,y,l.byteLength-y),await this.cb(r,s,l,D,o,y),o+=D,y+=D,y===l.byteLength&&(y=0);while(D>0)}catch(l){throw(0,b.ensureFileSystemProviderError)(l)}finally{await t.Promises.settled([typeof a=="number"?c.close(a):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async hb(c,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.ib(c,n,r,i))}async ib(c,n,r,i){return r.writeFile(i,await c.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async jb(c,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.kb(c,n,r,i))}async kb(c,n,r,i){const a=await r.open(i,{create:!0,unlock:!1});try{const s=await c.readFile(n);await this.cb(r,a,C.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await r.close(a)}}async lb(c,n,r,i){const a=await(0,C.streamToBuffer)(this.C(c,n,M.CancellationToken.None));await this.db(r,i,void 0,a)}mb(c,n){if(c.capabilities&2048)throw new b.FileOperationError((0,g.localize)(22,null,this.ob(n)),6);return c}nb(c,n){if((n.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,g.localize)(23,null,this.ob(c)),6)}ob(c){return c.scheme===k.Schemas.file?c.fsPath:c.toString(!0)}};d=pe([te(0,v.ILogService)],d),e.FileService=d}),define(ee[86],ie([0,1,40,278,8,39,17,3,30,2,9,4,20,57,23,161,16,108,203,44,199,198]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(E)}catch(r){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(r)}`)}})();class n extends v.AbstractDiskFileSystemProvider{constructor(i,a){super(i,a),this.onDidChangeCapabilities=P.Event.None,this.I=new M.ResourceMap(s=>I.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.M=new Map,this.N=new Map,this.O=new Map}get capabilities(){return this.G||(this.G=57374,k.isLinux&&(this.G|=1024)),this.G}async stat(i){try{const{stat:a,symbolicLink:s}=await p.SymlinkSupport.stat(this.D(i));return{type:this.H(a,s),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.ab(a)}}async readdir(i){try{const a=await p.Promises.readdir(this.D(i),{withFileTypes:!0}),s=[];return await Promise.all(a.map(async l=>{try{let o;l.isSymbolicLink()?o=(await this.stat((0,I.joinPath)(i,l.name))).type:o=this.H(l),s.push([l.name,o])}catch(o){this.a.trace(o)}})),s}catch(a){throw this.ab(a)}}H(i,a){let s;return a?.dangling?s=b.FileType.Unknown:i.isFile()?s=b.FileType.File:i.isDirectory()?s=b.FileType.Directory:s=b.FileType.Unknown,a&&(s|=b.FileType.SymbolicLink),s}async J(i){const a=this.D(i);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let s;for(;s=this.I.get(i);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await s.wait();const l=new C.Barrier;return this.I.set(i,l),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,w.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.I.get(i)===l&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.I.delete(i)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),l.open()})}async readFile(i,a){let s;try{a?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.D(i)})`),s=await this.J(i));const l=this.D(i);return await p.Promises.readFile(l)}catch(l){throw this.ab(l)}finally{s?.dispose()}}L(i){n.F&&this.a.trace(i)}readFileStream(i,a,s){const l=(0,f.newWriteableStream)(o=>A.VSBuffer.concat(o.map(y=>A.VSBuffer.wrap(y))).buffer);return(0,h.readFileIntoStream)(this,i,l,o=>o.buffer,{...a,bufferSize:256*1024},s),l}async writeFile(i,a,s){let l;try{const o=this.D(i);if(!s.create||!s.overwrite){if(await p.Promises.exists(o)){if(!s.overwrite)throw(0,b.createFileSystemProviderError)((0,g.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,b.createFileSystemProviderError)((0,g.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(l,0,a,0,a.byteLength)}catch(o){throw await this.bb(i,o)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){n.P=i}async open(i,a){const s=this.D(i);let l;(0,b.isFileOpenForWriteOptions)(a)&&(l=await this.J(i));let o;try{if((0,b.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:D}=await p.SymlinkSupport.stat(s);D.mode&128||await p.Promises.chmod(s,D.mode|128)}catch(D){this.a.trace(D)}let y;if((0,b.isFileOpenForWriteOptions)(a)){if(k.isWindows)try{await p.Promises.truncate(s,0),y="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}y||(y="w")}else y="r";o=await p.Promises.open(s,y)}catch(y){throw l?.dispose(),(0,b.isFileOpenForWriteOptions)(a)?await this.bb(i,y):this.ab(y)}if(this.M.set(o,0),(0,b.isFileOpenForWriteOptions)(a)&&this.O.set(o,i),l){const y=this.N.get(o);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${s})`),this.N.set(o,l),y&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${s})`),y.dispose())}return o}async close(i){const a=this.N.get(i);try{if(this.M.delete(i),this.O.delete(i)&&n.P)try{await p.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await p.Promises.close(i)}catch(s){throw this.ab(s)}finally{a&&(this.N.get(i)===a&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.N.delete(i)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),a.dispose())}}async read(i,a,s,l,o){const y=this.Q(i,a);let D=null;try{D=(await p.Promises.read(i,s,l,o,y)).bytesRead}catch(O){throw this.ab(O)}finally{this.R(i,y,D)}return D}Q(i,a){return a===this.M.get(i)?null:a}R(i,a,s){const l=this.M.get(i);typeof l=="number"&&(typeof a=="number"||(typeof s=="number"?this.M.set(i,l+s):this.M.delete(i)))}async write(i,a,s,l,o){return(0,C.retry)(()=>this.S(i,a,s,l,o),100,3)}async S(i,a,s,l,o){const y=this.Q(i,a);let D=null;try{D=(await p.Promises.write(i,s,l,o,y)).bytesWritten}catch(O){throw await this.bb(this.O.get(i),O)}finally{this.R(i,y,D)}return D}async mkdir(i){try{await p.Promises.mkdir(this.D(i))}catch(a){throw this.ab(a)}}async delete(i,a){try{const s=this.D(i);a.recursive?await p.Promises.rm(s,p.RimRafMode.MOVE):await p.Promises.unlink(s)}catch(s){throw this.ab(s)}}async rename(i,a,s){const l=this.D(i),o=this.D(a);if(l!==o)try{await this.U(i,a,"move",s.overwrite),await p.Promises.move(l,o)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,g.localize)(2,null,(0,S.basename)(l),(0,S.basename)((0,S.dirname)(o)),y.toString()))),this.ab(y)}}async copy(i,a,s){const l=this.D(i),o=this.D(a);if(l!==o)try{await this.U(i,a,"copy",s.overwrite),await p.Promises.copy(l,o,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,g.localize)(3,null,(0,S.basename)(l),(0,S.basename)((0,S.dirname)(o)),y.toString()))),this.ab(y)}}async U(i,a,s,l){const o=this.D(i),y=this.D(a);let D=!1;if(!!(this.capabilities&1024)||(D=(0,m.isEqual)(o,y,!0)),D&&s==="copy")throw(0,b.createFileSystemProviderError)((0,g.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!D&&await p.Promises.exists(y)){if(!l)throw(0,b.createFileSystemProviderError)((0,g.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(i,a){return this.W(i,a,!1)}async W(i,a,s){const l=this.D(i),o=this.D(a),y=!!(this.capabilities&1024);if((0,m.isEqual)(l,o,!y))return;const D=new w.DisposableStore;try{const[O,N]=await Promise.all([this.J(i),this.J(a)]);D.add(O),D.add(N),s&&await p.Promises.mkdir((0,S.dirname)(o),{recursive:!0}),await p.Promises.copyFile(l,o)}catch(O){if(O.code==="ENOENT"&&!s)return this.W(i,a,!0);throw this.ab(O)}finally{D.dispose()}}p(i,a,s){return new u.UniversalWatcherClient(l=>i(l),l=>a(l),s)}y(i,a,s){return new c.NodeJSWatcherClient(l=>i(l),l=>a(l),s)}ab(i){if(i instanceof b.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=b.FileSystemProviderErrorCode.NoPermissions;break;default:a=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(i,a)}async bb(i,a){let s=this.ab(a);if(i&&s.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await p.SymlinkSupport.stat(this.D(i));l.mode&128||(s=(0,b.createFileSystemProviderError)(a,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return s}}e.DiskFileSystemProvider=n,n.F=!1,n.P=!0}),define(ee[205],ie([0,1,3,86,2,17,57,22]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class m extends C.Disposable{constructor(k,I){super(),this.a=k,this.b=I,this.w=new Map,this.y=new Map}call(k,I,f){const p=this.c(k);switch(I){case"stat":return this.g(p,f[0]);case"readdir":return this.h(p,f[0]);case"open":return this.l(p,f[0],f[1]);case"close":return this.m(f[0]);case"read":return this.n(f[0],f[1],f[2]);case"readFile":return this.i(p,f[0],f[1]);case"write":return this.p(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.k(p,f[0],f[1],f[2]);case"rename":return this.t(p,f[0],f[1],f[2]);case"copy":return this.u(p,f[0],f[1],f[2]);case"cloneFile":return this.v(p,f[0],f[1]);case"mkdir":return this.r(p,f[0]);case"delete":return this.s(p,f[0],f[1]);case"watch":return this.D(p,f[0],f[1],f[2],f[3]);case"unwatch":return this.F(f[0],f[1])}throw new Error(`IPC Command ${I} not found`)}listen(k,I,f){const p=this.c(k);switch(I){case"fileChange":return this.C(p,f[0]);case"readFileStream":return this.j(p,f[0],f[1])}throw new Error(`Unknown event ${I}`)}g(k,I){const f=this.f(k,I,!0);return this.a.stat(f)}h(k,I){const f=this.f(k,I);return this.a.readdir(f)}async i(k,I,f){const p=this.f(k,I,!0),g=await this.a.readFile(p,f);return M.VSBuffer.wrap(g)}j(k,I,f){const p=this.f(k,I,!0),g=new P.CancellationTokenSource,b=new E.Emitter({onDidRemoveLastListener:()=>{g.cancel()}}),h=this.a.readFileStream(p,f,g.token);return(0,A.listenStream)(h,{onData:v=>b.fire(M.VSBuffer.wrap(v)),onError:v=>b.fire(v),onEnd:()=>{b.fire("end"),b.dispose(),g.dispose()}}),b.event}k(k,I,f,p){const g=this.f(k,I);return this.a.writeFile(g,f.buffer,p)}l(k,I,f){const p=this.f(k,I,!0);return this.a.open(p,f)}m(k){return this.a.close(k)}async n(k,I,f){const p=M.VSBuffer.alloc(f),g=0,b=await this.a.read(k,I,p.buffer,g,f);return[p,b]}p(k,I,f,p,g){return this.a.write(k,I,f.buffer,p,g)}r(k,I){const f=this.f(k,I);return this.a.mkdir(f)}s(k,I,f){const p=this.f(k,I);return this.a.delete(p,f)}t(k,I,f,p){const g=this.f(k,I),b=this.f(k,f);return this.a.rename(g,b,p)}u(k,I,f,p){const g=this.f(k,I),b=this.f(k,f);return this.a.copy(g,b,p)}v(k,I,f){const p=this.f(k,I),g=this.f(k,f);return this.a.cloneFile(p,g)}C(k,I){const f=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(I,this.G(k,f))},onDidRemoveLastListener:()=>{(0,C.dispose)(this.w.get(I)),this.w.delete(I)}});return f.event}async D(k,I,f,p,g){const b=this.w.get(I);if(b){const h=this.f(k,p),v=b.watch(f,h,g);this.y.set(I+f,v)}}async F(k,I){const f=k+I,p=this.y.get(f);p&&((0,C.dispose)(p),this.y.delete(f))}dispose(){super.dispose();for(const[,k]of this.y)k.dispose();this.y.clear();for(const[,k]of this.w)k.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=m;class w extends C.Disposable{constructor(k,I,f,p){super(),this.c=k,this.f=f,this.g=p,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(I)}h(k){const I=this.B(new E.Emitter);this.B(I.event(f=>{k.fire(f.map(p=>({resource:this.c.transformOutgoingURI(p.resource),type:p.type})))})),this.B(this.b.onDidChangeFile(f=>I.fire(f))),this.B(this.b.onDidWatchError(f=>k.fire(f)))}i(k){}j(k){}watch(k,I,f){const p=this.j(this.g);return Array.isArray(p)&&(f.excludes=[...f.excludes,...p]),this.a.set(k,this.b.watch(I,f)),(0,C.toDisposable)(()=>{(0,C.dispose)(this.a.get(k)),this.a.delete(k)})}dispose(){super.dispose();for(const[,k]of this.a)k.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=w}),define(ee[206],ie([0,1,13,160,4,7,16,9,205,139]),function(q,e,E,t,C,M,A,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class S extends m.AbstractDiskFileSystemProviderChannel{constructor(f,p,g){super(f,p),this.H=g}c(f){return w.DefaultURITransformer}f(f,p){return M.URI.revive(p)}async s(f,p,g){if(!g.useTrash)return super.s(f,p,g);const b=this.f(f,p),h=(0,P.normalize)(b.fsPath);try{await E.shell.trashItem(h)}catch{throw(0,A.createFileSystemProviderError)(C.isWindows?(0,t.localize)(0,null,(0,P.basename)(h)):(0,t.localize)(1,null,(0,P.basename)(h)),A.FileSystemProviderErrorCode.Unknown)}}G(f,p){return new k(f,p,this.b,this.H)}}e.DiskFileSystemProviderChannel=S;class k extends m.AbstractSessionFileWatcher{watch(f,p,g){if(g.recursive)throw(0,A.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(f,p,g)}}}),define(ee[207],ie([0,1,6]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(M,A){switch(A){case E.LogLevel.Trace:return M.trace;case E.LogLevel.Debug:return M.debug;case E.LogLevel.Info:return M.info;case E.LogLevel.Warning:return M.warn;case E.LogLevel.Error:return M.error;default:throw new Error("Invalid log level")}}class C extends E.AbstractLogger{constructor(A=E.DEFAULT_LOG_LEVEL){super(),this.f=[],this.g=void 0,this.setLevel(A),this.B(this.onDidChangeLogLevel(P=>{this.g?.setLevel(P)}))}set logger(A){this.g=A;for(const{level:P,args:m}of this.f)t(A,P).apply(A,m);this.f=[]}h(A,...P){this.g?t(this.g,A).apply(this.g,P):this.getLevel()<=A&&this.f.push({level:A,args:P})}trace(A,...P){this.h(E.LogLevel.Trace,A,...P)}debug(A,...P){this.h(E.LogLevel.Debug,A,...P)}info(A,...P){this.h(E.LogLevel.Info,A,...P)}warn(A,...P){this.h(E.LogLevel.Warning,A,...P)}error(A,...P){this.h(E.LogLevel.Error,A,...P)}dispose(){this.g?.dispose()}flush(){this.g?.flush()}}e.BufferLogService=C}),define(ee[208],ie([0,1,3,7,6]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(I,f){this.a=I,this.b=f,this.onDidChangeLogLevel=E.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,f){switch(f){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${f}`)}async call(I,f,p){switch(f){case"setLevel":return p[1]?this.b.setLevel(t.URI.revive(p[1]),p[0]):this.a.setLevel(p[0])}throw new Error(`Call not found: ${f}`)}}e.LogLevelChannel=M;class A{constructor(I){this.a=I}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(I,f){A.setLevel(this.a,I,f)}static setLevel(I,f,p){return I.call("setLevel",[f,p])}}e.LogLevelChannelClient=A;class P{constructor(I){this.b=I,this.a=new Map}listen(I,f){throw new Error(`Event not found: ${f}`)}async call(I,f,p){switch(f){case"createLogger":this.c(t.URI.revive(p[0]),p[1]);return;case"log":return this.e(t.URI.revive(p[0]),p[1]);case"consoleLog":return this.d(p[0],p[1])}throw new Error(`Call not found: ${f}`)}c(I,f){this.a.set(I.toString(),this.b.createLogger(I,f))}d(I,f){let p=console.log;switch(I){case C.LogLevel.Error:p=console.error;break;case C.LogLevel.Warning:p=console.warn;break;case C.LogLevel.Info:p=console.info;break}p.call(console,...f)}e(I,f){const p=this.a.get(I.toString());if(!p)throw new Error("Create the logger before logging");for(const[g,b]of f)(0,C.log)(p,g,b)}}e.LoggerChannel=P;class m extends C.AbstractLoggerService{constructor(I,f,p){super(I,f),this.g=p}createConsoleMainLogger(){return new C.AdapterLogger({log:(I,f)=>{this.g.call("consoleLog",[I,f])}})}f(I,f,p){return new w(this.g,I,f,p)}}e.LoggerChannelClient=m;class w extends C.AbstractMessageLogger{constructor(I,f,p,g){super(g?.always),this.l=I,this.m=f,this.j=!1,this.k=[],this.setLevel(p),this.l.call("createLogger",[f,g]).then(()=>{this.p(this.k),this.j=!0})}f(I,f){const p=[[I,f]];this.j?this.p(p):this.k.push(...p)}p(I){this.l.call("log",[this.m,I])}}class S extends C.LogService{constructor(I,f){super(f),this.c=I,this.B(I.onDidChangeLogLevel(p=>f.setLevel(p)))}setLevel(I){super.setLevel(I),this.c.setLevel(I)}}e.FollowerLogService=S}),define(ee[209],ie([0,1,16,6]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var C;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(C||(C={}));async function M(w,S,k,I,f){try{const p=await new Promise((b,h)=>{q(["spdlog"],b,h)});p.setFlushOn(t.LogLevel.Trace);const g=await p.createAsyncRotatingLogger(w,S,k,I);return f?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(p){console.error(p)}return null}function A(w,S,k){switch(S){case t.LogLevel.Trace:w.trace(k);break;case t.LogLevel.Debug:w.debug(k);break;case t.LogLevel.Info:w.info(k);break;case t.LogLevel.Warning:w.warn(k);break;case t.LogLevel.Error:w.error(k);break;default:throw new Error("Invalid log level")}}function P(w,S){switch(S){case t.LogLevel.Trace:w.setLevel(C.Trace);break;case t.LogLevel.Debug:w.setLevel(C.Debug);break;case t.LogLevel.Info:w.setLevel(C.Info);break;case t.LogLevel.Warning:w.setLevel(C.Warning);break;case t.LogLevel.Error:w.setLevel(C.Error);break;case t.LogLevel.Off:w.setLevel(C.Off);break;default:throw new Error("Invalid log level")}}class m extends t.AbstractMessageLogger{constructor(S,k,I,f,p){super(),this.j=[],this.setLevel(p),this.k=this.m(S,k,I,f),this.B(this.onDidChangeLogLevel(g=>{this.l&&P(this.l,g)}))}async m(S,k,I,f){const p=I?6:1,g=30/p*E.ByteSize.MB,b=await M(S,k,g,p,f);if(b){this.l=b,P(this.l,this.getLevel());for(const{level:h,message:v}of this.j)A(this.l,h,v);this.j=[]}}f(S,k){this.l?A(this.l,S,k):this.getLevel()<=S&&this.j.push({level:S,message:k})}flush(){this.l?this.l.flush():this.k.then(()=>this.flush())}dispose(){this.l?this.p():this.k.then(()=>this.p())}p(){this.l&&(this.l.drop(),this.l=void 0)}}e.SpdLogLogger=m}),define(ee[210],ie([0,1,29,6,209]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let M=class extends t.AbstractLoggerService{constructor(P){super(P.getLevel(),P.onDidChangeLogLevel)}f(P,m,w){return new C.SpdLogLogger(w?.name||(0,E.generateUuid)(),P.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,m)}};M=pe([te(0,t.ILogService)],M),e.LoggerService=M}),define(ee[211],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(A){return A.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function t(A){return A.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function C(A){return A.uri!==void 0}e.isMenubarMenuItemRecentAction=C;function M(A){return!E(A)&&!t(A)&&!C(A)}e.isMenubarMenuItemAction=M}),define(ee[36],ie([0,1,3,66,2,5]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,M.createDecorator)("policy");class A extends C.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const S=Object.keys(this.f).length;return this.f={...w,...this.f},S!==Object.keys(this.f).length&&await this.i(w),t.Iterable.reduce(this.g.entries(),(k,[I,f])=>({...k,[I]:f}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(w,[S,k])=>({...w,[S]:{definition:k,value:this.g.get(S)}}),{})}}e.AbstractPolicyService=A;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ee[212],ie([0,1,8,3,66,12,16,6,36]),function(q,e,E,t,C,M,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function w(k,I){const f=[];for(const p of C.Iterable.concat(k.keys(),I.keys()))k.get(p)!==I.get(p)&&f.push(p);return f}let S=class extends m.AbstractPolicyService{constructor(I,f,p){super(),this.j=I,this.k=f,this.l=p,this.c=this.B(new E.ThrottledDelayer(500));const g=t.Event.filter(f.onDidFilesChange,b=>b.affects(I));this.B(f.watch(I)),this.B(g(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const I=new Map;try{const f=await this.k.readFile(this.j),p=JSON.parse(f.value.toString());if(!(0,M.isObject)(p))throw new Error("Policy file isn't a JSON object");for(const g of Object.keys(p))this.f[g]&&I.set(g,p[g])}catch(f){f.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",f)}return I}async p(){const I=await this.n(),f=w(this.g,I);this.g=I,f.length>0&&this.h.fire(f)}};S=pe([te(1,A.IFileService),te(2,P.ILogService)],S),e.FilePolicyService=S}),define(ee[213],ie([0,1,3,2,36]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class M{constructor(m){this.b=m,this.a=new t.DisposableStore}listen(m,w){switch(w){case"onDidChange":return E.Event.map(this.b.onDidChange,S=>S.reduce((k,I)=>({...k,[I]:this.b.getPolicyValue(I)??null}),{}),this.a)}throw new Error(`Event not found: ${w}`)}call(m,w,S){switch(w){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${w}`)}dispose(){this.a.dispose()}}e.PolicyChannel=M;class A extends C.AbstractPolicyService{constructor(m,w){super(),this.a=w;for(const S in m){const{definition:k,value:I}=m[S];this.f[S]=k,I!==void 0&&this.g.set(S,I)}this.a.listen("onDidChange")(S=>{for(const k in S){const I=S[k];I===null?this.g.delete(k):this.g.set(k,I)}this.h.fire(Object.keys(S))})}async i(m){const w=await this.a.call("updatePolicyDefinitions",m);for(const S in w)this.g.set(S,w[S])}}e.PolicyChannelClient=A}),define(ee[54],ie([0,1,4,32]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const M=E.globals.vscode.context.configuration();if(M)C=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:M.version})}}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(ee[19],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[214],ie([0,1,77,6,19]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(P,m){this.b=P,this.c=m,this.a=new Map}async isExtensionUrlTrusted(P,m){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(m);if(!w)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",m),!1;const[,S,k]=w;let I=this.a.get(P);if(!I){if(I=this.b.trustedExtensionUrlPublicKeys[P],!I||I.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...I])}const f=Buffer.from(decodeURIComponent(k),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",m),!1;const p=f.slice(0,6),g=f.readUIntBE(0,6),b=Date.now()-g;if(b<0||b>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",m),!1;const h=f.slice(6),v=E.createVerify("SHA256");v.write(p),v.write(Buffer.from(S)),v.end();for(let d=0;d<I.length;d++){let u=I[d];if(u!==null){if(typeof u=="string")try{u=E.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),I[d]=u}catch(c){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${P}:`,c),I[d]=null;continue}if(v.verify(u,h))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",m),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",m),!1}};M=pe([te(0,C.IProductService),te(1,t.ILogService)],M),e.ExtensionUrlTrustService=M}),define(ee[215],ie([0,1,8,6]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let C=class{constructor(A,P,m){this.a=A,this.b=P,this.c=m}async inspect(A){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(A);const m=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),m.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};C=pe([te(2,t.ILogService)],C),e.WindowProfiler=C}),define(ee[61],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ee[47],ie([0,1,121,12]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.a=new Map}add(A,P){E.ok(t.isString(A)),E.ok(t.isObject(P)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,P)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.Registry=new C}),define(ee[216],ie([0,1,3,47]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,w){this.a[C(m)]=w,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;t.Registry.add(e.Extensions.JSONContribution,A)}),define(ee[62],ie([0,1,24,3,12,148,18,216,47]),function(q,e,E,t,C,M,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=m.Registry.as(P.Extensions.JSONContribution);class I{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=this.k(n,r);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(n){const r=this.l(n);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=[];i.push(...this.l(r)),i.push(...this.k(n,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,E.distinct)(i)})}registerDefaultConfigurations(n){const r=[],i=[];for(const{overrides:a,source:s}of n)for(const l in a)if(r.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const o=this.a.get(l),y=o?.valuesSources??new Map;if(s)for(const Y of Object.keys(a[l]))y.set(Y,s);const D={...o?.value||{},...a[l]};this.a.set(l,{source:s,value:D,valuesSources:y});const O=(0,A.getLanguageTagSettingPlainKey)(l),N={type:"object",default:D,description:M.localize(1,null,O),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:C.isString(s)?void 0:s,defaultValueSource:s};i.push(...g(l)),this.d[l]=N,this.b.properties[l]=N}else{this.a.set(l,{value:a[l],source:s});const o=this.d[l];o&&(this.s(l,o),this.o(l,o))}this.registerOverrideIdentifiers(i),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const r=[];for(const{overrides:i,source:a}of n)for(const s in i){const l=this.a.get(s),o=C.isString(a)?a:a?.id,y=C.isString(l?.source)?l?.source:l?.source?.id;if(o===y)if(r.push(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const D=this.d[s];D&&(this.s(s,D),this.o(s,D))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){for(const r of n)this.h.add(r);this.q()}k(n,r){const i=[];return n.forEach(a=>{i.push(...this.m(a,r,a.extensionInfo,a.restrictedProperties)),this.c.push(a),this.n(a)}),i}l(n){const r=[],i=a=>{if(a.properties)for(const s in a.properties){r.push(s);const l=this.d[s];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[s],this.p(s,a.properties[s])}a.allOf?.forEach(s=>i(s))};for(const a of n){i(a);const s=this.c.indexOf(a);s!==-1&&this.c.splice(s,1)}return r}m(n,r=!0,i,a,s=3){s=C.isUndefinedOrNull(n.scope)?s:n.scope;const l=[],o=n.properties;if(o)for(const D in o){const O=o[D];if(r&&d(D,O)){delete o[D];continue}if(O.source=i,O.defaultDefaultValue=o[D].default,this.s(D,O),e.OVERRIDE_PROPERTY_REGEX.test(D)?O.scope=void 0:(O.scope=C.isUndefinedOrNull(O.scope)?s:O.scope,O.restricted=C.isUndefinedOrNull(O.restricted)?!!a?.includes(D):O.restricted),o[D].hasOwnProperty("included")&&!o[D].included){this.f[D]=o[D],delete o[D];continue}else this.d[D]=o[D],o[D].policy?.name&&this.e.set(o[D].policy.name,D);!o[D].deprecationMessage&&o[D].markdownDeprecationMessage&&(o[D].deprecationMessage=o[D].markdownDeprecationMessage),l.push(D)}const y=n.allOf;if(y)for(const D of y)l.push(...this.m(D,r,i,a,s));return l}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(n){const r=i=>{const a=i.properties;if(a)for(const l in a)this.o(l,a[l]);i.allOf?.forEach(r)};r(n)}o(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.g.properties[n]=r;break}}p(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}q(){for(const n of this.h.values()){const r=`[${n}]`,i={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this.i.fire()}r(){const n={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}s(n,r){const i=this.a.get(n);let a=i?.value,s=i?.source;C.isUndefined(a)&&(a=r.defaultDefaultValue,s=void 0),C.isUndefined(a)&&(a=h(r.type)),r.default=a,r.defaultValueSource=s}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(c){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=p.exec(c);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=p.exec(c)}}return(0,E.distinct)(n)}e.overrideIdentifiersFromKey=g;function b(c){return c.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=b;function h(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const v=new I;m.Registry.add(e.Extensions.Configuration,v);function d(c,n){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?M.localize(7,null,c):v.getConfigurationProperties()[c]!==void 0?M.localize(8,null,c):n.policy?.name&&v.getPolicyConfigurations().get(n.policy?.name)!==void 0?M.localize(9,null,c,n.policy?.name,v.getPolicyConfigurations().get(n.policy?.name)):null:M.localize(6,null)}e.validateProperty=d;function u(){const c=[],n=v.getConfigurationProperties();for(const r of Object.keys(n))c.push([r,n[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=u}),define(ee[109],ie([0,1,24,3,43,2,39,50,12,7,18,62,47]),function(q,e,E,t,C,M,A,P,m,w,S,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class f{constructor(r={},i=[],a=[],s){this.c=r,this.d=i,this.f=a,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof f)return i;const a=new p("");return a.parseRaw(i),a.configurationModel});this.g=r.reduce((i,a)=>a===i?a:i.merge(a),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,S.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const a=this.rawConfiguration.getValue(r),s=i?this.rawConfiguration.getOverrideValue(r,i):void 0,l=i?this.rawConfiguration.override(i).getValue(r):a;return{value:a,override:s,merged:l}}getOverrideValue(r,i){const a=this.l(i);return a?r?(0,S.getConfigurationValue)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const a of this.overrides)a.identifiers.includes(r)&&i.push(...a.keys);return E.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return E.distinct(r)}override(r){let i=this.b.get(r);return i||(i=this.h(r),this.b.set(r,i)),i}merge(...r){const i=P.deepClone(this.contents),a=P.deepClone(this.overrides),s=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const o of r)if(l.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.j(i,o.contents);for(const y of o.overrides){const[D]=a.filter(O=>E.equals(O.identifiers,y.identifiers));D?(this.j(D.contents,y.contents),D.keys.push(...y.keys),D.keys=E.distinct(D.keys)):a.push(P.deepClone(y))}for(const y of o.keys)s.indexOf(y)===-1&&s.push(y)}return new f(i,s,a,l.every(o=>o instanceof f)?void 0:l)}freeze(){return this.a=!0,this}clone(){return new f(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}h(r){const i=this.l(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const s of E.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[s];const o=i[s];o&&(typeof l=="object"&&typeof o=="object"?(l=P.deepClone(l),this.j(l,o)):l=o),a[s]=l}return new f(a,this.keys,this.overrides)}j(r,i){for(const a of Object.keys(i)){if(a in r&&m.isObject(r[a])&&m.isObject(i[a])){this.j(r[a],i[a]);continue}r[a]=P.deepClone(i[a])}}k(r){return this.a&&!Object.isFrozen(r)?P.deepFreeze(r):r}l(r){let i=null,a=null;const s=l=>{l&&(a?this.j(a,l):a=P.deepClone(l))};for(const l of this.overrides)E.equals(l.identifiers,[r])?i=l.contents:l.identifiers.includes(r)&&s(l.contents);return s(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.m(r),(0,S.addToValueTree)(this.contents,r,i,a=>{throw new Error(a)})}removeValue(r){this.n(r)&&(0,S.removeFromValueTree)(this.contents,r)}m(r){let i=this.keys.length;for(let a=0;a<i;a++)r.indexOf(this.keys[a])===0&&(i=a);this.keys.splice(i,1,r)}n(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class p{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!m.isUndefinedOrNull(r)){const a=this.g(r);this.parseRaw(a,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:a,keys:s,overrides:l,restricted:o,hasExcludedProperties:y}=this.h(r,i);this.b=new f(a,s,l,y?[r]:void 0),this.c=o||[]}g(r){let i={},a=null,s=[];const l=[],o=[];function y(O){Array.isArray(s)?s.push(O):a!==null&&(s[a]=O)}const D={onObjectBegin:()=>{const O={};y(O),l.push(s),s=O,a=null},onObjectProperty:O=>{a=O},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const O=[];y(O),l.push(s),s=O,a=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:y,onError:(O,N,Y)=>{o.push({error:O,offset:N,length:Y})}};if(r)try{C.visit(r,D),i=s[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}h(r,i){const a=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),s=this.j(r,a,!0,i);r=s.raw;const l=(0,S.toValuesTree)(r,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),o=Object.keys(r),y=this.l(r,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:l,keys:o,overrides:y,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(r,i,a,s){let l=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:l};const o={},y=[];for(const D in r)if(k.OVERRIDE_PROPERTY_REGEX.test(D)&&a){const O=this.j(r[D],i,!1,s);o[D]=O.raw,l=l||O.hasExcludedProperties,y.push(...O.restricted)}else{const O=i[D],N=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&y.push(D),(N===void 0||s.scopes===void 0||s.scopes.includes(N))&&!(s.skipRestricted&&O?.restricted)?o[D]=r[D]:l=!0}return{raw:o,restricted:y,hasExcludedProperties:l}}l(r,i){const a=[];for(const s of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(s)){const l={};for(const o in r[s])l[o]=r[s][o];a.push({identifiers:(0,k.overrideIdentifiersFromKey)(s),keys:Object.keys(l),contents:(0,S.toValuesTree)(l,i)})}return a}}e.ConfigurationModelParser=p;class g extends M.Disposable{constructor(r,i,a,s){super(),this.f=r,this.g=i,this.h=s,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&a.isEqual(l.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new f}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=g;class b{constructor(r,i,a,s,l,o,y,D,O,N,Y,G,V){this.a=r,this.b=i,this.value=a,this.overrideIdentifiers=s,this.c=l,this.d=o,this.f=y,this.g=D,this.h=O,this.j=N,this.k=Y,this.l=G,this.m=V}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get A(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class h{constructor(r,i,a,s,l=new f,o=new f,y=new A.ResourceMap,D=new f,O=new A.ResourceMap,N=!0){this.c=r,this.d=i,this.f=a,this.g=s,this.h=l,this.j=o,this.l=y,this.m=D,this.n=O,this.p=N,this.a=null,this.b=new A.ResourceMap,this.q=null}getValue(r,i,a){return this.s(r,i,a).getValue(r)}updateValue(r,i,a={}){let s;a.resource?(s=this.n.get(a.resource),s||(s=new f,this.n.set(a.resource,s))):s=this.m,i===void 0?s.removeValue(r):s.setValue(r,i),a.resource||(this.a=null)}inspect(r,i,a){const s=this.s(r,i,a),l=E.distinct(s.overrides.map(D=>D.identifiers).flat()).filter(D=>s.getOverrideValue(r,D)!==void 0),o=this.w(i.resource,a),y=i.resource?this.n.get(i.resource)||this.m:this.m;return new b(r,i,s.getValue(r),l.length?l:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),a?this.j.freeze():void 0,o?o.freeze():void 0,y.inspect(r,i.overrideIdentifier))}keys(r){const i=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.l.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const a=[];if(!i){const{added:s,updated:l,removed:o}=u(this.c,r);i=[...s,...l,...o]}for(const s of i)for(const l of(0,k.overrideIdentifiersFromKey)(s)){const o=this.c.getKeysForOverrideIdentifier(l),y=r.getKeysForOverrideIdentifier(l),D=[...y.filter(O=>o.indexOf(O)===-1),...o.filter(O=>y.indexOf(O)===-1),...o.filter(O=>!P.equals(this.c.override(l).getValue(O),r.override(l).getValue(O)))];a.push([l,D])}return this.updateDefaultConfiguration(r),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:a,removed:s}=u(this.d,r),l=[...i,...a,...s];return l.length&&this.updatePolicyConfiguration(r),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:a,removed:s,overrides:l}=u(this.applicationConfiguration,r),o=[...i,...a,...s];return o.length&&this.updateApplicationConfiguration(r),{keys:o,overrides:l}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:a,removed:s,overrides:l}=u(this.localUserConfiguration,r),o=[...i,...a,...s];return o.length&&this.updateLocalUserConfiguration(r),{keys:o,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:a,removed:s,overrides:l}=u(this.remoteUserConfiguration,r),o=[...i,...a,...s];return o.length&&this.updateRemoteUserConfiguration(r),{keys:o,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:a,removed:s,overrides:l}=u(this.workspaceConfiguration,r),o=[...i,...a,...s];return o.length&&this.updateWorkspaceConfiguration(r),{keys:o,overrides:l}}compareAndUpdateFolderConfiguration(r,i){const a=this.r.get(r),{added:s,updated:l,removed:o,overrides:y}=u(a,i),D=[...s,...l,...o];return(D.length||!a)&&this.updateFolderConfiguration(r,i),{keys:D,overrides:y}}compareAndDeleteFolderConfiguration(r){const i=this.r.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:s,removed:l,overrides:o}=u(i,void 0);return{keys:[...a,...s,...l],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,i,a){let s=this.t(i,a);return i.overrideIdentifier&&(s=s.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(s=s.merge(this.d)),s}t({resource:r},i){let a=this.u();if(i&&r){const s=i.getFolder(r);s&&(a=this.v(s.uri)||a);const l=this.n.get(r);l&&(a=a.merge(l))}return a}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let i=this.b.get(r);if(!i){const a=this.u(),s=this.l.get(r);s?(i=a.merge(s),this.p&&(i=i.freeze()),this.b.set(r,i)):i=a}return i}w(r,i){if(i&&r){const a=i.getFolder(r);if(a)return this.l.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,i)=>{const{contents:a,overrides:s,keys:l}=this.l.get(i);return r.push([i,{contents:a,overrides:s,keys:l}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this.j.freeze().keys.forEach(i=>r.add(i)),this.l.forEach(i=>i.freeze().keys.forEach(a=>r.add(a))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.l.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}y(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.j.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.l.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s))),[...i.values()]}static parse(r){const i=this.A(r.defaults),a=this.A(r.policy),s=this.A(r.application),l=this.A(r.user),o=this.A(r.workspace),y=r.folders.reduce((D,O)=>(D.set(w.URI.revive(O[0]),this.A(O[1])),D),new A.ResourceMap);return new h(i,a,s,l,new f,o,y,new f,new A.ResourceMap,!1)}static A(r){return new f(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=h;function v(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const s of n)s.keys.forEach(l=>r.add(l)),s.overrides.forEach(([l,o])=>{const y=(0,A.getOrSet)(i,l,new Set);o.forEach(D=>y.add(D))});const a=[];return i.forEach((s,l)=>a.push([l,[...s.values()]])),{keys:[...r.values()],overrides:a}}e.mergeChanges=v;class d{constructor(r,i,a,s){this.change=r,this.b=i,this.c=a,this.d=s,this.f=void 0;const l=new Set;r.keys.forEach(y=>l.add(y)),r.overrides.forEach(([,y])=>y.forEach(D=>l.add(D))),this.affectedKeys=[...l.values()];const o=new f;this.affectedKeys.forEach(y=>o.setValue(y,{})),this.a=o.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=h.parse(this.b.data)),this.f}affectsConfiguration(r,i){if(this.g(this.a,r)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.b?.workspace):void 0,s=this.c.getValue(r,i,this.d);return!P.equals(a,s)}return!0}return!1}g(r,i){let a=(0,S.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof a=="object"&&(s=Object.keys(a)[0]);){if(r=r[s],!r)return!1;a=a[s]}return!0}}e.ConfigurationChangeEvent=d;function u(n,r){const{added:i,removed:a,updated:s}=c(r?.rawConfiguration,n?.rawConfiguration),l=[],o=n?.getAllOverrideIdentifiers()||[],y=r?.getAllOverrideIdentifiers()||[];if(r){const D=y.filter(O=>!o.includes(O));for(const O of D)l.push([O,r.getKeysForOverrideIdentifier(O)])}if(n){const D=o.filter(O=>!y.includes(O));for(const O of D)l.push([O,n.getKeysForOverrideIdentifier(O)])}if(r&&n){for(const D of o)if(y.includes(D)){const O=c({contents:n.getOverrideValue(void 0,D)||{},keys:n.getKeysForOverrideIdentifier(D)},{contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)});l.push([D,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:a,updated:s,overrides:l}}function c(n,r){const i=n?r?n.keys.filter(l=>r.keys.indexOf(l)===-1):[...n.keys]:[],a=r?n?r.keys.filter(l=>n.keys.indexOf(l)===-1):[...r.keys]:[],s=[];if(n&&r){for(const l of r.keys)if(n.keys.indexOf(l)!==-1){const o=(0,S.getConfigurationValue)(r.contents,l),y=(0,S.getConfigurationValue)(n.contents,l);P.equals(o,y)||s.push(l)}}return{added:i,removed:a,updated:s}}}),define(ee[217],ie([0,1,24,3,2,50,12,18,109,62,6,36,47]),function(q,e,E,t,C,M,A,P,m,w,S,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class f extends C.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new p(this.f())),this.b}async initialize(){return this.b=void 0,this.B(I.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:d})=>this.c(v,d))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(v,d){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:v})}f(){return{}}}e.DefaultConfiguration=f;class p extends m.ConfigurationModel{constructor(v={}){const d=I.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(d),c=Object.create(null),n=[];for(const r in d){const i=v[r],a=i!==void 0?i:d[r].default;(0,P.addToValueTree)(c,r,a,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(c))w.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(c[r]),contents:(0,P.toValuesTree)(c[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,u,n)}}e.DefaultConfigurationModel=p;class g{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new m.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let b=class extends C.Disposable{get configurationModel(){return this.b}constructor(v,d,u){super(),this.c=v,this.f=d,this.g=u,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new m.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.i(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.j(await this.h(v),!0))),this.b}async h(v){const d={},u=[],c=I.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const n of v){const r=c[n];if(!r){u.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}u.push(n),d[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(d)||await this.f.updatePolicyDefinitions(d),u}i(v){const d=I.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),u=(0,E.coalesce)(v.map(c=>d.get(c)));this.j(u,!0)}j(v,d){const u=I.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),c=[],n=this.b.isEmpty();for(const r of v){const i=u[r]?.policy?.name;if(i){const a=this.f.getPolicyValue(i);(n?a!==void 0:!(0,M.equals)(this.b.getValue(r),a))&&c.push([r,a])}else this.b.getValue(r)!==void 0&&c.push([r,void 0])}if(c.length){const r=this.b;this.b=new m.ConfigurationModel;for(const i of r.keys)this.b.setValue(i,r.getValue(i));for(const[i,a]of c)a===void 0?this.b.removeValue(i):this.b.setValue(i,a);d&&this.a.fire(this.b)}}};b=pe([te(1,k.IPolicyService),te(2,S.ILogService)],b),e.PolicyConfiguration=b}),define(ee[218],ie([0,1,8,3,2,20,18,109,217,36]),function(q,e,E,t,C,M,A,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class S extends C.Disposable{constructor(I,f,p,g){super(),this.i=I,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new m.DefaultConfiguration),this.c=p instanceof w.NullPolicyService?new m.NullPolicyConfiguration:this.B(new m.PolicyConfiguration(this.b,p,g)),this.f=this.B(new P.UserSettings(this.i,void 0,M.extUriBiasedIgnorePathCase,f)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:b,properties:h})=>this.k(b,h))),this.B(this.c.onDidChangeConfiguration(b=>this.l(b))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[I,f,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(I,f,new P.ConfigurationModel,p)}getConfigurationData(){return this.a.toData()}getValue(I,f){const p=typeof I=="string"?I:void 0,g=(0,A.isConfigurationOverrides)(I)?I:(0,A.isConfigurationOverrides)(f)?f:{};return this.a.getValue(p,g,void 0)}updateValue(I,f,p,g){return Promise.reject(new Error("not supported"))}inspect(I){return this.a.inspect(I,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const I=await this.f.loadConfiguration();this.j(I)}j(I){const f=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(I);this.m(p,f,2)}k(I,f){const p=this.a.toData(),g=this.a.compareAndUpdateDefaultConfiguration(I,f);this.m(g,p,7)}l(I){const f=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(I);this.m(p,f,7)}m(I,f,p){const g=new P.ConfigurationChangeEvent(I,{data:f},this.a);g.source=p,g.sourceConfig=this.n(p),this.h.fire(g)}n(I){switch(I){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=S}),define(ee[219],ie([0,1,15,5]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var C;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends E.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof M&&P._code===C.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof M&&P._code===C.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof M&&P._code===C.NoResolverFound}static isHandled(P){return P instanceof M&&P.isHandled}constructor(P,m=C.Unknown,w){super(P),this._message=P,this._code=m,this._detail=w,this.isHandled=m===C.NotAvailable&&w===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M}),define(ee[63],ie([0,1,14]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=t;function C(w){if(!w)return;const S=w.indexOf("+");return S<0?w:w.substr(0,S)}e.getRemoteName=C;function M(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=M;function A(w){const{host:S,port:k}=m(w);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:S,port:k}}e.parseAuthorityWithPort=A;function P(w,S){let{host:k,port:I}=m(w);return typeof I>"u"&&(I=S),{host:k,port:I}}e.parseAuthorityWithOptionalPort=P;function m(w){const S=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const k=w.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const I=w.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:w,port:void 0}}}),define(ee[87],ie([0,1,25,5,63]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=M;function A(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var m;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(m=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(g){this.value=g,this.c=g.toLowerCase()}static equals(g,b){if(typeof g>"u"||g===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof g=="string"||typeof b=="string"){const h=typeof g=="string"?g:g.value,v=typeof b=="string"?b:b.value;return E.equalsIgnoreCase(h,v)}return g.c===b.c}static toKey(g){return typeof g=="string"?g.toLowerCase():g.c}}e.ExtensionIdentifier=w;function S(p){return k(p)}e.isApplicationScopedExtension=S;function k(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function I(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function f(p,g){if(g){const b=`onResolveRemoteAuthority:${(0,C.getRemoteName)(g)}`;return p.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[110],ie([0,1,25,191,87,4,7,15,32]),function(q,e,E,t,C,M,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,E.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=w;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(i){const a=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new k(i.identifier,a,s)}static parse(i){const a=S.exec(i);return a&&a[1]&&a[2]?new k({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,s="undefined"){this.version=a,this.targetPlatform=s,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof k?w(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=k;const I=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(r){const i=I.exec(r);return i&&i[1]?[g(i[1]),i[2]]:[g(r),void 0]}e.getIdAndVersion=f;function p(r,i){return`${r}.${i}`}e.getExtensionId=p;function g(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function b(r,i){return g(p(r,i))}e.getGalleryExtensionId=b;function h(r,i){const a=[],s=l=>{for(const o of a)if(o.some(y=>w(i(y),i(l))))return o;return null};for(const l of r){const o=s(l);o?o.push(l):a.push([l])}return a}e.groupByExtension=h;function v(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function d(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function u(r,i){const a=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const l=s.shift();if(l&&a.every(o=>!w(o.identifier,{id:l}))){const o=r.filter(y=>w(y.identifier,{id:l}));o.length===1&&(a.push(o[0]),s.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=u;async function c(r,i){if(!M.isLinux)return!1;let a;try{a=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(l))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function n(r,i){const a=await c(r,i),s=(0,t.getTargetPlatform)(a?"alpine":M.platform,m.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(ee[220],ie([0,1,8,17,22,15,3,2,29,102,219,63]),function(q,e,E,t,C,M,A,P,m,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var f;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function p(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(B){const H=new C.CancellationTokenSource;return setTimeout(()=>H.cancel(),B),H.token}function b(B,H){if(B.isCancellationRequested||H.isCancellationRequested)return C.CancellationToken.Cancelled;const R=new C.CancellationTokenSource;return B.onCancellationRequested(()=>R.cancel()),H.onCancellationRequested(()=>R.cancel()),R.token}class h{get didTimeout(){return this.c==="timedout"}constructor(H){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((R,W)=>{this.f=R,this.g=W}),H.isCancellationRequested?this.h():this.d.add(H.onCancellationRequested(()=>this.h()))}registerDisposable(H){this.c==="pending"?this.d.add(H):H.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(H))}reject(H){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(H))}}function v(B,H){const R=new h(H);return R.registerDisposable(B.onControlMessage(W=>{const $=JSON.parse(W.toString()),z=F($);z?R.reject(z):R.resolve($)})),R.promise}function d(B,H,R,W,$,z,J,ne){const j=new h(ne);return H.connect(R,W,$,z,J,(x,_)=>{j.didTimeout?(x&&B.error(x),_?.dispose()):x||!_?j.reject(x):j.resolve(_)}),j.promise}function u(B,H){const R=new h(H);return B.then(W=>{R.didTimeout||R.resolve(W)},W=>{R.didTimeout||R.reject(W)}),R.promise}async function c(B,H,R,W){const $=U(B,H);B.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let z;try{z=await d(B.logService,B.socketFactory,B.host,B.port,(0,k.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${p(H)}-${B.reconnectionToken}`,W)}catch(_){throw B.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),B.logService.error(_),_}B.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let J,ne;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(z,null),J=B.reconnectionProtocol,ne=!1):(J=new w.PersistentProtocol(z,null),ne=!0),B.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const j=await u(B.signService.createNewMessage((0,m.generateUuid)()),W),x={type:"auth",auth:B.connectionToken||"00000000000000000000",data:j.data};J.sendControl(t.VSBuffer.fromString(JSON.stringify(x)));try{const _=await v(J,b(W,g(1e4)));if(_.type!=="sign"||typeof _.data!="string"){const Oe=new Error("Unexpected handshake message");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}if(B.logService.trace(`${$} 4/6. received SignRequest control message.`),!await u(B.signService.validate(j,_.signedData),W)){const Oe=new Error("Refused to connect to unsupported server");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}const ge=await u(B.signService.sign(_.data),W),Me={type:"connectionType",commit:B.commit,signedData:ge,desiredConnectionType:H};return R&&(Me.args=R),B.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(t.VSBuffer.fromString(JSON.stringify(Me))),{protocol:J,ownsProtocol:ne}}catch(_){throw _&&_.code==="ETIMEDOUT"&&(B.logService.error(`${$} the handshake timed out. Error:`),B.logService.error(_)),_&&_.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${$} received error control message when negotiating connection. Error:`),B.logService.error(_)),ne&&le(J),_}}async function n(B,H,R,W){const $=Date.now(),z=U(B,H),{protocol:J,ownsProtocol:ne}=await c(B,H,R,W),j=new h(W);return j.registerDisposable(J.onControlMessage(x=>{const _=JSON.parse(x.toString()),ae=F(_);ae?(B.logService.error(`${z} received error control message when negotiating connection. Error:`),B.logService.error(ae),ne&&le(J),j.reject(ae)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${Q($)}!`),j.resolve({protocol:J,firstMessage:_}))})),j.promise}async function r(B,H){const{protocol:R}=await n(B,1,void 0,H);return{protocol:R}}async function i(B,H,R){const{protocol:W,firstMessage:$}=await n(B,2,H,R),z=$&&$.debugPort;return{protocol:W,debugPort:z}}async function a(B,H,R){const W=Date.now(),$=U(B,3),{protocol:z}=await c(B,3,H,R);return B.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${Q(W)}!`),z}async function s(B,H,R){const{host:W,port:$,connectionToken:z}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:W,port:$,connectionToken:z,reconnectionToken:H,reconnectionProtocol:R,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function l(B,H,R){return y(B,async W=>{const{protocol:$}=await r(W,C.CancellationToken.None);return new de(B,H,R,W.reconnectionToken,$)})}e.connectRemoteAgentManagement=l;async function o(B,H){return y(B,async R=>{const{protocol:W,debugPort:$}=await i(R,H,C.CancellationToken.None);return new X(B,H,R.reconnectionToken,W,$)})}e.connectRemoteAgentExtensionHost=o;async function y(B,H){for(let W=1;;W++)try{const $=(0,m.generateUuid)(),z=await s(B,$,null);return await H(z)}catch($){if(W<5)B.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),B.logService.error($);else throw B.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error($),re.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled($)),$}}async function D(B,H,R){const W=await s(B,(0,m.generateUuid)(),null);return await a(W,{host:H,port:R},C.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function O(B){return(0,E.createCancelablePromise)(H=>new Promise((R,W)=>{const $=setTimeout(R,B*1e3);H.onCancellationRequested(()=>{clearTimeout($),R()})}))}var N;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class Y{constructor(H,R){this.reconnectionToken=H,this.millisSinceLastIncomingData=R,this.type=0}}e.ConnectionLostEvent=Y;class G{constructor(H,R,W,$){this.reconnectionToken=H,this.millisSinceLastIncomingData=R,this.durationSeconds=W,this.c=$,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=G;class V{constructor(H,R,W){this.reconnectionToken=H,this.millisSinceLastIncomingData=R,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=V;class se{constructor(H,R,W){this.reconnectionToken=H,this.millisSinceLastIncomingData=R,this.attempt=W,this.type=4}}e.ConnectionGainEvent=se;class oe{constructor(H,R,W,$){this.reconnectionToken=H,this.millisSinceLastIncomingData=R,this.attempt=W,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class re extends P.Disposable{static triggerPermanentFailure(H,R,W){this._permanentFailure=!0,this.f=H,this.g=R,this.h=W,this.i.forEach($=>$.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(H=>H.r())}static debugPauseSocketWriting(){this.i.forEach(H=>H.v())}get k(){return this.c||re._permanentFailure}constructor(H,R,W,$,z){super(),this.m=H,this.n=R,this.reconnectionToken=W,this.protocol=$,this.p=z,this.j=this.B(new A.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new se(this.reconnectionToken,0,0)),this.B($.onSocketClose(J=>{const ne=T(this.m,this.reconnectionToken,!0);J?J.type===0?(this.n.logService.info(`${ne} received socket close event (hadError: ${J.hadError}).`),J.error&&this.n.logService.error(J.error)):(this.n.logService.info(`${ne} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.n.logService.error(J.event)):this.n.logService.info(`${ne} received socket close event.`),this.r()})),this.B($.onSocketTimeout(J=>{const ne=T(this.m,this.reconnectionToken,!0);this.n.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.r()})),re.i.push(this),this.B((0,P.toDisposable)(()=>{const J=re.i.indexOf(this);J>=0&&re.i.splice(J,1)})),this.k&&this.u(re.f,re.g,re.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const H=T(this.m,this.reconnectionToken,!0);this.n.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const R=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const $=W<R.length?R[W]:R[R.length-1];try{if($>0){const J=O($);this.j.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,J)),this.n.logService.info(`${H} waiting for ${$} seconds before reconnecting...`);try{await J}catch{}}if(this.k){this.n.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this.n.logService.info(`${H} resolving connection...`);const z=await s(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${H} connecting to ${z.host}:${z.port}...`),await this.w(z,g(I)),this.n.logService.info(`${H} reconnected!`),this.j.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(z),this.t(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this.n.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(z),this.t(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this.n.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.n.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(z);continue}if((0,M.isCancellationError)(z)){this.n.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(z);continue}if(z instanceof S.RemoteAuthorityResolverError){this.n.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(z),this.t(this.protocol.getMillisSinceLastIncomingData(),W+1,S.RemoteAuthorityResolverError.isHandled(z));break}this.n.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(z),this.t(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this.k)}t(H,R,W){this.p?re.triggerPermanentFailure(H,R,W):this.u(H,R,W)}u(H,R,W){this.j.fire(new oe(this.reconnectionToken,H,R,W)),le(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=re,re._permanentFailure=!1,re.f=0,re.g=0,re.h=!1,re.i=[];class de extends re{constructor(H,R,W,$,z){super(1,H,$,z,!0),this.client=this.B(new w.Client(z,{remoteAuthority:R,clientId:W},H.ipcLogger))}async w(H,R){await r(H,R)}}e.ManagementPersistentConnection=de;class X extends re{constructor(H,R,W,$,z){super(2,H,W,$,!1),this.y=R,this.debugPort=z}async w(H,R){await i(H,this.y,R)}}e.ExtensionHostPersistentConnection=X;function le(B){try{B.acceptDisconnect();const H=B.getSocket();B.dispose(),H.dispose()}catch(H){(0,M.onUnexpectedError)(H)}}function F(B){if(B&&B.type==="error"){const H=new Error(`Connection error: ${B.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function L(B,H){for(;B.length<H;)B+=" ";return B}function T(B,H,R){return`[remote-connection][${L(p(B),13)}][${H.substr(0,5)}\u2026][${R?"reconnect":"initial"}]`}function U(B,H){return`${T(H,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function Q(B){return`${Date.now()-B} ms`}}),define(ee[221],ie([0,1,78,83]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(C,M,A,P,m,w){const S=I=>w(I,void 0),k=E.createConnection({host:C,port:M},()=>{k.removeListener("error",S);const I=Buffer.alloc(16);for(let b=0;b<16;b++)I[b]=Math.round(Math.random()*256);const f=I.toString("base64"),p=[`GET ws://${/:/.test(C)?`[${C}]`:C}:${M}${A}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];k.write(p.join(`\r
`)+`\r
\r
`);const g=b=>{b.toString().indexOf(`\r
\r
`)>=0&&(k.off("data",g),w(void 0,new t.NodeSocket(k,m)))};k.on("data",g)});k.setNoDelay(!0),k.once("error",S)}}}),define(ee[222],ie([0,1,27,45,40,181]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let A;async function P(f=!1){return(A===void 0||f)&&(A=m()),A}e.hasWSLFeatureInstalled=P;async function m(){const f=w();if(f===void 0)return!1;if(f>=22e3){const p=k();if(p)return new Promise(g=>{t.execFile(p,["--status"],b=>g(!b))})}else{const p=I();if(p)try{if((await C.promises.stat(p)).isFile())return!0}catch{}}return!1}function w(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(f)return parseInt(f[3])}function S(f){const p=process.env.SystemRoot;if(p){const g=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(p,g?"Sysnative":"System32",f)}}function k(){return S("wsl.exe")}function I(){return S("lxss\\LxssManager.dll")}}),define(ee[55],ie([0,1,17,165,62,5,47]),function(q,e,E,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function P(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=P;function m(g){return g.res.statusCode===204}async function w(g){return m(g)?null:(await(0,E.streamToBuffer)(g.stream)).toString()}e.asText=w;async function S(g){if(!P(g))throw new Error("Server returned "+g.res.statusCode);return w(g)}e.asTextOrError=S;async function k(g){if(!P(g))throw new Error("Server returned "+g.res.statusCode);if(m(g))return null;const h=(await(0,E.streamToBuffer)(g.stream)).toString();try{return JSON.parse(h)}catch(v){throw v.message+=`:
`+h,v}}e.asJson=k;function I(g){p(g)}e.updateProxyConfigurationsScope=I;let f;function p(g){const b=A.Registry.as(C.Extensions.Configuration),h=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[f],remove:h?[h]:[]})}p(2)}),define(ee[223],ie([0,1,17,22]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class C{constructor(P){this.a=P}listen(P,m){throw new Error("Invalid listen")}call(P,m,w,S=t.CancellationToken.None){switch(m){case"request":return this.a.request(w[0],S).then(async({res:k,stream:I})=>{const f=await(0,E.streamToBuffer)(I);return[{statusCode:k.statusCode,headers:k.headers},f]});case"resolveProxy":return this.a.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=C;class M{constructor(P){this.a=P}async request(P,m){const[w,S]=await this.a.call("request",[P],m);return{res:w,stream:(0,E.bufferToStream)(S)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=M}),define(ee[224],ie([0,1,225,12]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function C(A,P){return A.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:A.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function M(A,P,m={}){const w=(0,E.parse)(A),S=m.proxyUrl||C(w,P);if(!S)return null;const k=(0,E.parse)(S);if(!/^https?:$/.test(k.protocol||""))return null;const I={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,t.isBoolean)(m.strictSSL)?m.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((f,p)=>{q(["http-proxy-agent"],f,p)}))(I):new(await new Promise((f,p)=>{q(["https-proxy-agent"],f,p)}))(I)}e.getProxyAgent=M}),define(ee[111],ie([0,1,45,9,166,22,44,15,4,29,142,59,8]),function(q,e,E,t,C,M,A,P,m,w,S,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const f=1e4;let p;async function g(h,v,d){return v["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):m.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(d)&&!v["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(d)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=I.Promises.withAsyncBody(async(u,c)=>{const n=new M.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),c(new Error((0,C.localize)(0,null)))},f);try{u(await b(h,n.token))}catch(i){!(0,P.isCancellationError)(i)&&!n.token.isCancellationRequested?c(new Error((0,C.localize)(1,null,(0,A.toErrorMessage)(i)))):u({})}finally{clearTimeout(r),n.dispose()}})),p)}e.getResolvedShellEnv=g;async function b(h,v){const d=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",d);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",u);const c=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};h.trace("getUnixShellEnvironment#env",r);const i=await(0,S.getSystemShell)(m.OS,r);return h.trace("getUnixShellEnvironment#shell",i),new Promise((a,s)=>{if(v.isCancellationRequested)return s((0,P.canceled)());const l=(0,t.basename)(i);let o,y;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(o=`& '${process.execPath}' ${D} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,y=["-Login","-Command"]):(o=`'${process.execPath}' ${D} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,l==="tcsh"?y=["-ic"]:y=["-ilc"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),o);const O=(0,E.spawn)(i,[...y,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});v.onCancellationRequested(()=>(O.kill(),s((0,P.canceled)()))),O.on("error",G=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(G)),s(G)});const N=[];O.stdout.on("data",G=>N.push(G));const Y=[];O.stderr.on("data",G=>Y.push(G)),O.on("close",(G,V)=>{const se=Buffer.concat(N).toString("utf8");h.trace("getUnixShellEnvironment#raw",se);const oe=Buffer.concat(Y).toString("utf8");if(oe.trim()&&h.trace("getUnixShellEnvironment#stderr",oe),G||V)return s(new Error((0,C.localize)(2,null,G,V)));const re=n.exec(se),de=re?re[1]:"{}";try{const X=JSON.parse(de);d?X.ELECTRON_RUN_AS_NODE=d:delete X.ELECTRON_RUN_AS_NODE,u?X.ELECTRON_NO_ATTACH_CONSOLE=u:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",X),a(X)}catch(X){h.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(X)),s(X)}})})}}),define(ee[88],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[226],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.b=new Map}c(){return new Promise((C,M)=>q(["vsda"],C,M))}async createNewMessage(C){try{const M=await this.c(),A=new M.validator;if(A){const P=String(E.a++);return this.b.set(P,A),{id:P,data:A.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,M){if(!C.id)return!0;const A=this.b.get(C.id);if(!A)return!1;this.b.delete(C.id);try{return A.validate(M)==="ok"}catch{return!1}}async sign(C){try{const M=await this.c(),A=new M.signer;if(A)return A.sign(C)}catch{}return C}}e.SignService=E,E.a=1}),define(ee[37],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(ee[21],ie([0,1,13,41,8,3,2,4,32,12,5,6,37,26]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,S.createDecorator)("lifecycleMainService");var p;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(p=e.ShutdownReason||(e.ShutdownReason={}));var g;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})(g=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class Et extends A.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(v,d,u){super(),this.v=v,this.w=d,this.y=u,this.c=this.B(new M.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new M.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.C(),this.when(2).then(()=>this.D())}C(){this.j=!!this.w.getItem(Et.b),this.j&&this.w.removeItem(Et.b)}D(){const v=()=>{this.i||(this.M("Lifecycle#app.on(before-quit)"),this.i=!0,this.M("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.isMacintosh&&this.n===0&&this.F(1))};E.app.addListener("before-quit",v);const d=()=>{this.M("Lifecycle#app.on(window-all-closed)"),(this.i||!P.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",d),E.app.once("will-quit",u=>{this.M("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.F(1).finally(()=>{this.I(!1),E.app.removeListener("before-quit",v),E.app.removeListener("window-all-closed",d),E.app.quit()})})}F(v){if(this.s)return this.s;this.M("Lifecycle#onWillShutdown.fire()");const d=[];return this.f.fire({reason:v,join(u){d.push(u)}}),this.s=(async()=>{try{await C.Promises.settled(d)}catch(u){this.v.error(u)}try{await this.w.close()}catch(u){this.v.error(u)}})(),this.s}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===v)return;this.M(`lifecycle (main): phase changed (value: ${v})`),this.k=v;const d=this.u.get(this.k);d&&(d.open(),this.u.delete(this.k))}async when(v){if(v<=this.k)return;let d=this.u.get(v);d||(d=new C.Barrier,this.u.set(v,d)),await d.wait()}registerWindow(v){const d=new A.DisposableStore;this.n++,d.add(v.onWillLoad(c=>this.g.fire({window:v,workspace:c.workspace,reason:c.reason})));const u=(0,w.assertIsDefined)(v.win);u.on("close",c=>{const n=v.id;if(this.l.has(n)){this.l.delete(n);return}this.M(`Lifecycle#window.on('close') - window ID ${v.id}`),c.preventDefault(),this.unload(v,1).then(r=>{if(r){this.l.delete(n);return}this.l.add(n),this.M(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${n}`),this.h.fire(v),v.close()})}),u.on("closed",()=>{this.M(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.n--,d.dispose(),this.n===0&&(!P.isMacintosh||this.i)&&this.F(1)})}async reload(v,d){await this.unload(v,3)||v.reload(d)}unload(v,d){const u=this.t.get(v.id);if(u)return u;const c=this.G(v,d).finally(()=>{this.t.delete(v.id)});return this.t.set(v.id,c),c}async G(v,d){if(!v.isReady)return!1;this.M(`Lifecycle#unload() - window ID ${v.id}`);const u=this.i?2:d,c=await this.J(v,u);return c?(this.M(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.H(c)):(await this.L(v,u),!1)}H(v){return v?(this.I(!0),this.i=!1,!0):!1}I(v){this.r&&(this.r(v),this.r=void 0,this.p=void 0)}J(v,d){return new Promise(u=>{const c=this.m++,n=`vscode:ok${c}`,r=`vscode:cancel${c}`;t.validatedIpcMain.once(n,()=>{u(!1)}),t.validatedIpcMain.once(r,()=>{u(!0)}),v.send("vscode:onBeforeUnload",{okChannel:n,cancelChannel:r,reason:d})})}L(v,d){return new Promise(u=>{const n=`vscode:reply${this.m++}`;t.validatedIpcMain.once(n,()=>u()),v.send("vscode:onWillUnload",{replyChannel:n,reason:d})})}quit(v){return this.M(`Lifecycle#quit() - begin (willRestart: ${v})`),this.p?(this.M("Lifecycle#quit() - returning pending quit promise"),this.p):(v&&this.w.setItem(Et.b,!0),this.p=new Promise(d=>{this.r=d,this.M("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}M(v){this.y.args["enable-smoke-test-driver"]?this.v.info(v):this.v.trace(v)}async relaunch(v){this.M("Lifecycle#relaunch()");const d=process.argv.slice(1);if(v?.addArgs&&d.push(...v.addArgs),v?.removeArgs)for(const n of v.removeArgs){const r=d.indexOf(n);r>=0&&d.splice(r,1)}const u=()=>{try{if(P.isWindows){const n=(0,m.cwd)();n!==process.cwd()&&process.chdir(n)}}catch(n){this.v.error(n)}this.M("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:d})};E.app.once("quit",u),await this.quit(!0)&&E.app.removeListener("quit",u)}async kill(v){this.M("Lifecycle#kill()"),await this.F(2),await Promise.race([(0,C.timeout)(1e3),(async()=>{for(const d of E.BrowserWindow.getAllWindows())if(d&&!d.isDestroyed()){let u;d.webContents&&!d.webContents.isDestroyed()?u=new Promise(c=>d.once("closed",c)):u=Promise.resolve(),d.destroy(),await u}})()]),E.app.exit(v)}};b.b="lifecycle.quitAndRestart",b=pe([te(0,k.ILogService),te(1,I.IStateMainService),te(2,f.IEnvironmentMainService)],b),e.LifecycleMainService=b}),define(ee[227],ie([0,1,4,3,2,5,21]),function(q,e,E,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let P=class extends C.Disposable{constructor(S){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,S.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const S=await new Promise((k,I)=>{q(["native-keymap"],k,I)});this.c=m(S),E.isCI||S.onDidChangeKeyboardLayout(()=>{this.c=m(S),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};P=pe([te(0,A.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function m(w){const S=w.getKeyMap(),k=w.getCurrentKeyboardLayout();return{keyboardMapping:S,keyboardLayoutInfo:k}}}),define(ee[228],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ee[229],ie([0,1,8,17,12,34,16,6]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class m{constructor(k,I,f){this.f=k,this.g=I,this.h=f,this.a=Object.create(null),this.b="",this.c=new E.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(k){k.fileOperationResult!==1&&this.g.error(k)}}getItem(k,I){const f=this.a[k];return(0,C.isUndefinedOrNull)(f)?I:f}setItem(k,I){this.setItems([{key:k,data:I}])}setItems(k){let I=!1;for(const{key:f,data:p}of k)this.a[f]!==p&&((0,C.isUndefinedOrNull)(p)?(0,C.isUndefined)(this.a[f])||(this.a[f]=void 0,I=!0):(this.a[f]=p,I=!0));I&&this.j()}removeItem(k){(0,C.isUndefined)(this.a[k])||(this.a[k]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const k=JSON.stringify(this.a,null,4);if(k!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(k)),this.b=k}catch(I){this.g.error(I)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=m;let w=class{constructor(k,I,f){this.a=new m(k.stateResource,I,f)}async init(){await this.a.init()}getItem(k,I){return this.a.getItem(k,I)}};w=pe([te(0,M.IEnvironmentService),te(1,P.ILogService),te(2,A.IFileService)],w),e.StateService=w}),define(ee[230],ie([0,1,229]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends E.StateService{setItem(M,A){this.a.setItem(M,A)}setItems(M){this.a.setItems(M)}removeItem(M){this.a.removeItem(M)}close(){return this.a.close()}}e.StateMainService=t}),define(ee[112],ie([0,1,4,32,7,29]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(w){if(E.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function P(w,S,k,I,f,p,g,b,h,v){const d=Object.create(null);d["common.machineId"]=g,d.sessionID=(0,M.generateUuid)()+Date.now(),d.commitHash=f,d.version=p,d["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,E.PlatformToString)(E.platform),d["common.nodePlatform"]=t.platform,d["common.nodeArch"]=I,d["common.product"]=v||"desktop",b&&(d["common.msftInternal"]=b);let u=0;const c=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),E.isLinuxSnap&&(d["common.snap"]="true");const n=A(k);n&&(d["common.platformDetail"]=n);try{const r=await w.readFile(C.URI.file(h));d["common.source"]=r.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=P;function m(w){const S=t.env.USERDNSDOMAIN;if(!S)return!1;const k=S.toLowerCase();return w.some(I=>k===I)}e.verifyMicrosoftInternalDomain=m}),define(ee[35],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[231],ie([0,1,27,8,43,14,9,4,7,81,23,101,84,16,19,35]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const b=new Map;async function h(n,r){const i=`${n}::${r.join(":")}`,a=b.get(i);if(a)return a;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,o=new Map,y=2e4;function D(N,Y,G,V){const se=Y.substring(N.length+1);return t.Promises.withAsyncBody(async oe=>{let re;try{re=await S.Promises.readdir(Y,{withFileTypes:!0})}catch{oe();return}if(V.count>=y){V.count+=re.length,V.maxReached=!0,oe();return}let de=re.length;if(de===0){oe();return}let X=re;V.count+re.length>y&&(V.maxReached=!0,de=y-V.count,X=re.slice(0,de)),V.count+=re.length;for(const le of X)if(le.isDirectory()){if(G.includes(le.name)||await D(N,(0,A.join)(Y,le.name),G,V),--de===0){oe();return}}else{const F=le.name.lastIndexOf(".");if(F>=0){const L=le.name.substring(F+1);L&&l.set(L,(l.get(L)??0)+1)}for(const L of s)L.relativePathPattern?.test(se)!==!1&&L.filePattern.test(le.name)&&o.set(L.tag,(o.get(L.tag)??0)+1);if(--de===0){oe();return}}})}const O=t.Promises.withAsyncBody(async N=>{const Y={count:0,maxReached:!1};await D(n,n,r,Y);const G=await u(n);N({configFiles:v(o),fileTypes:v(l),fileCount:Y.count,maxFilesReached:Y.maxReached,launchConfigFiles:G})});return b.set(i,O),O}e.collectWorkspaceStats=h;function v(n){return Array.from(n.entries(),([r,i])=>({name:r,count:i})).sort((r,i)=>i.count-r.count)}function d(){const n={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},r=E.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=d;async function u(n){try{const r=new Map,i=(0,A.join)(n,".vscode","launch.json"),a=await S.Promises.readFile(i),s=[],l=(0,C.parse)(a.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,C.getNodeType)(l)==="object"&&l.configurations)for(const o of l.configurations){const y=o.type;y&&(r.has(y)?r.set(y,r.get(y)+1):r.set(y,1))}return v(r)}catch{return[]}}e.collectLaunchConfigs=u;let c=class{constructor(r,i){this.c=r,this.d=i}f(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}g(r){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const a=E.cpus();return a&&a.length>0&&i.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${E.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,k.listProcesses)(r.mainPID),this.k(r)]).then(async a=>{let[s,l]=a,o=this.m(r,s);return i.forEach(y=>{if((0,I.isRemoteDiagnosticError)(y))o+=`
${y.errorMessage}`,l+=`
${y.errorMessage}`;else if(o+=`

Remote: ${y.hostName}`,y.processes&&(o+=`
${this.m(r,y.processes)}`),y.workspaceMetadata){l+=`
|  Remote: ${y.hostName}`;for(const D of Object.keys(y.workspaceMetadata)){const O=y.workspaceMetadata[D];let N=`${O.fileCount} files`;O.maxFilesReached&&(N=`more than ${N}`),l+=`|    Folder (${D}): ${N}`,l+=this.h(O)}}}),{processInfo:o,workspaceInfo:l}})}async getSystemInfo(r,i){const{memory:a,vmHint:s,os:l,cpus:o}=d(),y={os:l,memory:a,cpus:o,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(y.load=`${E.loadavg().map(D=>Math.round(D)).join(", ")}`),P.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,i){const a=[];return(0,k.listProcesses)(r.mainPID).then(async s=>(a.push(""),a.push(this.g(r)),a.push(""),a.push(this.m(r,s)),r.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.k(r))),i.forEach(l=>{if((0,I.isRemoteDiagnosticError)(l))a.push(`
${l.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${l.hostName}`),a.push(this.f(l.machineInfo)),l.processes&&a.push(this.m(r,l.processes)),l.workspaceMetadata)for(const o of Object.keys(l.workspaceMetadata)){const y=l.workspaceMetadata[o];let D=`${y.fileCount} files`;y.maxFilesReached&&(D=`more than ${D}`),a.push(`Folder (${o}): ${D}`),a.push(this.h(y))}}),a.push(""),a.push(""),a.join(`
`)))}h(r){const i=[];let s=0;const l=(O,N)=>{const Y=` ${O}(${N})`;s+Y.length>60?(i.push(o),o="|                 ",s=o.length):s+=Y.length,o+=Y};let o="|      File types:";const y=10,D=r.fileTypes.length>y?y:r.fileTypes.length;for(let O=0;O<D;O++){const N=r.fileTypes[O];l(N.name,N.count)}if(i.push(o),r.configFiles.length>=0&&(o="|      Conf files:",s=0,r.configFiles.forEach(O=>{l(O.name,O.count)}),i.push(o)),r.launchConfigFiles.length>0){let O="|      Launch Configs:";r.launchConfigFiles.forEach(N=>{O+=N.count>1?` ${N.name}(${N.count})`:` ${N.name}`}),i.push(O)}return i.join(`
`)}j(r){const i=Math.max(...Object.keys(r).map(a=>a.length));return Object.keys(r).map(a=>`${a}:  ${" ".repeat(i-a.length)}  ${r[a]}`).join(`
                  `)}k(r){const i=[],a=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const o=m.URI.revive(l);if(o.scheme===M.Schemas.file){const y=o.fsPath;a.push(h(y,["node_modules",".git"]).then(D=>{let O=`${D.fileCount} files`;D.maxFilesReached&&(O=`more than ${O}`),i.push(`|    Folder (${(0,A.basename)(y)}): ${O}`),i.push(this.h(D))}).catch(D=>{i.push(`|      Error: Unable to collect workspace stats for folder ${y} (${D.toString()})`)}))}else i.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,i){const a=new Map;r.windows.forEach(l=>a.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.n(r.mainPID,a,s,i,0),s.join(`
`)}n(r,i,a,s,l){const o=l===0;let y;o?y=s.pid===r?`${this.d.applicationName} main`:"remote agent":(y=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(y=`${y} (${i.get(s.pid)})`));const D=process.platform==="win32"?s.mem:E.totalmem()*(s.mem/100);a.push(`${s.load.toFixed(0).padStart(5," ")}	${(D/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(s.children)&&s.children.forEach(O=>this.n(r,i,a,O,l+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:a}of r.folders){const s=m.URI.revive(a);if(s.scheme!==M.Schemas.file)continue;const l=s.fsPath;try{(await h(l,["node_modules",".git"])).fileTypes.forEach(y=>i.add(y.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const a=m.URI.revive(i);if(a.scheme!==M.Schemas.file)continue;const s=a.fsPath;try{const l=await h(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),l.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),l.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),l.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};c=pe([te(0,g.ITelemetryService),te(1,p.IProductService)],c),e.DiagnosticsService=c}),define(ee[232],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(M){this.b=M}listen(M,A){throw new Error(`Event not found: ${A}`)}call(M,A,{eventName:P,data:m}){return this.b.forEach(w=>w.log(P,m)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class t{constructor(M){this.b=M}log(M,A){return this.b.call("log",{eventName:M,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ee[73],ie([0,1,50,97,12,18,112,35]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class m{constructor(l){this.value=l}}e.TrustedTelemetryValue=m;class w{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(l,o){return Promise.resolve(void 0)}publicLog2(l,o){return this.publicLog(l,o)}publicLogError(l,o){return Promise.resolve(void 0)}publicLogError2(l,o){return this.publicLogError(l,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class S{async publicLog(l,o,y){}async publicLogError(l,o,y){}}e.NullEndpointTelemetryService=S,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function k(s,l){return l.onDidChangeConfiguration(o=>{o.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(o.source),configurationKeys:d(o.sourceConfig)})})}e.configurationTelemetry=k;function I(s,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!s.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=I;function f(s,l){return!(l.isBuilt||l.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=f;function p(s){const l=s.getValue(P.TELEMETRY_SETTING_ID),o=s.getValue("telemetry.enableCrashReporter");if(s.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function g(s){const l={},o={},y={};v(s,y);for(let D in y){D=D.length>150?D.substr(D.length-149):D;const O=y[D];typeof O=="number"?o[D]=O:typeof O=="boolean"?o[D]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${O.length}`),l[D]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(l[D]=O)}return{properties:l,measurements:o}}e.validateTelemetryData=g;const b=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function h(s){if(!s)return"none";for(const l of b)if(s.startsWith(`${l}+`))return l;return"other"}e.cleanRemoteAuthority=h;function v(s,l,o=0,y){if(!!s)for(const D of Object.getOwnPropertyNames(s)){const O=s[D],N=y?y+D:D;Array.isArray(O)?l[N]=(0,E.safeStringify)(O):O instanceof Date?l[N]=O.toISOString():(0,C.isObject)(O)?o<2?v(O,l,o+1,N+"."):l[N]=(0,E.safeStringify)(O):l[N]=O}}function d(s){if(!s)return[];const l=[];return u(l,"",s),l}function u(s,l,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(y=>u(s,l?`${l}.${y}`:y,o[y])):s.push(l)}function c(s,l){const o=s.msftInternalDomains||[],y=l.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(o)||y}e.isInternalTelemetry=c;function n(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=n;function r(s,l){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let o=s;const y=[];for(const Y of l)for(;;){const G=Y.exec(s);if(!G)break;y.push([G.index,Y.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(o="";;){const Y=O.exec(s);if(!Y)break;const G=y.some(([V,se])=>Y.index<se&&V<O.lastIndex);!D.test(Y[0])&&!G&&(o+=s.substring(N,Y.index)+"<REDACTED: user-file-path>",N=O.lastIndex)}return N<s.length&&(o+=s.substr(N)),o}function i(s){if(!s)return s;const l=s.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const y of o)if(y.regex.test(l))return`<REDACTED: ${y.label}>`;return s}function a(s,l){return(0,E.cloneAndChange)(s,o=>{if(o instanceof m)return o.value;if(typeof o=="string"){let y=o.replaceAll("%20"," ");y=r(y,l);for(const D of l)y=y.replace(D,"");return y=i(y),y}})}e.cleanData=a}),define(ee[233],ie([0,1,188,73]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function C(M,A,P,m,w,S,k){const I={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${A.nameShort})`};if((0,t.supportsTelemetry)(A,P)&&(0,t.getTelemetryLevel)(m)===3){const f=await(0,E.getServiceMachineId)(P,w,S),{machineId:p}=await k.getTelemetryInfo();I["X-Market-User-Id"]=f,I["VSCode-SessionId"]=p||f}return I}e.resolveMarketplaceHeaders=C}),define(ee[234],ie([0,1,2,50,97,4,25,167,18,62,54,19,47,35,73]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(v,d,u){this.j=d,this.k=u,this.d={},this.telemetryLevel=new C.MutableObservableValue(3),this.h=new E.DisposableStore,this.i=[],this.b=v.appenders,this.c=v.commonProperties||Promise.resolve({}),this.f=v.piiPaths||[],this.g=!!v.sendErrorTelemetry,this.i=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.i.push(new RegExp((0,A.escapeRegExpCharacters)(c),"gi")),c.indexOf("\\")>=0&&this.i.push(new RegExp((0,A.escapeRegExpCharacters)(c.replace(/\\/g,"/")),"gi"));this.l(),this.j.onDidChangeConfiguration(this.l,this,this.h)}setExperimentProperty(v,d){this.d[v]=d}l(){let v=(0,p.getTelemetryLevel)(this.j);const d=this.k.enabledTelemetryLevels;if(d){this.g=this.sendErrorTelemetry?d.error:!1;const u=d.usage?3:d.error?2:0;v=Math.min(v,u)}this.telemetryLevel.value=v}get sendErrorTelemetry(){return this.g}async getTelemetryInfo(){const v=await this.c,d=v.sessionID,u=v["common.machineId"],c=v["common.firstSessionDate"],n=v["common.msftInternal"];return{sessionId:d,machineId:u,firstSessionDate:c,msftInternal:n}}dispose(){this.h.dispose()}m(v,d,u){return this.telemetryLevel.value<d?Promise.resolve(void 0):this.c.then(c=>{u=(0,t.mixin)(u,this.d),u=(0,p.cleanData)(u,this.i),u=(0,t.mixin)(u,c),this.b.forEach(n=>n.log(v,u))},c=>{console.error(c)})}publicLog(v,d){return this.m(v,3,d)}publicLog2(v,d){return this.publicLog(v,d)}publicLogError(v,d){return this.g?this.m(v,2,d):Promise.resolve(void 0)}publicLogError2(v,d){return this.publicLogError(v,d)}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=pe([te(1,m.IConfigurationService),te(2,k.IProductService)],g),e.TelemetryService=g;function b(){const h=(0,P.localize)(0,null,S.default.nameLong),v=S.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=M.isWeb?"":(0,P.localize)(3,null),u=(0,P.localize)(4,null),c=(0,P.localize)(5,null),n=(0,P.localize)(6,null),r=(0,P.localize)(7,null),i=`
|       | ${u} | ${c} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,P.localize)(8,null);return`
${h} ${v} ${d}

&nbsp;

${r}
${i}

&nbsp;

${a}
`}I.Registry.as(w.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[f.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(w.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[f.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,P.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,P.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${f.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[235],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var E;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(E=e.ColorScheme||(e.ColorScheme={}));function t(M){return M===E.HIGH_CONTRAST_DARK||M===E.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function C(M){return M===E.DARK||M===E.HIGH_CONTRAST_DARK}e.isDark=C}),define(ee[236],ie([0,1,119,3,2,5,47,235]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var m;(function(b){function h(v){return v&&typeof v=="object"&&typeof v.id=="string"}b.isThemeColor=h})(m=e.ThemeColor||(e.ThemeColor={}));function w(b){return{id:b}}e.themeColorFromId=w;var S;(function(b){function h(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||m.isThemeColor(a.color))}b.isThemeIcon=h;const v=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function d(a){const s=v.exec(a);if(!s)return;const[,l]=s;return{id:l}}b.fromString=d;function u(a){return{id:a}}b.fromId=u;function c(a,s){let l=a.id;const o=l.lastIndexOf("~");return o!==-1&&(l=l.substring(0,o)),s&&(l=`${l}~${s}`),{id:l}}b.modify=c;function n(a){const s=a.id.lastIndexOf("~");if(s!==-1)return a.id.substring(s+1)}b.getModifier=n;function r(a,s){return a.id===s.id&&a.color?.id===s.color?.id}b.isEqual=r;function i(a,s){return{id:a.id,color:s?w(s):void 0}}b.asThemeIcon=i,b.asClassNameArray=E.CSSIcon.asClassNameArray,b.asClassName=E.CSSIcon.asClassName,b.asCSSSelector=E.CSSIcon.asCSSSelector})(S=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=E.Codicon.file,e.FolderThemeIcon=E.Codicon.folder;function k(b){switch(b){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(h){return this.a.push(h),this.b.fire(h),(0,C.toDisposable)(()=>{const v=this.a.indexOf(h);this.a.splice(v,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const f=new I;A.Registry.add(e.Extensions.ThemingContribution,f);function p(b){return f.onColorThemeChange(b)}e.registerThemingParticipant=p;class g extends C.Disposable{constructor(h){super(),this.k=h,this.h=h.getColorTheme(),this.B(this.k.onDidColorThemeChange(v=>this.n(v)))}n(h){this.h=h,this.updateStyles()}updateStyles(){}w(h,v){let d=this.h.getColor(h);return d&&v&&(d=v(d,this.h)),d?d.toString():null}}e.Themable=g}),define(ee[64],ie([0,1,13,3,2,4,18,5,37]),function(q,e,E,t,C,M,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const w="#FFFFFF",S="#1E1E1E",k="#000000",I="#FFFFFF",f="theme",p="themeBackground",g="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let b=class extends C.Disposable{constructor(v,d){super(),this.b=v,this.c=d,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return v.dark?k:I;let d=this.b.getItem(p,null);if(!d)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":d=w;break;case"hc-black":d=k;break;case"hc-light":d=I;break;default:d=S}return M.isMacintosh&&d.toUpperCase()===S&&(d="#171717"),d}saveWindowSplash(v,d){this.b.setItems([{key:f,data:d.baseTheme},{key:p,data:d.colorInfo.background},{key:g,data:d}]),typeof v=="number"&&this.f(v,d)}f(v,d){for(const u of E.BrowserWindow.getAllWindows())if(u.id===v){u.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(g)}};b=pe([te(0,m.IStateMainService),te(1,A.IConfigurationService)],b),e.ThemeMainService=b}),define(ee[113],ie([0,1,3,18,5,6]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var A;(function(g){g.Http="http",g.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var m;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(m=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=S,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=k;function I(g,b,h,v){if(h===1)return!1;if(h===2&&k(b)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(d?.length===4&&parseInt(d[1])>=18)return!1}return g<1024}e.isPortPrivileged=I;class f{constructor(b,h,v){this.remoteAddress=b,this.localAddress=h,this.b=v,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=f;let p=class{constructor(b,h){this.i=b,this.j=h,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const b=this.j.getValue("remote.localPortHost");return!b||b==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(b){return this.e=b,b?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this.f=b.elevation,this.g=b.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const b=[],h=Array.from(this.d.values());for(const v of h){const d=Array.from(v.values());for(const u of d){const c=await u.value;c&&b.push(c)}}return b}async dispose(){for(const b of this.d.values()){for(const{value:h}of b.values())await h.then(v=>v?.dispose());b.clear()}this.d.clear()}setEnvironmentTunnel(b,h,v,d,u){this.o(b,h,Promise.resolve({tunnelRemoteHost:b,tunnelRemotePort:h,localAddress:v,privacy:d,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(b,h){(k(b)||S(b))&&(b=e.LOCALHOST_ADDRESSES[0]);const v=this.q(b,h);if(v)return++v.refcount,v.value}openTunnel(b,h,v,d,u=!1,c,n){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${v} on local port ${d}.`),!b)return;if(h||(h="localhost"),this.e&&this.h.has(v)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(b,h,v,d,u,c,n);return r?r.then(i=>{if(!i){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,v);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(i);return(i.tunnelRemoteHost!==h||i.tunnelRemotePort!==v)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const h=this.d.get(b.tunnelRemoteHost);if(h){const v=h.get(b.tunnelRemotePort);v&&(v.refcount--,await this.n(b.tunnelRemoteHost,b.tunnelRemotePort,v))}}}}async n(b,h,v){if(v.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${h}.`);const d=v.value.then(async u=>{u&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.d.has(b)&&this.d.get(b).delete(h),d}}async closeTunnel(b,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${h} `);const v=this.d.get(b);if(v&&v.has(h)){const d=v.get(h);d.refcount=0,await this.n(b,h,d)}}o(b,h,v){this.d.has(b)||this.d.set(b,new Map),this.d.get(b).set(h,{refcount:1,value:v})}async p(b,h){const v=this.d.get(b);v&&(await v.get(h)||v.delete(h),v.size===0&&this.d.delete(b))}q(b,h){const v=[b];S(b)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):k(b)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const d=v.map(u=>this.d.get(u));for(const u of d){const c=u?.get(h);if(c)return c}}canTunnel(b){return!!w(b)}s(b,h,v,d,u,c,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${v} on local port ${d}.`);const r=v;this.h.add(r);const i=d===void 0?v:d,a={elevationRequired:u?this.isPortPrivileged(i):!1},s={remoteAddress:{host:h,port:v},localAddressPort:d,privacy:c,public:c?c!==P.Private:void 0,protocol:n},l=b.forwardPort(s,a);return l?(this.o(h,v,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),l}};p=pe([te(0,M.ILogService),te(1,t.IConfigurationService)],p),e.AbstractTunnelService=p}),define(ee[237],ie([0,1,78,27,96,221,8,2,18,6,19,220,113,88,4]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(u,c,n,r,i){let a;for(let s=3;s&&(a?.dispose(),a=await new b(u,c,n,r,i).waitForReady(),!(i&&C.BROWSER_RESTRICTED_PORTS[i]||!C.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));s--);return a}class b extends P.Disposable{constructor(c,n,r,i,a){super(),this.j=n,this.k=a,this.privacy=I.TunnelPrivacyId.Private,this.i=new Map,this.a=c,this.b=E.createServer(),this.c=new A.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const c=this.k??this.tunnelRemotePort,n=(0,I.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,C.findFreePortFaster)(c,2,1e3,n),i=null;return this.b.listen(r,this.j),await this.c.wait(),i=this.b.address(),i||(r=0,this.b.listen(r,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(c){c.pause();const n=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,k.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),i=r.getSocket().socket,a=r.readEntireBuffer();r.dispose(),a.byteLength>0&&c.write(a.buffer),c.on("end",()=>{c.localAddress&&this.i.delete(c.localAddress),i.end()}),c.on("close",()=>i.end()),c.on("error",()=>{c.localAddress&&this.i.delete(c.localAddress),i.destroy()}),i.on("end",()=>c.end()),i.on("close",()=>c.end()),i.on("error",()=>{c.destroy()}),c.pipe(i),i.pipe(c),c.localAddress&&this.i.set(c.localAddress,()=>{c.end(),i.end()})}}let h=class extends I.AbstractTunnelService{constructor(c,n,r,i,a){super(n,a),this.t=c,this.u=r,this.v=i}isPortPrivileged(c){return(0,I.isPortPrivileged)(c,this.k,p.OS,t.release())}r(c,n,r,i,a,s,l){const o=this.q(n,r);if(o)return++o.refcount,o.value;if(this.e)return this.s(this.e,n,r,i,a,s,l);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${i}.`);const y={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:c,signService:this.u,logService:this.i,ipcLogger:null},D=g(y,this.k,n,r,i);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,r,D),D}}};h=pe([te(1,w.ILogService),te(2,f.ISignService),te(3,S.IProductService),te(4,m.IConfigurationService)],h),e.BaseTunnelService=h;let v=class extends h{constructor(c,n,r,i){super(M.nodeSocketFactory,c,n,r,i)}};v=pe([te(0,w.ILogService),te(1,f.ISignService),te(2,S.IProductService),te(3,m.IConfigurationService)],v),e.TunnelService=v;let d=class extends P.Disposable{constructor(c,n,r,i){super(),this.b=c,this.c=n,this.f=r,this.g=i,this.a=new Map}async openTunnel(c,n,r,i,a,s,l,o){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${i} on local port ${a}.`),!this.a.has(c)){const y=new v(this.b,this.f,this.c,this.g);this.B(y),this.a.set(c,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(n,r,i,a,s,l,o)}};d=pe([te(0,w.ILogService),te(1,S.IProductService),te(2,f.ISignService),te(3,m.IConfigurationService)],d),e.SharedTunnelsService=d}),define(ee[48],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(t=e.StateType||(e.StateType={}));var C;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(C=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,A)=>({type:"idle",updateType:M,error:A}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ee[238],ie([0,1,4,168,62,47]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(C.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[239],ie([0,1,3,48]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class C{constructor(P){this.a=P}listen(P,m){switch(m){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${m}`)}call(P,m,w){switch(m){case"checkForUpdates":return this.a.checkForUpdates(w);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(w)}throw new Error(`Call not found: ${m}`)}}e.UpdateChannel=C;class M{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(m=>this.state=m),this.c.call("_getInitialState").then(m=>this.state=m)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=M}),define(ee[89],ie([0,1,8,22,3,18,26,21,6,19,55,48]),function(q,e,E,t,C,M,A,P,m,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(p,g,b){return`${b.updateUrl}/api/update/${p}/${g}/${b.commit}`}e.createUpdateURL=I;let f=class{get state(){return this.b}d(g){this.j.info("update#setState",g.type),this.b=g,this.c.fire(g)}constructor(g,b,h,v,d,u){this.f=g,this.g=b,this.h=h,this.i=v,this.j=d,this.k=u,this.b=k.State.Uninitialized,this.c=new C.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.l(),b=this.m(g);if(!b){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(b),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(k.State.Idle(this.q())),g==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,h=>this.j.error(h))}l(){return(0,M.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(g){return g==="none"?void 0:this.k.quality}n(g=60*60*1e3){return(0,E.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(g){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(g)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(g){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(g){}q(){return 1}r(){}};f=pe([te(0,P.ILifecycleMainService),te(1,M.IConfigurationService),te(2,A.IEnvironmentMainService),te(3,S.IRequestService),te(4,m.ILogService),te(5,w.IProductService)],f),e.AbstractUpdateService=f}),define(ee[240],ie([0,1,13,53,3,2,18,26,21,6,19,55,35,48,89]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends p.AbstractUpdateService{get v(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"error",(h,v)=>v)}get w(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(h,v,d)=>({url:v,version:d,productVersion:d}))}get y(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(h,v,d,u)=>({releaseNotes:v,version:d,productVersion:d,date:u}))}constructor(h,v,d,u,c,n,r){super(h,v,u,c,n,r),this.A=d,this.u=new M.DisposableStore}async initialize(){await super.initialize(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(h){this.j.error("UpdateService error:",h);const d=(this.state.type==="checking for updates"?this.state.explicit:!0)?h:void 0;this.d(f.State.Idle(1,d))}s(h){let v;this.k.darwinUniversalAssetId?v=this.k.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,p.createUpdateURL)(v,h,this.k);try{E.autoUpdater.setFeedURL({url:d})}catch(u){this.j.error("Failed to set update feed URL",u);return}return d}t(h){this.d(f.State.CheckingForUpdates(h)),E.autoUpdater.checkForUpdates()}E(h){this.state.type==="checking for updates"&&this.d(f.State.Downloading(h))}F(h){this.state.type==="downloading"&&(this.A.publicLog2("update:downloaded",{version:h.version}),this.d(f.State.Ready(h)))}G(){this.state.type==="checking for updates"&&(this.A.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],g.prototype,"v",null),pe([t.memoize],g.prototype,"w",null),pe([t.memoize],g.prototype,"x",null),pe([t.memoize],g.prototype,"y",null),g=pe([te(0,m.ILifecycleMainService),te(1,A.IConfigurationService),te(2,I.ITelemetryService),te(3,P.IEnvironmentMainService),te(4,k.IRequestService),te(5,w.ILogService),te(6,S.IProductService)],g),e.DarwinUpdateService=g}),define(ee[241],ie([0,1,45,40,8,3,9,26,21,6,35,48]),function(q,e,E,t,C,M,A,P,m,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{get state(){return this.a}d(g){this.g.info("update#setState",g.type),this.a=g,this.b.fire(g)}constructor(g,b,h){if(this.f=g,this.g=h,this.a=k.State.Uninitialized,this.b=new M.Emitter,this.onStateChange=this.b.event,b.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(k.State.Idle(this.k())),this.h(30*1e3).then(void 0,v=>this.g.error(v))}h(g=60*60*1e3){return(0,C.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(g){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(g)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(g){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(g){}};I=pe([te(0,m.ILifecycleMainService),te(1,P.IEnvironmentMainService),te(2,w.ILogService)],I);let f=class extends I{constructor(g,b,h,v,d,u){super(h,v,d),this.o=g,this.p=b,this.q=u;const c=(0,t.watch)(A.dirname(this.o)),n=M.Event.fromNodeEventEmitter(c,"change",(s,l)=>l),r=M.Event.filter(n,s=>s==="current"),a=M.Event.debounce(r,(s,l)=>l,2e3)(()=>this.checkForUpdates(!1));h.onWillShutdown(()=>{a.dispose(),c.close()})}m(){this.d(k.State.CheckingForUpdates(!1)),this.u().then(g=>{g?this.d(k.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(k.State.Idle(2)))},g=>{this.g.error(g),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(k.State.Idle(2,g.message||g))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+A.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const g=await new Promise((h,v)=>(0,t.realpath)(`${A.dirname(this.o)}/current`,(d,u)=>d?v(d):h(u))),b=A.basename(g);return this.p!==b}isLatestVersion(){return this.u().then(void 0,g=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=pe([te(2,m.ILifecycleMainService),te(3,P.IEnvironmentMainService),te(4,w.ILogService),te(5,S.ITelemetryService)],f),e.SnapUpdateService=f}),define(ee[42],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ee[242],ie([0,1,42,189,16,20,125,3,2]),function(q,e,E,t,C,M,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(I){this.uri=I,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let S=class{constructor(I){this.g=I,this.c=new m.DisposableStore,this.f=2**16;const f=new Map,p=g=>{let b=f.get(g.scheme);return b===void 0&&(b=I.hasProvider(g)&&!this.g.hasCapability(g,1024),f.set(g.scheme,b)),b};this.c.add(P.Event.any(I.onDidChangeFileSystemProviderRegistrations,I.onDidChangeFileSystemProviderCapabilities)(g=>{f.delete(g.scheme)})),this.extUri=new M.ExtUri(p),this.d=new A.SkipList((g,b)=>this.extUri.compare(g,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(I){this.g.hasProvider(I)&&(I=(0,M.normalizePath)(I));const f=this.d.get(I);return f?f.touch().uri.with({fragment:I.fragment}):(this.d.set(I,new w(I)),this.h(),I)}h(){if(this.d.size<this.f)return;const I=[...this.d.entries()].sort((p,g)=>p[1].touch<g[1].touch?1:p[1].touch>g[1].touch?-1:0);w._clock=0,this.d.clear();const f=this.f*.5;for(let p=0;p<f;p++)this.d.set(I[p][0],I[p][1].touch())}};S=pe([te(0,C.IFileService)],S),e.UriIdentityService=S,(0,t.registerSingleton)(E.IUriIdentityService,S,1)}),define(ee[114],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ee[243],ie([0,1,7]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(P){this.a=P}listen(P,m){throw new Error(`Event not found: ${m}`)}call(P,m,w){switch(m){case"handleURL":return this.a.handleURL(E.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${m}`)}}e.URLHandlerChannel=t;class C{constructor(P){this.a=P}handleURL(P,m){return this.a.call("handleURL",[P.toJSON(),m])}}e.URLHandlerChannelClient=C;class M{constructor(P){this.a=P}async routeCall(P,m,w,S){if(m!=="handleURL")throw new Error(`Call not found: ${m}`);if(w){const k=E.URI.revive(w);if(k&&k.query){const I=/\bwindowId=(\d+)/.exec(k.query);if(I){const f=I[1],p=new RegExp(`window:${f}`),g=P.connections.find(b=>p.test(b.ctx));if(g)return g}}}return this.a.routeCall(P,m,w,S)}routeEvent(P,m){throw new Error(`Event not found: ${m}`)}}e.URLHandlerRouter=M}),define(ee[244],ie([0,1,8,2,7,19]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class A extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(w,S){const k=[...this.a.values()];return(0,E.first)(k.map(I=>()=>I.handleURL(w,S)),void 0,!1).then(I=>I||!1)}registerHandler(w){return this.a.add(w),(0,t.toDisposable)(()=>this.a.delete(w))}}e.AbstractURLService=A;let P=class extends A{constructor(w){super(),this.b=w}create(w){let{authority:S,path:k,query:I,fragment:f}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return S&&k&&k.indexOf("/")!==0&&(k=`/${k}`),C.URI.from({scheme:this.b.urlProtocol,authority:S,path:k,query:I,fragment:f})}};P=pe([te(0,M.IProductService)],P),e.NativeURLService=P}),define(ee[245],ie([0,1,13,8,3,2,4,7]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function m(S){try{return P.URI.parse(S)}catch{return null}}class w{constructor(k,I,f,p,g){if(this.f=I,this.a=[],this.b=0,this.c=M.Disposable.None,this.d=new M.DisposableStore,this.a=k,A.isWindows){const v=p.isBuilt?[]:[`"${p.appRoot}"`];v.push("--open-url","--"),E.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,v)}const b=C.Event.map(C.Event.fromNodeEventEmitter(E.app,"open-url",(v,d)=>({event:v,url:d})),({event:v,url:d})=>(v.preventDefault(),d));this.d.add(b(v=>{const d=m(v);!d||this.f.open(d,{originalUrl:v})})),f.getWindows().filter(v=>v.isReady).length>0?this.g():C.Event.once(f.onDidSignalReadyWindow)(this.g,this,this.d)}async g(){if(this.b++>10)return;const k=[];for(const I of this.a)await this.f.open(I.uri,{originalUrl:I.url})||k.push(I);k.length!==0&&(this.a=k,this.c=(0,t.disposableTimeout)(()=>this.g(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=w}),define(ee[246],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ee[247],ie([0,1,13,2,14,7]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class A extends t.Disposable{constructor(){super();const m=this.b.bind(this);E.protocol.registerFileProtocol(C.Schemas.vscodeWebview,m)}b(m,w){try{const S=M.URI.parse(m.url),k=A.a.get(S.path);if(typeof k=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${k}`,f=C.FileAccess.asFileUri(I);return w({path:decodeURIComponent(f.fsPath),headers:{...C.COI.getHeadersFromQuery(m.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=A,A.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[74],ie([0,1,4]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(S){return!!S.workspaceUri}e.isWorkspaceToOpen=t;function C(S){return!!S.folderUri}e.isFolderToOpen=C;function M(S){return!!S.fileUri}e.isFileToOpen=M;function A(S){const k=P(S),I=S.getValue("window.menuBarVisibility");return I==="default"||k==="native"&&I==="compact"||E.isMacintosh&&E.isNative?"classic":I}e.getMenuBarVisibility=A;function P(S){if(E.isWeb)return"custom";const k=S.getValue("window");if(k){if(E.isMacintosh&&k.nativeTabs===!0||E.isMacintosh&&k.nativeFullScreen===!1)return"native";const p=k.titleBarStyle;if(p==="native"||p==="custom")return p}return E.isLinux?"native":"custom"}e.getTitleBarStyle=P;function m(S,k){if(!E.isWindows||E.isWeb||P(S)==="native")return!1;const I=S.getValue("window.experimental.windowControlsOverlay.enabled");return typeof I=="boolean"?I:k.quality==="insider"||k.quality==="exploration"}e.useWindowControlsOverlay=m;function w(S=0){return Math.pow(1.2,S)}e.zoomLevelToZoomFactor=w}),define(ee[115],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var t;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const C=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=C;var M;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(M=e.WindowMode||(e.WindowMode={}));var A;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(A=e.WindowError||(e.WindowError={}))}),define(ee[31],ie([0,1,5]),function(q,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var t;(function(C){C[C.CLI=0]="CLI",C[C.DOCK=1]="DOCK",C[C.MENU=2]="MENU",C[C.DIALOG=3]="DIALOG",C[C.DESKTOP=4]="DESKTOP",C[C.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ee[248],ie([0,1,13,22,3,67,2,29,70,106,6,19,31]),function(q,e,E,t,C,M,A,P,m,w,S,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let p=class extends A.Disposable{constructor(b,h,v,d,u){super(),this.g=b,this.h=h,this.i=v,this.j=d,this.k=u,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=f.Initial,this.f=void 0,this.l()}l(){const b=C.Event.fromNodeEventEmitter(E.app,"login",(h,v,d,u,c)=>({event:h,webContents:v,req:d,authInfo:u,callback:c}));this.B(b(this.m,this))}async m({event:b,authInfo:h,req:v,callback:d}){if(!h.isProxy)return;if(!this.b&&this.c===f.LoginDialogShown&&v.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let u;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(h);try{u=await this.b}finally{this.b=void 0}}d(u?.username,u?.password)}async n(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const h=await this.p(b);if(h)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),h;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const h=String((0,M.hash)({scheme:b.scheme,host:b.host,port:b.port}));let v,d;try{const r=await this.i.getPassword(this.a,h);if(r){const i=JSON.parse(await this.j.decrypt(r));v=i.username,d=i.password}}catch(r){this.g.error(r)}if(this.c!==f.StoredCredentialsUsed&&typeof v=="string"&&typeof d=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=f.StoredCredentialsUsed,{username:v,password:d};const u=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!u){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const c={authInfo:b,username:this.f?.username??v,password:this.f?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.c=f.LoginDialogShown;const n=await new Promise(r=>{const i=async(a,s,l)=>{if(s===c.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",i),l){const o={username:l.username,password:l.password};try{if(l.remember){const y=await this.j.encrypt(JSON.stringify(o));await this.i.setPassword(this.a,h,y)}else await this.i.deletePassword(this.a,h)}catch(y){this.g.error(y)}r({username:o.username,password:o.password})}else r(void 0)};u.win?.webContents.on("ipc-message",i)});return this.f=n,n}};p=pe([te(0,S.ILogService),te(1,I.IWindowsMainService),te(2,m.ICredentialsMainService),te(3,w.IEncryptionMainService),te(4,k.IProductService)],p),e.ProxyAuthHandler=p}),define(ee[249],ie([0,1,70,6,34,19,31,201]),function(q,e,E,t,C,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let m=class extends P.BaseCredentialsMainService{constructor(S,k,I,f){super(S),this.j=k,this.k=I,this.l=f,this.i=p=>{this.l.sendToFocused("vscode:showCredentialsError",p.message??p)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const S=await new Promise((k,I)=>{q(["keytar"],k,I)});return await S.findCredentials("test-keytar-loads"),this.f=S,this.f}};m=pe([te(0,t.ILogService),te(1,C.INativeEnvironmentService),te(2,M.IProductService),te(3,A.IWindowsMainService)],m),e.CredentialsNativeMainService=m}),define(ee[250],ie([0,1,15,2,3,6,21,80,45,279,8,14,50,4,32,13,31]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const h=g.utilityProcess,v=typeof h<"u";let d=class Bt{constructor(r,i,a){this.d=r,this.f=a,this.c=!1,this.b=new Map,i.onWillShutdown(s=>{this.c=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}g(r){const i=this.b.get(r);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(r){return this.g(r).onStdout}onDynamicStderr(r){return this.g(r).onStderr}onDynamicMessage(r){return this.g(r).onMessage}onDynamicError(r){return this.g(r).onError}onDynamicExit(r){return this.g(r).onExit}async canUseUtilityProcess(){return v}async createExtensionHost(r){if(this.c)throw(0,E.canceled)();const i=String(++Bt.a);let a;if(r){if(!v)throw new Error("Cannot use UtilityProcess!");a=new c(i,this.d,this.f)}else a=new u(i,this.d);return this.b.set(i,a),a.onExit(({pid:s,code:l,signal:o})=>{this.d.info(`Extension host with pid ${s} exited with code: ${l}, signal: ${o}.`),setTimeout(()=>{a.dispose(),this.b.delete(i)})}),{id:i}}async start(r,i){if(this.c)throw(0,E.canceled)();return this.g(r).start(i)}async enableInspectPort(r){if(this.c)throw(0,E.canceled)();const i=this.b.get(r);return i?i.enableInspectPort():!1}async kill(r){if(this.c)throw(0,E.canceled)();const i=this.b.get(r);!i||i.kill()}async _killAllNow(){for(const[,r]of this.b)r.kill()}async _waitForAllExit(r){const i=[];for(const[,a]of this.b)i.push(a.waitForExit(r));return S.Promises.settled(i).then(()=>{})}};d.a=0,d=pe([te(0,M.ILogService),te(1,A.ILifecycleMainService),te(2,b.IWindowsMainService)],d),e.ExtensionHostStarter=d;let u=class extends t.Disposable{constructor(r,i){super(),this.id=r,this.c=i,this._onStdout=this.B(new C.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new C.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new C.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new C.Emitter),this.onError=this._onError.event,this._onExit=this.B(new C.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(r){f.isCI&&this.c.info("Calling fork to start extension host...");const i=P.StopWatch.create(!1);this.a=(0,m.fork)(k.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,I.mixin)({cwd:(0,p.cwd)()},r));const a=i.elapsed(),s=this.a.pid;this.c.info(`Starting extension host with pid ${s} (fork() took ${a} ms).`);const l=new w.StringDecoder("utf-8");this.a.stdout?.on("data",y=>{const D=typeof y=="string"?y:l.write(y);this._onStdout.fire(D)});const o=new w.StringDecoder("utf-8");this.a.stderr?.on("data",y=>{const D=typeof y=="string"?y:o.write(y);this._onStderr.fire(D)}),this.a.on("message",y=>{this._onMessage.fire(y)}),this.a.on("error",y=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(y)})}),this.a.on("exit",(y,D)=>{this.b=!0,this._onExit.fire({pid:s,code:y,signal:D})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):f.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(r){if(!this.a)return;const i=this.a.pid;this.c.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([C.Event.toPromise(this.onExit),(0,S.timeout)(r)]),this.b||(this.c.info(`Extension host with pid ${i} did not exit within ${r}ms.`),this.a.kill())}};u=pe([te(1,M.ILogService)],u);let c=class extends t.Disposable{constructor(r,i,a){super(),this.id=r,this.c=i,this.f=a,this.onError=C.Event.None,this._onStdout=this.B(new C.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new C.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new C.Emitter),this.onMessage=this._onMessage.event,this._onExit=this.B(new C.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(r){const i=this.f.getWindowById(r.responseWindowId);if(!i){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const a=i.win;if(!a||a.isDestroyed()||a.webContents.isDestroyed()){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,l=k.FileAccess.asFileUri("bootstrap-fork.js").fsPath,o=["--type=extensionHost","--skipWorkspaceStorageLock"],y=r.execArgv||[],D={...r.env},O=!0,N="pipe";for(const re of Object.keys(D))D[re]=String(D[re]);this.c.info(`UtilityProcess<${this.id}>: Creating new...`),this.a=h.fork(l,o,{serviceName:s,env:D,execArgv:y,allowLoadingUnsignedLibraries:O,stdio:N});const Y=new w.StringDecoder("utf-8");this.a.stdout?.on("data",re=>{const de=typeof re=="string"?re:Y.write(re);this._onStdout.fire(de)});const G=new w.StringDecoder("utf-8");this.a.stderr?.on("data",re=>{const de=typeof re=="string"?re:G.write(re);this._onStderr.fire(de)}),this.a.on("message",re=>{this._onMessage.fire(re)}),this.B(C.Event.fromNodeEventEmitter(this.a,"spawn")(()=>{this.c.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const V=C.Event.fromNodeEventEmitter(this.a,"exit",re=>re);this.B(V(re=>{this.c.info(`UtilityProcess<${this.id}>: received exit event with code ${re}.`),this.b=!0,this._onExit.fire({pid:this.a.pid,code:re,signal:""})}));const{port1:se,port2:oe}=new g.MessageChannelMain;this.a.postMessage("null",[oe]),a.webContents.postMessage(r.responseChannel,r.responseNonce,[se])}enableInspectPort(){return this.a?(this.c.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):!1):!1}kill(){!this.a||(this.c.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(r){if(!this.a)return;const i=this.a.pid;this.c.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([C.Event.toPromise(this.onExit),(0,S.timeout)(r)]),this.b||(this.c.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${r}ms, will kill it now.`),this.a.kill())}};c=pe([te(1,M.ILogService),te(2,b.IWindowsMainService)],c)}),define(ee[251],ie([0,1,13,24,4,7,23,18,59,5,6,114,31]),function(q,e,E,t,C,M,A,P,m,w,S,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,w.createDecorator)(e.ID);let f=class{constructor(g,b,h,v){this.a=g,this.b=b,this.c=h,this.d=v}async start(g,b){this.a.trace("Received data from other instance: ",g,b),C.isMacintosh&&E.app.focus({steal:!0});const h=this.e(g);if(h.length){let v=Promise.resolve();if(this.b.getWindowCount()===0){const d=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));d&&(v=d.ready())}v.then(()=>{for(const{uri:d,url:u}of h)this.c.open(d,{originalUrl:u})})}else return this.f(g,b)}e(g){return g["open-url"]&&g._urls&&g._urls.length>0?(0,t.coalesce)(g._urls.map(b=>{try{return{uri:M.URI.parse(b),url:b}}catch{return null}})):[]}async f(g,b){const h=(0,m.isLaunchedFromCli)(b)?0:4;let v=[];const d=g.wait&&g.waitMarkerFilePath?M.URI.file(g.waitMarkerFilePath):void 0,u=g.remote||void 0,c={context:h,cli:g,userEnv:b,waitMarkerFileURI:d,remoteAuthority:u,forceProfile:g.profile,forceTempProfile:g["profile-temp"]};if(g.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(g.extensionDevelopmentPath,c);else if(!g._.length&&!g["folder-uri"]&&!g["file-uri"]){let n=!1;if(g["new-window"]||g["unity-launch"]||c.forceProfile||c.forceTempProfile)n=!0;else if(g["reuse-window"])n=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!C.isMacintosh}if(n)v=await this.b.open({...c,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,c),v=[r]):v=await this.b.open({...c,forceEmpty:!0})}}else v=await this.b.open({...c,forceNewWindow:g["new-window"],preferNewWindow:!g["reuse-window"]&&!g.wait,forceReuseWindow:g["reuse-window"],diffMode:g.diff,mergeMode:g.merge,addMode:g.add,noRecentEntry:!!g["skip-add-to-recently-opened"],gotoLineMode:g.goto});if(d&&v.length===1&&v[0])return Promise.race([v[0].whenClosedOrLoaded,(0,A.whenDeleted)(d.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};f=pe([te(0,S.ILogService),te(1,I.IWindowsMainService),te(2,k.IURLService),te(3,P.IConfigurationService)],f),e.LaunchMainService=f}),define(ee[252],ie([0,1,13,3,2,247,31]),function(q,e,E,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends C.Disposable{constructor(w){super(),this.b=w,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,S){let k;if(typeof w.windowId=="number"){const{windowId:I}=w,f=this.b.getWindowById(I);if(!f?.win)throw new Error(`Invalid windowId: ${I}`);k=f.win.webContents}else{const{webContentsId:I}=w;if(k=E.webContents.fromId(I),!k)throw new Error(`Invalid webContentsId: ${I}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(S)}async findInFrame(w,S,k,I){const p=this.c(w,S);if(typeof p.findInFrame=="function"){p.findInFrame(k,{findNext:I.findNext,forward:I.forward});const g=(b,h)=>{h.finalUpdate&&(this.a.fire(h),p.removeListener("found-in-frame",g))};p.on("found-in-frame",g)}}async stopFindInFrame(w,S,k){const f=this.c(w,S);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}c(w,S){const k=this.b.getWindowById(w.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${w}`);const I=k.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===S);if(!I)throw new Error(`Unknown frame: ${S}`);return I}};P=pe([te(0,A.IWindowsMainService)],P),e.WebviewMainService=P}),define(ee[253],ie([0,1,8,3,2]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends C.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:m,getActiveWindowId:w}){super(),this.a=this.B(new C.DisposableStore),t.Event.latch(t.Event.any(P,m))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>w()),(async()=>{try{const k=await this.b;this.c=typeof this.c=="number"?this.c:k}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=M}),define(ee[28],ie([0,1,172,9,58,20,7,5,14]),function(q,e,E,t,C,M,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function w(r){const i=r;return typeof i?.id=="string"&&A.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function S(r,i){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,t.basename)(r)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const a=r;if(a.configuration)return{id:a.id,configPath:a.configuration};if(a.folders.length===1)return{id:a.id,uri:a.folders[0].uri}}e.toWorkspaceIdentifier=S;function k(r){const i=r;return typeof i?.id=="string"&&A.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=k;function I(r){const i=r;if(i?.uri)return{id:i.id,uri:A.URI.revive(i.uri)};const a=r;if(a?.configPath)return{id:a.id,configPath:A.URI.revive(a.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=I;var f;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function p(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=p;function g(r){const i=r;return!!(i&&typeof i=="object"&&A.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=g;class b{constructor(i,a,s,l,o){this.h=i,this.j=s,this.k=l,this.l=o,this.c=C.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=C.TernarySearchTree.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class h{constructor(i,a){this.raw=a,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,M.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function v(r){return new h({uri:r,index:0,name:(0,M.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(r,i){return M.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function u(r){let i;return A.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===m.Schemas.tmp}e.isTemporaryWorkspace=u;function c(r,i){return!d(r,i)&&!u(r)}e.isSavedWorkspace=c;function n(r){return(typeof r=="string"?(0,t.extname)(r):(0,M.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ee[56],ie([0,1,13,8,67,33,2,76,4,12,23,149,5,6,28]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,I.createDecorator)("dialogMainService");let g=class{constructor(h){this.d=h,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(h,v){return this.e({...h,pickFolders:!0,pickFiles:!0,title:(0,k.localize)(0,null)},v)}pickFolder(h,v){return this.e({...h,pickFolders:!0,title:(0,k.localize)(1,null)},v)}pickFile(h,v){return this.e({...h,pickFiles:!0,title:(0,k.localize)(2,null)},v)}pickWorkspace(h,v){const d=(0,k.localize)(3,null),u=(0,M.mnemonicButtonLabel)((0,k.localize)(4,null)),c=p.WORKSPACE_FILTER;return this.e({...h,pickFiles:!0,title:d,filters:c,buttonLabel:u},v)}async e(h,v){const d={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(d.properties=void 0,h.pickFiles&&h.pickFolders&&(d.properties=["multiSelections","openDirectory","openFile","createDirectory"])),d.properties||(d.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),m.isMacintosh&&d.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(d,(0,w.withNullAsUndefined)(v||E.BrowserWindow.getFocusedWindow()));if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}f(h){if(h){let v=this.b.get(h.id);return v||(v=new t.Queue,this.b.set(h.id,v)),v}else return this.c}showMessageBox(h,v){return this.f(v).queue(async()=>v?E.dialog.showMessageBox(v,h):E.dialog.showMessageBox(h))}async showSaveDialog(h,v){const d=this.i(h,v);if(!d)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(v).queue(async()=>{let u;return v?u=await E.dialog.showSaveDialog(v,h):u=await E.dialog.showSaveDialog(h),u.filePath=this.g(u.filePath),u})}finally{(0,A.dispose)(d)}}g(h){return h&&m.isMacintosh&&(h=(0,P.normalizeNFC)(h)),h}h(h){return h.map(v=>this.g(v))}async showOpenDialog(h,v){h.defaultPath&&(await S.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const d=this.i(h,v);if(!d)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(v).queue(async()=>{let u;return v?u=await E.dialog.showOpenDialog(v,h):u=await E.dialog.showOpenDialog(h),u.filePaths=this.h(u.filePaths),u})}finally{(0,A.dispose)(d)}}i(h,v){if(!v)return A.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",h);let d=this.a.get(v.id);d||(d=new Set,this.a.set(v.id,d));const u=(0,C.hash)(h);if(!d.has(u))return this.d.trace("[DialogMainService]: new file dialog lock created",h),d.add(u),(0,A.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",h),d?.delete(u),d?.size===0&&this.a.delete(v.id)})}};g=pe([te(0,f.ILogService)],g),e.DialogMainService=g}),define(ee[254],ie([0,1,3,2,68,28]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class A extends t.Disposable{constructor(m,w){super(),this.f=m,this.g=w,this.b=this.B(new E.Emitter),this.c=new Map,this.h(w.applicationStorage,this.b)}h(m,w){this.B(E.Event.debounce(m.onDidChangeStorage,(S,k)=>(S?S.push(k):S=[k],S),A.a)(S=>{S.length&&w.fire(this.i(S,m))}))}i(m,w){const S=new Map,k=new Set;return m.forEach(I=>{const f=w.get(I.key);typeof f=="string"?S.set(I.key,f):k.add(I.key)}),{changed:Array.from(S.entries()),deleted:Array.from(k.values())}}listen(m,w,S){switch(w){case"onDidChangeStorage":{const k=S.profile?(0,C.revive)(S.profile):void 0;if(!k)return this.b.event;let I=this.c.get(k.id);return I||(I=this.B(new E.Emitter),this.h(this.g.profileStorage(k),I),this.c.set(k.id,I)),I.event}}throw new Error(`Event not found: ${w}`)}async call(m,w,S){const k=S.profile?(0,C.revive)(S.profile):void 0,I=(0,M.reviveIdentifier)(S.workspace),f=await this.j(k,I);switch(w){case"getItems":return Array.from(f.items.entries());case"updateItems":{const p=S;if(p.insert)for(const[g,b]of p.insert)f.set(g,b);p.delete?.forEach(g=>f.delete(g));break}case"isUsed":{const p=S.payload;if(typeof p=="string")return this.g.isUsed(p)}default:throw new Error(`Call not found: ${w}`)}}async j(m,w){let S;w?S=this.g.workspaceStorage(w):m?S=this.g.profileStorage(m):S=this.g.applicationStorage;try{await S.init()}catch(k){this.f.error(`StorageIPC#init: Unable to init ${w?"workspace":m?"profile":"application"} storage due to ${k}`)}return S}}e.StorageDatabaseChannel=A,A.a=100}),define(ee[38],ie([0,1,67,3,2,20,7,169,34,16,5,6,28,39,42,8,29,25]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function v(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&A.URI.isUri(i.location)&&A.URI.isUri(i.globalStorageHome)&&A.URI.isUri(i.settingsResource)&&A.URI.isUri(i.keybindingsResource)&&A.URI.isUri(i.tasksResource)&&A.URI.isUri(i.snippetsHome)&&A.URI.isUri(i.extensionsResource))}e.isUserDataProfile=v,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,S.createDecorator)("IUserDataProfilesService");function d(r,i){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:A.URI.revive(r.location).with({scheme:i}),globalStorageHome:A.URI.revive(r.globalStorageHome).with({scheme:i}),settingsResource:A.URI.revive(r.settingsResource).with({scheme:i}),keybindingsResource:A.URI.revive(r.keybindingsResource).with({scheme:i}),tasksResource:A.URI.revive(r.tasksResource).with({scheme:i}),snippetsHome:A.URI.revive(r.snippetsHome).with({scheme:i}),extensionsResource:A.URI.revive(r.extensionsResource)?.with({scheme:i}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=d;function u(r,i,a,s){return{id:r,name:i,location:a,isDefault:!1,shortName:s?.shortName,globalStorageHome:(0,M.joinPath)(a,"globalStorage"),settingsResource:(0,M.joinPath)(a,"settings.json"),keybindingsResource:(0,M.joinPath)(a,"keybindings.json"),tasksResource:(0,M.joinPath)(a,"tasks.json"),snippetsHome:(0,M.joinPath)(a,"snippets"),extensionsResource:(0,M.joinPath)(a,"extensions.json"),useDefaultFlags:s?.useDefaultFlags,isTransient:s?.transient}}e.toUserDataProfile=u;let c=class extends C.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(i,a,s,l){super(),this.m=i,this.n=a,this.r=s,this.s=l,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,M.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(i){this.f!==i&&(this.t=void 0,this.f=i)}isEnabled(){return this.f}get u(){if(!this.t){const i=this.f?this.I().map(o=>u((0,M.basename)(o.location),o.name,o.location,{shortName:o.shortName,useDefaultFlags:o.useDefaultFlags})):[];let a;const s=new f.ResourceMap,l=u((0,E.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(i.unshift({...l,extensionsResource:this.N()??l.extensionsResource,isDefault:!0}),i.length){const o=this.L();if(o.workspaces)for(const[y,D]of Object.entries(o.workspaces)){const O=A.URI.parse(y),N=A.URI.parse(D),Y=i.find(G=>this.r.extUri.isEqual(G.location,N));Y&&s.set(O,Y)}if(o.emptyWindow){const y=A.URI.parse(o.emptyWindow);a=i.find(D=>this.r.extUri.isEqual(D.location,y))}}this.t={profiles:i,workspaces:s,emptyWindow:a}}return this.t}async createTransientProfile(i){const a="Temp",s=new RegExp(`${(0,h.escapeRegExpCharacters)(a)}\\s(\\d+)`);let l=0;for(const y of this.profiles){const D=s.exec(y.name),O=D?parseInt(D[1]):0;l=O>l?O:l}const o=`${a} ${l+1}`;return this.createProfile((0,E.hash)((0,b.generateUuid)()).toString(16),o,{transient:!0},i)}async createNamedProfile(i,a,s){return this.createProfile((0,E.hash)((0,b.generateUuid)()).toString(16),i,a,s)}async createProfile(i,a,s,l){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=await this.v(i,a,s);return l&&await this.setProfileForWorkspace(l,o),o}async v(i,a,s){let l=this.k.get(a);return l||(l=(async()=>{try{const o=this.profiles.find(O=>O.name===a||O.id===i);if(o)return o;const y=u(i,a,(0,M.joinPath)(this.profilesHome,i),s);await this.n.createFolder(y.location);const D=[];return this.h.fire({profile:y,join(O){D.push(O)}}),await g.Promises.settled(D),this.D([y],[],[]),y}finally{this.k.delete(a)}})(),this.k.set(a,l)),l}async updateProfile(i,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let s=this.profiles.find(l=>l.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);return s=u(s.id,a.name??s.name,s.location,{shortName:a.shortName??s.shortName,transient:a.transient??s.isTransient,useDefaultFlags:a.useDefaultFlags??s.useDefaultFlags}),this.D([],[],[s]),s}async removeProfile(i){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(l=>l.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const s=[];this.i.fire({profile:a,join(l){s.push(l)}});try{await Promise.allSettled(s)}catch(l){this.s.error(l)}a.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const l of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(l)?.id&&this.u.workspaces.delete(l);this.H(),this.D([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(l){this.s.error(l)}}getOrSetProfileForWorkspace(i,a=this.defaultProfile){if(!this.f)return this.defaultProfile;let s=this.w(i);return s||(s=a,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,s)),s}async setProfileForWorkspace(i,a){this.setProfileForWorkspaceSync(i,a)}setProfileForWorkspaceSync(i,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(l=>l.id===a.id);if(!s)throw new Error(`Profile '${a.name}' does not exist`);this.G(i,s)}unsetWorkspace(i,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.G(i,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.H(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const i=await this.n.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(s=>!this.r.extUri.isEqual(s.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.l.profiles.filter(a=>!this.C(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}w(i){const a=this.y(i);return A.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindow??this.u.emptyWindow}y(i){return(0,I.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,I.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}C(i){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,i.location)||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,i.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,i.location)||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,i.location)))}D(i,a,s){const l=[...this.profiles,...i],o=[];this.l.profiles=[];for(let y of l)y.isDefault||a.some(D=>y.id===D.id)||(y=s.find(D=>y.id===D.id)??y,y.isTransient?this.l.profiles.push(y):o.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.J(o),this.t=void 0,this.F(i,a,s)}F(i,a,s){this.g.fire({added:i,removed:a,updated:s,all:this.profiles})}G(i,a,s){s=a?.isTransient?!0:s,s||this.G(i,void 0,!0);const l=this.y(i),o=s?this.l:this.u;A.URI.isUri(l)?(o.workspaces.delete(l),a&&o.workspaces.set(l,a)):o.emptyWindow=a,s||this.H()}H(){const i={};for(const[s,l]of this.u.workspaces.entries())i[s.toString()]=l.location.toString();const a=this.u.emptyWindow?.location.toString();this.M({workspaces:i,emptyWindow:a}),this.t=void 0}I(){return[]}J(i){throw new Error("not implemented")}L(){return{}}M(i){throw new Error("not implemented")}N(){}};c.b="userDataProfiles",c.c="profileAssociations",c=pe([te(0,m.IEnvironmentService),te(1,w.IFileService),te(2,p.IUriIdentityService),te(3,k.ILogService)],c),e.UserDataProfilesService=c;class n extends c{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(i){this.a=i}L(){return this.Q}M(i){this.Q=i}}e.InMemoryUserDataProfilesService=n}),define(ee[90],ie([0,1,8,17,2,3,39,7,110,87,16,5,6,38,42]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,k.createDecorator)("IExtensionsProfileScannerService");let g=class extends C.Disposable{constructor(v,d,u,c){super(),this.h=v,this.i=d,this.j=u,this.k=c,this.a=this.B(new M.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new M.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new M.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new M.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new A.ResourceMap}scanProfileExtensions(v){return this.l(v)}async addExtensionsToProfile(v,d){const u=[],c=[];try{return await this.l(d,n=>{const r=[];for(const i of n)v.some(([a])=>(0,m.areSameExtensions)(a.identifier,i.identifier)&&a.manifest.version!==i.version)?u.push(i):r.push(i);for(const[i,a]of v)if(!r.some(s=>(0,m.areSameExtensions)(s.identifier,i.identifier)&&s.version===i.manifest.version)){const s={identifier:i.identifier,version:i.manifest.version,location:i.location,metadata:a};c.push(s),r.push(s)}return c.length&&this.a.fire({extensions:c,profileLocation:d}),u.length&&this.c.fire({extensions:u,profileLocation:d}),r}),c.length&&this.b.fire({extensions:c,profileLocation:d}),u.length&&this.f.fire({extensions:u,profileLocation:d}),c}catch(n){throw c.length&&this.b.fire({extensions:c,error:n,profileLocation:d}),u.length&&this.f.fire({extensions:u,error:n,profileLocation:d}),n}}async removeExtensionFromProfile(v,d){const u=[];this.c.fire({extensions:u,profileLocation:d});try{await this.l(d,c=>{const n=[];for(const r of c)(0,m.areSameExtensions)(r.identifier,v.identifier)?u.push(r):n.push(r);return u.length&&this.c.fire({extensions:u,profileLocation:d}),n}),u.length&&this.f.fire({extensions:u,profileLocation:d})}catch(c){throw u.length&&this.f.fire({extensions:u,error:c,profileLocation:d}),c}}async l(v,d){return this.p(v).queue(async()=>{let u=[],c;try{const n=await this.h.readFile(v);c=JSON.parse(n.value.toString())}catch(n){if((0,S.toFileOperationResult)(n)!==1)throw n;this.j.extUri.isEqual(v,this.i.defaultProfile.extensionsResource)&&(c=await this.n())}if(c)for(const n of c){if(!n.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",n);continue}if(!n.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",n);continue}if(!n.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",n);continue}u.push({identifier:n.identifier,location:P.URI.revive(n.location),version:n.version,metadata:n.metadata})}if(d){u=d(u);const n=u.map(r=>({identifier:r.identifier,version:r.version,location:r.location.toJSON(),metadata:r.metadata}));await this.h.writeFile(v,t.VSBuffer.fromString(JSON.stringify(n)))}return u})}async n(){return this.m||(this.m=(async()=>{const v=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let d;try{d=(await this.h.readFile(v)).value.toString()}catch(c){if((0,S.toFileOperationResult)(c)===1)return;throw c}this.k.info("Migrating extensions from old default profile location",v.toString());let u;try{const c=JSON.parse(d);Array.isArray(c)&&c.every(n=>!!(n&&typeof n=="object"&&(0,w.isIExtensionIdentifier)(n.identifier)&&b(n.location)&&n.version&&typeof n.version=="string"))?u=c:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.k.error(c)}if(u)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(u)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",v.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(c){if((0,S.toFileOperationResult)(c)===3)this.k.info("Migration from old default profile location to new location is done by another window",v.toString(),this.i.defaultProfile.extensionsResource.toString());else throw c}try{await this.h.del(v)}catch(c){(0,S.toFileOperationResult)(c)!==1&&this.k.error(c)}return u})()),this.m}p(v){let d=this.g.get(v);return d||(d=new E.Queue,this.g.set(v,d)),d}};g=pe([te(0,S.IFileService),te(1,f.IUserDataProfilesService),te(2,p.IUriIdentityService),te(3,I.ILogService)],g),e.ExtensionsProfileScannerService=g;function b(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}}),define(ee[116],ie([0,1,24,8,50,17,15,43,135,2,14,9,4,20,187,98,12,7,154,34,110,87,186,16,5,6,19,3,68,90,38,42,184,185]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c,n,r,i,a,s,l,o,y,D,O,N,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var G;(function(le){function F(L,T){if(L===T)return!0;const U=Object.keys(L),Q=new Set;for(const B of Object.keys(T))Q.add(B);if(U.length!==Q.size)return!1;for(const B of U){if(L[B]!==T[B])return!1;Q.delete(B)}return Q.size===0}le.equals=F})(G=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let V=class extends w.Disposable{constructor(F,L,T,U,Q,B,H,R,W,$,z,J){super(),this.systemExtensionsLocation=F,this.userExtensionsLocation=L,this.l=T,this.m=U,this.n=Q,this.p=B,this.r=H,this.s=R,this.t=W,this.u=$,this.v=z,this.w=J,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(re,(0,f.joinPath)(this.m,c.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(re,(0,f.joinPath)(this.m,c.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(oe,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,u.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(F,L,T){const[U,Q]=await Promise.all([this.scanSystemExtensions(F),this.scanUserExtensions(L)]),B=T?await this.scanExtensionsUnderDevelopment(F,[...U,...Q]):[];return this.F(U,Q,B,await this.getTargetPlatform(),!0)}async scanSystemExtensions(F){const L=[];L.push(this.G(!!F.useCache,F.language)),L.push(this.H(F.language,!!F.checkControlFile));const[T,U]=await Promise.all(L);return this.D([...T,...U],0,F,!1)}async scanUserExtensions(F){const L=F.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",L);const T=await this.J(L,!!F.profileLocation,1,!F.includeUninstalled,F.language);let Q=await(F.useCache&&!T.devMode&&T.excludeObsolete?this.j:this.k).scanExtensions(T);return Q=await this.D(Q,1,F,!0),this.s.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(F,L){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const T=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(U=>U.scheme===S.Schemas.file).map(async U=>{const Q=await this.J(U,!1,1,!0,F.language,!1);return(await this.k.scanOneOrMultipleExtensions(Q)).map(H=>(H.type=L.find(R=>(0,u.areSameExtensions)(R.identifier,H.identifier))?.type??H.type,this.k.validate(H,Q)))}))).flat();return this.D(T,"development",F,!0)}return[]}async scanExistingExtension(F,L,T){const U=await this.J(F,!1,L,!0,T.language),Q=await this.k.scanExtension(U);return!Q||!T.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions(F,L,T){const U=await this.J(F,!1,L,!0,T.language),Q=await this.k.scanOneOrMultipleExtensions(U);return this.D(Q,L,T,!0)}async scanMetadata(F){const L=(0,f.joinPath)(F,"package.json"),T=(await this.r.readFile(L)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(F,L){const T=(0,f.joinPath)(F,"package.json"),U=(await this.r.readFile(T)).value.toString(),Q=JSON.parse(U);L.isMachineScoped=L.isMachineScoped||void 0,L.isBuiltin=L.isBuiltin||void 0,L.installedTimestamp=L.installedTimestamp||void 0,Q.__metadata={...Q.__metadata,...L},await this.r.writeFile((0,f.joinPath)(F,"package.json"),M.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}initializeDefaultProfileExtensions(){return this.C||(this.C=(async()=>{try{const F=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(F))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const L=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(L.map(T=>[T,T.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(F,M.VSBuffer.fromString(""))}catch(L){(0,r.toFileOperationResult)(L)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)(L))}}catch(F){throw this.s.error(F),F}})()),this.C}async D(F,L,T,U){return T.includeAllVersions||(F=this.F(L===0?F:void 0,L===1?F:void 0,L==="development"?F:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(F=F.filter(Q=>Q.isValid)),F.sort((Q,B)=>{const H=k.basename(Q.location.fsPath),R=k.basename(B.location.fsPath);return H<R?-1:H>R?1:0})}F(F,L,T,U,Q){const B=(R,W,$)=>{if(R.isValid&&!W.isValid)return!1;if(R.isValid===W.isValid){if(Q&&p.gt(R.manifest.version,W.manifest.version))return this.s.debug(`Skipping extension ${W.location.path} with lower version ${W.manifest.version} in favour of ${R.location.path} with version ${R.manifest.version}`),!1;if(p.eq(R.manifest.version,W.manifest.version)){if(R.type===0)return this.s.debug(`Skipping extension ${W.location.path} in favour of system extension ${R.location.path} with same version`),!1;if(R.targetPlatform===U)return this.s.debug(`Skipping extension ${W.location.path} from different target platform ${W.targetPlatform}`),!1}}return $?this.s.warn(`Overwriting user extension ${R.location.path} with ${W.location.path}.`):this.s.debug(`Overwriting user extension ${R.location.path} with ${W.location.path}.`),!0},H=new Map;return F?.forEach(R=>{const W=c.ExtensionIdentifier.toKey(R.identifier.id),$=H.get(W);(!$||B($,R,!1))&&H.set(W,R)}),L?.forEach(R=>{const W=c.ExtensionIdentifier.toKey(R.identifier.id),$=H.get(W);if(!$&&F&&R.type===0){this.s.debug(`Skipping obsolete system extension ${R.location.path}.`);return}(!$||B($,R,!1))&&H.set(W,R)}),T?.forEach(R=>{const W=c.ExtensionIdentifier.toKey(R.identifier.id),$=H.get(W);(!$||B($,R,!0))&&H.set(W,R),H.set(W,R)}),[...H.values()]}async G(F,L){this.s.trace("Started scanning system extensions");const T=await this.J(this.systemExtensionsLocation,!1,0,!0,L),Q=await(F&&!T.devMode?this.i:this.k).scanExtensions(T);return this.s.trace("Scanned system extensions:",Q.length),Q}async H(F,L){const T=this.t.isBuilt?[]:this.u.builtInExtensions;if(!T?.length)return[];this.s.trace("Started scanning dev system extensions");const U=L?await this.I():{},Q=[],B=h.URI.file(k.normalize(k.join(S.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const R of T){const W=U[R.name]||"marketplace";switch(W){case"disabled":break;case"marketplace":Q.push((0,f.joinPath)(B,R.name));break;default:Q.push(h.URI.file(W));break}}const H=await Promise.all(Q.map(async R=>this.k.scanExtension(await this.J(R,!1,0,!0,F))));return this.s.trace("Scanned dev system extensions:",H.length),(0,E.coalesce)(H)}async I(){try{const F=await this.r.readFile(this.l);return JSON.parse(F.value.toString())}catch{return{}}}async J(F,L,T,U,Q,B=!0){const H=await this.f(Q??I.language),R=await this.L(F),W=L&&!this.v.extUri.isEqual(F,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,$=W?await this.L(W):void 0;return new se(F,R,W,$,L,T,U,B,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Q,H)}async L(F){try{const L=await this.r.stat(F);if(typeof L.mtime=="number")return L.mtime}catch{}}};V=pe([te(4,D.IUserDataProfilesService),te(5,y.IExtensionsProfileScannerService),te(6,r.IFileService),te(7,a.ILogService),te(8,d.IEnvironmentService),te(9,s.IProductService),te(10,O.IUriIdentityService),te(11,i.IInstantiationService)],V),e.AbstractExtensionsScannerService=V;class se{constructor(F,L,T,U,Q,B,H,R,W,$,z,J,ne,j){this.location=F,this.mtime=L,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=Q,this.type=B,this.excludeObsolete=H,this.validate=R,this.productVersion=W,this.productDate=$,this.productCommit=z,this.devMode=J,this.language=ne,this.translations=j}static createNlsConfiguration(F){return{language:F.language,pseudo:F.language==="pseudo",devMode:F.devMode,translations:F.translations}}static equals(F,L){return(0,f.isEqual)(F.location,L.location)&&F.mtime===L.mtime&&(0,f.isEqual)(F.applicationExtensionslocation,L.applicationExtensionslocation)&&F.applicationExtensionslocationMtime===L.applicationExtensionslocationMtime&&F.profile===L.profile&&F.type===L.type&&F.excludeObsolete===L.excludeObsolete&&F.validate===L.validate&&F.productVersion===L.productVersion&&F.productDate===L.productDate&&F.productCommit===L.productCommit&&F.devMode===L.devMode&&F.language===L.language&&G.equals(F.translations,L.translations)}}let oe=class extends w.Disposable{constructor(F,L,T,U,Q){super(),this.f=F,this.g=L,this.h=T,this.i=U,this.j=Q}async scanExtensions(F){const L=F.profile?await this.l(F):await this.k(F);let T={};if(F.excludeObsolete&&F.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,b.isEmptyObject)(T)?L:L.filter(U=>!T[u.ExtensionKey.create(U).toString()])}async k(F){const L=await this.i.resolve(F.location);if(!L.children?.length)return[];const T=await Promise.all(L.children.map(async U=>{if(!U.isDirectory||F.type===1&&(0,f.basename)(U.resource).indexOf(".")===0)return null;const Q=new se(U.resource,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(Q)}));return(0,E.coalesce)(T).sort((U,Q)=>U.location.path<Q.location.path?-1:1)}async l(F){let L=await this.m(F.location,()=>!0,F);if(F.applicationExtensionslocation&&!this.h.extUri.isEqual(F.location,F.applicationExtensionslocation)){L=L.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.m(F.applicationExtensionslocation,U=>!!U.metadata?.isApplicationScoped,F);L.push(...T)}return L}async m(F,L,T){const U=await this.g.scanProfileExtensions(F);if(!U.length)return[];const Q=await Promise.all(U.map(async B=>{if(L(B)){const H=new se(B.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(H,B.metadata)}return null}));return(0,E.coalesce)(Q)}async scanOneOrMultipleExtensions(F){try{if(await this.i.exists((0,f.joinPath)(F.location,"package.json"))){const L=await this.scanExtension(F);return L?[L]:[]}else return await this.scanExtensions(F)}catch(L){return this.j.error(`Error scanning extensions at ${F.location.path}:`,(0,A.getErrorMessage)(L)),[]}}async scanExtension(F,L){try{let T=await this.scanExtensionManifest(F.location);if(T){T.publisher||(T.publisher=c.UNDEFINED_PUBLISHER),L=L??T.__metadata,delete T.__metadata;const U=(0,u.getGalleryExtensionId)(T.publisher,T.name),Q=L?.id?{id:U,uuid:L.id}:{id:U},B=L?.isSystem?0:F.type,H=B===0||!!L?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(T),T=await this.n(F.location,T,se.createNlsConfiguration(F));const R={type:B,identifier:Q,manifest:T,location:F.location,isBuiltin:H,targetPlatform:L?.targetPlatform??"undefined",metadata:L,isValid:!0,validations:[]};return F.validate?this.validate(R,F):R}}catch(T){F.type!==0&&this.j.error(T)}return null}validate(F,L){let T=!0;const U=(0,n.validateExtensionManifest)(L.productVersion,L.productDate,L.location,F.manifest,F.isBuiltin);for(const[Q,B]of U)Q===g.default.Error&&(T=!1,this.j.error(this.t(L.location,B)));return F.isValid=T,F.validations=U,F}async scanExtensionManifest(F){const L=(0,f.joinPath)(F,"package.json");let T;try{T=(await this.i.readFile(L)).value.toString()}catch(Q){return(0,r.toFileOperationResult)(Q)!==1&&this.j.error(this.t(F,(0,v.localize)(0,null,L.path,Q.message))),null}let U;try{U=JSON.parse(T)}catch{const B=[];(0,P.parse)(T,B);for(const H of B)this.j.error(this.t(F,(0,v.localize)(1,null,L.path,H.offset,H.length,(0,m.getParseErrorMessage)(H.error))));return null}return(0,P.getNodeType)(U)!=="object"?(this.j.error(this.t(F,(0,v.localize)(2,null,L.path))),null):U}async n(F,L,T){const U=await this.p(F,L,T);if(U)try{const Q=[],B=await this.r(U.default,Q);if(Q.length>0)return Q.forEach(R=>{this.j.error(this.t(F,(0,v.localize)(3,null,U.default?.path,(0,m.getParseErrorMessage)(R.error))))}),L;if((0,P.getNodeType)(U)!=="object")return this.j.error(this.t(F,(0,v.localize)(4,null,U.default?.path))),L;const H=U.values||Object.create(null);return(0,N.localizeManifest)(L,H,B)}catch{}return L}async p(F,L,T){const U=(0,f.joinPath)(F,"package.nls.json"),Q=(W,$)=>{$.forEach(z=>{this.j.error(this.t(F,(0,v.localize)(5,null,W?.path,(0,m.getParseErrorMessage)(z.error))))})},B=W=>{this.j.error(this.t(F,(0,v.localize)(6,null,W?.path)))},H=`${L.publisher}.${L.name}`,R=T.translations[H];if(R)try{const W=h.URI.file(R),$=(await this.i.readFile(W)).value.toString(),z=[],J=(0,P.parse)($,z);return z.length>0?(Q(W,z),{values:void 0,default:U}):(0,P.getNodeType)(J)!=="object"?(B(W),{values:void 0,default:U}):{values:J.contents?J.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let $;try{$=await this.s(F,T)}catch{return}if(!$.localized)return{values:void 0,default:$.original};try{const z=(await this.i.readFile($.localized)).value.toString(),J=[],ne=(0,P.parse)(z,J);return J.length>0?(Q($.localized,J),{values:void 0,default:$.original}):(0,P.getNodeType)(ne)!=="object"?(B($.localized),{values:void 0,default:$.original}):{values:ne,default:$.original}}catch{return{values:void 0,default:$.original}}}}async r(F,L){if(F)try{const T=(await this.i.readFile(F)).value.toString();return(0,P.parse)(T,L)}catch{}}s(F,L){return new Promise((T,U)=>{const Q=B=>{const H=(0,f.joinPath)(F,`package.nls.${B}.json`);this.i.exists(H).then(R=>{R&&T({localized:H,original:(0,f.joinPath)(F,"package.nls.json")});const W=B.lastIndexOf("-");W===-1?T({localized:(0,f.joinPath)(F,"package.nls.json"),original:null}):(B=B.substring(0,W),Q(B))})};if(L.devMode||L.pseudo||!L.language)return T({localized:(0,f.joinPath)(F,"package.nls.json"),original:null});Q(L.language)})}t(F,L){return`[${F.path}]: ${L}`}};oe=pe([te(1,y.IExtensionsProfileScannerService),te(2,O.IUriIdentityService),te(3,r.IFileService),te(4,a.ILogService)],oe);let re=class extends oe{constructor(F,L,T,U,Q,B){super(L,T,U,Q,B),this.y=F,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(F){const L=await this.C();if(this.u=F,L&&L.input&&se.equals(L.input,this.u))return this.v.trigger(()=>this.F()),L.result.map(U=>(U.location=h.URI.revive(U.location),U));const T=await super.scanExtensions(F);return await this.D({input:F,result:T}),T}async C(){try{const F=await this.i.readFile(this.y),L=JSON.parse(F.value.toString());return{result:L.result,input:(0,o.revive)(L.input)}}catch(F){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,A.getErrorMessage)(F))}return null}async D(F){try{await this.i.writeFile(this.y,M.VSBuffer.fromString(JSON.stringify(F)))}catch(L){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,A.getErrorMessage)(L))}}async F(){if(!this.u)return;const F=await this.C();if(!F)return;const L=F.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!C.equals(T,L))try{await this.i.del(this.y),this.w.fire()}catch(U){this.j.error(U)}}};re=pe([te(2,y.IExtensionsProfileScannerService),te(3,O.IUriIdentityService),te(4,r.IFileService),te(5,a.ILogService)],re);function de(le,F){const L=(0,u.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:L,identifier:new c.ExtensionIdentifier(L),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:F,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.toExtensionDescription=de;class X extends V{constructor(F,L,T,U,Q,B,H,R,W,$,z,J){super(F,L,(0,f.joinPath)(T,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)(U,c.MANIFEST_CACHE_FOLDER),Q,B,H,R,W,$,z,J),this.M=(async()=>{if(I.translationsConfigFile)try{const ne=await this.r.readFile(h.URI.file(I.translationsConfigFile));return JSON.parse(ne.value.toString())}catch{}return Object.create(null)})()}f(F){return this.M}}e.NativeExtensionsScannerService=X}),define(ee[255],ie([0,1,7,34,90,116,16,5,6,19,42,38]),function(q,e,E,t,C,M,A,P,m,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let I=class extends M.NativeExtensionsScannerService{constructor(p,g,b,h,v,d,u,c){super(E.URI.file(v.builtinExtensionsPath),E.URI.file(v.extensionsPath),v.userHome,E.URI.file(v.userDataPath),p,g,b,h,v,d,u,c)}};I=pe([te(0,k.IUserDataProfilesService),te(1,C.IExtensionsProfileScannerService),te(2,A.IFileService),te(3,m.ILogService),te(4,t.INativeEnvironmentService),te(5,w.IProductService),te(6,S.IUriIdentityService),te(7,P.IInstantiationService)],I),e.ExtensionsScannerService=I}),define(ee[256],ie([0,1,13,2,14,9,4,58,7,29,41,34,6,38]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let p=class extends t.Disposable{constructor(b,h,v){super(),this.c=b,this.f=v,this.a=P.TernarySearchTree.forPaths(!A.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(h.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(b.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:b}=E.session;b.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(h,v)=>this.i(h,v)),b.protocol.interceptFileProtocol(C.Schemas.file,(h,v)=>this.h(h,v)),this.B((0,t.toDisposable)(()=>{b.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(b){const h=(0,M.normalize)(b);return this.a.get(h)?t.Disposable.None:(this.a.set(h,!0),(0,t.toDisposable)(()=>this.a.delete(h)))}h(b,h){const v=m.URI.parse(b.url);return this.f.error(`Refused to load resource ${v.fsPath} from ${C.Schemas.file}: protocol (original URL: ${b.url})`),h({error:-3})}i(b,h){const v=this.j(b);let d;return this.c.crossOriginIsolated&&((0,M.basename)(v)==="workbench.html"||(0,M.basename)(v)==="workbench-dev.html"?d=C.COI.CoopAndCoep:d=C.COI.getHeadersFromQuery(b.url)),this.a.findSubstr(v)?h({path:v,headers:d}):this.b.has((0,M.extname)(v).toLowerCase())?h({path:v}):(this.f.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${v} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),h({error:-3}))}j(b){const h=m.URI.parse(b.url),v=C.FileAccess.uriToFileUri(h);return(0,M.normalize)(v.fsPath)}createIPCObjectUrl(){let b;const h=m.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),v=h.toString(),d=async()=>b;return S.validatedIpcMain.handle(v,d),this.f.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:h,update:u=>b=u,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${v}.`),S.validatedIpcMain.removeHandler(v)}}}};p=pe([te(0,k.INativeEnvironmentService),te(1,f.IUserDataProfilesService),te(2,I.ILogService)],p),e.ProtocolMainService=p}),define(ee[257],ie([0,1,13,41,8,3,2,14,12,103,26,21,6,54,61,64,44,38,36]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let d=class extends A.Disposable{constructor(c,n,r,i,a,s,l,o,y){super(),this.g=c,this.h=n,this.i=r,this.j=i,this.k=a,this.l=s,this.m=l,this.n=o,this.p=y,this.a=new C.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new M.Emitter),this.onDidError=M.Event.buffer(this.f.event),this.w=void 0,this.y=void 0,this.r()}r(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,n)=>this.s(c,n)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,n)=>this.t(c,n)),this.B(this.k.onWillShutdown(()=>this.u()))}async s(c,n){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const r=await this.connect();if(c.sender.isDestroyed())return r.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",n,[r])}t(c,n){this.l.trace("SharedProcess: onWorkerConnection",n);const r=new A.DisposableStore,i=s=>{!this.G()||(this.l.trace(`SharedProcess: disposing worker (reason: '${s}')`,n),r.dispose(),this.v("vscode:electron-main->shared-process=disposeWorker",n))},a=E.BrowserWindow.fromId(n.reply.windowId);if(!a||a.isDestroyed()||a.webContents.isDestroyed()||!n.reply.channel){i("unavailable");return}r.add(M.Event.filter(this.k.onWillLoadWindow,s=>s.window.win===a)(()=>i("load"))),r.add(M.Event.fromNodeEventEmitter(a,"closed")(()=>i("closed"))),a.webContents.postMessage(n.reply.channel,n.reply.nonce,c.ports)}u(){const c=this.b;!c||(this.v("vscode:electron-main->shared-process=exit"),this.c&&(c.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{c.close()}catch{}this.b=void 0},0))}v(c,...n){if(!this.G()){this.l.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(c,...n)}catch(r){this.l.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,b.toErrorMessage)(r)}`)}}whenReady(){return this.w||(this.w=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),c()}))),this.w}get C(){return this.y||(this.y=(async()=>{await this.a.wait(),this.D(),this.F(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),c()}))})()),this.y}D(){const c=this.B(this.p.createIPCObjectUrl());this.b=new E.BrowserWindow({show:!1,backgroundColor:this.n.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),product:f.default,policiesData:this.m.serialize()}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}F(){!this.b||(this.c=c=>{this.l.trace("SharedProcess#close prevented"),c.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(c,n)=>this.f.fire({type:2,details:n})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(c,n,r)=>this.f.fire({type:3,details:{reason:r,exitCode:n}})))}async connect(){await this.C;const c=(0,m.assertIsDefined)(this.b);return(0,w.connect)(c)}async toggle(){await this.C,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}G(){const c=this.b;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};d=pe([te(2,S.IEnvironmentMainService),te(3,h.IUserDataProfilesService),te(4,k.ILifecycleMainService),te(5,I.ILogService),te(6,v.IPolicyService),te(7,g.IThemeMainService),te(8,p.IProtocolMainService)],d),e.SharedProcess=d}),define(ee[91],ie([0,1,8,3,2,72,12,104,5,38]),function(q,e,E,t,C,M,A,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,m.createDecorator)("storageService");var S;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(S=e.WillSaveStateReason||(e.WillSaveStateReason={}));var k;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(k=e.StorageScope||(e.StorageScope={}));var I;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));function f(v){const d=v.get(e.TARGET_KEY);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.loadKeyTargets=f;class p extends C.Disposable{constructor(d={flushInterval:p.a}){super(),this.j=d,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new C.MutableDisposable),this.u=void 0,this.w=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,C.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.J()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(d,u){if(u===e.TARGET_KEY){switch(d){case-1:this.C=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:u,target:this.F(d)[u]})}emitWillSaveState(d){this.f.fire({reason:d})}get(d,u,c){return this.L(u)?.get(d,c)}getBoolean(d,u,c){return this.L(u)?.getBoolean(d,c)}getNumber(d,u,c){return this.L(u)?.getNumber(d,c)}store(d,u,c,n){if((0,A.isUndefinedOrNull)(u)){this.remove(d,c);return}this.r(()=>{this.t(d,c,n),this.L(c)?.set(d,u)})}remove(d,u){this.r(()=>{this.t(d,u,void 0),this.L(u)?.delete(d)})}r(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,u){const c=[],n=this.F(d);for(const r of Object.keys(n))n[r]===u&&c.push(r);return c}t(d,u,c){const n=this.F(u);typeof c=="number"?n[d]!==c&&(n[d]=c,this.L(u)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[d]=="number"&&(delete n[d],this.L(u)?.set(e.TARGET_KEY,JSON.stringify(n)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get D(){return this.C||(this.C=this.G(-1)),this.C}F(d){switch(d){case-1:return this.D;case 0:return this.y;default:return this.v}}G(d){const u=this.L(d);return u?f(u):Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=S.NONE){this.f.fire({reason:d});const u=this.L(-1),c=this.L(0),n=this.L(1);switch(d){case S.NONE:await E.Promises.settled([u?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await E.Promises.settled([u?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.L(-1)?.items??new Map,u=this.L(0)?.items??new Map,c=this.L(1)?.items??new Map;return h(d,u,c,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(d,u){return this.emitWillSaveState(S.NONE),(0,w.isUserDataProfile)(d)?this.N(d,u):this.O(d,u)}H(d,u){return!(d.id===u.id||g(u)&&g(d))}I(d,u,c,n){this.r(()=>{if(n)for(const[r,i]of d)u.set(r,i);else{const r=new Set;for(const[i,a]of d)r.add(i),u.get(i)!==a&&this.n(c,i);for(const[i]of u.items)r.has(i)||this.n(c,i)}})}}e.AbstractStorageService=p,p.a=60*1e3;function g(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=g;class b extends p{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.B(this.Q.onDidChangeStorage(d=>this.n(1,d))),this.B(this.P.onDidChangeStorage(d=>this.n(0,d))),this.B(this.p.onDidChangeStorage(d=>this.n(-1,d)))}L(d){switch(d){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(d){return!1}}e.InMemoryStorageService=b;async function h(v,d,u,c,n,r){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},a=new Map,s=new Map;v.forEach((Y,G)=>{a.set(G,Y),s.set(G,i(Y))});const l=new Map,o=new Map;d.forEach((Y,G)=>{l.set(G,Y),o.set(G,i(Y))});const y=new Map,D=new Map;u.forEach((Y,G)=>{y.set(G,Y),D.set(G,i(Y))}),console.group(c!==n?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const O=[];if(a.forEach((Y,G)=>{O.push({key:G,value:Y})}),console.table(O),console.groupEnd(),console.log(s),c!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const Y=[];l.forEach((G,V)=>{Y.push({key:V,value:G})}),console.table(Y),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const N=[];y.forEach((Y,G)=>{N.push({key:G,value:Y})}),console.table(N),console.groupEnd(),console.log(D)}e.logStorage=h}),define(ee[258],ie([0,1,24,8,3,2,9,80,7,23,104,146,6,91,35,28]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class b extends M.Disposable{get storage(){return this.f}constructor(r,i){super(),this.j=r,this.k=i,this.b=this.B(new C.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new C.Emitter),this.onDidCloseStorage=this.c.event,this.f=new S.Storage(new S.InMemoryStorageDatabase),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=S.StorageState.None}init(){return this.g||(this.g=(async()=>{if(this.i===S.StorageState.None)try{const r=await this.n();this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(a=>this.b.fire({key:a}))),await this.m(r);const i=r.getBoolean(f.IS_NEW_KEY);i===void 0?r.set(f.IS_NEW_KEY,!0):i&&r.set(f.IS_NEW_KEY,!1)}catch(r){this.j.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.i=S.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===I.LogLevel.Trace?r=>this.j.trace(r):void 0,logError:r=>this.j.error(r)}}m(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}async close(){const r=new P.StopWatch(!1);await this.s(),r.stop(),r.elapsed()>b.a&&await this.r(r),this.c.fire()}async r(r){if(!!this.path)try{const i=(0,E.top)(Array.from(this.f.items.entries()).map(([s,l])=>({key:s,length:l.length})),(s,l)=>l.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),a=(await this.k.stat(m.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${a}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=S.StorageState.Closed,await this.f.close()}}b.a=2e3;class h extends b{get path(){if(!this.v.useInMemoryStorage)return(0,A.join)(this.u.globalStorageHome.fsPath,h.t)}constructor(r,i,a,s){super(a,s),this.u=r,this.v=i}async n(){return new S.Storage(new k.SQLiteStorageDatabase(this.path??k.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}))}}h.t="state.vscdb";class v extends h{constructor(r,i,a,s){super(r,i,a,s)}}e.ProfileStorageMain=v;class d extends h{constructor(r,i,a,s){super(i.defaultProfile,r,a,s)}async m(r){await super.m(r),this.C(r)}C(r){r.get(p.firstSessionDateStorageKey,void 0)===void 0&&r.set(p.firstSessionDateStorageKey,new Date().toUTCString());const a=r.get(p.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();r.set(p.lastSessionDateStorageKey,typeof a>"u"?null:a),r.set(p.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=d;class u extends b{get path(){if(!this.w.useInMemoryStorage)return(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id,u.t)}constructor(r,i,a,s,l){super(a,l),this.v=r,this.w=i,this.y=s}async n(){const{storageFilePath:r,wasCreated:i}=await this.D();return new S.Storage(new k.SQLiteStorageDatabase(r,{logging:this.l()}),{hint:i?S.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async D(){if(this.w.useInMemoryStorage)return{storageFilePath:k.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,A.join)(r,u.t);return await w.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await w.Promises.mkdir(r,{recursive:!0}),this.F(r),{storageFilePath:i,wasCreated:!0})}async F(r){let i;if((0,g.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,g.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const a=(0,A.join)(r,u.u);await w.Promises.exists(a)||await w.Promises.writeFile(a,JSON.stringify(i,void 0,2))}catch(a){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${a}`)}}}e.WorkspaceStorageMain=u,u.t="state.vscdb",u.u="workspace.json";class c extends b{get path(){}async n(){return new S.Storage(new S.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(ee[259],ie([0,1,3,2,91]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class M extends t.Disposable{constructor(P,m,w){super(),this.b=P,this.c=m,this.f=w;const S=this.B(new t.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>S.value=this.g(),onDidRemoveLastListener:()=>S.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new t.DisposableStore;return P.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(m,w)=>(m?m.push(w.key):m=[w.key],m),100)(m=>this.h(m))),P.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(m,w)=>{m||(m=new Map);let S=m.get(w.profile.id);return S||m.set(w.profile.id,S={profile:w.profile,keys:[],storage:w.storage}),S.keys.push(w.key),m},100)(m=>this.i(m))),P}h(P){const m=P.includes(C.TARGET_KEY)?[this.c.defaultProfile]:[],w=[];if(P=P.filter(S=>S!==C.TARGET_KEY),P.length){const S=(0,C.loadKeyTargets)(this.b.applicationStorage.storage);w.push({profile:this.c.defaultProfile,changes:P.map(k=>({key:k,scope:0,target:S[k]}))})}this.j(m,w)}i(P){const m=[],w=new Map;for(const[S,k]of P.entries()){k.keys.includes(C.TARGET_KEY)&&m.push(k.profile);const I=k.keys.filter(f=>f!==C.TARGET_KEY);if(I.length){const f=(0,C.loadKeyTargets)(k.storage.storage);w.set(S,{profile:k.profile,changes:I.map(p=>({key:p,scope:0,target:f[p]}))})}}this.j(m,[...w.values()])}j(P,m){(P.length||m.length)&&this.a.fire({valueChanges:m,targetChanges:P})}listen(P,m,w){switch(m){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${m}`)}async call(P,m){throw new Error(`Call not found: ${m}`)}}e.ProfileStorageChangesListenerChannel=M}),define(ee[260],ie([0,1,68,7,34,16,6,228,42,38]),function(q,e,E,t,C,M,A,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let S=class Lt extends w.UserDataProfilesService{constructor(I,f,p,g,b){super(p,g,f,b),this.a=I,this.O=p}I(){return(0,E.revive)(this.a.getItem(Lt.b,[]))}L(){return(0,E.revive)(this.a.getItem(Lt.c,{}))}N(){return this.r.extUri.joinPath(t.URI.file(this.O.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};S=pe([te(0,P.IStateService),te(1,m.IUriIdentityService),te(2,C.INativeEnvironmentService),te(3,M.IFileService),te(4,A.ILogService)],S),e.UserDataProfilesService=S}),define(ee[51],ie([0,1,7,34,16,5,6,37,42,38,260]),function(q,e,E,t,C,M,A,P,m,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,M.refineServiceDecorator)(w.IUserDataProfilesService);let k=class ft extends S.UserDataProfilesService{constructor(f,p,g,b,h){super(f,p,g,b,h),this.S=f}setEnablement(f){super.setEnablement(f),this.f||(this.J([]),this.M({}))}J(f){f.length?this.S.setItem(ft.b,f):this.S.removeItem(ft.b)}M(f){f.emptyWindow||f.workspaces?this.S.setItem(ft.c,f):this.S.removeItem(ft.c)}L(){const f="workspaceAndProfileInfo",p=this.S.getItem(f,void 0);if(p){this.S.removeItem(f);const g=p.reduce((b,{workspace:h,profile:v})=>(b[E.URI.revive(h).toString()]=E.URI.revive(v).toString(),b),{});this.S.setItem(ft.c,{workspaces:g})}return super.L()}};k=pe([te(0,P.IStateMainService),te(1,m.IUriIdentityService),te(2,t.INativeEnvironmentService),te(3,C.IFileService),te(4,A.ILogService)],k),e.UserDataProfilesMainService=k}),define(ee[92],ie([0,1,7,49,3,2,34,16,5,21,6,91,258,38,51,42]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,m.createDecorator)("storageMainService");let b=class extends M.Disposable{constructor(d,u,c,n,r,i){super(),this.c=d,this.f=u,this.g=c,this.h=n,this.i=r,this.j=i,this.a=void 0,this.b=this.B(new C.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(d=>{d.window.profile&&this.profileStorage(d.window.profile).init(),d.workspace&&this.workspaceStorage(d.workspace).init()})),this.B(this.h.onWillShutdown(d=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=d.reason,d.join(this.applicationStorage.close());for(const[,u]of this.n)d.join(u.close());for(const[,u]of this.r)d.join(u.close())})),this.B(this.g.onWillCreateProfile(d=>{d.join((async()=>{await this.i.exists(d.profile.globalStorageHome)||await this.i.createFolder(d.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(d=>{const u=this.n.get(d.profile.id);u&&d.join(u.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const d=new I.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(d.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),d}profileStorage(d){if((0,k.isProfileUsingDefaultStorage)(d))return this.applicationStorage;let u=this.n.get(d.id);if(!u){this.c.trace(`StorageMainService: creating profile storage (${d.name})`),u=this.p(d),this.n.set(d.id,u);const c=this.B(u.onDidChangeStorage(n=>this.b.fire({...n,storage:u,profile:d})));(0,t.once)(u.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${d.name})`),this.n.delete(d.id),c.dispose()})}return u}p(d){return this.a===2?new I.InMemoryStorageMain(this.c,this.i):new I.ProfileStorageMain(d,this.k(),this.c,this.i)}workspaceStorage(d){let u=this.r.get(d.id);return u||(this.c.trace(`StorageMainService: creating workspace storage (${d.id})`),u=this.s(d),this.r.set(d.id,u),(0,t.once)(u.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${d.id})`),this.r.delete(d.id)})),u}s(d){return this.a===2?new I.InMemoryStorageMain(this.c,this.i):new I.WorkspaceStorageMain(d,this.k(),this.c,this.f,this.i)}isUsed(d){const u=E.URI.file(d);for(const c of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!c.path&&this.j.extUri.isEqualOrParent(E.URI.file(c.path),u))return!0;return!1}};b=pe([te(0,S.ILogService),te(1,A.IEnvironmentService),te(2,p.IUserDataProfilesMainService),te(3,w.ILifecycleMainService),te(4,P.IFileService),te(5,g.IUriIdentityService)],b),e.StorageMainService=b,e.IApplicationStorageMainService=(0,m.createDecorator)("applicationStorageMainService");let h=class extends k.AbstractStorageService{constructor(d,u){super(),this.p=d,this.s=u,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(d){if(d===-1)return this.s.applicationStorage.storage}M(d){if(d===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};h=pe([te(0,f.IUserDataProfilesService),te(1,e.IStorageMainService)],h),e.ApplicationStorageMainService=h}),define(ee[261],ie([0,1,2,21,51]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let M=class extends E.Disposable{constructor(P,m){super(),this.a=m,this.B(P.onWillLoadWindow(w=>{w.reason===2&&this.b(w.window.openedWorkspace??"empty-window")})),this.B(P.onBeforeCloseWindow(w=>this.b(w.openedWorkspace??"empty-window")))}async b(P){this.a.getOrSetProfileForWorkspace(P).isTransient&&(this.a.unsetWorkspace(P,!0),await this.a.cleanUpTransientProfiles())}};M=pe([te(0,t.ILifecycleMainService),te(1,C.IUserDataProfilesMainService)],M),e.UserDataTransientProfilesHandler=M}),define(ee[117],ie([0,1,20,7,28]),function(q,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function M(m,w,S){for(const I of m){const f=I.openedWorkspace;if((0,C.isWorkspaceIdentifier)(f)){const p=await S(f);if(p){if(p.folders.some(g=>E.extUriBiasedIgnorePathCase.isEqualOrParent(w,g.uri)))return I}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(w,f.configPath))return I}}const k=m.filter(I=>(0,C.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(w,I.openedWorkspace.uri));if(k.length)return k.sort((I,f)=>-(I.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function A(m,w){for(const S of m)if((0,C.isWorkspaceIdentifier)(S.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.configPath,w)||(0,C.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.uri,w))return S}e.findWindowOnWorkspaceOrFolder=A;function P(m,w){const S=k=>w.some(I=>E.extUriBiasedIgnorePathCase.isEqual(t.URI.file(I),t.URI.file(k)));for(const k of m)if(k.config?.extensionDevelopmentPath?.some(I=>S(I)))return k}e.findWindowOnExtensionDevelopmentPath=P}),define(ee[262],ie([0,1,13,2,4,20,7,18,21,6,37,31,115,28]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class Ot extends t.Disposable{get state(){return this.b}constructor(u,c,n,r,i){super(),this.g=u,this.h=c,this.i=n,this.j=r,this.k=i,this.b=g(this.h.getItem(Ot.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(u=>this.p(u)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(u=>this.p(u))}m(){this.f=!0,this.n()}n(){const u=new Set,c={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!c.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),i&&(c.lastActiveWindow=this.r(i),c.lastActiveWindow.uiState.mode===3&&u.add(c.lastActiveWindow.uiState.display))}const n=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);n&&(c.lastPluginDevelopmentHostWindow=this.r(n),c.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(c.lastPluginDevelopmentHostWindow.uiState.display)?C.isMacintosh&&!n.win?.isSimpleFullScreen()&&(c.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(c.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(c.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const a=this.r(i);return a.uiState.mode===3&&(u.has(a.uiState.display)?C.isMacintosh&&a.windowId!==c.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(a.uiState.mode=1):u.add(a.uiState.display)),a}));const r=h(c);this.h.setItem(Ot.a,r),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",r)}p(u){if(this.i.quitRequested)return;const c=this.r(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this.b.openedWindows.forEach(n=>{const r=(0,f.isWorkspaceIdentifier)(u.openedWorkspace)&&n.workspace?.id===u.openedWorkspace.id,i=(0,f.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&n.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(n.folderUri,u.openedWorkspace.uri);(r||i)&&(n.uiState=c.uiState)}),this.g.getWindowCount()===1&&(this.c=c)}r(u){return{windowId:u.id,workspace:(0,f.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.s(u),n=this.k.getValue("window");if(c.mode===3){let r;c.hasDefaultState?r=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):r=!!(this.i.wasRestarted||n?.restoreFullscreen),r||(c.mode=1)}return c}s(u){const c=this.g.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=u.workspace;if((0,f.isWorkspaceIdentifier)(l)){const y=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===l.id).map(D=>D.uiState);if(y.length)return y[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(l)){const y=this.state.openedWindows.filter(D=>D.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(D.folderUri,l.uri)).map(D=>D.uiState);if(y.length)return y[0]}else if(u.backupPath){const y=this.state.openedWindows.filter(D=>D.backupPath===u.backupPath).map(D=>D.uiState);if(y.length)return y[0]}const o=this.c||this.state.lastActiveWindow;if(!c&&o)return o.uiState}let n;const r=E.screen.getAllDisplays();if(r.length===1)n=r[0];else{if(C.isMacintosh){const l=E.screen.getCursorScreenPoint();n=E.screen.getDisplayNearestPoint(l)}!n&&c&&(n=E.screen.getDisplayMatching(c.getBounds())),n||(n=E.screen.getPrimaryDisplay()||r[0])}let i=(0,I.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const a=this.k.getValue("window");let s=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")i.mode=0,s=!1;else if(a.newWindowDimensions==="fullscreen")i.mode=3,s=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&c){const l=c.serializeWindowState();l.mode===3?i.mode=3:i=l,s=i.mode!==3&&a.newWindowDimensions==="offset"}}return s&&(i=this.t(i)),i.hasDefaultState=!0,i}t(u){if(this.g.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.g.getWindows().map(n=>n.getBounds());for(;c.some(n=>n.x===u.x||n.y===u.y);)u.x+=30,u.y+=30;return u}};p.a="windowsState",p=pe([te(0,k.IWindowsMainService),te(1,S.IStateMainService),te(2,m.ILifecycleMainService),te(3,w.ILogService),te(4,P.IConfigurationService)],p),e.WindowsStateHandler=p;function g(d){const u={openedWindows:[]},c=d||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=b(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=b(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(n=>b(n))),u}e.restoreWindowsState=g;function b(d){const u={uiState:d.uiState};return d.backupPath&&(u.backupPath=d.backupPath),d.remoteAuthority&&(u.remoteAuthority=d.remoteAuthority),d.folder&&(u.folderUri=A.URI.parse(d.folder)),d.workspaceIdentifier&&(u.workspace={id:d.workspaceIdentifier.id,configPath:A.URI.parse(d.workspaceIdentifier.configURIPath)}),u}function h(d){return{lastActiveWindow:d.lastActiveWindow&&v(d.lastActiveWindow),lastPluginDevelopmentHostWindow:d.lastPluginDevelopmentHostWindow&&v(d.lastPluginDevelopmentHostWindow),openedWindows:d.openedWindows.map(u=>v(u))}}e.getWindowsStateStoreData=h;function v(d){return{workspaceIdentifier:d.workspace&&{id:d.workspace.id,configURIPath:d.workspace.configPath.toString()},folder:d.folderUri&&d.folderUri.toString(),backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.uiState}}}),define(ee[93],ie([0,1,30,43,123,33,14,9,4,20,7,5,63,28]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,k.createDecorator)("workspacesService");function p(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function g(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=g;function b(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=b;function h(D){return v(D)||d(D)}e.isStoredWorkspaceFolder=h;function v(D){const O=D;return typeof O?.path=="string"&&(!O.name||typeof O.name=="string")}function d(D){const O=D;return typeof O?.uri=="string"&&(!O.name||typeof O.name=="string")}function u(D,O,N,Y,G){if(D.scheme!==Y.scheme)return{name:N,uri:D.toString(!0)};let V=O?void 0:G.relativePath(Y,D);if(V!==void 0)V.length===0?V=".":m.isWindows&&(V=c(V));else if(D.scheme===A.Schemas.file)V=D.fsPath,m.isWindows&&(V=c(V));else if(G.isEqualAuthority(D.authority,Y.authority))V=D.path;else return{name:N,uri:D.toString(!0)};return{name:N,path:V}}e.getStoredWorkspaceFolder=u;function c(D){return D=(0,M.normalizeDriveLetter)(D),(0,E.isUNC)(D)||(D=(0,E.toSlashes)(D)),D}function n(D,O,N){const Y=[],G=new Set,V=N.dirname(O);for(const se of D){let oe;if(v(se))se.path&&(oe=N.resolvePath(V,se.path));else if(d(se))try{oe=S.URI.parse(se.uri),oe.path[0]!==P.posix.sep&&(oe=oe.with({path:P.posix.sep+oe.path}))}catch(re){console.warn(re)}if(oe){const re=N.getComparisonKey(oe);if(!G.has(re)){G.add(re);const de=se.name||N.basenameOrAuthority(oe);Y.push(new f.WorkspaceFolder({uri:oe,name:de,index:Y.length},se))}}}return Y}e.toWorkspaceFolders=n;function r(D,O,N,Y,G){const V=i(O,D),se=G.dirname(O),oe=G.dirname(Y),re=[];for(const F of V.folders){const L=v(F)?G.resolvePath(se,F.path):S.URI.parse(F.uri);let T;N?T=!1:T=!v(F)||(0,P.isAbsolute)(F.path),re.push(u(L,T,F.name,oe,G))}const de={insertSpaces:!1,tabSize:4,eol:m.isLinux||m.isMacintosh?`
`:`\r
`},X=C.setProperty(D,["folders"],re,de);let le=C.applyEdits(D,X);return(0,w.isEqualAuthority)(V.remoteAuthority,(0,I.getRemoteAuthority)(Y))&&(le=C.applyEdits(le,C.removeProperty(le,["remoteAuthority"],de))),le}e.rewriteWorkspaceFileForNewLocation=r;function i(D,O){const N=t.parse(O);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(Y=>h(Y));else throw new Error(`${D} looks like an invalid workspace file.`);return N}function a(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function s(D){return typeof D.folderUri=="string"}function l(D){return typeof D.fileUri=="string"}function o(D,O){const N={workspaces:[],files:[]};if(D){const Y=function(V,se){for(let oe=0;oe<V.length;oe++)try{se(V[oe],oe)}catch(re){O.warn(`Error restoring recent entry ${JSON.stringify(V[oe])}: ${re.toString()}. Skip entry.`)}},G=D;Array.isArray(G.entries)&&Y(G.entries,V=>{const se=V.label,oe=V.remoteAuthority;a(V)?N.workspaces.push({label:se,remoteAuthority:oe,workspace:{id:V.workspace.id,configPath:S.URI.parse(V.workspace.configPath)}}):s(V)?N.workspaces.push({label:se,remoteAuthority:oe,folderUri:S.URI.parse(V.folderUri)}):l(V)&&N.files.push({label:se,remoteAuthority:oe,fileUri:S.URI.parse(V.fileUri)})})}return N}e.restoreRecentlyOpened=o;function y(D){const O={entries:[]};for(const N of D.workspaces)g(N)?O.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):O.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of D.files)O.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return O}e.toStoreData=y}),define(ee[94],ie([0,1,77,14,4,20]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(w){function S(){let k=w.scheme===t.Schemas.file?(0,M.originalFSPath)(w):w.toString();return C.isLinux||(k=k.toLowerCase()),(0,E.createHash)("md5").update(k).digest("hex")}return{id:S(),configPath:w}}e.getWorkspaceIdentifier=A;function P(w,S){function k(){if(w.scheme!==t.Schemas.file)return(0,E.createHash)("md5").update(w.toString()).digest("hex");if(!S)return;let f;return C.isLinux?f=S.ino:C.isMacintosh?f=S.birthtime.getTime():C.isWindows&&(typeof S.birthtimeMs=="number"?f=Math.floor(S.birthtimeMs):f=S.birthtime.getTime()),(0,E.createHash)("md5").update(w.fsPath).update(f?String(f):"").digest("hex")}const I=k();if(typeof I=="string")return{id:I,uri:w}}e.getSingleFolderWorkspaceIdentifier=P;function m(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=m}),define(ee[263],ie([0,1,77,30,14,9,4,20,23,176,18,26,37,16,6,175,28,94]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class Tt{constructor(u,c,n,r){this.j=u,this.k=c,this.l=n,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.extUriBiasedIgnorePathCase,this.i={isEqual:(i,a)=>(0,t.isEqual)(i,a,!A.isLinux)}}async initialize(){const u=await this.n();this.g=await this.v(u.emptyWindows),this.d=await this.t((0,w.deserializeWorkspaceInfos)(u)),this.e=await this.u((0,w.deserializeFolderInfos)(u)),this.C()}async n(){let u=this.m.getItem(Tt.a);if(!u)try{const c=(0,M.join)(this.c,"workspaces.json"),n=await m.Promises.readFile(c,"utf8");try{await m.Promises.unlink(c)}catch{}const r=JSON.parse(n);u={workspaces:Array.isArray(r.rootURIWorkspaces)?r.rootURIWorkspaces:[],folders:Array.isArray(r.folderWorkspaceInfos)?r.folderWorkspaceInfos:[],emptyWindows:Array.isArray(r.emptyWorkspaceInfos)?r.emptyWorkspaceInfos:[]}}catch(c){c.code!=="ENOENT"&&this.l.error(`Backup: Could not migrate legacy backup workspaces metadata: ${c.toString()}`)}return u??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.o()?[]:this.d.slice(0)}getFolderBackups(){return this.o()?[]:this.e.slice(0)}isHotExitEnabled(){return this.q()!==f.HotExitConfiguration.OFF}o(){return this.q()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}q(){return this.k.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(u,c){this.d.some(r=>u.workspace.id===r.workspace.id)||(this.d.push(u),this.C());const n=(0,M.join)(this.c,u.workspace.id);return c?this.s(n,c).then(()=>n):n}async s(u,c){if(await m.Promises.exists(u)&&await this.y(u),await m.Promises.exists(c))try{await m.Promises.rename(c,u)}catch(n){this.l.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}registerFolderBackup(u){return this.e.some(c=>this.h.isEqual(u.folderUri,c.folderUri))||(this.e.push(u),this.C()),(0,M.join)(this.c,this.getFolderHash(u))}registerEmptyWindowBackup(u){return this.g.some(c=>!!c.backupFolder&&this.i.isEqual(c.backupFolder,u.backupFolder))||(this.g.push(u),this.C()),(0,M.join)(this.c,u.backupFolder)}async t(u){if(!Array.isArray(u))return[];const c=new Set,n=[];for(const r of u){const i=r.workspace;if(!(0,b.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const a=(0,M.join)(this.c,i.id);await this.B(a)?i.configPath.scheme!==C.Schemas.file||await m.Promises.exists(i.configPath.fsPath)?n.push(r):await this.y(a):await this.w(a)}}return n}async u(u){if(!Array.isArray(u))return[];const c=[],n=new Set;for(const r of u){const i=r.folderUri,a=this.h.getComparisonKey(i);if(!n.has(a)){n.add(a);const s=(0,M.join)(this.c,this.getFolderHash(r));await this.B(s)?i.scheme!==C.Schemas.file||await m.Promises.exists(i.fsPath)?c.push(r):await this.y(s):await this.w(s)}}return c}async v(u){if(!Array.isArray(u))return[];const c=[],n=new Set;for(const r of u){const i=r.backupFolder;if(typeof i!="string")return[];if(!n.has(i)){n.add(i);const a=(0,M.join)(this.c,i);await this.B(a)?c.push(r):await this.w(a)}}return c}async w(u){try{await m.Promises.rm(u,m.RimRafMode.MOVE)}catch(c){this.l.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}x(){let u=(0,h.createEmptyWorkspaceIdentifier)();for(;this.g.some(c=>!!c.backupFolder&&this.i.isEqual(c.backupFolder,u.id));)u=(0,h.createEmptyWorkspaceIdentifier)();return{backupFolder:u.id}}async y(u){const c=this.x(),n=(0,M.join)(this.c,c.backupFolder);try{await m.Promises.rename(u,n)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(c),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.d)await this.A(c)&&u.push(c);for(const c of this.e)await this.A(c)&&u.push(c);return u}A(u){let c;return(0,w.isEmptyWindowBackupInfo)(u)?c=(0,M.join)(this.c,u.backupFolder):(0,g.isFolderBackupInfo)(u)?c=(0,M.join)(this.c,this.getFolderHash(u)):c=(0,M.join)(this.c,u.workspace.id),this.B(c)}async B(u){try{const c=await m.Promises.readdir(u);for(const n of c)try{if((await m.Promises.readdir((0,M.join)(u,n))).length>0)return!0}catch{}}catch{}return!1}C(){const u={workspaces:this.d.map(({workspace:c,remoteAuthority:n})=>{const r={id:c.id,configURIPath:c.configPath.toString()};return n&&(r.remoteAuthority=n),r}),folders:this.e.map(({folderUri:c,remoteAuthority:n})=>{const r={folderUri:c.toString()};return n&&(r.remoteAuthority=n),r}),emptyWindows:this.g.map(({backupFolder:c,remoteAuthority:n})=>{const r={backupFolder:c};return n&&(r.remoteAuthority=n),r})};this.m.setItem(Tt.a,u)}getFolderHash(u){const c=u.folderUri;let n;return c.scheme===C.Schemas.file?n=A.isLinux?c.fsPath:c.fsPath.toLowerCase():n=c.toString().toLowerCase(),(0,E.createHash)("md5").update(n).digest("hex")}};v.a="backupWorkspaces",v=pe([te(0,k.IEnvironmentMainService),te(1,S.IConfigurationService),te(2,p.ILogService),te(3,I.IStateMainService)],v),e.BackupMainService=v}),define(ee[52],ie([0,1,13,3,43,33,2,14,9,20,12,23,174,60,56,26,5,6,19,51,117,28,93,94]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,b.createDecorator)("workspacesManagementMainService");let i=class extends A.Disposable{constructor(s,l,o,y,D,O){super(),this.g=s,this.h=l,this.i=o,this.j=y,this.k=D,this.l=O,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const s=(await k.Promises.readdir(this.c.fsPath)).map(l=>(0,w.joinPath)(this.c,l,c.UNTITLED_WORKSPACE_NAME));for(const l of s){const o=(0,r.getWorkspaceIdentifier)(l),y=await this.resolveLocalWorkspace(l);y?this.f.push({workspace:o,remoteAuthority:y.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(s){s.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${s}).`)}}resolveLocalWorkspace(s){return this.m(s,l=>k.Promises.readFile(l,"utf8"))}m(s,l){if(!!this.n(s)&&s.scheme===P.Schemas.file)try{const o=l(s.fsPath);return o instanceof Promise?o.then(y=>this.p(s,y),y=>{}):this.p(s,o)}catch{return}}n(s){return(0,c.isUntitledWorkspace)(s,this.g)||(0,c.hasWorkspaceFileExtension)(s)}p(s,l){try{const o=this.r(s,l),y=(0,r.getWorkspaceIdentifier)(s);return{id:y.id,configPath:y.configPath,folders:(0,n.toWorkspaceFolders)(o.folders,y.configPath,w.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}r(s,l){const o=(0,C.parse)(l);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(y=>(0,n.isStoredWorkspaceFolder)(y));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(s,l){const{workspace:o,storedWorkspace:y}=this.s(s,l),D=o.configPath.fsPath;return await k.Promises.mkdir((0,m.dirname)(D),{recursive:!0}),await k.Promises.writeFile(D,JSON.stringify(y,null,"	")),this.f.push({workspace:o,remoteAuthority:l}),o}s(s=[],l){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),y=(0,w.joinPath)(this.c,o),D=(0,w.joinPath)(y,c.UNTITLED_WORKSPACE_NAME),O=[];for(const N of s)O.push((0,n.getStoredWorkspaceFolder)(N.uri,!0,N.name,y,w.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(D),storedWorkspace:{folders:O,remoteAuthority:l}}}async getWorkspaceIdentifier(s){return(0,r.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,c.isUntitledWorkspace)(s.configPath,this.g)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.t(s),this.i.isEnabled()&&this.i.unsetWorkspace(s),this.a.fire(s))}async t(s){const l=(0,w.originalFSPath)(s.configPath);try{await k.Promises.rm((0,m.dirname)(l));const o=(0,m.join)(this.g.workspaceStorageHome.fsPath,s.id);await k.Promises.exists(o)&&await k.Promises.writeFile((0,m.join)(o,"obsolete"),""),this.f=this.f.filter(y=>y.workspace.id!==s.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${l} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(s,l,o){if(!s||!s.win||!s.isReady||!await this.u(s,l,o))return;const D=await this.v(s,(0,r.getWorkspaceIdentifier)(o));if(!!D)return this.b.fire({window:s,workspace:D.workspace}),D}async u(s,l,o){if(!o)return!0;if((0,c.isWorkspaceIdentifier)(s.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,o))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(l,o)){const y={title:this.l.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,I.localize)(0,null))],message:(0,I.localize)(1,null,(0,w.basename)(o)),detail:(0,I.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(y,(0,S.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1}return!0}async v(s,l){if(!s.config)return;s.focus();let o;return s.config.extensionDevelopmentPath||(s.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:l,remoteAuthority:s.remoteAuthority},s.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:l,remoteAuthority:s.remoteAuthority})),(0,c.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=l,s.config.backupPath=o,{workspace:l,backupPath:o}}};i=pe([te(0,g.IEnvironmentMainService),te(1,h.ILogService),te(2,d.IUserDataProfilesMainService),te(3,f.IBackupMainService),te(4,p.IDialogMainService),te(5,v.IProductService)],i),e.WorkspacesManagementMainService=i}),define(ee[118],ie([0,1,13,41,22,5,31,28,52,12,6]),function(q,e,E,t,C,M,A,P,m,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,M.createDecorator)(e.ID);let k=class{constructor(f,p,g){this.a=f,this.b=p,this.c=g}async getRemoteDiagnostics(f){const p=this.a.getWindows();return(await Promise.all(p.map(async b=>{const h=b.remoteAuthority;if(!h)return;const v=`vscode:getDiagnosticInfoResponse${b.id}`,d={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(u=>{b.sendWhenReady("vscode:getDiagnosticInfo",C.CancellationToken.None,{replyChannel:v,args:d}),t.validatedIpcMain.once(v,(c,n)=>{n||u({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),u(n)}),setTimeout(()=>{u({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const p of E.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(p.id);g?f.push(await this.d(g)):f.push(this.e(p))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(f){const p=await this.f(f),g=(0,w.assertIsDefined)(f.win);return this.e(g,p,f.remoteAuthority)}e(f,p=[],g){return{pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:p,remoteAuthority:g}}async f(f){const p=[],g=f.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(g))p.push(g.uri);else if((0,P.isWorkspaceIdentifier)(g)){const b=await this.b.resolveLocalWorkspace(g.configPath);b&&b.folders.forEach(v=>{p.push(v.uri)})}return p}};k=pe([te(0,A.IWindowsMainService),te(1,m.IWorkspacesManagementMainService),te(2,S.ILogService)],k),e.DiagnosticsMainService=k}),define(ee[65],ie([0,1,45,13,27,140,53,3,33,2,14,9,4,7,100,81,23,96,164,56,26,5,21,6,19,64,31,28,52,17,222,215]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c,n,r,i,a,s,l,o,y,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let N=class extends w.Disposable{constructor(G,V,se,oe,re,de,X,le,F){super(),this.a=G,this.b=V,this.c=se,this.f=oe,this.g=re,this.h=de,this.i=X,this.j=le,this.k=F,this.onDidOpenWindow=P.Event.map(this.b.onDidOpenWindow,L=>L.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:T,y:U})=>({windowId:L.id,x:T,y:U})),({windowId:L})=>!!this.b.getWindowById(L)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(L,T)=>T.id),L=>!!this.b.getWindowById(L)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(L,T)=>T.id),L=>!!this.b.getWindowById(L)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(L,T)=>T.id),L=>!!this.b.getWindowById(L)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),L=>!!L),L=>L.id),P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(L,T)=>T.id),L=>!!this.b.getWindowById(L))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.l=this.B(new P.Emitter),this.onDidChangePassword=this.l.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(L,T,U)=>U),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),P.Event.fromNodeEventEmitter(t.screen,"display-added"),P.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(V=>({id:V.id,workspace:V.openedWorkspace??(0,l.toWorkspaceIdentifier)(V.backupPath,V.isExtensionDevelopmentHost),title:V.win?.getTitle()??"",filename:V.getRepresentedFilename(),dirty:V.isDocumentEdited()}))}async getWindowCount(G){return this.b.getWindowCount()}async getActiveWindowId(G){const V=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(V)return V.id}openWindow(G,V,se){return Array.isArray(V)?this.m(G,V,se):this.n(G,V)}async m(G,V,se=Object.create(null)){V.length>0&&await this.b.open({context:5,contextWindowId:G,urisToOpen:V,cli:this.g.args,forceNewWindow:se.forceNewWindow,forceReuseWindow:se.forceReuseWindow,preferNewWindow:se.preferNewWindow,diffMode:se.diffMode,mergeMode:se.mergeMode,addMode:se.addMode,gotoLineMode:se.gotoLineMode,noRecentEntry:se.noRecentEntry,waitMarkerFileURI:se.waitMarkerFileURI,remoteAuthority:se.remoteAuthority||void 0})}async n(G,V){await this.b.openEmptyWindow({context:5,contextWindowId:G},V)}async toggleFullScreen(G){this.v(G)?.toggleFullScreen()}async handleTitleDoubleClick(G){this.v(G)?.handleTitleDoubleClick()}async isMaximized(G){const V=this.v(G);return V?.win?V.win.isMaximized():!1}async maximizeWindow(G){const V=this.v(G);V?.win&&V.win.maximize()}async unmaximizeWindow(G){const V=this.v(G);V?.win&&V.win.unmaximize()}async minimizeWindow(G){const V=this.v(G);V?.win&&V.win.minimize()}async updateWindowControls(G,V){const se=this.v(G);se&&se.updateWindowControls(V)}async focusWindow(G,V){V&&typeof V.windowId=="number"&&(G=V.windowId),this.v(G)?.focus({force:V?.force??!1})}async setMinimumSize(G,V,se){const oe=this.v(G);if(oe?.win){const[re,de]=oe.win.getSize(),[X,le]=oe.win.getMinimumSize(),[F,L]=[V??X,se??le],[T,U]=[Math.max(re,F),Math.max(de,L)];(X!==F||le!==L)&&oe.win.setMinimumSize(F,L),(re!==T||de!==U)&&oe.win.setSize(T,U)}}async saveWindowSplash(G,V){this.j.saveWindowSplash(G,V)}async installShellCommand(G){const{source:V,target:se}=await this.p();try{const{symbolicLink:oe}=await b.SymlinkSupport.stat(V);if(oe&&!oe.dangling){const re=await(0,p.realpath)(V);if(se===re)return}await b.Promises.unlink(V)}catch(oe){if(oe.code!=="ENOENT")throw oe}try{await b.Promises.symlink(se,V)}catch(oe){if(oe.code!=="EACCES"&&oe.code!=="ENOENT")throw oe;const{response:re}=await this.showMessageBox(G,{title:this.i.nameLong,type:"info",message:(0,v.localize)(0,null,this.i.nameShort),buttons:[(0,m.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,m.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const de=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${se}' '${V}'\\" with administrator privileges"`;await(0,M.promisify)(E.exec)(de)}catch{throw new Error((0,v.localize)(3,null,V))}}}async uninstallShellCommand(G){const{source:V}=await this.p();try{await b.Promises.unlink(V)}catch(se){switch(se.code){case"EACCES":{const{response:oe}=await this.showMessageBox(G,{title:this.i.nameLong,type:"info",message:(0,v.localize)(4,null,this.i.nameShort),buttons:[(0,m.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,m.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const re=`osascript -e "do shell script \\"rm '${V}'\\" with administrator privileges"`;await(0,M.promisify)(E.exec)(re)}catch{throw new Error((0,v.localize)(7,null,V))}break}case"ENOENT":break;default:throw se}}}async p(){const G=(0,k.resolve)(this.g.appRoot,"bin","code"),V=`/usr/local/bin/${this.i.applicationName}`;if(!await b.Promises.exists(G))throw new Error((0,v.localize)(8,null,G));return{source:V,target:G}}async showMessageBox(G,V){return this.c.showMessageBox(V,this.r(G))}async showSaveDialog(G,V){return this.c.showSaveDialog(V,this.r(G))}async showOpenDialog(G,V){return this.c.showOpenDialog(V,this.r(G))}r(G){const V=this.v(G);if(V?.win)return V.win}async pickFileFolderAndOpen(G,V){const se=await this.c.pickFileFolder(V);se&&await this.s(await Promise.all(se.map(async oe=>await b.SymlinkSupport.existsDirectory(oe)?{folderUri:f.URI.file(oe)}:{fileUri:f.URI.file(oe)})),V,G)}async pickFolderAndOpen(G,V){const se=await this.c.pickFolder(V);se&&await this.s(se.map(oe=>({folderUri:f.URI.file(oe)})),V,G)}async pickFileAndOpen(G,V){const se=await this.c.pickFile(V);se&&await this.s(se.map(oe=>({fileUri:f.URI.file(oe)})),V,G)}async pickWorkspaceAndOpen(G,V){const se=await this.c.pickWorkspace(V);se&&await this.s(se.map(oe=>({workspaceUri:f.URI.file(oe)})),V,G)}async s(G,V,se){await this.b.open({context:3,contextWindowId:se,cli:this.g.args,urisToOpen:G,forceNewWindow:V.forceNewWindow})}async showItemInFolder(G,V){t.shell.showItemInFolder(V)}async setRepresentedFilename(G,V){this.v(G)?.setRepresentedFilename(V)}async setDocumentEdited(G,V){this.v(G)?.setDocumentEdited(V)}async openExternal(G,V){return I.isLinuxSnap?this.t(V):t.shell.openExternal(V),!0}t(G){const V=process.env.GDK_PIXBUF_MODULE_FILE,se=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(G),process.env.GDK_PIXBUF_MODULE_FILE=V,process.env.GDK_PIXBUF_MODULEDIR=se}moveItemToTrash(G,V){return t.shell.trashItem(V)}async isAdmin(){let G;return I.isWindows?G=(await new Promise((V,se)=>{q(["native-is-elevated"],V,se)}))():G=process.getuid()===0,G}async writeElevated(G,V,se,oe){const re=await new Promise((de,X)=>{q(["@vscode/sudo-prompt"],de,X)});return new Promise((de,X)=>{const le=[`"${this.u}"`];oe?.unlock&&le.push("--file-chmod"),le.push("--file-write",`"${V.fsPath}"`,`"${se.fsPath}"`);const F={name:this.i.nameLong.replace("-",""),icns:I.isMacintosh&&this.g.isBuilt?(0,k.join)((0,k.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};re.exec(le.join(" "),F,(L,T,U)=>{T&&this.h.trace(`[sudo-prompt] received stdout: ${T}`),U&&this.h.trace(`[sudo-prompt] received stderr: ${U}`),L?X(L):de(void 0)})})}get u(){return I.isWindows?this.g.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,k.join)(this.g.appRoot,"scripts","code-cli.bat"):I.isLinux?this.g.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,k.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,k.join)(this.g.appRoot,"bin","code"):(0,k.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,C.totalmem)(),freemem:(0,C.freemem)(),loadavg:(0,C.loadavg)()}}async getOSProperties(){return{arch:(0,C.arch)(),platform:(0,C.platform)(),release:(0,C.release)(),type:(0,C.type)(),cpus:(0,C.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return I.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(G,V,se){process.kill(V,se)}async readClipboardText(G,V){return t.clipboard.readText(V)}async writeClipboardText(G,V,se){return t.clipboard.writeText(V,se)}async readClipboardFindText(G){return t.clipboard.readFindText()}async writeClipboardFindText(G,V){return t.clipboard.writeFindText(V)}async writeClipboardBuffer(G,V,se,oe){return t.clipboard.writeBuffer(V,Buffer.from(se.buffer),oe)}async readClipboardBuffer(G,V){return y.VSBuffer.wrap(t.clipboard.readBuffer(V))}async hasClipboard(G,V,se){return t.clipboard.has(V,se)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(G,V){this.v(G)?.updateTouchBar(V)}async notifyReady(G){this.v(G)?.setReady()}async relaunch(G,V){return this.f.relaunch(V)}async reload(G,V){const se=this.v(G);if(se){if((0,l.isWorkspaceIdentifier)(se.openedWorkspace)){const oe=se.openedWorkspace.configPath;if(oe.scheme===S.Schemas.file&&(await this.k.resolveLocalWorkspace(oe))?.transient)return this.openWindow(se.id,{forceReuseWindow:!0})}return this.f.reload(se,V?.disableExtensions!==void 0?{_:[],"disable-extensions":V.disableExtensions}:void 0)}}async closeWindow(G){this.closeWindowById(G,G)}async closeWindowById(G,V){const se=this.v(V);if(se?.win)return se.win.close()}async quit(G){const V=this.b.getLastActiveWindow();V?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&V.win?V.win.close():this.f.quit()}async exit(G,V){await this.f.kill(V)}async resolveProxy(G,V){const oe=this.v(G)?.win?.webContents?.session;if(oe)return oe.resolveProxy(V)}findFreePort(G,V,se,oe,re=1){return(0,h.findFreePort)(V,se,oe,re)}async openDevTools(G,V){const se=this.v(G);se?.win&&se.win.webContents.openDevTools(V)}async toggleDevTools(G){const V=this.v(G);V?.win&&V.win.webContents.toggleDevTools()}async sendInputEvent(G,V){const se=this.v(G);se?.win&&(V.type==="mouseDown"||V.type==="mouseUp")&&se.win.webContents.sendInputEvent(V)}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(G,V,se){const oe=this.v(G);if(!oe||!oe.win)throw new Error;return await new O.WindowProfiler(oe.win,V,this.h).inspect(se)}async windowsGetStringRegKey(G,V,se,oe){if(!I.isWindows)return;const re=await new Promise((de,X)=>{q(["@vscode/windows-registry"],de,X)});try{return re.GetStringRegKey(V,se,oe)}catch{return}}v(G){if(typeof G=="number")return this.b.getWindowById(G)}};pe([A.memoize],N.prototype,"u",null),N=pe([te(1,s.IWindowsMainService),te(2,d.IDialogMainService),te(3,n.ILifecycleMainService),te(4,u.IEnvironmentMainService),te(5,r.ILogService),te(6,i.IProductService),te(7,a.IThemeMainService),te(8,o.IWorkspacesManagementMainService)],N),e.NativeHostMainService=N}),define(ee[264],ie([0,1,13,41,27,33,2,14,4,101,162,84,118,56,26,5,6,65,54,19,61,74,30,12]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,g.createDecorator)("issueMainService");let i=class jt{constructor(s,l,o,y,D,O,N,Y,G){this.g=s,this.h=l,this.i=o,this.j=y,this.k=D,this.l=O,this.m=N,this.n=Y,this.o=G,this.b=null,this.c=null,this.d=null,this.f=null,this.p()}p(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[l,o]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),y=await this.j.getSystemInfo(l,o);this.q(s,"vscode:issueSystemInfoResponse",y)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const l=[];try{l.push({name:(0,S.localize)(0,null),rootProcess:await(0,w.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(y=>{(0,k.isRemoteDiagnosticError)(y)?l.push({name:y.hostName,rootProcess:y}):y.processes&&l.push({name:y.hostName,rootProcess:y.processes})})}catch(o){this.i.error(`Listing processes failed: ${o}`)}this.q(s,"vscode:listProcessesResponse",l)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const l={title:this.o.nameLong,message:(0,S.localize)(1,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,S.localize)(2,null)),(0,M.mnemonicButtonLabel)((0,S.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const o=await this.l.showMessageBox(l,this.b);this.q(s,"vscode:issueReporterClipboardResponse",o.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const l=await this.u();this.q(s,"vscode:issuePerformanceInfoResponse",l)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.o.nameLong,message:(0,S.localize)(4,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,M.mnemonicButtonLabel)((0,S.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(s,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,l)=>{const{id:o,from:y,args:D}=l;let O;switch(y){case"issueReporter":O=this.c;break;case"processExplorer":O=this.f;break;default:throw new Error(`Unexpected command source: ${y}`)}O?.webContents.send("vscode:runAction",{id:o,from:y,args:D})}),t.validatedIpcMain.on("vscode:openExternal",(s,l)=>{this.m.openExternal(void 0,l)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const l=await this.k.getMainDiagnostics();this.q(s,"vscode:windowsInfoResponse",l.windows)})}q(s,l,...o){s.sender.isDestroyed()||s.sender.send(l,...o)}async openReporter(s){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const l=new A.DisposableStore,o=l.add(this.n.createIPCObjectUrl()),y=this.t(this.c,700,800);this.b=this.s(y,o,{backgroundColor:s.styles.backgroundColor,title:(0,S.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:s,disableExtensions:!!this.h.disableExtensions,os:{type:(0,C.type)(),arch:(0,C.arch)(),release:(0,C.release)()},product:v.default}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,l.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,l.dispose())})}this.b&&this.r(this.b)}async openProcessExplorer(s){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const l=new A.DisposableStore,o=l.add(this.n.createIPCObjectUrl()),y=this.t(this.f,800,500);this.d=this.s(y,o,{backgroundColor:s.styles.backgroundColor,title:(0,S.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),o.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:s,product:v.default}),this.d.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,l.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,l.dispose())})}this.d&&this.r(this.d)}r(s){s.isMinimized()&&s.restore(),s.focus()}s(s,l,o,y){const D=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:o.title,backgroundColor:o.backgroundColor||jt.a,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,`--vscode-window-kind=${y}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return D.setMenuBarVisibility(!1),D}async getSystemStatus(){const[s,l]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(s,l)}t(s,l,o){let y;const D=E.screen.getAllDisplays();if(D.length===1)y=D[0];else{if(m.isMacintosh){const Y=E.screen.getCursorScreenPoint();y=E.screen.getDisplayNearestPoint(Y)}!y&&s&&(y=E.screen.getDisplayMatching(s.getBounds())),y||(y=E.screen.getPrimaryDisplay()||D[0])}const O={width:l,height:o},N=y.bounds;return O.x=N.x+N.width/2-O.width/2,O.y=N.y+N.height/2-O.height/2,N.width>0&&N.height>0&&(O.x<N.x&&(O.x=N.x),O.y<N.y&&(O.y=N.y),O.x>N.x+N.width&&(O.x=N.x),O.y>N.y+N.height&&(O.y=N.y),O.width>N.width&&(O.width=N.width),O.height>N.height&&(O.height=N.height)),O}async u(){try{const[s,l]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(s,l)}catch(s){throw this.i.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.h.args.trace)return;const s=await E.contentTracing.stopRecording(`${(0,n.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,S.localize)(9,null),detail:(0,S.localize)(10,null,s),buttons:[(0,M.mnemonicButtonLabel)((0,S.localize)(11,null))],defaultId:0,noLink:!0},(0,r.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,s)}};i.a="#1E1E1E",i=pe([te(1,p.IEnvironmentMainService),te(2,b.ILogService),te(3,k.IDiagnosticsService),te(4,I.IDiagnosticsMainService),te(5,f.IDialogMainService),te(6,h.INativeHostMainService),te(7,u.IProtocolMainService),te(8,d.IProductService)],i),e.IssueMainService=i}),define(ee[265],ie([0,1,22,18,26,21,6,65,19,55,35,48,89]),function(q,e,E,t,C,M,A,P,m,w,S,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends I.AbstractUpdateService{constructor(g,b,h,v,d,u,c,n){super(g,b,v,d,u,n),this.e=h,this.u=c}s(g){return(0,I.createUpdateURL)(`linux-${process.arch}`,g,this.k)}t(g){!this.a||(this.d(k.State.CheckingForUpdates(g)),this.i.request({url:this.a},E.CancellationToken.None).then(w.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!g}),this.d(k.State.Idle(1))):this.d(k.State.AvailableForDownload(b))}).then(void 0,b=>{this.j.error(b),this.e.publicLog2("update:notAvailable",{explicit:!!g});const h=g?b.message||b:void 0;this.d(k.State.Idle(1,h))}))}async o(g){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):g.update.url&&this.u.openExternal(void 0,g.update.url),this.d(k.State.Idle(1))}};f=pe([te(0,M.ILifecycleMainService),te(1,t.IConfigurationService),te(2,S.ITelemetryService),te(3,C.IEnvironmentMainService),te(4,w.IRequestService),te(5,A.ILogService),te(6,P.INativeHostMainService),te(7,m.IProductService)],f),e.LinuxUpdateService=f}),define(ee[266],ie([0,1,45,40,27,8,22,53,9,7,126,23,18,26,16,21,6,65,19,55,35,48,89]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(l,o=1e3){for(;!l();)await(0,M.timeout)(o)}let i;function a(){return typeof i>"u"&&(i=t.existsSync(m.join(m.dirname(process.execPath),"unins000.exe"))?0:1),i}let s=class extends n.AbstractUpdateService{get cachePath(){const o=m.join((0,C.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return k.Promises.mkdir(o,{recursive:!0}).then(()=>o)}constructor(o,y,D,O,N,Y,G,V,se){super(o,y,O,N,Y,se),this.u=D,this.v=G,this.w=V}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(o){let y="win32";return process.arch!=="ia32"&&(y+=`-${process.arch}`),a()===1?y+="-archive":this.k.target==="user"&&(y+="-user"),(0,n.createUpdateURL)(y,o,this.k)}t(o){!this.a||(this.d(c.State.CheckingForUpdates(o)),this.i.request({url:this.a},A.CancellationToken.None).then(d.asJson).then(y=>{const D=a();return!y||!y.url||!y.version||!y.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!o}),this.d(c.State.Idle(D)),Promise.resolve(null)):D===1?(this.d(c.State.AvailableForDownload(y)),Promise.resolve(null)):(this.d(c.State.Downloading(y)),this.C(y.version).then(()=>this.B(y.version).then(O=>k.Promises.exists(O).then(N=>{if(N)return Promise.resolve(O);const Y=y.url,G=y.hash,V=`${O}.tmp`;return this.i.request({url:Y},A.CancellationToken.None).then(se=>this.v.writeFile(w.URI.file(V),se.stream)).then(G?()=>(0,S.checksum)(V,y.hash):()=>{}).then(()=>k.Promises.rename(V,O)).then(()=>O)})).then(O=>{const N=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:O},N&&y.supportsFastUpdate?this.k.target==="user"?this.p():this.d(c.State.Downloaded(y)):this.d(c.State.Ready(y))})))}).then(void 0,y=>{this.j.error(y),this.u.publicLog2("update:notAvailable",{explicit:!!o});const D=o?y.message||y:void 0;this.d(c.State.Idle(a(),D))}))}async o(o){o.update.url&&this.w.openExternal(void 0,o.update.url),this.d(c.State.Idle(a()))}async B(o){const y=await this.cachePath;return m.join(y,`CodeSetup-${this.k.quality}-${o}.exe`)}async C(o=null){const y=o?Y=>!new RegExp(`${this.k.quality}-${o}\\.exe$`).test(Y):()=>!0,D=await this.cachePath,N=(await k.Promises.readdir(D)).filter(y).map(async Y=>{try{await k.Promises.unlink(m.join(D,Y))}catch{}});await Promise.all(N)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const o=this.state.update;this.d(c.State.Updating(o));const y=await this.cachePath;this.e.updateFilePath=m.join(y,`CodeSetup-${this.k.quality}-${o.version}.flag`),await k.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(c.State.Idle(a()))});const O=`${this.k.win32MutexName}-ready`,N=await new Promise((Y,G)=>{q(["windows-mutex"],Y,G)});r(()=>N.isActive(O)).then(()=>this.d(c.State.Ready(o)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(o){if(this.state.type!=="idle")return;const y=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!y};this.d(c.State.Downloading(D)),this.e={packagePath:o},y?this.k.target==="user"?this.p():this.d(c.State.Downloaded(D)):this.d(c.State.Ready(D))}};pe([P.memoize],s.prototype,"cachePath",null),s=pe([te(0,g.ILifecycleMainService),te(1,I.IConfigurationService),te(2,u.ITelemetryService),te(3,f.IEnvironmentMainService),te(4,d.IRequestService),te(5,b.ILogService),te(6,p.IFileService),te(7,h.INativeHostMainService),te(8,v.IProductService)],s),e.Win32UpdateService=s}),define(ee[267],ie([0,1,13,8,22,44,3,33,2,14,9,72,4,7,170,60,18,56,26,59,16,21,6,19,61,233,92,35,236,64,74,31,28,52,115,120,36,37,54,51]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c,n,r,i,a,s,l,o,y,D,O,N,Y,G,V,se,oe,re,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var X;(function(F){F[F.NONE=0]="NONE",F[F.NAVIGATING=1]="NAVIGATING",F[F.READY=2]="READY"})(X||(X={}));let le=class Ft extends m.Disposable{get id(){return this.j}get win(){return this.k}get lastFocusTime(){return this.l}get backupPath(){return this.m?.backupPath}get openedWorkspace(){return this.m?.workspace}get profile(){return this.config?this.O.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.O.profiles.find(L=>L.id===this.config?.profiles.profile.id)??this.O.defaultProfile):void 0}get remoteAuthority(){return this.m?.remoteAuthority}get config(){return this.m}get isExtensionDevelopmentHost(){return!!this.m?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.m?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.m?.debugId}constructor(L,T,U,Q,B,H,R,W,$,z,J,ne,j,x,_,ae,ge,Me,Oe){super(),this.L=T,this.M=U,this.N=Q,this.O=B,this.P=H,this.Q=R,this.R=W,this.S=$,this.U=z,this.W=J,this.X=ne,this.Y=j,this.ab=x,this.bb=_,this.db=ae,this.eb=ge,this.fb=Me,this.gb=Oe,this.b=this.B(new A.Emitter),this.onWillLoad=this.b.event,this.c=this.B(new A.Emitter),this.onDidSignalReady=this.c.event,this.f=this.B(new A.Emitter),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new A.Emitter),this.onDidClose=this.g.event,this.h=this.B(new A.Emitter),this.onDidDestroy=this.h.event,this.l=-1,this.s=void 0,this.t=void 0,this.w=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.eb.createIPCObjectUrl()),this.J=!1,this.hb=0;{const[De,Re]=this.rb(L.state);this.n=De,this.L.trace("window#ctor: using window state",De);const ve=this.n.mode===0||this.n.mode===3,we=this.S.getValue("window");let be=!1;typeof we?.experimental?.useSandbox=="boolean"?be=we.experimental.useSandbox:be=typeof re.default.quality=="string"&&re.default.quality!=="stable";const Ce={width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y,backgroundColor:this.U.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!ve,title:this.db.nameLong,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(we?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...be?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};I.isLinux?Ce.icon=(0,S.join)(this.M.appRoot,"resources/linux/code.png"):I.isWindows&&!this.M.isBuilt&&(Ce.icon=(0,S.join)(this.M.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.yb()&&(Ce.fullscreenable=!1),I.isMacintosh&&(Ce.acceptFirstMouse=!0,we?.clickThroughInactive===!1&&(Ce.acceptFirstMouse=!1));const Z=I.isMacintosh&&we?.nativeTabs===!0;Z&&(Ce.tabbingIdentifier=this.db.nameShort);const ue=(0,D.getTitleBarStyle)(this.S)==="custom";if(ue&&(Ce.titleBarStyle="hidden",I.isMacintosh||(Ce.frame=!1),(0,D.useWindowControlsOverlay)(this.S,this.db))){const he=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),ye=V.Color.fromHex(he).isDarker()?"#FFFFFF":"#000000";Ce.titleBarOverlay={height:29,color:he,symbolColor:ye},this.w=!0}if((0,k.mark)("code/willCreateCodeBrowserWindow"),this.k=new E.BrowserWindow(Ce),(0,k.mark)("code/didCreateCodeBrowserWindow"),this.j=this.k.id,I.isMacintosh&&ue&&this.k.setSheetOffset(22),ue&&(I.isWindows&&(0,D.useWindowControlsOverlay)(this.S,this.db)||I.isMacintosh)){const he=this.gb.getItem(Ft.a);he&&this.updateWindowControls({height:he})}I.isWindows&&ue&&this.k.hookWindowMessage(278,()=>{const[ye,Ie]=this.k.getPosition(),We=E.screen.getCursorScreenPoint(),Te=We.x-ye,ze=We.y-Ie;return(()=>!(Te>30&&ze>=0&&ze<=Math.max(this.k.getBounds().height*.15,35)))()||(this.k.setEnabled(!1),this.k.setEnabled(!0),this.f.fire({x:Te,y:ze})),0}),(I.isMacintosh||I.isWindows)&&Re&&(!Z||E.BrowserWindow.getAllWindows().length===1)&&[this.n.width,this.n.height,this.n.x,this.n.y].every(he=>typeof he=="number")&&this.k.setBounds({width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y}),ve&&((0,k.mark)("code/willMaximizeCodeWindow"),this.k.maximize(),this.n.mode===3&&this.ub(!0),this.k.show(),(0,k.mark)("code/didMaximizeCodeWindow")),this.l=Date.now()}this.M.args["open-devtools"]===!0&&this.k.webContents.openDevTools(),this.ob(),this.Db(),this.ib()}setRepresentedFilename(L){I.isMacintosh?this.k.setRepresentedFilename(L):this.u=L}getRepresentedFilename(){return I.isMacintosh?this.k.getRepresentedFilename():this.u}setDocumentEdited(L){I.isMacintosh&&this.k.setDocumentEdited(L),this.v=L}isDocumentEdited(){return I.isMacintosh?this.k.isDocumentEdited():!!this.v}focus(L){I.isMacintosh&&L?.force&&E.app.focus({steal:!0}),this.k&&(this.k.isMinimized()&&this.k.restore(),this.k.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.j})`),this.hb=2;this.C.length;)this.C.pop()(this);this.c.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.C.push(L)})}get isReady(){return this.hb===2}get whenClosedOrLoaded(){return new Promise(L=>{function T(){U.dispose(),Q.dispose(),L()}const U=this.onDidClose(()=>T()),Q=this.onWillLoad(()=>T())})}ib(){this.k.on("unresponsive",()=>this.lb(1)),this.k.webContents.on("render-process-gone",(T,U)=>this.lb(2,U)),this.k.webContents.on("did-fail-load",(T,U,Q)=>this.lb(3,{reason:Q,exitCode:U})),this.k.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.k.on("closed",()=>{this.g.fire(),this.dispose()}),this.k.webContents.on("did-finish-load",()=>{this.I&&(this.m=this.I,this.I=void 0)}),this.k.on("focus",()=>{this.l=Date.now()}),this.k.on("maximize",T=>{this.m&&(this.m.maximized=!0),E.app.emit("browser-window-maximize",T,this.k)}),this.k.on("unmaximize",T=>{this.m&&(this.m.maximized=!1),E.app.emit("browser-window-unmaximize",T,this.k)}),this.k.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",C.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.k.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",C.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.B(this.S.onDidChangeConfiguration(T=>this.ob(T))),this.B(this.W.onDidDeleteUntitledWorkspace(T=>this.nb(T)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.k.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(T,U)=>{const Q=await this.kb();U({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,Q)})})}kb(){return this.jb||(this.jb=(0,a.resolveMarketplaceHeaders)(this.db.version,this.db,this.M,this.S,this.P,this.Q,this.Y)),this.jb}async lb(L,T){switch(L){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:L,reason:T?.reason,code:T?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.bb.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.mb(!1,!1),this.bb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.k&&this.k.webContents&&this.k.webContents.isDevToolsOpened())return;const U=await this.ab.showMessageBox({title:this.db.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,p.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(2,null))],message:(0,p.localize)(3,null),detail:(0,p.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.m?.workspace?(0,p.localize)(5,null):void 0},this.k);if(U.response!==1){const Q=U.response===0;await this.mb(Q,U.checkboxChecked)}}else if(L===2){let U;T?U=(0,p.localize)(7,null,T.reason,T.exitCode??"<unknown>"):U=(0,p.localize)(6,null);const Q=await this.ab.showMessageBox({title:this.db.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,p.localize)(8,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(9,null))],message:U,detail:(0,p.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this.m?.workspace?(0,p.localize)(11,null):void 0},this.k),B=Q.response===0;await this.mb(B,Q.checkboxChecked)}break}}async mb(L,T){const U=this.m?.workspace;if(T&&U)try{const Q=this.R.workspaceStorage(U);await Q.init(),Q.delete("memento/workbench.parts.editor"),await Q.close()}catch(Q){this.L.error(Q)}if(this.h.fire(),this.k?.destroy(),L&&this.m){let Q,B;(0,N.isSingleFolderWorkspaceIdentifier)(U)?Q={folderUri:U.uri}:(0,N.isWorkspaceIdentifier)(U)?Q={workspaceUri:U.configPath}:B=!0;const[H]=await this.fb.open({context:5,userEnv:this.m.userEnv,cli:{...this.M.args,_:[]},urisToOpen:Q?[Q]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});H.focus()}}nb(L){this.m?.workspace?.id===L.id&&(this.m.workspace=void 0)}ob(L){const T=this.Ab();T!==this.r&&(this.r=T,this.Bb(T));let U=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const Q=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.F||Q!==this.G)){this.F=U,this.G=Q;const B=U||"",H=Q?`${Q},<local>`:"<local>";this.L.trace(`Setting proxy to '${B}', bypassing '${H}'`),this.k.webContents.session.setProxy({proxyRules:B,proxyBypassRules:H,pacScript:""})}}addTabbedWindow(L){I.isMacintosh&&L.win&&this.k.addTabbedWindow(L.win)}load(L,T=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!T.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.k.setTitle(this.db.nameLong)),this.pb(L,T),this.hb===0?this.m=L:this.I=L,this.hb=1,this.k.loadURL(w.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const U=this.J;this.J=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.k&&!this.k.isVisible()&&!this.k.isMinimized()&&(this.k.show(),this.focus({force:!0}),this.k.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:L.workspace,reason:T.isReload?3:U?2:1})}pb(L,T){const U=(this.m??this.I)?.userEnv;if(U){const Q=(0,d.isLaunchedFromCli)(U)&&!(0,d.isLaunchedFromCli)(L.userEnv),B=this.isExtensionDevelopmentHost;(Q||B)&&(L.userEnv={...U,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(L["disable-extensions"]=T.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.k.isMaximized(),L.partsSplash=this.U.getWindowSplash(),(0,k.mark)("code/willOpenNewWindow"),L.perfMarks=(0,k.getMarks)(),this.H.update(L)}async reload(L){const T=Object.assign({},this.m);T.workspace=await this.qb(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&L&&(T.verbose=L.verbose,T.debugId=L.debugId,T.extensionEnvironment=L.extensionEnvironment,T["inspect-extensions"]=L["inspect-extensions"],T["inspect-brk-extensions"]=L["inspect-brk-extensions"],T["extensions-dir"]=L["extensions-dir"]),T.isInitialStartup=!1,T.policiesData=this.N.serialize(),T.continueOn=this.M.continueOn,T.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile},this.load(T,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async qb(L){if((0,N.isWorkspaceIdentifier)(L.workspace)){const T=L.workspace.configPath;if(T.scheme===w.Schemas.file&&!await this.P.exists(T))return}else if((0,N.isSingleFolderWorkspaceIdentifier)(L.workspace)){const T=L.workspace.uri;if(T.scheme===w.Schemas.file&&!await this.P.exists(T))return}return L.workspace}serializeWindowState(){if(!this.k)return(0,G.defaultWindowState)();if(this.isFullScreen){let U;try{U=E.screen.getDisplayMatching(this.getBounds())}catch{}const Q=(0,G.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.n.width||Q.width,height:this.n.height||Q.height,x:this.n.x||0,y:this.n.y||0}}const L=Object.create(null);let T;if(!I.isMacintosh&&this.k.isMaximized()?T=0:T=1,T===0?L.mode=0:L.mode=1,T===1||T===0){let U;T===1?U=this.getBounds():U=this.k.getNormalBounds(),L.x=U.x,L.y=U.y,L.width=U.width,L.height=U.height}return L}updateWindowControls(L){if(L.height&&this.gb.setItem(Ft.a,L.height),I.isWindows&&this.w)this.k.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(I.isMacintosh&&L.height!==void 0){const T=(L.height-15)/2;this.k.setTrafficLightPosition({x:T,y:T})}}rb(L){(0,k.mark)("code/willRestoreCodeWindowState");let T=!1;if(L)try{const U=E.screen.getAllDisplays();T=U.length>1,L=this.sb(L,U)}catch(U){this.L.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,k.mark)("code/didRestoreCodeWindowState"),[L||(0,G.defaultWindowState)(),T]}sb(L,T){if(this.L.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const B=this.tb(T[0]);if(B){let H=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!B||(L.x<B.x&&(L.x=B.x),L.y<B.y&&(L.y=B.y))};this.L.trace("window#validateWindowState: 1 monitor working area",B),H(),L.width>B.width&&(L.width=B.width),L.height>B.height&&(L.height=B.height),L.x>B.x+B.width-128&&(L.x=B.x+B.width-L.width),L.y>B.y+B.height-128&&(L.y=B.y+B.height-L.height),H()}return L}if(L.display&&L.mode===3){const B=T.find(H=>H.id===L.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const H=(0,G.defaultWindowState)(3);return H.x=B.bounds.x,H.y=B.bounds.y,H}}let U,Q;try{U=E.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),Q=this.tb(U)}catch{}if(U&&Q&&L.x+L.width>Q.x&&L.y+L.height>Q.y&&L.x<Q.x+Q.width&&L.y<Q.y+Q.height)return this.L.trace("window#validateWindowState: multi-monitor working area",Q),L}tb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,T]=this.k.getPosition(),[U,Q]=this.k.getSize();return{x:L,y:T,width:U,height:Q}}toggleFullScreen(){this.ub(!this.isFullScreen)}ub(L){this.yb()?this.vb(L):this.xb(L),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",C.CancellationToken.None),this.r&&this.Bb(this.r,!1)}get isFullScreen(){return I.isMacintosh&&typeof this.s=="boolean"?this.s:this.k.isFullScreen()||this.k.isSimpleFullScreen()}vb(L){this.k.isSimpleFullScreen()&&this.k.setSimpleFullScreen(!1),this.wb(L)}wb(L){I.isMacintosh&&(this.s=L,this.t=new t.DeferredPromise,Promise.race([this.t.p,(0,t.timeout)(1e3)]).finally(()=>this.s=void 0)),this.k.setFullScreen(L)}xb(L){this.k.isFullScreen()&&this.wb(!1),this.k.setSimpleFullScreen(L),this.k.webContents.focus()}yb(){const L=this.S.getValue("window");return!L||typeof L.nativeFullScreen!="boolean"||L.nativeTabs?!0:L.nativeFullScreen!==!1}isMinimized(){return this.k.isMinimized()}Ab(){let L=(0,D.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Bb(L,T=!0){I.isMacintosh||(L==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,p.localize)(12,null)),L==="hidden"?setTimeout(()=>{this.Cb(L)}):this.Cb(L))}Cb(L){const T=this.isFullScreen;switch(L){case"classic":this.k.setMenuBarVisibility(!T),this.k.autoHideMenuBar=T;break;case"visible":this.k.setMenuBarVisibility(!0),this.k.autoHideMenuBar=!1;break;case"toggle":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!0;break;case"hidden":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.k.minimize();break;case"None":break;case"Maximize":default:this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}else this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}close(){this.k?.close()}sendWhenReady(L,T,...U){this.isReady?this.send(L,...U):this.ready().then(()=>{T.isCancellationRequested||this.send(L,...U)})}send(L,...T){if(this.k){if(this.k.isDestroyed()||this.k.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.k.webContents.send(L,...T)}catch(U){this.L.warn(`Error sending IPC message to channel '${L}' of window ${this.j}: ${(0,M.toErrorMessage)(U)}`)}}}updateTouchBar(L){!I.isMacintosh||this.D.forEach((T,U)=>{const Q=L[U];T.segments=this.Fb(Q)})}Db(){if(!!I.isMacintosh){for(let L=0;L<10;L++){const T=this.Eb();this.D.push(T)}this.k.setTouchBar(new E.TouchBar({items:this.D}))}}Eb(L=[]){const T=this.Fb(L),U=new E.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:Q=>{this.sendWhenReady("vscode:runAction",C.CancellationToken.None,{id:U.segments[Q].id,from:"touchbar"})}});return U}Fb(L=[]){return L.map(U=>{let Q;U.icon&&!o.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===w.Schemas.file&&(Q=E.nativeImage.createFromPath(f.URI.revive(U.icon.dark).fsPath),Q.isEmpty()&&(Q=void 0));let B;return typeof U.title=="string"?B=U.title:B=U.title.value,{id:U.id,label:Q?void 0:B,icon:Q}})}dispose(){super.dispose(),this.k=null}};le.a="windowControlHeight",le=pe([te(1,n.ILogService),te(2,v.IEnvironmentMainService),te(3,se.IPolicyService),te(4,de.IUserDataProfilesMainService),te(5,u.IFileService),te(6,s.IApplicationStorageMainService),te(7,s.IStorageMainService),te(8,b.IConfigurationService),te(9,y.IThemeMainService),te(10,Y.IWorkspacesManagementMainService),te(11,g.IBackupMainService),te(12,l.ITelemetryService),te(13,h.IDialogMainService),te(14,c.ILifecycleMainService),te(15,r.IProductService),te(16,i.IProtocolMainService),te(17,O.IWindowsMainService),te(18,oe.IStateMainService)],le),e.CodeWindow=le}),define(ee[75],ie([0,1,13,24,8,3,33,2,14,4,20,7,23,173,5,21,6,92,93,28,52,39]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,p.createDecorator)("workspacesHistoryMainService");let n=class rt extends P.Disposable{constructor(i,a,s,l){super(),this.f=i,this.g=a,this.h=s,this.j=l,this.c=this.B(new M.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.C=this.B(new C.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.D()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let a=[],s=[];for(const o of i)if((0,v.isRecentWorkspace)(o))!this.g.isUntitledWorkspace(o.workspace)&&!this.r(a,o.workspace)&&a.push(o);else if((0,v.isRecentFolder)(o))this.s(a,o.folderUri)||a.push(o);else{const y=this.t(s,o.fileUri),D=o.fileUri.scheme===m.Schemas.file&&rt.y.indexOf((0,S.basename)(o.fileUri))>=0;!y&&!D&&(s.push(o),w.isWindows&&o.fileUri.scheme===m.Schemas.file&&E.app.addRecentDocument(o.fileUri.fsPath))}const l=await this.l({workspaces:a,files:s});a=l.workspaces,s=l.files,a.length>rt.a&&(a.length=rt.a),s.length>rt.a&&(s.length=rt.a),await this.n({workspaces:a,files:s}),this.c.fire(),w.isMacintosh&&this.C.trigger(()=>this.I())}async removeRecentlyOpened(i){const a=y=>{const D=this.p(y);for(const O of i)if(S.extUriBiasedIgnorePathCase.isEqual(O,D))return!1;return!0},s=await this.getRecentlyOpened(),l=s.workspaces.filter(a),o=s.files.filter(a);(l.length!==s.workspaces.length||o.length!==s.files.length)&&(await this.n({files:o,workspaces:l}),this.c.fire(),w.isMacintosh&&this.C.trigger(()=>this.I()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const a=new c.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.workspaces)for(const o of i.workspaces)a.set(this.p(o),o);const s=new c.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.files)for(const o of i.files)s.set(this.p(o),o);const l=await this.m();for(const o of l.workspaces){const y=a.get(this.p(o));y?y.label=y.label??o.label:a.set(this.p(o),o)}for(const o of l.files){const y=s.get(this.p(o));y?y.label=y.label??o.label:s.set(this.p(o),o)}return{workspaces:[...a.values()],files:[...s.values()]}}async m(){await this.j.whenReady;let i;const a=this.j.get(rt.b,-1);if(typeof a=="string")try{i=JSON.parse(a)}catch(s){this.f.error("Unexpected error parsing opened paths list",s)}return(0,v.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,v.toStoreData)(i)),-1,1)}p(i){return(0,v.isRecentFolder)(i)?i.folderUri:(0,v.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,a){return!!i.find(s=>(0,v.isRecentWorkspace)(s)&&s.workspace.id===a.id)}s(i,a){return!!i.find(s=>(0,v.isRecentFolder)(s)&&S.extUriBiasedIgnorePathCase.isEqual(s.folderUri,a))}t(i,a){return!!i.find(s=>S.extUriBiasedIgnorePathCase.isEqual(s.fileUri,a))}async D(){!w.isWindows||(await this.F(),this.B(this.onDidChangeRecentlyOpened(()=>this.F())))}async F(){if(!w.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const o of E.app.getJumpListSettings().removedItems){const y=o.args;if(y){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(y);D&&a.push(k.URI.parse(D[2]))}}await this.removeRecentlyOpened(a);let s=!1;const l=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(o=>{const y=(0,v.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:D,description:O}=this.G(y,o.label);let N;return k.URI.isUri(y)?N=`--folder-uri "${y.toString()}"`:(s=!0,N=`--file-uri "${y.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:O.substr(0,255),program:process.execPath,args:N,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&i.push({type:"custom",name:s?(0,f.localize)(2,null):(0,f.localize)(3,null),items:l})}i.push({type:"recent"});try{const a=E.app.setJumpList(i);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}G(i,a){if(a)return{title:(0,A.splitName)(a).name,description:a};if(k.URI.isUri(i))return{title:(0,S.basename)(i),description:this.H(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let s=(0,S.basename)(i.configPath);return s.endsWith(d.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-d.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,s),description:this.H(i.configPath)}}H(i){return i.scheme==="file"?(0,A.normalizeDriveLetter)(i.fsPath):i.toString()}async I(){if(!w.isMacintosh)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),a=[];let s=0;for(let o=0;o<i.workspaces.length&&s<rt.u;o++){const y=this.p(i.workspaces[o]);if(y.scheme===m.Schemas.file){const D=(0,S.originalFSPath)(y);await I.Promises.exists(D)&&(a.push(D),s++)}}const l=[];for(let o=0;o<i.files.length&&s<rt.v;o++){const y=this.p(i.files[o]);if(y.scheme===m.Schemas.file){const D=(0,S.originalFSPath)(y);if(rt.y.includes((0,S.basename)(y))||a.includes(D))continue;await I.Promises.exists(D)&&(l.push(D),s++)}}l.reverse().forEach(o=>E.app.addRecentDocument(o)),a.reverse().forEach(o=>E.app.addRecentDocument(o))}};n.a=500,n.b="history.recentlyOpenedPathsList",n.u=7,n.v=10,n.w=7,n.y=["COMMIT_EDITMSG","MERGE_MSG"],n=pe([te(0,b.ILogService),te(1,u.IWorkspacesManagementMainService),te(2,g.ILifecycleMainService),te(3,h.IApplicationStorageMainService)],n),e.WorkspacesHistoryMainService=n}),define(ee[268],ie([0,1,13,8,22,33,4,7,163,18,26,21,6,211,65,19,37,35,48,74,31,75]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let r=class Wt{constructor(s,l,o,y,D,O,N,Y,G,V,se){this.n=s,this.o=l,this.p=o,this.q=y,this.r=D,this.s=O,this.t=N,this.u=Y,this.v=G,this.w=V,this.x=se,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.F(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.isMacintosh||(0,d.getTitleBarStyle)(this.o)==="native")&&this.y(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}y(){const s=this.t.getItem(Wt.a);s&&(s.menus&&(this.k=s.menus),s.keybindings&&(this.l=s.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(O,N,Y)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.newWindow"]=(O,N,Y)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.files.openFileFolder"]=(O,N,Y)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.Q(Y),telemetryExtraData:{from:n}}),this.m["workbench.action.files.openFolder"]=(O,N,Y)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.Q(Y),telemetryExtraData:{from:n}}),this.m["workbench.action.openWorkspace"]=(O,N,Y)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.Q(Y),telemetryExtraData:{from:n}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const s=this.x.twitterUrl;s&&(this.m["workbench.action.openTwitterUrl"]=()=>this.bb(s,"openTwitterUrl"));const l=this.x.requestFeatureUrl;l&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.bb(l,"openUserVoiceUrl"));const o=this.x.reportIssueUrl;o&&(this.m["workbench.action.openIssueReporter"]=()=>this.bb(o,"openReportIssues"));const y=this.x.licenseUrl;y&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.language){const O=y.indexOf("?")>0?"&":"?";this.bb(`${y}${O}lang=${A.language}`,"openLicenseUrl")}else this.bb(y,"openLicenseUrl")});const D=this.x.privacyStatementUrl;D&&y&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.bb(D,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(s=>this.G(s)),this.w.onDidBlurWindow(()=>this.H()),this.w.onDidFocusWindow(()=>this.H())}get C(){const s=this.o.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get D(){if(!A.isMacintosh)return!1;const s=this.o.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,l){this.k=s.menus,this.l=s.keybindings,this.t.setItem(Wt.a,s),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(s){!A.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.d=s.newCount===0,this.E())}H(){!A.isMacintosh||(this.f=!E.BrowserWindow.getFocusedWindow(),this.E())}I(){const s=E.Menu.getApplicationMenu();if(s&&this.j.push(s),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(A.isMacintosh?new E.Menu:null);return}const l=new E.Menu;let o;if(A.isMacintosh){const D=new E.Menu;o=new E.MenuItem({label:this.x.nameShort,submenu:D}),this.J(D),l.append(o)}if(A.isMacintosh&&!this.c){this.c=!0;const D=new E.Menu;D.append(new E.MenuItem({label:this.db(m.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(D)}if(this.L("File")){const D=new E.Menu,O=new E.MenuItem({label:this.db(m.localize(1,null)),submenu:D});this.N(D,"File"),l.append(O)}if(this.L("Edit")){const D=new E.Menu,O=new E.MenuItem({label:this.db(m.localize(2,null)),submenu:D});this.N(D,"Edit"),l.append(O)}if(this.L("Selection")){const D=new E.Menu,O=new E.MenuItem({label:this.db(m.localize(3,null)),submenu:D});this.N(D,"Selection"),l.append(O)}if(this.L("View")){const D=new E.Menu,O=new E.MenuItem({label:this.db(m.localize(4,null)),submenu:D});this.N(D,"View"),l.append(O)}if(this.L("Go")){const D=new E.Menu,O=new E.MenuItem({label:this.db(m.localize(5,null)),submenu:D});this.N(D,"Go"),l.append(O)}if(this.L("Run")){const D=new E.Menu,O=new E.MenuItem({label:this.db(m.localize(6,null)),submenu:D});this.N(D,"Run"),l.append(O)}if(this.L("Terminal")){const D=new E.Menu,O=new E.MenuItem({label:this.db(m.localize(7,null)),submenu:D});this.N(D,"Terminal"),l.append(O)}let y;if(this.L("Window")){const D=new E.Menu;y=new E.MenuItem({label:this.db(m.localize(8,null)),submenu:D,role:"window"}),this.T(D)}if(y&&l.append(y),this.L("Help")){const D=new E.Menu,O=new E.MenuItem({label:this.db(m.localize(9,null)),submenu:D,role:"help"});this.N(D,"Help"),l.append(O)}l.items&&l.items.length>0?E.Menu.setApplicationMenu(l):E.Menu.setApplicationMenu(null),this.h.schedule()}J(s){const l=this.V(m.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),o=this.U();let y;if(this.L("Preferences")){const oe=new E.Menu;this.N(oe,"Preferences"),y=new E.MenuItem({label:this.db(m.localize(11,null)),submenu:oe})}const D=new E.Menu,O=new E.MenuItem({label:m.localize(12,null),role:"services",submenu:D}),N=new E.MenuItem({label:m.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),Y=new E.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new E.MenuItem({label:m.localize(15,null),role:"unhide"}),V=new E.MenuItem(this.ab("workbench.action.quit",{label:m.localize(16,null,this.x.nameLong),click:async(oe,re,de)=>{const X=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||X?.isMinimized())&&await this.K(de)&&this.w.quit(void 0)}})),se=[l];se.push(...o),y&&se.push(i(),y),se.push(i(),O,i(),N,Y,G,i(),V),se.forEach(oe=>s.append(oe))}async K(s){if(this.p.getWindowCount()===0)return!0;const l=this.o.getValue("window.confirmBeforeClose");if(l==="always"||l==="keyboardOnly"&&this.R(s)){const o={title:this.x.nameLong,type:"question",buttons:[(0,M.mnemonicButtonLabel)(m.localize(17,null)),(0,M.mnemonicButtonLabel)(m.localize(18,null))],message:m.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:y}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,o);return y===0}return!0}L(s){if(!A.isMacintosh&&(0,d.getTitleBarStyle)(this.o)==="custom")return!1;switch(s){case"File":case"Help":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[s];case"Window":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[s]}}M(s,l){l.forEach(o=>{if((0,f.isMenubarMenuItemSeparator)(o))s.append(i());else if((0,f.isMenubarMenuItemSubmenu)(o)){const y=new E.Menu,D=new E.MenuItem({label:this.db(o.label),submenu:y});this.M(y,o.submenu.items),s.append(D)}else(0,f.isMenubarMenuItemRecentAction)(o)?s.append(this.P(o)):(0,f.isMenubarMenuItemAction)(o)&&(o.id==="workbench.action.showAboutDialog"&&this.O(s),A.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[o.id]?s.append(new E.MenuItem(this.ab(o.id,{label:this.db(o.label),click:this.m[o.id]}))):s.append(this.V(o.label,o.id,!1,o.checked)):s.append(this.V(o.label,o.id,o.enabled!==!1,!!o.checked)):s.append(this.V(o.label,o.id,o.enabled!==!1,!!o.checked)))})}N(s,l){this.k&&this.k[l]&&this.M(s,this.k[l].items)}O(s){const l=this.U();l.length&&(l.forEach(o=>s.append(o)),s.append(i()))}P(s){const l=P.URI.revive(s.uri),o=s.id,y=o==="openRecentFile"?{fileUri:l}:o==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new E.MenuItem(this.ab(o,{label:s.label,click:async(D,O,N)=>{const Y=this.Q(N);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[y],forceNewWindow:Y,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([l])}},!1))}Q(s){return!!(s&&(!A.isMacintosh&&(s.ctrlKey||s.shiftKey)||A.isMacintosh&&(s.metaKey||s.altKey)))}R(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}S(s,l,o){const y={label:this.db(s),role:o,enabled:!0};return new E.MenuItem(this.Y(l,y))}T(s){const l=new E.MenuItem({label:m.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),o=new E.MenuItem({label:m.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),y=new E.MenuItem({label:m.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),D=this.V(m.localize(23,null),"workbench.action.switchWindow"),O=[];this.D&&(O.push(i()),O.push(this.V(m.localize(24,null),"workbench.action.newWindowTab")),O.push(this.S(m.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),O.push(this.S(m.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),O.push(this.S(m.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),O.push(this.S(m.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,o,i(),D,...O,i(),y].forEach(N=>s.append(N))}U(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.db(m.localize(29,null)),click:()=>setTimeout(()=>{this.cb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:m.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.db(m.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:m.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.db(m.localize(33,null)),click:()=>{this.cb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:m.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.db(m.localize(35,null)),click:()=>{this.cb("RestartToUpdate"),this.n.quitAndInstall()}})]}}V(s,l,o,y){const D=this.db(s),O=typeof l=="function"?l:(se,oe,re)=>{const de=se?se.userSettingsLabel:null;let X=l;Array.isArray(l)&&(X=this.Q(re)?l[1]:l[0]),de&&re.triggeredByAccelerator?this.X({type:"keybinding",userSettingsLabel:de}):this.X({type:"commandId",commandId:X})},N=typeof o=="boolean"?o:this.p.getWindowCount()>0,Y=typeof y=="boolean"?y:!1,G={label:D,click:O,enabled:N};Y&&(G.type="checkbox",G.checked=Y);let V;return typeof l=="string"?V=l:Array.isArray(l)&&(V=l[0]),A.isMacintosh&&(V==="editor.action.clipboardCutAction"?G.role="cut":V==="editor.action.clipboardCopyAction"?G.role="copy":V==="editor.action.clipboardPasteAction"&&(G.role="paste"),V==="undo"?G.click=this.W(O,{inDevTools:se=>se.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):V==="redo"?G.click=this.W(O,{inDevTools:se=>se.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):V==="editor.action.selectAll"&&(G.click=this.W(O,{inDevTools:se=>se.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.Y(V,G))}W(s,l){return(o,y,D)=>{const O=E.BrowserWindow.getFocusedWindow();if(!O)return l.inNoWindow();if(O.webContents.isDevToolsFocused()&&O.webContents.devToolsWebContents)return l.inDevTools(O.webContents.devToolsWebContents);s(o,y||O,D)}}X(s){let l=E.BrowserWindow.getFocusedWindow();if(!l){const y=this.p.getLastActiveWindow();y?.isMinimized()&&(l=y.win)}const o=l?this.p.getWindowById(l.id):void 0;if(o){if(this.v.trace("menubar#runActionInRenderer",s),A.isMacintosh&&!this.q.isBuilt&&!o.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const y={id:s.commandId,from:"menu"};o.sendWhenReady("vscode:runAction",C.CancellationToken.None,y)}else{const y={userSettingsLabel:s.userSettingsLabel};o.sendWhenReady("vscode:runKeybinding",C.CancellationToken.None,y)}}else this.v.trace("menubar#runActionInRenderer: no active window found",s)}Y(s,l){const o=typeof s=="string"?this.l[s]:void 0;if(o?.label){if(o.isNative!==!1)l.accelerator=o.label,l.userSettingsLabel=o.userSettingsLabel;else if(typeof l.label=="string"){const y=l.label.indexOf("[");y>=0?l.label=`${l.label.substr(0,y)} [${o.label}]`:l.label=`${l.label} [${o.label}]`}}else l.accelerator=void 0;return l}ab(s,l,o=!l.accelerator){o&&(l=this.Y(s,l));const y=l.click;return l.click=(D,O,N)=>{this.cb(s),y?.(D,O,N)},l}bb(s,l){this.w.openExternal(void 0,s),this.cb(l)}cb(s){this.r.publicLog2("workbenchActionExecuted",{id:s,from:n})}db(s){return(0,M.mnemonicMenuLabel)(s,!this.C)}};r.a="lastKnownMenubarData",r=pe([te(0,v.IUpdateService),te(1,w.IConfigurationService),te(2,u.IWindowsMainService),te(3,S.IEnvironmentMainService),te(4,h.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,b.IStateMainService),te(7,k.ILifecycleMainService),te(8,I.ILogService),te(9,p.INativeHostMainService),te(10,g.IProductService)],r),e.Menubar=r;function i(){return new E.MenuItem({type:"separator"})}}),define(ee[269],ie([0,1,5,21,6,268]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let A=class{constructor(m,w,S){this.b=m,this.c=w,this.d=S,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.Menubar)}async updateMenubar(m,w){this.d.trace("menubarService#updateMenubar",m),(await this.a).updateMenu(w,m)}};A=pe([te(0,E.IInstantiationService),te(1,t.ILifecycleMainService),te(2,C.ILogService)],A),e.MenubarMainService=A}),define(ee[270],ie([0,1,13,23,27,24,22,3,30,49,33,2,14,9,72,4,32,20,12,7,171,60,18,56,26,16,5,21,6,54,19,61,63,37,74,267,117,262,28,94,75,52,64,36,51]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c,n,r,i,a,s,l,o,y,D,O,N,Y,G,V,se,oe,re,de,X,le,F,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function U(H){return(0,re.isWorkspaceIdentifier)(H?.workspace)}function Q(H){return(0,re.isSingleFolderWorkspaceIdentifier)(H?.workspace)}let B=class dt extends k.Disposable{constructor(R,W,$,z,J,ne,j,x,_,ae,ge,Me,Oe,De,Re,ve,we,be){super(),this.k=R,this.l=W,this.m=$,this.n=z,this.r=J,this.s=ne,this.t=j,this.u=x,this.v=_,this.w=ae,this.C=ge,this.D=Me,this.F=Oe,this.G=De,this.H=Re,this.I=ve,this.J=we,this.L=be,this.b=this.B(new P.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new P.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new P.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new P.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new oe.WindowsStateHandler(this,this.n,this.u,this.m,this.w)),this.M()}M(){this.B(this.D.onDidEnterWorkspace(R=>this.c.fire(R.window))),this.B(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const W=new k.DisposableStore;if(W.add(P.Event.any(R.onDidClose,R.onDidDestroy)(()=>W.dispose())),R.config.extensionDevelopmentPath)for(const $ of R.config.extensionDevelopmentPath)W.add(this.J.addValidFileRoot($));R.config.extensionTestsPath&&W.add(this.J.addValidFileRoot(R.config.extensionTestsPath))}}))}openEmptyWindow(R,W){const $=this.s.args,z=W?.remoteAuthority||void 0,J=!0,ne=W?.forceReuseWindow,j=!ne;return this.open({...R,cli:$,forceEmpty:J,forceNewWindow:j,forceReuseWindow:ne,remoteAuthority:z})}openExistingWindow(R,W){R.focus(),this.N(W,[R])}async open(R){this.m.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const W=[],$=[],z=[],J=[],ne=[];let j,x=0;const _=await this.U(R);this.m.trace("windowsManager#open pathsToOpen",_);for(const De of _)Q(De)?R.addMode?W.push(De):$.push(De):U(De)?z.push(De):De.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),j.filesToOpenOrCreate.push(De)):De.backupPath?ne.push({backupFolder:(0,f.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):x++;R.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),R.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&R.waitMarkerFileURI&&(j.filesToWait={paths:(0,M.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(J.push(...this.D.getUntitledWorkspaces()),z.push(...J),ne.push(...this.v.getEmptyWindowBackups())):ne.length=0;const{windows:ae,filesOpenedInWindow:ge}=await this.O(R,z,$,ne,x,j,W);if(this.m.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${$.length}, emptyToRestore: ${ne.length}, emptyToOpen: ${x})`),ae.length>1)if(ge)ge.focus();else{const De=this.j.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let Re=!0,ve=!0;if(De){const we=ae.filter(be=>this.j.state.lastActiveWindow&&be.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Re=!1,ve=!1)}if(Re)for(let we=ae.length-1;we>=0;we--){const be=ae[we];if(!(be.openedWorkspace&&J.some(Ce=>be.openedWorkspace&&Ce.workspace.id===be.openedWorkspace.id)||be.backupPath&&ne.some(Ce=>be.backupPath&&Ce.backupFolder===(0,f.basename)(be.backupPath)))){be.focus(),ve=!1;break}}ve&&ae[ae.length-1].focus()}const Me=j&&j.filesToDiff.length>0,Oe=j&&j.filesToMerge.length>0;if(!ae.some(De=>De.isExtensionDevelopmentHost)&&!Me&&!Oe&&!R.noRecentEntry){const De=[];for(const Re of _)U(Re)&&!Re.transient?De.push({label:Re.label,workspace:Re.workspace,remoteAuthority:Re.remoteAuthority}):Q(Re)?De.push({label:Re.label,folderUri:Re.workspace.uri,remoteAuthority:Re.remoteAuthority}):Re.fileUri&&De.push({label:Re.label,fileUri:Re.fileUri,remoteAuthority:Re.remoteAuthority});this.C.addRecentlyOpened(De)}return this.N(R,ae),ae}N(R,W){const $=R.waitMarkerFileURI;R.context===0&&$&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.H.del($)}catch{}})()}async O(R,W,$,z,J,ne,j){const x=[];let _;function ae(we,be){x.push(we),be&&(_=we,ne=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Me}=this.hb(R);if(!R.initialStartup&&j.length>0){const we=j[0].remoteAuthority,be=this.mb(we);be&&ae(this.Q(be,j.map(Ce=>Ce.workspace.uri)))}const Oe=$.length+W.length+z.length;if(ne&&Oe===0){const we=ne.filesToOpenOrCreate[0]||ne.filesToDiff[0]||ne.filesToMerge[3],be=this.getWindows().filter(Z=>ne&&(0,h.isEqualAuthority)(Z.remoteAuthority,ne.remoteAuthority));let Ce;we?.fileUri&&!Me&&((R.context===4||R.context===0||R.context===1)&&(Ce=await(0,se.findWindowOnFile)(be,we.fileUri,async Z=>Z.configPath.scheme===I.Schemas.file?this.D.resolveLocalWorkspace(Z.configPath):void 0)),Ce||(Ce=this.nb(be))),Ce?(0,re.isWorkspaceIdentifier)(Ce.openedWorkspace)?W.push({workspace:Ce.openedWorkspace,remoteAuthority:Ce.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(Ce.openedWorkspace)?$.push({workspace:Ce.openedWorkspace,remoteAuthority:Ce.remoteAuthority}):ae(this.P(R,Ce,ne),!0):ae(await this.ib({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:ne,forceNewWindow:!0,remoteAuthority:ne.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile}),!0)}const De=(0,M.distinct)(W,we=>we.workspace.id);if(De.length>0){const we=(0,M.coalesce)(De.map(be=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),be.workspace.configPath)));if(we.length>0){const be=we[0],Ce=(0,h.isEqualAuthority)(ne?.remoteAuthority,be.remoteAuthority)?ne:void 0;ae(this.P(R,be,Ce),!!Ce),ge=!0}for(const be of De){if(we.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===be.workspace.id))continue;const Ce=be.remoteAuthority,Z=(0,h.isEqualAuthority)(ne?.remoteAuthority,Ce)?ne:void 0;ae(await this.S(R,be,ge,Z),!!Z),ge=!0}}const Re=(0,M.distinct)($,we=>h.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Re.length>0){const we=(0,M.coalesce)(Re.map(be=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),be.workspace.uri)));if(we.length>0){const be=we[0],Ce=(0,h.isEqualAuthority)(ne?.remoteAuthority,be.remoteAuthority)?ne:void 0;ae(this.P(R,be,Ce),!!Ce),ge=!0}for(const be of Re){if(we.some(ue=>(0,re.isSingleFolderWorkspaceIdentifier)(ue.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(ue.openedWorkspace.uri,be.workspace.uri)))continue;const Ce=be.remoteAuthority,Z=(0,h.isEqualAuthority)(ne?.remoteAuthority,Ce)?ne:void 0;ae(await this.S(R,be,ge,Z),!!Z),ge=!0}}const ve=(0,M.distinct)(z,we=>we.backupFolder);if(ve.length>0)for(const we of ve){const be=we.remoteAuthority,Ce=(0,h.isEqualAuthority)(ne?.remoteAuthority,be)?ne:void 0;ae(await this.R(R,!0,be,Ce,we),!!Ce),ge=!0}if(x.length===0||ne){ne&&!J&&J++;const we=ne?ne.remoteAuthority:R.remoteAuthority;for(let be=0;be<J;be++)ae(await this.R(R,ge,we,ne),!!ne),ge=!0}return{windows:(0,M.distinct)(x),filesOpenedInWindow:_}}P(R,W,$){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:$}),W.focus();const z={filesToOpenOrCreate:$?.filesToOpenOrCreate,filesToDiff:$?.filesToDiff,filesToMerge:$?.filesToMerge,filesToWait:$?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",A.CancellationToken.None,z),W}Q(R,W){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),R.focus();const $={foldersToAdd:W};return R.sendWhenReady("vscode:addFolders",A.CancellationToken.None,$),R}R(R,W,$,z,J){this.m.trace("windowsManager#doOpenEmpty",{restore:!!J,remoteAuthority:$,filesToOpen:z,forceNewWindow:W});let ne;return!W&&typeof R.contextWindowId=="number"&&(ne=this.getWindowById(R.contextWindowId)),this.ib({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:$,forceNewWindow:W,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:z,windowToUse:ne,emptyWindowBackupInfo:J,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}S(R,W,$,z,J){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:z}),!$&&!J&&typeof R.contextWindowId=="number"&&(J=this.getWindowById(R.contextWindowId)),this.ib({workspace:W.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:$,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:z,windowToUse:J,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}async U(R){let W,$=!1,z=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(W=await this.W(R),$=!0):R.forceEmpty?W=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(W=await this.X(R.cli),W.length===0&&W.push(Object.create(null)),$=!0):(W=await this.ab(),W.length===0&&W.push(Object.create(null)),z=!0),!R.addMode&&$){const J=W.filter(ne=>Q(ne));if(J.length>1){const ne=J[0].remoteAuthority;if(J.every(j=>(0,h.isEqualAuthority)(j.remoteAuthority,ne))){const j=await this.D.createUntitledWorkspace(J.map(x=>({uri:x.workspace.uri})));W.push({workspace:j,remoteAuthority:ne}),W=W.filter(x=>!Q(x))}}}if(R.initialStartup&&!z&&this.w.getValue("window")?.restoreWindows==="preserve"){const J=await this.ab();W.unshift(...J.filter(ne=>U(ne)||Q(ne)||ne.backupPath))}return W}async W(R){const W={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority},$=await Promise.all((0,M.coalesce)(R.urisToOpen||[]).map(async z=>{const J=await this.cb(z,W);if(J)return J.label=z.label,J;const ne=this.eb(z),j={title:this.I.nameLong,type:"info",buttons:[(0,S.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:ne.scheme===I.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:ne.scheme===I.Schemas.file?(0,u.localize)(3,null,(0,S.getPathLabel)(ne,{os:g.OS,tildify:this.s})):(0,u.localize)(4,null,ne.toString(!0)),noLink:!0};this.G.showMessageBox(j,(0,v.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,M.coalesce)($)}async X(R){const W=[],$={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:R.diff&&R._.length===2||R.merge&&R._.length===4},z=R["folder-uri"];if(z){const j=await Promise.all(z.map(x=>{const _=this.Y(x);if(!!_)return this.cb({folderUri:_},$)}));W.push(...(0,M.coalesce)(j))}const J=R["file-uri"];if(J){const j=await Promise.all(J.map(x=>{const _=this.Y(x);if(!!_)return this.cb((0,re.hasWorkspaceFileExtension)(x)?{workspaceUri:_}:{fileUri:_},$)}));W.push(...(0,M.coalesce)(j))}const ne=await Promise.all(R._.map(j=>$.remoteAuthority?this.gb(j,$):this.fb(j,$)));return W.push(...(0,M.coalesce)(ne)),W}Y(R){try{const W=d.URI.parse(R);if(!W.scheme){this.m.error(`Invalid URI input string, scheme missing: ${R}`);return}return W}catch(W){this.m.error(`Invalid URI input string: ${R}, ${W.message}`)}}async ab(){const R=this.bb();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];R!=="one"&&W.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&W.push(this.j.state.lastActiveWindow);const $=await Promise.all(W.map(async z=>{if(z.workspace){const J=await this.cb({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(U(J))return J}else if(z.folderUri){const J=await this.cb({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(Q(J))return J}else if(R!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,M.coalesce)($)}}}bb(){let R;return this.u.wasRestarted?R="all":(R=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}async cb(R,W=Object.create(null)){const $=this.eb(R);return $.scheme===I.Schemas.file?((0,G.isFileToOpen)(R)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.fb($.fsPath,W)):this.db(R,W)}db(R,W){let $=this.eb(R);const z=(0,N.getRemoteAuthority)($)||W.remoteAuthority;if($=(0,h.removeTrailingPathSeparator)((0,h.normalizePath)($)),(0,G.isFileToOpen)(R)){if(W.gotoLineMode){const{path:J,line:ne,column:j}=(0,m.parseLineAndColumnAware)($.path);return{fileUri:$.with({path:J}),options:{selection:ne?{startLineNumber:ne,startColumn:j||1}:void 0},remoteAuthority:z}}return{fileUri:$,remoteAuthority:z}}else if((0,G.isWorkspaceToOpen)(R))return{workspace:(0,de.getWorkspaceIdentifier)($),remoteAuthority:z};return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:z}}eb(R){return(0,G.isWorkspaceToOpen)(R)?R.workspaceUri:(0,G.isFolderToOpen)(R)?R.folderUri:R.fileUri}async fb(R,W){let $,z;W.gotoLineMode&&({path:R,line:$,column:z}=(0,m.parseLineAndColumnAware)(R)),R=(0,m.sanitizeFilePath)((0,f.normalize)(R),(0,b.cwd)());try{const J=await t.Promises.stat(R);if(J.isFile()){if(!W.forceOpenWorkspaceAsFile){const ne=await this.D.resolveLocalWorkspace(d.URI.file(R));if(ne)return ne.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:a.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:d.URI.file(R),type:a.FileType.File,exists:!0,options:{selection:$?{startLineNumber:$,startColumn:z||1}:void 0}}}else{if(J.isDirectory())return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(d.URI.file(R),J),type:a.FileType.Directory,exists:!0};if(!g.isWindows&&R==="/dev/null")return{fileUri:d.URI.file(R),type:a.FileType.File,exists:!0}}}catch{const ne=d.URI.file(R);if(this.C.removeRecentlyOpened([ne]),W.ignoreFileNotFound)return{fileUri:ne,type:a.FileType.File,exists:!1}}}gb(R,W){const $=R.charCodeAt(0),z=W.remoteAuthority;let J,ne;W.gotoLineMode&&({path:R,line:J,column:ne}=(0,m.parseLineAndColumnAware)(R)),$!==47&&((0,m.isWindowsDriveLetter)($)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,m.toSlashes)(R)),R=`/${R}`);const j=d.URI.from({scheme:I.Schemas.vscodeRemote,authority:z,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,re.hasWorkspaceFileExtension)(R))return W.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:J?{startLineNumber:J,startColumn:ne||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,de.getWorkspaceIdentifier)(j),remoteAuthority:z};if(W.gotoLineMode||f.posix.basename(R).indexOf(".")!==-1)return{fileUri:j,options:{selection:J?{startLineNumber:J,startColumn:ne||1}:void 0},remoteAuthority:z}}return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:z}}hb(R){const W=this.w.getValue("window"),$=W?.openFoldersInNewWindow||"default",z=W?.openFilesInNewWindow||"off";let J=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&($==="on"||$==="off")&&(J=$==="on");let ne=!1;return R.forceNewWindow||R.forceReuseWindow?ne=!!R.forceNewWindow&&!R.forceReuseWindow:(g.isMacintosh?R.context===1&&(ne=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(ne=!0),!R.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(ne=z==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:ne}}async openExtensionDevelopmentHostWindow(R,W){const $=(0,se.findWindowOnExtensionDevelopmentPath)(this.getWindows(),R);if($)return this.u.reload($,W.cli),$.focus(),[$];let z=W.cli["folder-uri"]||[],J=W.cli["file-uri"]||[],ne=W.cli._;if(!ne.length&&!z.length&&!J.length&&!W.cli.extensionTestsPath){const _=this.j.state.lastPluginDevelopmentHostWindow,ae=_?.workspace??_?.folderUri;ae&&(d.URI.isUri(ae)?ae.scheme===I.Schemas.file?ne=[ae.fsPath]:z=[ae.toString()]:ae.configPath.scheme===I.Schemas.file?ne=[(0,h.originalFSPath)(ae.configPath)]:J=[ae.configPath.toString()])}let j=W.remoteAuthority;for(const _ of R)if(_.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=d.URI.parse(_),ge=(0,N.getRemoteAuthority)(ae);ge&&(j?(0,h.isEqualAuthority)(ge,j)||this.m.error("more than one extension development path authority"):j=ge)}ne=ne.filter(_=>{const ae=d.URI.file(_);return(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,h.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j)}),z=z.filter(_=>{const ae=this.Y(_);return ae&&!!(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,h.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j):!1}),J=J.filter(_=>{const ae=this.Y(_);return ae&&!!(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,h.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j):!1}),W.cli._=ne,W.cli["folder-uri"]=z,W.cli["file-uri"]=J;const x={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!ne.length&&!z.length&&!J.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:j,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(x)}async ib(R){const W=this.w.getValue("window"),$={...this.s.args,...R.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,f.join)(this.s.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.t.profiles,profile:await this.kb(R)},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.l,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToMerge:R.filesToOpen?.filesToMerge,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),logsPath:this.s.logsPath,product:y.default,isInitialStartup:R.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,C.release)(),hostname:(0,C.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.L.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn};let z;if(!R.forceNewWindow&&!R.forceNewTabbedWindow&&(z=R.windowToUse||this.getLastActiveWindow(),z&&z.focus()),z){const J=z.config;!$.extensionDevelopmentPath&&J?.extensionDevelopmentPath&&($.extensionDevelopmentPath=J.extensionDevelopmentPath,$.extensionDevelopmentKind=J.extensionDevelopmentKind,$["enable-proposed-api"]=J["enable-proposed-api"],$.verbose=J.verbose,$["inspect-extensions"]=J["inspect-extensions"],$["inspect-brk-extensions"]=J["inspect-brk-extensions"],$.debugId=J.debugId,$.extensionEnvironment=J.extensionEnvironment,$["extensions-dir"]=J["extensions-dir"],$["disable-extensions"]=J["disable-extensions"])}else{const J=this.j.getNewWindowState($);(0,p.mark)("code/willCreateCodeWindow");const ne=z=this.F.createInstance(V.CodeWindow,{state:J,extensionDevelopmentPath:$.extensionDevelopmentPath,isExtensionTestHost:!!$.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ne),dt.a.push(ne),this.b.fire(ne),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(ne.onDidSignalReady)(()=>this.c.fire(ne)),(0,w.once)(ne.onDidClose)(()=>this.lb(ne)),(0,w.once)(ne.onDidDestroy)(()=>this.f.fire(ne)),ne.onDidTriggerSystemContextMenu(({x,y:_})=>this.h.fire({window:ne,x,y:_}));const j=(0,v.assertIsDefined)(ne.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.u.reload(ne)),this.u.registerWindow(ne)}return $.windowId=z.id,z.isReady?this.u.unload(z,4).then(J=>{J||this.jb(z,$,R)}):this.jb(z,$,R),z}jb(R,W,$){W.extensionDevelopmentPath||((0,re.isWorkspaceIdentifier)(W.workspace)?W.backupPath=this.v.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(W.workspace)?W.backupPath=this.v.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.v.registerEmptyWindowBackup({backupFolder:$.emptyWindowBackupInfo?.backupFolder??(0,de.createEmptyWorkspaceIdentifier)().id,remoteAuthority:W.remoteAuthority})),R.load(W)}async kb(R){let W;return this.t.isEnabled()&&(R.forceProfile?W=this.t.profiles.find($=>$.name===R.forceProfile)??await this.t.createNamedProfile(R.forceProfile):R.forceTempProfile&&(W=await this.t.createTransientProfile())),W?this.t.setProfileForWorkspaceSync(R.workspace??"empty-window",W):W=this.t.getOrSetProfileForWorkspace(R.workspace??"empty-window",(R.windowToUse??this.getLastActiveWindow())?.profile??this.t.defaultProfile),W}lb(R){const W=dt.a.indexOf(R);dt.a.splice(W,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=E.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.nb(this.getWindows())}mb(R){return this.nb(this.getWindows().filter(W=>(0,h.isEqualAuthority)(W.remoteAuthority,R)))}nb(R){const W=Math.max.apply(Math,R.map($=>$.lastFocusTime));return R.find($=>$.lastFocusTime===W)}sendToFocused(R,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(R,A.CancellationToken.None,...W)}sendToAll(R,W,$){for(const z of this.getWindows())$&&$.indexOf(z.id)>=0||z.sendWhenReady(R,A.CancellationToken.None,W)}getWindows(){return dt.a}getWindowCount(){return dt.a.length}getWindowById(R){const W=this.getWindows().filter($=>$.id===R);return(0,M.firstOrDefault)(W)}getWindowByWebContents(R){const W=E.BrowserWindow.fromWebContents(R);if(!!W)return this.getWindowById(W.id)}};B.a=[],B=pe([te(2,o.ILogService),te(3,Y.IStateMainService),te(4,L.IPolicyService),te(5,i.IEnvironmentMainService),te(6,T.IUserDataProfilesMainService),te(7,l.ILifecycleMainService),te(8,c.IBackupMainService),te(9,n.IConfigurationService),te(10,X.IWorkspacesHistoryMainService),te(11,le.IWorkspacesManagementMainService),te(12,s.IInstantiationService),te(13,r.IDialogMainService),te(14,a.IFileService),te(15,D.IProductService),te(16,O.IProtocolMainService),te(17,F.IThemeMainService)],B),e.WindowsMainService=B}),define(ee[271],ie([0,1,60,31,75,52]),function(q,e,E,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let A=class{constructor(m,w,S,k){this.a=m,this.b=w,this.c=S,this.d=k,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(m,w){const S=this.b.getWindowById(m);if(S)return this.a.enterWorkspace(S,this.b.getWindows(),w)}createUntitledWorkspace(m,w,S){return this.a.createUntitledWorkspace(w,S)}deleteUntitledWorkspace(m,w){return this.a.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(m,w){return this.a.getWorkspaceIdentifier(w)}getRecentlyOpened(m){return this.c.getRecentlyOpened()}addRecentlyOpened(m,w){return this.c.addRecentlyOpened(w)}removeRecentlyOpened(m,w){return this.c.removeRecentlyOpened(w)}clearRecentlyOpened(m){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};A=pe([te(0,M.IWorkspacesManagementMainService),te(1,t.IWindowsMainService),te(2,C.IWorkspacesHistoryMainService),te(3,E.IBackupMainService)],A),e.WorkspacesMainService=A}),define(ee[272],ie([0,1,13,41,27,17,44,15,30,49,43,33,2,14,9,4,12,7,29,81,130,46,144,103,248,147,60,263,18,70,179,84,118,56,106,202,26,59,111,192,214,193,250,107,194,195,16,206,86,69,5,85,264,227,251,21,6,208,269,65,19,63,257,88,37,254,92,112,35,232,234,73,48,239,240,265,241,266,114,243,244,245,246,252,31,270,253,28,93,75,271,52,249,36,213,51,223,55,90,116,255,261,259,8]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c,n,r,i,a,s,l,o,y,D,O,N,Y,G,V,se,oe,re,de,X,le,F,L,T,U,Q,B,H,R,W,$,z,J,ne,j,x,_,ae,ge,Me,Oe,De,Re,ve,we,be,Ce,Z,ue,he,ye,Ie,We,Te,ze,Be,qe,Ye,je,Xe,K,ce,fe,me,Se,Le,Ne,it,Ze,Ve,et,nt,ct,gt,It,$t,zt,Ut,qt,Ht,Vt,Gt,kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pt=class extends I.Disposable{constructor(Ee,Pe,Ae,ke,Fe,$e,_e,tt,Ue,Ge,Ke){super(),this.c=Ee,this.f=Pe,this.g=Ae,this.h=ke,this.i=Fe,this.j=$e,this.k=_e,this.l=tt,this.m=Ue,this.n=Ge,this.p=Ke,this.r(),this.s()}r(){const Ee=Ue=>Ue?.startsWith(`${f.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ue,Ge,Ke,xe)=>Ee(xe.requestingUrl)?Ke(Pe.has(Ge)):Ke(!1)),E.session.defaultSession.setPermissionCheckHandler((Ue,Ge,Ke,xe)=>Ee(xe.requestingUrl)?Pe.has(Ge):!1);const Ae=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),ke=Ue=>{for(let Ge=Ue;Ge;Ge=Ge.parent)if(Ge.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Ue=>Ue.resourceType==="xhr"||ke(Ue.frame),$e=Ue=>{const Ge=Ue.frame;if(!Ge||!this.a)return!1;const Ke=E.BrowserWindow.getAllWindows();for(const xe of Ke)if(Ge.processId===xe.webContents.mainFrame.processId)return!0;return!1},_e=(Ue,Ge)=>{if(Ue.path!=="/index.html")return!0;const Ke=Ge.frame;if(!Ke||!this.a)return!1;for(const xe of this.a.getWindows())if(xe.win&&Ke.processId===xe.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ue,Ge)=>{const Ke=h.URI.parse(Ue.url);return Ke.scheme===f.Schemas.vscodeWebview&&!_e(Ke,Ue)?(this.h.error("Blocked vscode-webview request",Ue.url),Ge({cancel:!0})):Ke.scheme===f.Schemas.vscodeFileResource&&!$e(Ue)?(this.h.error("Blocked vscode-file request",Ue.url),Ge({cancel:!0})):Ke.path.endsWith(".svg")&&!Ae.has(Ke.scheme)?Ge({cancel:!Fe(Ue)}):Ge({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ue,Ge)=>{const Ke=Ue.responseHeaders,xe=Ke["content-type"]||Ke["Content-Type"];if(xe&&Array.isArray(xe)){const st=h.URI.parse(Ue.url);if(st.path.endsWith(".svg")&&Ae.has(st.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ge({cancel:!1,responseHeaders:Ke});if(!st.path.endsWith(f.Schemas.vscodeRemoteResource)&&xe.some(at=>at.toLowerCase().includes("image/svg")))return Ge({cancel:!Fe(Ue)})}return Ge({cancel:!1})});const tt=E.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.i.codeCachePath&&tt.setCodeCachePath((0,p.join)(this.i.codeCachePath,"chrome"))}s(){(0,P.setUnexpectedErrorHandler)(Ae=>this.u(Ae)),process.on("uncaughtException",Ae=>(0,P.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,P.onUnexpectedError)(Ae)),this.j.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(Ae,ke)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",ke)}),E.app.on("activate",async(Ae,ke)=>{this.h.trace("app#activate"),ke||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(Ae,ke)=>{ke.on("will-navigate",Fe=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),ke.setWindowOpenHandler(({url:Fe})=>(this.b?.openExternal(void 0,Fe),{action:"deny"}))});let Ee=[],Pe;E.app.on("open-file",(Ae,ke)=>{this.h.trace("app#open-file: ",ke),Ae.preventDefault(),Ee.push((0,Ne.hasWorkspaceFileExtension)(ke)?{workspaceUri:h.URI.file(ke)}:{fileUri:h.URI.file(ke)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Pe=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Ae=>{const ke=this.a?.getWindowByWebContents(Ae.sender);let Fe,$e;return ke?.config?(Fe=ke.config,$e={...process.env,...ke.config.userEnv}):(Fe=this.i.args,$e=process.env),this.M(Fe,$e,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Ae,ke,Fe)=>{const $e=this.t([ke]);if(!$e||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile($e,M.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Ae,...ke)=>{const Fe=this.t(ke);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Ae=>Ae.sender.reload())}t(Ee){let Pe;for(const Ae of Ee)typeof Ae=="string"&&(typeof Pe!="string"?Pe=Ae:Pe=(0,p.join)(Pe,Ae));if(!(typeof Pe!="string"||!(0,p.isAbsolute)(Pe)||!(0,m.isEqualOrParent)(Pe,this.i.cachedLanguagesPath,!g.isLinux)))return h.URI.file(Pe)}u(Ee){if(Ee){const Pe={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Ee=this.n.win32AppUserModelId;g.isWindows&&Ee&&E.app.setAppUserModelId(Ee);try{g.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.h.error(Ue)}const Pe=new n.Server;this.j.onWillShutdown(Ue=>{Ue.reason===2&&Pe.dispose()}),this.h.trace("Resolving machine identifier...");const Ae=await this.w();this.h.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcess:ke,sharedProcessReady:Fe,sharedProcessClient:$e}=this.y(Ae),_e=await this.C(Ae,ke,Fe);this.v(_e),_e.invokeFunction(Ue=>this.D(Ue,Pe,$e)),await _e.invokeFunction(Ue=>this.F(Ue,Pe)),_e.invokeFunction(Ue=>this.I(Ue,ke)),this.B(new kt.RunOnceScheduler(()=>{this.B((0,kt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Ee){this.B(Ee.createInstance(i.ProxyAuthHandler)),this.B(Ee.createInstance(Vt.UserDataTransientProfilesHandler))}async w(){let Ee=this.l.getItem(Z.machineIdKey);return(!Ee||g.isMacintosh&&Ee==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(Ee=await(0,d.getMachineId)(),this.l.setItem(Z.machineIdKey,Ee)),Ee}y(Ee){const Pe=this.B(this.g.createInstance(De.SharedProcess,Ee,this.f)),Ae=(async()=>{this.h.trace("Main->SharedProcess#connect");const Fe=await Pe.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new r.Client(Fe,"main")})(),ke=(async()=>(await Pe.whenReady(),Ae))();return{sharedProcess:Pe,sharedProcessReady:ke,sharedProcessClient:Ae}}async C(Ee,Pe,Ae){const ke=new $.ServiceCollection;switch(process.platform){case"win32":ke.set(Ie.IUpdateService,new R.SyncDescriptor(qe.Win32UpdateService));break;case"linux":g.isLinuxSnap?ke.set(Ie.IUpdateService,new R.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ke.set(Ie.IUpdateService,new R.SyncDescriptor(ze.LinuxUpdateService));break;case"darwin":ke.set(Ie.IUpdateService,new R.SyncDescriptor(Te.DarwinUpdateService));break}ke.set(me.IWindowsMainService,new R.SyncDescriptor(Se.WindowsMainService,[Ee,this.f],!1));const Fe=new Y.DialogMainService(this.h);ke.set(Y.IDialogMainService,Fe),ke.set(ne.ILaunchMainService,new R.SyncDescriptor(ne.LaunchMainService,void 0,!1)),ke.set(N.IDiagnosticsMainService,new R.SyncDescriptor(N.DiagnosticsMainService,void 0,!1)),ke.set(O.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(Ae.then(tt=>tt.getChannel("diagnostics"))))),ke.set(z.IIssueMainService,new R.SyncDescriptor(z.IssueMainService,[this.f])),ke.set(G.IEncryptionMainService,new R.SyncDescriptor(V.EncryptionMainService,[Ee])),ke.set(J.IKeyboardLayoutMainService,new R.SyncDescriptor(J.KeyboardLayoutMainService)),ke.set(ge.INativeHostMainService,new R.SyncDescriptor(ge.NativeHostMainService,[Pe],!1)),ke.set(y.ICredentialsMainService,new R.SyncDescriptor(nt.CredentialsNativeMainService)),ke.set(ce.IWebviewManagerService,new R.SyncDescriptor(fe.WebviewMainService)),ke.set(ae.IMenubarMainService,new R.SyncDescriptor(ae.MenubarMainService)),ke.set(de.IExtensionUrlTrustService,new R.SyncDescriptor(X.ExtensionUrlTrustService)),ke.set(le.IExtensionHostStarter,new R.SyncDescriptor(F.ExtensionHostStarter)),ke.set(be.IStorageMainService,new R.SyncDescriptor(be.StorageMainService)),ke.set(be.IApplicationStorageMainService,new R.SyncDescriptor(be.ApplicationStorageMainService)),g.isWindows?ke.set(L.IExternalTerminalMainService,new R.SyncDescriptor(T.WindowsExternalTerminalService)):g.isMacintosh?ke.set(L.IExternalTerminalMainService,new R.SyncDescriptor(T.MacExternalTerminalService)):g.isLinux&&ke.set(L.IExternalTerminalMainService,new R.SyncDescriptor(T.LinuxExternalTerminalService));const $e=new l.BackupMainService(this.i,this.k,this.h,this.l);ke.set(s.IBackupMainService,$e);const _e=new et.WorkspacesManagementMainService(this.i,this.h,this.p,$e,Fe,this.n);if(ke.set(et.IWorkspacesManagementMainService,_e),ke.set(it.IWorkspacesService,new R.SyncDescriptor(Ve.WorkspacesMainService,void 0,!1)),ke.set(Ze.IWorkspacesHistoryMainService,new R.SyncDescriptor(Ze.WorkspacesHistoryMainService,void 0,!1)),ke.set(Ye.IURLService,new R.SyncDescriptor(Xe.NativeURLService,void 0,!1)),(0,ye.supportsTelemetry)(this.n,this.i)){const tt=(0,ye.isInternalTelemetry)(this.n,this.k),Ue=(0,c.getDelayedChannel)(Ae.then(at=>at.getChannel("telemetryAppender"))),Ge=new ue.TelemetryAppenderClient(Ue),Ke=(0,Ce.resolveCommonProperties)(this.m,(0,C.release)(),(0,C.hostname)(),process.arch,this.n.commit,this.n.version,Ee,tt,this.i.installSourcePath),xe=(0,ye.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ge],commonProperties:Ke,piiPaths:xe,sendErrorTelemetry:!0};ke.set(Z.ITelemetryService,new R.SyncDescriptor(he.TelemetryService,[st],!1))}else ke.set(Z.ITelemetryService,ye.NullTelemetryService);return ke.set(Ut.IExtensionsProfileScannerService,new R.SyncDescriptor(Ut.ExtensionsProfileScannerService,void 0,!0)),ke.set(qt.IExtensionsScannerService,new R.SyncDescriptor(Ht.ExtensionsScannerService,void 0,!0)),await kt.Promises.settled([$e.initialize(),_e.initialize()]),this.g.createChild(ke)}D(Ee,Pe,Ae){const ke=c.ProxyChannel.fromService(Ee.get(ne.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",ke);const Fe=c.ProxyChannel.fromService(Ee.get(N.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Fe);const $e=new gt.PolicyChannel(Ee.get(ct.IPolicyService));Pe.registerChannel("policy",$e),Ae.then(Je=>Je.registerChannel("policy",$e));const _e=this.m.getProvider(f.Schemas.file);(0,b.assertType)(_e instanceof H.DiskFileSystemProvider);const tt=new B.DiskFileSystemProviderChannel(_e,this.h,this.i);Pe.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Ae.then(Je=>Je.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const Ue=c.ProxyChannel.fromService(Ee.get(It.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",Ue),Ae.then(Je=>Je.registerChannel("userDataProfiles",Ue));const Ge=new $t.RequestChannel(Ee.get(zt.IRequestService));Ae.then(Je=>Je.registerChannel("request",Ge));const Ke=new We.UpdateChannel(Ee.get(Ie.IUpdateService));Pe.registerChannel("update",Ke);const xe=c.ProxyChannel.fromService(Ee.get(z.IIssueMainService));Pe.registerChannel("issue",xe);const st=c.ProxyChannel.fromService(Ee.get(G.IEncryptionMainService));Pe.registerChannel("encryption",st);const at=c.ProxyChannel.fromService(Ee.get(y.ICredentialsMainService));Pe.registerChannel("credentials",at);const Ct=c.ProxyChannel.fromService(Ee.get(Re.ISignService));Pe.registerChannel("sign",Ct);const Qe=c.ProxyChannel.fromService(Ee.get(J.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Qe),this.b=Ee.get(ge.INativeHostMainService);const mt=c.ProxyChannel.fromService(this.b);Pe.registerChannel("nativeHost",mt),Ae.then(Je=>Je.registerChannel("nativeHost",mt));const wt=c.ProxyChannel.fromService(Ee.get(it.IWorkspacesService));Pe.registerChannel("workspaces",wt);const bt=c.ProxyChannel.fromService(Ee.get(ae.IMenubarMainService));Pe.registerChannel("menubar",bt);const Dt=c.ProxyChannel.fromService(Ee.get(Ye.IURLService));Pe.registerChannel("url",Dt);const Mt=c.ProxyChannel.fromService(Ee.get(de.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Mt);const pt=c.ProxyChannel.fromService(Ee.get(ce.IWebviewManagerService));Pe.registerChannel("webview",pt);const lt=this.B(new we.StorageDatabaseChannel(this.h,Ee.get(be.IStorageMainService)));Pe.registerChannel("storage",lt),Ae.then(Je=>Je.registerChannel("storage",lt));const yt=this.B(new Gt.ProfileStorageChangesListenerChannel(Ee.get(be.IStorageMainService),Ee.get(It.IUserDataProfilesMainService),this.h));Ae.then(Je=>Je.registerChannel("profileStorageListener",yt));const vt=c.ProxyChannel.fromService(Ee.get(L.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",vt);const ut=new _.LogLevelChannel(Ee.get(x.ILogService),Ee.get(x.ILoggerService));Pe.registerChannel("logLevel",ut),Ae.then(Je=>Je.registerChannel("logLevel",ut));const He=new _.LoggerChannel(Ee.get(x.ILoggerService));Pe.registerChannel("logger",He),Ae.then(Je=>Je.registerChannel("logger",He));const ot=new D.ElectronExtensionHostDebugBroadcastChannel(Ee.get(me.IWindowsMainService));Pe.registerChannel("extensionhostdebugservice",ot);const ht=c.ProxyChannel.fromService(Ee.get(le.IExtensionHostStarter));Pe.registerChannel(le.ipcExtensionHostStarterChannelName,ht)}async F(Ee,Pe){const Ae=this.a=Ee.get(me.IWindowsMainService),ke=Ee.get(Ye.IURLService),Fe=Ee.get(ge.INativeHostMainService);this.j.phase=2;const $e=[],_e=[...this.i.args["open-url"]?this.i.args._urls||[]:[],...global.getOpenUrls()||[]].map(He=>{try{return{uri:h.URI.parse(He),url:He}}catch{return}}).filter(He=>{if(!He||this.G(He.uri))return!1;const ot=this.H(He.uri);return ot?($e.push(ot),!1):!0}),tt=this,Ue=this.i,Ge=this.n,Ke=this.h;ke.registerHandler({async handleURL(He,ot){if(Ke.trace("app#handleURL: ",He.toString(!0),ot),He.scheme===Ge.urlProtocol&&He.path==="workspace"&&(He=He.with({authority:"file",path:h.URI.parse(He.query).path,query:""})),tt.G(He))return!0;let ht=!1;const Je=new URLSearchParams(He.query);Je.get("windowId")==="_blank"&&(Je.delete("windowId"),He=He.with({query:Je.toString()}),ht=!0),ht||=g.isMacintosh&&Ae.getWindowCount()===0;const Nt=Je.get("continueOn");Nt!==null&&(Ue.continueOn=Nt??void 0,Je.delete("continueOn"),He=He.with({query:Je.toString()}));const At=tt.H(He);if(Ke.trace("app#handleURL: windowOpenableFromProtocolLink = ",At),At){const[Rt]=await Ae.open({context:5,cli:{...Ue.args},urisToOpen:[At],forceNewWindow:ht,gotoLineMode:!0});return Rt.focus(),!0}if(ht){const[Rt]=await Ae.open({context:5,cli:{...Ue.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Oe.getRemoteAuthority)(He)});return await Rt.ready(),ke.open(He,ot)}return!1}});const xe=this.B(new Le.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),st=new c.StaticRouter(He=>xe.getActiveClientId().then(ot=>He===ot)),at=new je.URLHandlerRouter(st),Ct=Pe.getChannel("urlHandler",at);ke.registerHandler(new je.URLHandlerChannelClient(Ct)),this.B(new K.ElectronURLListener(_e,ke,Ae,this.i,this.n));const Qe=this.i.args,mt=global.macOpenFiles,wt=(0,oe.isLaunchedFromCli)(process.env)?0:4,bt=Qe._.length,Dt=!!Qe["folder-uri"],Mt=!!Qe["file-uri"],pt=Qe["skip-add-to-recently-opened"]===!0,lt=Qe.wait&&Qe.waitMarkerFilePath?h.URI.file(Qe.waitMarkerFilePath):void 0,yt=Qe.remote||void 0,vt=Qe.profile,ut=Qe["profile-temp"];if($e.length>0)return Ae.open({context:wt,cli:Qe,urisToOpen:$e,gotoLineMode:!0,initialStartup:!0});if(!bt&&!Dt&&!Mt){if(Qe["new-window"]||vt||ut)return Ae.open({context:wt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:pt,waitMarkerFileURI:lt,initialStartup:!0,remoteAuthority:yt,forceProfile:vt,forceTempProfile:ut});if(mt.length)return Ae.open({context:1,cli:Qe,urisToOpen:mt.map(He=>(0,Ne.hasWorkspaceFileExtension)(He)?{workspaceUri:h.URI.file(He)}:{fileUri:h.URI.file(He)}),noRecentEntry:pt,waitMarkerFileURI:lt,initialStartup:!0})}return Ae.open({context:wt,cli:Qe,forceNewWindow:Qe["new-window"]||!bt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:pt,waitMarkerFileURI:lt,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:yt,forceProfile:vt,forceTempProfile:ut})}G(Ee){return!!(Ee.authority===f.Schemas.file&&g.isWindows&&E.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,k.mnemonicButtonLabel)((0,a.localize)(0,null)),(0,k.mnemonicButtonLabel)((0,a.localize)(1,null))],defaultId:0,cancelId:1,message:(0,a.localize)(2,null,(0,k.getPathLabel)(Ee,{os:g.OS,tildify:this.i}),this.n.nameShort),detail:(0,a.localize)(3,null),noLink:!0})===1)}H(Ee){if(!!Ee.path){if(Ee.authority===f.Schemas.file){const Pe=h.URI.file(Ee.fsPath);return(0,Ne.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Ee.authority===f.Schemas.vscodeRemote){const Pe=Ee.path.indexOf(p.posix.sep,1);if(Pe!==-1){const Ae=Ee.path.substring(1,Pe),ke=Ee.path.substring(Pe),Fe=h.URI.from({scheme:f.Schemas.vscodeRemote,authority:Ae,path:ke,query:Ee.query,fragment:Ee.fragment});return(0,Ne.hasWorkspaceFileExtension)(ke)?{workspaceUri:Fe}:/:[\d]+$/.test(ke)?{fileUri:Fe}:{folderUri:Fe}}}}}I(Ee,Pe){const Ae=Ee.get(Z.ITelemetryService),ke=Ee.get(Ie.IUpdateService);this.j.phase=3,this.L(Ae,Pe),this.J(),E.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(Fe,$e)=>{$e({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(ke instanceof qe.Win32UpdateService||ke instanceof ze.LinuxUpdateService||ke instanceof Te.DarwinUpdateService)&&ke.initialize(),this.M(this.i.args,process.env,!0),this.N()}async J(){const Ee=this.n.win32MutexName;if(g.isWindows&&Ee)try{const Pe=await new Promise((ke,Fe)=>{q(["windows-mutex"],ke,Fe)}),Ae=new Pe.Mutex(Ee);(0,w.once)(this.j.onWillShutdown)(()=>Ae.release())}catch(Pe){this.h.error(Pe)}}L(Ee,Pe){let Ae=!1;(0,w.once)(this.j.onWillShutdown)(()=>Ae=!0),this.B(Pe.onDidError(({type:ke,details:Fe})=>{let $e;switch(ke){case 1:$e="SharedProcess: detected unresponsive window";break;case 2:$e=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:$e=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error($e)),Ee.publicLog2("sharedprocesserror",{type:ke,reason:Fe?.reason,code:Fe?.exitCode,visible:Pe.isVisible(),shuttingdown:Ae})}))}async M(Ee,Pe,Ae){try{return await(0,re.getResolvedShellEnv)(this.h,Ee,Pe)}catch(ke){const Fe=(0,A.toErrorMessage)(ke);Ae?this.a?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.h.error(Fe)}return{}}async N(){try{const Pe=(await this.m.readFile(this.i.argvResource)).value.toString(),Ae=JSON.parse((0,S.stripComments)(Pe)),Fe=(0,ye.getTelemetryLevel)(this.k)>=1;if(Ae["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],_e=Pe.substring(0,Pe.length-2).concat(`,
`,$e.join(`
`));await this.m.writeFile(this.i.argvResource,M.VSBuffer.fromString(_e))}else{const $e=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);$e!==Pe&&await this.m.writeFile(this.i.argvResource,M.VSBuffer.fromString($e))}}catch(Ee){this.h.error(Ee)}}};Pt=pe([te(2,W.IInstantiationService),te(3,x.ILogService),te(4,se.IEnvironmentMainService),te(5,j.ILifecycleMainService),te(6,o.IConfigurationService),te(7,ve.IStateMainService),te(8,Q.IFileService),te(9,Me.IProductService),te(10,It.IUserDataProfilesMainService)],Pt),e.CodeApplication=Pt}),define(ee[273],ie([0,1,36,8,280,2,6]),function(q,e,E,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends E.AbstractPolicyService{constructor(w,S){super(),this.j=w,this.k=S,this.a=new t.Throttler,this.b=this.B(new M.MutableDisposable)}async i(w){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(w).length} policy definitions`),await this.a.queue(()=>new Promise((S,k)=>{try{this.b.value=(0,C.createWatcher)(this.k,w,I=>{this.m(I),S()})}catch(I){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",I),k(I)}}))}m(w){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(w)}`);for(const S in w){const k=w[S];k===void 0?this.g.delete(S):this.g.set(S,k)}this.h.fire(Object.keys(w))}};P=pe([te(0,A.ILogService)],P),e.NativePolicyService=P}),define(ee[274],ie([0,1,225,8,17,15,2,12,18,34,111,6,224,281]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends A.Disposable{constructor(b,h,v){super(),this.h=h,this.i=v,this.j(b.getValue()),this.B(b.onDidChangeConfiguration(()=>this.j(b.getValue()),this))}j(b){this.a=b.http&&b.http.proxy,this.b=!!(b.http&&b.http.proxyStrictSSL),this.f=b.http&&b.http.proxyAuthorization}async request(b,h){this.i.trace("RequestService#request (node) - begin",b.url);const{a:v,b:d}=this;let u;try{u=await(0,S.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(r){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",r))}const c={...process.env,...u},n=b.agent?b.agent:await(0,I.getProxyAgent)(b.url||"",c,{proxyUrl:v,strictSSL:d});b.agent=n,b.strictSSL=d,this.f&&(b.headers={...b.headers||{},"Proxy-Authorization":this.f});try{const r=await this.l(b,h);return this.i.trace("RequestService#request (node) - success",b.url),r}catch(r){throw this.i.trace("RequestService#request (node) - error",b.url,r),r}}async k(b){return((0,E.parse)(b.url).protocol==="https:"?await new Promise((d,u)=>{q(["https"],d,u)}):await new Promise((d,u)=>{q(["http"],d,u)})).request}l(b,h){return t.Promises.withAsyncBody(async(v,d)=>{const u=(0,E.parse)(b.url),c=b.getRawRequest?b.getRawRequest(b):await this.k(b),n={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,P.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(n.auth=b.user+":"+b.password);const r=c(n,i=>{const a=(0,P.isNumber)(b.followRedirects)?b.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&a>0&&i.headers.location)this.l({...b,url:i.headers.location,followRedirects:a-1},h).then(v,d);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,f.createGunzip)())),v({res:i,stream:(0,C.streamToBufferReadableStream)(s)})}});r.on("error",d),b.timeout&&r.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&r.write(b.data),r.end(),h.onCancellationRequested(()=>{r.abort(),d(new M.CancellationError)})})}async resolveProxy(b){}};p=pe([te(0,m.IConfigurationService),te(1,w.INativeEnvironmentService),te(2,k.ILogService)],p),e.RequestService=p}),define(ee[275],ie([0,1,13,274]),function(q,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function C(A){return E.net.request}class M extends t.RequestService{request(P,m){return super.request({...P||{},getRawRequest:C},m)}}e.RequestMainService=M}),define(ee[282],ie([0,1,13,40,7,24,8,44,15,30,49,33,14,9,72,4,32,25,23,46,83,272,10,18,218,231,26,59,183,16,204,86,69,200,85,21,207,6,210,54,19,61,256,113,237,55,275,88,226,37,230,73,64,51,36,273,212,2,42,242,38,238]),function(q,e,E,t,C,M,A,P,m,w,S,k,I,f,p,g,b,h,v,d,u,c,n,r,i,a,s,l,o,y,D,O,N,Y,G,V,se,oe,re,de,X,le,F,L,T,U,Q,B,H,R,W,$,z,J,ne,j,x,_,ae,ge,Me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Oe{main(){try{this.a()}catch(ve){console.error(ve.message),E.app.exit(1)}}async a(){(0,m.setUnexpectedErrorHandler)(Ie=>console.error(Ie));const[ve,we,be,Ce,Z,ue,he,ye]=this.b();try{try{await this.d(be,ye,Ce,Z,he)}catch(Ie){throw this.f(be,he.nameLong,Ie),Ie}await ve.invokeFunction(async Ie=>{const We=Ie.get(oe.ILogService),Te=Ie.get(V.ILifecycleMainService),ze=Ie.get(y.IFileService),Be=Ie.get(oe.ILoggerService),qe=await this.e(We,be,Te,ve,he,!0);return v.Promises.writeFile(be.mainLockfile,String(process.pid)).catch(Ye=>{We.warn(`Error writing main lockfile: ${Ye.stack}`)}),ue.logger=Be.createLogger(C.URI.file((0,f.join)(be.logsPath,"main.log")),{name:"main"}),(0,S.once)(Te.onWillShutdown)(Ye=>{ze.dispose(),Ce.dispose(),Ye.join(v.Promises.unlink(be.mainLockfile).catch(()=>{}))}),ve.createInstance(c.CodeApplication,qe,we).startup()})}catch(Ie){ve.invokeFunction(this.i,Ie)}}b(){const ve=new G.ServiceCollection,we=new _.DisposableStore;process.once("exit",()=>we.dispose());const be={_serviceBrand:void 0,...de.default};ve.set(X.IProductService,be);const Ce=new s.EnvironmentMainService(this.j(),be),Z=this.c(Ce);ve.set(s.IEnvironmentMainService,Ce);const ue=new se.BufferLogService,he=we.add(new oe.MultiplexLogService([new oe.ConsoleMainLogger((0,oe.getLogLevel)(Ce)),ue]));ve.set(oe.ILogService,he);const ye=new D.FileService(he);ve.set(y.IFileService,ye);const Ie=new O.DiskFileSystemProvider(he);ye.registerProvider(I.Schemas.file,Ie);const We=new ge.UriIdentityService(ye);ve.set(ae.IUriIdentityService,We),ve.set(oe.ILoggerService,new re.LoggerService(he));const Te=new W.StateMainService(Ce,he,ye);ve.set(R.IStateMainService,Te);const ze=new J.UserDataProfilesMainService(Te,We,Ce,ye,he);ve.set(J.IUserDataProfilesMainService,ze);const Be=g.isWindows&&be.win32RegValueName?we.add(new j.NativePolicyService(he,be.win32RegValueName)):Ce.policyFile?we.add(new x.FilePolicyService(Ce.policyFile,ye,he)):new ne.NullPolicyService;ve.set(ne.IPolicyService,Be);const qe=new i.ConfigurationService(ze.defaultProfile.settingsResource,ye,Be,he);return ve.set(r.IConfigurationService,qe),ve.set(V.ILifecycleMainService,new N.SyncDescriptor(V.LifecycleMainService,void 0,!1)),ve.set(U.IRequestService,new N.SyncDescriptor(Q.RequestMainService,void 0,!0)),ve.set(z.IThemeMainService,new N.SyncDescriptor(z.ThemeMainService)),ve.set(B.ISignService,new N.SyncDescriptor(H.SignService,void 0,!1)),ve.set(L.ITunnelService,new N.SyncDescriptor(T.TunnelService)),ve.set(le.IProtocolMainService,new F.ProtocolMainService(Ce,ze,he)),[new Y.InstantiationService(ve,!0),Z,Ce,qe,Te,ue,be,ze]}c(ve){const we={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(be=>{const Ce=process.env[be];typeof Ce=="string"&&(we[be]=Ce)}),Object.assign(process.env,we),we}async d(ve,we,be,Ce,Z){await A.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,we.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(ue=>ue?v.Promises.mkdir(ue,{recursive:!0}):void 0)),Ce.init(),be.initialize()]),we.setEnablement(Z.quality!=="stable"||be.getValue(Me.PROFILES_ENABLEMENT_CONFIG))}async e(ve,we,be,Ce,Z,ue){let he;try{(0,p.mark)("code/willStartMainServer"),he=await(0,u.serve)(we.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,S.once)(be.onWillShutdown)(()=>he.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.f(we,Z.nameLong,ye),ye;let Ie;try{Ie=await(0,u.connect)(we.mainIPCHandle,"main")}catch(Be){if(!ue||g.isWindows||Be.code!=="ECONNREFUSED")throw Be.code==="EPERM"&&this.g((0,n.localize)(0,null,Z.nameShort),(0,n.localize)(1,null),Z.nameLong),Be;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(qe){throw ve.warn("Could not delete obsolete instance handle",qe),qe}return this.e(ve,we,be,Ce,Z,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const Be=`Running extension tests from the command line is currently only supported if no other instance of ${Z.nameShort} is running.`;throw ve.error(Be),Ie.dispose(),new Error(Be)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.g((0,n.localize)(2,null,Z.nameShort),(0,n.localize)(3,null),Z.nameLong)},1e4));const Te=d.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0}),ze=d.ProxyChannel.toService(Ie.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return Ce.invokeFunction(async()=>{const Be=new a.DiagnosticsService($.NullTelemetryService,Z),qe=await ze.getMainDiagnostics(),Ye=await ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),je=await Be.getDiagnostics(qe,Ye);throw console.log(je),new m.ExpectedError});throw g.isWindows&&await this.h(Te,ve),ve.trace("Sending env to running instance..."),await Te.start(we.args,process.env),Ie.dispose(),We&&clearTimeout(We),new m.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw ve.warn(`Warning: The --status argument can only be used if ${Z.nameShort} is already running. Please run it again after {0} has started.`),new m.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),he}f(ve,we,be){if(be.code==="EACCES"||be.code==="EPERM"){const Ce=(0,M.coalesce)([ve.userDataPath,ve.extensionsPath,u.XDG_RUNTIME_DIR]).map(Z=>(0,k.getPathLabel)(C.URI.file(Z),{os:g.OS,tildify:ve}));this.g((0,n.localize)(4,null),(0,n.localize)(5,null,(0,P.toErrorMessage)(be),Ce.join(`
`)),we)}}g(ve,we,be){E.dialog.showMessageBoxSync({title:be,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,n.localize)(6,null))],message:ve,detail:we,defaultId:0,noLink:!0})}async h(ve,we){if(g.isWindows){const be=await ve.getMainProcessId();we.trace("Sending some foreground love to the running instance:",be);try{(await new Promise((Ce,Z)=>{q(["windows-foreground-love"],Ce,Z)})).allowSetForegroundWindow(be)}catch(Ce){we.error(Ce)}}}i(ve,we){const be=ve.get(oe.ILogService),Ce=ve.get(V.ILifecycleMainService);let Z=0;we&&(we.isExpected?we.message&&be.trace(we.message):(Z=1,we.stack?be.error(we.stack):be.error(`Startup error: ${we.toString()}`))),Ce.kill(Z)}j(){const ve=this.k((0,l.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const we=(0,o.createWaitMarkerFileSync)(ve.verbose);we&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",we),ve.waitMarkerFilePath=we)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const we=this.l(ve._,ve.goto);ve._=we}return ve}l(ve,we){const be=(0,b.cwd)(),Ce=ve.map(he=>{let ye=String(he),Ie;we&&(Ie=(0,w.parseLineAndColumnAware)(ye),ye=Ie.path),ye&&(ye=this.m(be,ye));const We=(0,w.sanitizeFilePath)(ye,be),Te=(0,f.basename)(We);return Te&&!(0,w.isValidBasename)(Te)?null:we&&Ie?(Ie.path=We,this.n(Ie)):We}),Z=g.isWindows||g.isMacintosh,ue=(0,M.distinct)(Ce,he=>he&&Z?he.toLowerCase():he||"");return(0,M.coalesce)(ue)}m(ve,we){return g.isWindows&&(we=(0,h.rtrim)(we,'"')),we=(0,h.trim)((0,h.trim)(we," "),"	"),g.isWindows&&(we=(0,f.resolve)(ve,we),we=(0,h.rtrim)(we,".")),we}n(ve){const we=[ve.path];return typeof ve.line=="number"&&we.push(String(ve.line)),typeof ve.column=="number"&&we.push(String(ve.column)),we.join(":")}}new Oe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f730160c5d5fe36a7ad8db51f74f40a9d316e8b2/core/vs/code/electron-main/main.js.map
